;;; Old.lisp

;;; ============================================
;;; Fichier 4-Charge.lisp / 18 mai 2003
;;; ============================================

(in-package :midishare)



(setf *grille-defautbeat* 
  '((c) / (c) / (c) / (c)))

(setf *grille-goodbye*                    ;;; interbarre = demi-mesure
      '((f 7) / (c# 7) / (f#) / (b 7) / (eb 7) / (c# 7) / (eb 7) / (f 7) /
        (bb m7) / (g# 7) / (g m7) / (c 7) / (d 7) / (g 7) / (c# 7) / (f#) /
        (bb 7) / (c# 7) / (c 7) / (eb 7) / (f 7) / (c# 7) / (f#) / (b 7)))


;;; ===========================================
;;; PRINCIPE DE L'IMPRO ORACLE 29/9/2004
;;; ===========================================

;;; determine-durees -> Donne liste de couples (accord nb-interbarre) avec eventuellement marques *
;;; Ex "Rain": (((e 7) 1) ((b m7) 1) (((e *) 7) 1) ((bb m7) 1) ((eb 7) 1) ((g# m7) 2) ((c# 7) 2) ((f#) 2) ((g# 7) 2) ((b 7) 2) ((bb 7) 2))

;;; interbarre = valeur minimale des accords
;;; car la seule regle de division R1 est / x / -> / x x /

;;; on peut rajouter / x / -> / x x x x /
;;; sans changer les autres regles
;;; en fait la duree minimale des accords est fixee par cette regle R1

;;; 2-Omax.lisp
;;; (fonction-grammaire) lance calcul oracle
;;; (creer-piano-bass) cree 5 sequences midi (Rain + 4 oracles)

;;; 1-2-Arrange.lisp
;;; *grilletmporacle* = (duplique-beat *grilletmp* *nbeatsaccord*)
;;; enleve les barres et duplique les accords en autant de fois que leur nombre de valeurs minimales
;;; ex: / Bbm7 Eb7 / G# / devient Bbm7 Eb7 G# G#
;;; enleve-marque supprime les * des accords


;;; Impro oracle
;;; ------------
;;; (om::ImprovizeOnHarmGrid oracle (length *grilletmporacle*) *grilletmporacle*)

;;; dans un "improvizer":
;;; vectext = veteur de "beats"

;;; chaque "beat" contient:
;;; midiset = liste de donnees midi en 5uples (pitch date dur vel can)
;;; duration = ms
;;; harmlabel = liste d'accords

;;; les durations des beats peuvent etre differentes,
;;; elles sont scales sur la duree commune des beats au tempo de la performance
;;; (om::clone-and-scale-beats res *dureebeat*)
;;; = scale dates et durees selon ratio = duree beat courant dans Max / (duration beat)

;;; Decoupage en beats
;;; ------------------
;;; (setf seq-tmp (formate-liste-events->liste-beats seq-tmp))
;;; = liste de couples (accord liste-5uples)
;;; 6-Voicings.lisp

;;; Apprentissage avec beats
;;; ------------------------
;;; (om::learn-beat-list *oracle-courant* seq-tmp *numbeatinit*)
;;; fixe les parametres de chaque beat:
;;; Numbeat = reste de la divisions de StartBeatNb par le nb de beats par mesure
;;; RefHarmLabel = accord correspondant dans la grille de ref de l'improvizer
;;; duration = RefTempo de l'improvizer (mis a jour dans set-cur-orc-dureebeat)

#|
(setf levts   
'((0 248) (10 157 10 2) (0 155 80 95) (137 155 80 0) (147 155 81 55) (232 155 80 61) (262 155 81 0) (337 155 78 58) (342 155 80 0) (427 155 78 0) (462 157 10 0) 
(462 248) (462 155 80 67) (464 157 3 3) (752 155 78 79) (787 155 80 0) (940 157 3 0) 
(940 248) (947 157 8 2) (1227 155 75 64) (1262 155 78 0) (1367 155 75 0) 
(1422 248) (1902 157 8 0) 
(1902 248) (1902 155 73 58) (1904 157 1 3) (2042 155 73 0) 
(2380 248) (2387 155 73 82) (2635 155 75 60) (2667 155 73 0) (2807 155 75 0) (2862 157 1 0) 
(2862 248) (2867 157 6 1) 
(3342 248) (3820 157 6 0) 
(3820 248) (3827 157 8 3) 
(4302 248) (4782 157 8 0) 
(4782 248) (4787 157 11 3) (4807 157 11 0)))

|#

;;; (list-ev->quintuples levts)


;;; ========================================================
;;; CHARGEMENT DES ENVIRONNEMENTS POUR CHAQUE GRILLE
;;; Fonctions de modifications dans patch "Interface Omax"
;;; ========================================================


(defun om::charge-orchestre ()
  (setf contenu-fichier (om::load-orchestre-from))
  (when (neq contenu-fichier :cancel)
    (if (eq (type-of contenu-fichier) 'om::improvizer) 
      (progn (init-oracle)
             (setf *oracle1* contenu-fichier)
             (setf (aref (om::improvizer-array *orchestre*) 0) *oracle1*))
      (progn (setf *oracle1* (aref (om::improvizer-array contenu-fichier) 0))
             (setf *oracle2* (aref (om::improvizer-array contenu-fichier) 1))
             (setf *oracle3* (aref (om::improvizer-array contenu-fichier) 2))
             (setf *oracle4* (aref (om::improvizer-array contenu-fichier) 3))
             (setf *orchestre* contenu-fichier)))
    (setf *oracle-courant* *oracle1*))
  contenu-fichier)


(defun om::sauve-orchestre ()
  (om::save-orchestre-as *orchestre*)
  T)



(defun init-oracle ()
  (setf *oracle1* (om::NewImprovizer))
  (setf *oracle2* (om::NewImprovizer))
  (setf *oracle3* (om::NewImprovizer))
  (setf *oracle4* (om::NewImprovizer))
  (setf *orchestre* (make-instance 'om::orchestre :improvizer-array 
                                   (make-array 4 :initial-contents 
                                               (list *oracle1* *oracle2* *oracle3* *oracle4*))))
  *oracle1*)

(defun om::grammaire0 () (setf *grammaire* *grammaire0*))   ;;; version sans acc mineurs
(defun om::grammaire1 () (setf *grammaire* *grammaire1*))   ;;; version complete (valeur par defaut)

;;; Dans (creer-piano-bass), les reecritures se font sur variable *grille*
;;; En general, grilles de 4 mesures sauf le blues de 12 mesures
;;; MARQUEUR /
;;; -> sert a controler la profondeur d'application des regles de division
;;; (accord divisable = encadre par deux /)
;;; Table d'arrangement: unite de duree accord = 1 demi-interbarre (/ X X /)
;;; -> accords = 1 demi-interbarre, ou 2 demi-interbarres = interbarre (interbarre = pseudo-"mesure")

;;; *nbeatsaccord* = nbre de beats par unite de duree grille (DEMI-BARRE)
;;; "Rain" -> beat = 1 demi-interbarre -> *nbeatsaccord* = 1
;;; "Goodbye Pork Pie Hat" -> idem (2 beats par / X / = demi-mesure) -> *nbeatsaccord* = 1

;;; ATTENTION: ne gere pas les enharmonies (Ex: g# et non ab)
;;; -> (c c# d eb e f f# g g# a bb b)

(setf *nbeatsaccord* 2)
(setf *dureebeat* 484)



(defun om::charge-ornithology ()          ;;; BPM=230, 64 beats (16 mesures)
  (setf *nbeatsaccord* 2)                 ;;; / X / = 2 * 4 beats (tempo dedouble)
  (setf *dureebeat* 261)
  (setf *grille* 
        '((g) / (g) / (g m7) / (c 7) / (f) / (f) / (f m7) / (bb 7) / 
          (eb 7) / (d 7) / (g m7) (c m7) / (g m7) / (b m7) / (e 7) / (a m7) / (d 7)))    ;;; seulement 16 mes/

          ;(g) / (g) / (g m7) / (c 7) / (f) / (f) / (f m7) / (bb 7) / 
          ;(eb 7) / (d 7) / (g m7) (c m7) / (g) / (g) / (g) / (g) / (g)))
  (setf *blues?* nil)
  (setf *k* 0)                               ;;; pas de substitution
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement Ornithology... BPM=230, 64 beats (16 mesures)~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)


(defun om::charge-sweeterlove ()          ;;; BPM=120, 16 beats (4 mesures)
  (setf *nbeatsaccord* 4)
  (setf *dureebeat* 500)
  (setf *grille* 
        '((c# m7) / (b m7) / (f# m7) / (a m7) (g m7)))
  (setf *blues?* nil)
  (setf *k* 0)                               ;;; pas de substitution
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement Sweeter Love... BPM=120, 16 beats (4 mesures)~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

(defvar *grille-bluesBb* 
  '((bb) / (bb) / (bb) / (bb 7) /
    (eb) / (eb) / (bb) / (bb 7) /
    (f) / (eb) / (bb) / (f 7)))


(defun om::charge-bluesBb ()        ;;; BPM=112, 48 beats
  (setf *nbeatsaccord* 2)
  (setf *dureebeat* 536)
  (setf *grille*                     ;;; interbarre = mesure
        '((bb) / (bb) / (bb) / (bb 7) /
          (eb) / (eb) / (bb) / (bb 7) /
          (f) / (eb) / (bb) / (f 7)))   ;;; version a jouer 2 fois plus lentement
  (setf *blues?* t)
  (setf *oracle-courant* (init-oracle))

  (setf (om::Beats/Measure *oracle-courant*) 4)
  (setf (om::RefTempo *oracle-courant*) *dureebeat*)
  (setf (om::RefHarmGrid *oracle-courant*) (enleve-marque* (duplique-beat *grille*)))
  (setf (om::HarmGridLength *oracle-courant*) (length (om::RefHarmGrid *oracle-courant*)))
  (om::setMaxCont *oracle-courant* 4)
  (om::set-best-suffix-mode *oracle-courant* nil)
  (om::set-start-region *oracle-courant* '(90 100))
  (om::set-suffix-law *oracle-courant* '(t t))

  (format t "Chargement du blues en Bb sur Ziste... BPM=112, 48 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

(defvar *grille-dicidence* '((f m7) / (g 7) / (c m7) / (c m7) / (f m7) / (g 7) / (c m7) / (c m7)  /
                             (f m7) / (g 7) / (c m7) / (c m7)  / (f m7) / (g 7) / (c m7) / (c 7)  /
                             (f m7) / (bb 7) / (eb) / (g#) / (d 7) / (g 7) / (c m7) / (c 7) /
                             (f m7) / (bb 7) / (eb) / (g#) / (d 7) / (g 7) / (c m7) / (c m7)
                             ))


(defun om::charge-dicidence ()         ;;; BPM=188, 128 beats (32 mesures)
  (setf *nbeatsaccord* 2)
  (setf *dureebeat* 319)
  (setf *grille* 
        '((f m7) / (g 7) / (c m7) / (c m7) / (f m7) / (g 7) / (c m7) / (c m7)  /
          (f m7) / (g 7) / (c m7) / (c m7)  / (f m7) / (g 7) / (c m7) / (c 7)  /
          (f m7) / (bb 7) / (eb) / (g#) / (d 7) / (g 7) / (c m7) / (c 7) /
          (f m7) / (bb 7) / (eb) / (g#) / (d 7) / (g 7) / (c m7) / (c m7)
          ))   
  (setf *blues?* nil)
  
  (setf *oracle-courant* (init-oracle))
  (setf (om::Beats/Measure *oracle-courant*) 4)
  (setf (om::RefTempo *oracle-courant*) *dureebeat*)
  (setf (om::RefHarmGrid *oracle-courant*) (enleve-marque* (duplique-beat *grille*)))
  (setf (om::HarmGridLength *oracle-courant*) (length (om::RefHarmGrid *oracle-courant*)))
  
  (om::setMaxCont *oracle-courant* 16)
  (om::set-best-suffix-mode *oracle-courant* t)
  (om::set-start-region *oracle-courant* '(0 100))
  (om::set-suffix-law *oracle-courant* '(t t))
  
  (format t "Chargement de Dicidence... BPM=188, 128 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
  )




(defun om::charge-rain ()          ;;; BPM=125, 16 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 484)
  (setf *grille* *grille-rain*)
  (setf *blues?* nil)
  ;;;;;(charge-baserain)      ;;; ancienne base d'impro
  (setf *oracle-courant* (init-oracle))

  (setf (om::Beats/Measure *oracle-courant*) 4)
  (setf (om::RefTempo *oracle-courant*) *dureebeat*)
  (setf (om::RefHarmGrid *oracle-courant*) (enleve-marque* (duplique-beat *grille*)))
  (setf (om::HarmGridLength *oracle-courant*) (length (om::RefHarmGrid *oracle-courant*)))
  (om::setMaxCont *oracle-courant* 4)
  (om::set-best-suffix-mode *oracle-courant* nil)
  (om::set-start-region *oracle-courant* '(90 100))
  (om::set-suffix-law *oracle-courant* '(t t))


  (format t "Chargement de Rain... BPM=125, 16 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)




(defvar *grille-toutpiti*
  '((f) / (f) / (f 7) / (bb) /
    (bb m7) (eb 7) / (a m7) (d 7) / (g m7) (c 7) / (f) /
    (f) / (f) / (f 7) / (bb) /
    (bb m7) (eb 7) / (a m7) (d 7) / (g m7) (c 7) / (f) /
    (c 7) / (f) / (c 7) / (f) / 
    (c 7) / (f) / (c 7) / (f)))

(defun om::charge-toutpiti ()             ;;; BPM=118, 96 beats (3*8 mesures, partie A A B)
  (setf *nbeatsaccord* 2)                 ;;; / X / = 2 * 4 beats (tempo dedouble)
  (setf *dureebeat* 508)
  (setf *grille* 
        '((f) / (f) / (f 7) / (bb) /
          (bb m7) (eb 7) / (a m7) (d 7) / (g m7) (c 7) / (f) /
          (f) / (f) / (f 7) / (bb) /
          (bb m7) (eb 7) / (a m7) (d 7) / (g m7) (c 7) / (f) /
          (c 7) / (f) / (c 7) / (f) / 
          (c 7) / (f) / (c 7) / (f)))
  (setf *blues?* nil)
  (setf *k* 0)                               ;;; pas de substitution
  (setf *oracle-courant* (init-oracle))

  (setf (om::RefTempo *oracle-courant*) *dureebeat*)
  (setf (om::Beats/Measure *oracle-courant*) 4)
  (setf (om::RefHarmGrid *oracle-courant*) (enleve-marque* (duplique-beat *grille*)))
  (setf (om::HarmGridLength *oracle-courant*) (length (om::RefHarmGrid *oracle-courant*)))
  (om::setMaxCont *oracle-courant* 4)
  (om::set-best-suffix-mode *oracle-courant* nil)
  (om::set-start-region *oracle-courant* '(90 100))
  (om::set-suffix-law *oracle-courant* '(t t))



  (format t "Chargement Tout piti... BPM=118, 96 beats (3*8 mesures)~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)


(defun om::charge-goodbye ()        ;;; BPM=77, 48 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 779)
  (setf *grille*                    ;;; interbarre = demi-mesure
        '((f 7) / (c# 7) / (f#) / (b 7) / (eb 7) / (c# 7) / (eb 7) / (f 7) /
          (bb m7) / (g# 7) / (g m7) / (c 7) / (d 7) / (g 7) / (c# 7) / (f#) /
          (bb 7) / (c# 7) / (c 7) / (eb 7) / (f 7) / (c# 7) / (f#) / (b 7)))
  (setf *blues?* nil)
  (setf *oracle-courant* (init-oracle))

  (setf (om::RefTempo *oracle-courant*) *dureebeat*)
  (setf (om::Beats/Measure *oracle-courant*) 2)
  (setf (om::RefHarmGrid *oracle-courant*) (enleve-marque* (duplique-beat *grille*)))
  (setf (om::HarmGridLength *oracle-courant*) (length (om::RefHarmGrid *oracle-courant*)))
  (om::setMaxCont *oracle-courant* 4)
  (om::set-best-suffix-mode *oracle-courant* nil)
  (om::set-start-region *oracle-courant* '(90 100))
  (om::set-suffix-law *oracle-courant* '(t t))


  (format t "Chargement de Goodbye Pork Pie Hat... BPM=77, 48 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)



(defun om::charge-ziste ()          ;;; BPM=112, 16 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 535)
  (setf *grille*                     ;;; interbarre = demi-mesure
        '((bb) / (bb) / (bb) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))
;;; Lubat-Minvielle
  (setf *blues?* nil)

  (setf *oracle-courant* (init-oracle))

  (setf (om::RefTempo *oracle-courant*) *dureebeat*)
  (setf (om::Beats/Measure *oracle-courant*) 2)
  (setf (om::RefHarmGrid *oracle-courant*) (enleve-marque* (duplique-beat *grille*)))
  (setf (om::HarmGridLength *oracle-courant*) (length (om::RefHarmGrid *oracle-courant*)))
  (om::setMaxCont *oracle-courant* 4)
  (om::set-best-suffix-mode *oracle-courant* nil)
  (om::set-start-region *oracle-courant* '(90 100))
  (om::set-suffix-law *oracle-courant* '(t t))

  ;;;;;(charge-baseziste)   ;;; ancienne base d'impro
  (format t "Chargement de Ziste... BPM=112, 16 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)



;;; ===============
;;; CHARGEMENT FREE
;;; ===============

(defun om::charge-free ()         
  (setf *oracle-courant* (init-oracle))
  (om::setMaxCont *oracle-courant* 4)
  (om::set-best-suffix-mode *oracle-courant* t)
  (om::set-start-region *oracle-courant* '(90 100))
  (om::set-suffix-law *oracle-courant* '(t t))

  (format t "Chargement free... Remise a zero de l'oracle~%")
)


(defun om::charge-freeE ()         
  (setf *oracle-courant* (init-oracle))
  (om::setMaxCont *oracle-courant* 4)
  (om::set-best-suffix-mode *oracle-courant* t)
  (om::set-start-region *oracle-courant* '(90 100))
  (om::set-suffix-law *oracle-courant* '(t t))

  (setf (om::useEstrada *oracle-courant*) t)
  (setf (om::useHindemith *oracle-courant*) t)
  (format t "Chargement free... Remise a zero de l'oracle~%")
)






;(defun om::charge-free ()          ;;; BPM=160, 16 beats
;  (setf *nbeatsaccord* 1)
;  (setf *dureebeat* 375)
;  (setf *grille* 
;        '((c) / (c) / (c) / (c) / (c) / (c) / (c) / (c)))
;  (setf *blues?* nil)
;  (setf *k* 0)                               ;;; pas de substitution
;  (setf *oracle-courant* (om::NewImprovizer))
;  (format t "Chargement free... BPM bidon(=160, 16 beats)~%")
;  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
;  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
;)



;;; ============================================
;;; Fichier 1-1-Steedman.lisp / 20 fevrier 2003
;;; ============================================

(in-package :midishare)



#|
;;; ========================================================
;;; CHARGEMENT DES ENVIRONNEMENTS POUR CHAQUE GRILLE
;;; Fonctions de modifications dans patch "Interface Omax"
;;; ========================================================

(defun om::grammaire0 () (setf *grammaire* *grammaire0*))   ;;; version sans acc mineurs
(defun om::grammaire1 () (setf *grammaire* *grammaire1*))   ;;; version complete (valeur par defaut)

;;; Dans (creer-piano-bass), les reecritures se font sur variable *grille*
;;; En general, grilles de 4 mesures sauf le blues de 12 mesures
;;; MARQUEUR /
;;; -> sert a controler la profondeur d'application des regles de division
;;; (accord divisable = encadre par deux /)
;;; Table d'arrangement: unite de duree accord = 1 demi-interbarre (/ X X /)
;;; -> accords = 1 demi-interbarre, ou 2 demi-interbarres = interbarre (interbarre = pseudo-"mesure")

;;; *nbeatsaccord* = nbre de beats par unite de duree grille (DEMI-BARRE)
;;; "Rain" -> beat = 1 demi-interbarre -> *nbeatsaccord* = 1
;;; "Goodbye Pork Pie Hat" -> idem (2 beats par / X / = demi-mesure) -> *nbeatsaccord* = 1

;;; ATTENTION: ne gere pas les enharmonies (Ex: g# et non ab)
;;; -> (c c# d eb e f f# g g# a bb b)

(setf *nbeatsaccord* 2)
(setf *dureebeat* 484)

(defun om::charge-rain ()          ;;; BPM=125, 16 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 484)
  (setf *grille* *grille-rain*)
  (setf *blues?* nil)
  ;;;;;(charge-baserain)      ;;; ancienne base d'impro
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement de Rain... BPM=125, 16 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

(defun om::charge-rainE ()          ;;; BPM=125, 16 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 484)
  (setf *grille* *grille-rain*)
  (setf *blues?* nil)
  ;;;;;(charge-baserain)      ;;; ancienne base d'impro
  (setf *oracle-courant* (om::NewImprovizer))
  (setf (om::useEstrada *oracle-courant*) t)
  (setf (om::useHindemith *oracle-courant*) t)

  (format t "Chargement de Rain... BPM=125, 16 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)



(defun om::charge-goodbye ()        ;;; BPM=77, 48 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 779)
  (setf *grille*                    ;;; interbarre = demi-mesure
        '((f 7) / (c# 7) / (f#) / (b 7) / (eb 7) / (c# 7) / (eb 7) / (f 7) /
          (bb m7) / (g# 7) / (g m7) / (c 7) / (d 7) / (g 7) / (c# 7) / (f#) /
          (bb 7) / (c# 7) / (c 7) / (eb 7) / (f 7) / (c# 7) / (f#) / (b 7)))
  (setf *blues?* nil)
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement de Goodbye Pork Pie Hat... BPM=77, 48 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
) 

(defun om::charge-bluesBb ()        ;;; BPM=112, 48 beats
  (setf *nbeatsaccord* 2)
  (setf *dureebeat* 535)
  (setf *grille*                     ;;; interbarre = mesure
        '((bb) / (bb) / (bb) / (bb 7) /
          (eb) / (eb) / (bb) / (bb 7) /
          (f) / (eb) / (bb) / (f 7)))   ;;; version a jouer 2 fois plus lentement
  (setf *blues?* t)
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement du blues en Bb sur Ziste... BPM=112, 48 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

(defun om::charge-ziste ()          ;;; BPM=112, 16 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 535)
  (setf *grille*                     ;;; interbarre = demi-mesure
        '((bb) / (bb) / (bb) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))
;;; Lubat-Minvielle
  (setf *blues?* nil)
  (setf *oracle-courant* (om::NewImprovizer))
  ;;;;;(charge-baseziste)   ;;; ancienne base d'impro
  (format t "Chargement de Ziste... BPM=112, 16 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

;(defun om::charge-free ()          ;;; BPM=160, 16 beats
;  (setf *nbeatsaccord* 1)
;  (setf *dureebeat* 375)
;  (setf *grille* 
;        '((c) / (c) / (c) / (c) / (c) / (c) / (c) / (c)))
;  (setf *blues?* nil)
;  (setf *k* 0)                               ;;; pas de substitution
;  (setf *oracle-courant* (om::NewImprovizer))
;  (format t "Chargement free... BPM bidon(=160, 16 beats)~%")
;  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
;  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
;)

(defun om::charge-ornithology ()          ;;; BPM=230, 64 beats (16 mesures)
  (setf *nbeatsaccord* 2)                 ;;; / X / = 2 * 4 beats (tempo dedouble)
  (setf *dureebeat* 261)
  (setf *grille* 
        '((g) / (g) / (g m7) / (c 7) / (f) / (f) / (f m7) / (bb 7) / 
          (eb 7) / (d 7) / (g m7) (c m7) / (g m7) / (b m7) / (e 7) / (a m7) / (d 7)))    ;;; seulement 16 mes/
          ;(g) / (g) / (g m7) / (c 7) / (f) / (f) / (f m7) / (bb 7) / 
          ;(eb 7) / (d 7) / (g m7) (c m7) / (g) / (g) / (g) / (g) / (g)))
  (setf *blues?* nil)
  (setf *k* 0)                               ;;; pas de substitution
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement Ornithology... BPM=230, 64 beats (16 mesures)~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

(defun om::charge-sweeterlove ()          ;;; BPM=120, 16 beats (4 mesures)
  (setf *nbeatsaccord* 4)
  (setf *dureebeat* 500)
  (setf *grille* 
        '((c# m7) / (b m7) / (f# m7) / (a m7) (g m7)))
  (setf *blues?* nil)
  (setf *k* 0)                               ;;; pas de substitution
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement Sweeter Love... BPM=120, 16 beats (4 mesures)~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

|#


;;; ============================================
;;; Fichier 5-Free.lisp / 21 mars 2003
;;; ============================================


;(defun lzupdate ()
;(format t "Mise a jour du dico~%")
;  (when (not (null *baseimprolz*))
;    (setf *dicoimprolz* (om::lzify (om::midi->cross (list (concat-2-coll *baseimprolz*))) *nbiter*))));

;(defun lzimpro ()                                 ;;;canal OM=0 (quelque soit le canal des phrases du dico) 
;(format t "Calcul d'une phrase d'impro~%")
;  (if (null *dicoimprolz*) (progn (format t "Dico vide, jouer une phrase~%") nil)
;      (let ((res (om::cross->chordseq (om::lzgenerate *dicoimprolz* *lengthcontext* *lengthres*))))
;        (formate-5-listes->2-coll (list (om::om/ (om::Lmidic res) 100) (om::Lonset res) (om::Ldur res) (om::Lvel res) (om::om- (om::Lchan res) 1))))))

;(setf *nbiter* 1)
;(setf *lengthcontext* 10)
;(setf *lengthres* 30)

;;; ============================================
;;; Mise bout-a-bout des sequences de la base
;;; ============================================

(defun concat-2-coll (liste-2-coll)
  (let* ((new-liste (mapcar #'2-coll->liste-5uplets liste-2-coll))
         (res ()) 
         (d 0))
    (do ((l new-liste (cdr l)))
        ((null l) (apply #'append (reverse res)))
      (setf res (cons (ajoute-date-init d (car l)) res))
      (setf d (+ d (calcule-duree-totale (car l)))))))

(defun ajoute-date-init (d liste-5uplets)
  (mapcar #'(lambda (5uplet) (list (car 5uplet) (+ d (cadr 5uplet)) (caddr 5uplet) (cadddr 5uplet) (cadddr (cdr 5uplet)))) liste-5uplets))
    
;PROBLEME POUR GERER LE TEMPO??????????????????
; midi->cross ne gere pas les clocks (car 1 octet au lieu de 3 octets)
;(defun calcule-delta-clock (2-coll)
;  (let ((d 0) (nbre-clock 0))
;    (do ((ldiff (car 2-coll) (cdr ldiff)) (lev (cadr 2-coll) (cdr lev)))
;        ((or (null ldiff) (= nbre-clock 2)) d)
;      (when (= (cadr (car lev)) 248) (setf nbre-clock (+ nbre-clock 1)))
;      (when (= nbre-clock 1) (setf d (+ d (cumuler (cdr (car ldiff)))))))))

(defun calcule-duree-totale (liste-5uplets)
  (let ((s 0))
    (do ((l liste-5uplets (cdr l)))
        ((null l) s)
      (setf s (max s (+ (cadr (car l)) (caddr (car l))))))))

;;; ============================================
;;; Conversion Max "midijoue" (2 coll) -> OM liste de 5-uplets
;;; (format accepte par midi->cross)
;;; ============================================

(defun 2-coll->liste-5uplets (2-coll)
  (let ((liste-date-ev (date-diff 2-coll)))
    (noteoff->duree liste-date-ev)))

(setf test-2-coll    ;;; pour tester (debut 2eme phrase d'impro sur "Rain")
'(((1 0 67) (2 0 49) (3 0 46) (4 0 80) (5 0 25) (6 0 45) (7 0 45) (8 0 60) (9 0 30) (10 0 35) (11 0 29) (12 0 23) (13 1 3) (14 0 10) (15 0 60) (16 0 35) (17 0 80) (18 0 35) (19 0 25) (20 0 80)) 
  ((1 248) (2 146 65 36) (3 146 65 0) (4 146 66 35) (5 146 66 0) (6 146 67 34) (7 146 67 0) (8 146 68 32) (9 146 68 0) (10 146 69 60) (11 248) (12 146 69 0) (13 146 70 33) (14 146 70 0) (15 146 71 59) (16 146 71 0) (17 146 72 37) (18 146 73 33 146 72 0) (19 146 73 0) (20 146 74 46)))
)

;;; date-diff retourne une liste de 
;;; (date (144+canal pitch vel)) ou (date (248)) pour les clocks
 
(defun date-diff (2-coll)
  (let ((res ()) (date-courante 0))
    (do ((liste-diff (car 2-coll) (cdr liste-diff)) 
         (liste-ev (cadr 2-coll) (cdr liste-ev)))
        ((null liste-ev) (reverse res))
      (let* ((ev-separes (isole-ev-midi (cdr (car liste-ev))))
             (delta-date (cumuler (cdr (car liste-diff))))
             (ev-dates (mapcar #'(lambda (l) (list date-courante l)) ev-separes)))
        (setf res (append ev-dates res))
        (setf date-courante (+ date-courante delta-date))))))

(defun cumuler (couple-dur) (+ (* 100 (car couple-dur)) (cadr couple-dur))) 

(defun isole-ev-midi (ev)
  (cond ((null ev) ())
        ((and (>= (car ev) 144) (<= (car ev) 159))  ;;; NoteOn
         (cons (list (car ev) (cadr ev) (caddr ev)) (isole-ev-midi (cdddr ev))))
        ((= (car ev) 248)  ;;; Clock
         (cons (list (car ev)) (isole-ev-midi (cdr ev))))
        (t (isole-ev-midi (cdr ev)))))

; (isole-ev-midi '(146 73 33 146 72 0))
(setf liste-date-ev
'((0 (248)) (67 (146 65 36)) (116 (146 65 0)) (162 (146 66 35)) (242 (146 66 0)) (267 (146 67 34)) (312 (146 67 0)) (357 (146 68 32)) (417 (146 68 0)) (447 (146 69 60)) (482 (248)) (511 (146 69 0)) (534 (146 70 33)) (637 (146 70 0)) (647 (146 71 59)) (707 (146 71 0)) (742 (146 72 37)) (822 (146 72 0)) (822 (146 73 33)) (857 (146 73 0)) (882 (146 74 46)))
)

;(noteoff->duree liste-date-ev)

(defun noteoff->duree (liste-date-ev)
  (let ((res ()))
    (do ((l liste-date-ev (cdr l)))
        ((null l) (reverse res))
      (let ((date (car (car l))) (ev (cadr (car l))))
        (when (and (not (null (cdr ev)))      ;;; elimine les clocks 248
                   (not (= 0 (caddr ev))))    ;;; et les NoteOff
          (let* ((canal (- (car ev) 144))
                 (pitch (cadr ev))
                 (date-noteoff (cherche-noteoff canal pitch (cdr l)))   ;;; ATTENTION cherche-noteoff = date, pas duree
                 (dur (if (null date-noteoff) 0 (- date-noteoff date))))
            (when (> dur 0) (setf res (cons (list pitch (car (car l)) dur (caddr ev) canal) res)))))))))

; (cherche-noteoff 2 71 '((647 (146 71 59)) (707 (146 71 0)) (742 (146 72 37)) (822 (146 72 0)) (822 (146 73 33)) (857 (146 73 0)) (882 (146 74 46))))
(defun cherche-noteoff (canal pitch liste-date-ev)
  (cond ((null liste-date-ev) ())
        ((and (not (null (cddr (cadr (car liste-date-ev)))))
              (= pitch (cadr (cadr (car liste-date-ev))))
              (= canal (- (car (cadr (car liste-date-ev))) 144))
              (= 0 (caddr (cadr (car liste-date-ev)))))
         (car (car liste-date-ev)))                       ;;; date correspondant au NoteOff
        (t (cherche-noteoff canal pitch (cdr liste-date-ev)))))

;;; pour tester:
(setf ex-2-coll 
'(((1 0 40) (2 0 10) (3 1 19) (4 0 6) (5 0 25) (6 2 85) (7 4 85) (8 0 0)) 
  ((1 248) (2 145 56 34) (3 145 66 37 145 61 46) (4 145 61 0) (5 145 56 0) (6 145 66 0) (7 248) (8 248))
))


;;; ============================================
;;; Exemple de base d'impro pour lz
;;; ============================================

(setf *baseimprolz*    ;;; 3 phrases de blues en Do
'((((1 16 60) (2 0 5) (3 0 5) (4 6 10) (5 0 30) (6 0 5) (7 1 90) (8 0 5) (9 2 95) (10 0 5) (11 1 65) (12 0 5) (13 2 10) (14 0 65) (15 0 70) (16 0 24) (17 0 6) (18 1 25) (19 0 25) (20 0 70) (21 0 70) (22 0 60) (23 0 45) (24 0 45) (25 2 50) (26 0 15) (27 2 15) (28 0 15) (29 1 55) (30 1 5) (31 1 85) (32 0 60) (33 1 65) (34 2 15) (35 1 15) (36 0 44) (37 0 81) (38 1 20) (39 0 5) (40 0 45) (41 0 55) (42 0 20) (43 0 65) (44 0 10) (45 0 10) (46 1 70) (47 1 0) (48 1 15) (49 1 65) (50 4 0) (51 0 95) (52 0 60) (53 0 35) (54 1 5) (55 0 15) (56 2 55) (57 1 70) (58 2 45) (59 0 70) (60 0 15) (61 0 20) (62 0 70) (63 0 10) (64 0 10) (65 0 35) (66 0 50) (67 0 90) (68 0 10) (69 0 35) (70 0 5) (71 0 90) (72 0 10) (73 0 75) (74 0 10) (75 0 70) (76 0 5) (77 1 20) (78 0 80) (79 0 10) (80 0 70) (81 0 5) (82 0 35) (83 0 10) (84 0 15) (85 0 20) (86 0 40) (87 0 65) (88 0 35) (89 0 15) (90 0 40) (91 0 30) (92 0 5) (93 0 35) (94 0 5) (95 0 45) (96 0 3) (97 0 17) (98 0 85) (99 0 4) (100 4 81) (101 0 45) (102 0 85) (103 0 35) (104 2 90) (105 0 5) (106 0 55) (107 0 20) (108 0 4) (109 0 6) (110 0 29) (111 0 35) (112 0 21) (113 0 55) (114 0 65) (115 0 40) (116 0 40) (117 0 50) (118 0 45) (119 0 30) (120 0 20) (121 0 40) (122 0 20) (123 0 70) (124 0 4) (125 0 16) (126 0 25) (127 2 0) (128 0 5) (129 0 75) (130 0 40) (131 0 75) (132 0 25) (133 0 35) (134 1 5) (135 1 25) (136 0 25) (137 0 55) (138 0 5) (139 0 75) (140 0 10) (141 0 5) (142 0 80) (143 0 5) (144 0 55) (145 0 60) (146 0 80) (147 0 10) (148 0 15) (149 0 40) (150 0 50) (151 0 85) (152 0 10) (153 0 65) (154 0 25) (155 0 35) (156 1 30) (157 0 35) (158 0 10) (159 0 55) (160 0 40) (161 0 45) (162 0 35) (163 0 55) (164 0 15) (165 0 25) (166 0 15) (167 0 75) (168 0 60) (169 0 65) (170 0 40) (171 0 30) (172 0 10) (173 1 5) (174 0 60) (175 0 40) (176 0 75) (177 0 29) (178 0 51) (179 0 25) (180 0 45) (181 0 45) (182 5 95) (183 0 5) (184 4 5) (185 0 10) (186 2 30) (187 1 15) (188 0 25) (189 0 20) (190 0 15) (191 0 60) (192 3 25) (193 2 35) (194 0 10) (195 1 80) (196 0 40) (197 0 14) (198 0 41) (199 3 15) (200 0 10) (201 1 85) (202 0 10) (203 2 65) (204 0 35) (205 0 5) (206 1 85) (207 0 15) (208 0 35) (209 1 0) (210 0 10) (211 0 5) (212 0 10) (213 1 95) (214 0 70) (215 1 65) (216 0 4) (217 0 31) (218 0 25) (219 1 35) (220 0 5) (221 0 10) (222 0 40) (223 1 60) (224 1 95) (225 2 55) (226 0 10) (227 4 30) (228 0 60) (229 0 45) (230 0 10) (231 0 15) (232 0 10) (233 0 25) (234 1 15) (235 0 25) (236 4 5) (237 1 30) (238 0 20) (239 0 70) (240 0 95) (241 0 55) (242 0 10) (243 0 10) (244 3 15) (245 0 75) (246 0 55) (247 0 10) (248 0 75) (249 0 30) (250 0 55) (251 0 20) (252 0 80) (253 0 20) (254 0 15) (255 0 80) (256 0 10) (257 0 60) (258 0 25) (259 0 55) (260 0 25) (261 0 30) (262 0 40) (263 0 55) (264 0 75) (265 0 40) (266 0 10) (267 0 50) (268 0 70) (269 1 25) (270 0 35) (271 1 60) (272 1 5) (273 0 40) (274 0 55) (275 0 75) (276 0 69) (277 0 41) (278 1 15) (279 0 85) (280 1 54) (281 0 6) (282 4 75) (283 0 85) (284 0 20) (285 0 5) (286 0 90) (287 0 10) (288 0 29) (289 1 26) (290 0 10) (291 0 60) (292 0 15) (293 0 90) (294 0 15) (295 1 0) (296 0 10) (297 1 30) (298 0 5) (299 0 54) (300 0 26) (301 0 5) (302 1 30) (303 0 10) (304 0 80) (305 0 20) (306 0 5) (307 1 30) (308 0 20) (309 1 10) (310 0 5) (311 0 5) (312 0 20) (313 3 10) (314 0 40) (315 0 5) (316 2 10) (317 0 50) (318 1 40) (319 1 30) (320 1 50) (321 0 55) (322 1 40) (323 1 5) (324 1 50) (325 1 75) (326 2 0) (327 1 95) (328 1 40) (329 0 10) (330 0 50) (331 0 50) (332 0 40) (333 0 35) (334 0 15) (335 0 60) (336 0 60) (337 1 40) (338 2 35) (339 0 50) (340 0 30) (341 0 15) (342 0 60) (343 0 20) (344 0 35) (345 0 25) (346 0 35) (347 2 85) (348 1 60) (349 0 60) (350 0 35) (351 0 5) (352 0 30) (353 0 15) (354 0 35) (355 0 45) (356 0 35) (357 0 25) (358 1 50) (359 1 5) (360 0 60) (361 0 40) (362 0 60) (363 0 5) (364 0 30) (365 0 50) (366 0 20) (367 1 45) (368 1 75) (369 0 15) (370 1 69) (371 0 11) (372 1 70) (373 0 85) (374 0 30) (375 1 30) (376 2 55) (377 0 35) (378 3 29) (379 0 91) (380 0 55) (381 0 80) (382 1 75) (383 0 5) (384 1 80) (385 2 45) (386 0 30) (387 0 10) (388 2 40) (389 0 10) (390 2 5) (391 0 15) (392 0 25) (393 0 15) (394 2 25) (395 0 15) (396 0 15) (397 0 15) (398 0 40) (399 0 39) (400 3 25) (401 1 71) (402 0 70) (403 3 5) (404 3 60) (405 0 10) (406 1 29) (407 0 6) (408 0 29) (409 0 6) (410 0 0))
   ((1 144 36 54) (2 144 78 78) (3 144 77 78) (4 144 84 78) (5 144 78 0) (6 144 77 0) (7 144 84 0) (8 144 77 88 144 84 90) (9 144 78 84) (10 144 78 0 144 77 0) (11 144 84 0) (12 144 84 78 144 78 74) (13 144 77 78) (14 144 78 0) (15 144 84 0) (16 144 36 0) (17 144 75 38) (18 144 77 0) (19 144 75 0) (20 144 72 37) (21 144 72 0) (22 144 70 25) (23 144 70 0) (24 144 67 29) (25 144 67 0) (26 144 63 16) (27 144 54 28) (28 144 63 0) (29 144 60 23) (30 144 60 0) (31 144 65 26) (32 144 65 0) (33 144 67 36) (34 144 67 0) (35 144 70 25) (36 144 70 0) (37 144 72 39) (38 144 72 0) (39 144 44 13) (40 144 75 51) (41 144 54 0) (42 144 75 0) (43 144 44 0) (44 144 41 23) (45 144 77 39) (46 144 51 20) (47 144 77 0) (48 144 79 53) (49 144 79 0) (50 144 79 24) (51 144 79 0) (52 144 79 16) (53 144 79 0) (54 144 75 27) (55 144 75 0) (56 144 72 18) (57 144 72 0) (58 144 84 15) (59 144 79 22) (60 144 79 0) (61 144 84 0) (62 144 80 27) (63 144 41 0) (64 144 80 0) (65 144 81 50) (66 144 51 0) (67 144 81 0 144 82 39) (68 144 83 65) (69 144 82 0) (70 144 83 0) (71 144 84 51) (72 144 84 0) (73 144 82 35) (74 144 81 46) (75 144 82 0) (76 144 82 39) (77 144 81 0) (78 144 82 0 144 83 59) (79 144 83 0) (80 144 84 54) (81 144 84 0) (82 144 85 35) (83 144 85 0) (84 144 58 20) (85 144 52 14) (86 144 63 9 144 86 53) (87 144 86 0) (88 144 87 19) (89 144 88 55) (90 144 87 0) (91 144 88 0) (92 144 89 35) (93 144 91 37) (94 144 91 0) (95 144 88 32) (96 144 87 44) (97 144 89 0) (98 144 88 0) (99 144 87 0) (100 144 86 38) (101 144 86 0) (102 144 90 27) (103 144 90 0) (104 144 91 14) (105 144 89 25) (106 144 91 0) (107 144 63 0) (108 144 87 42) (109 144 89 0) (110 144 52 0) (111 144 58 0) (112 144 87 0) (113 144 84 30) (114 144 84 0) (115 144 82 26) (116 144 82 0) (117 144 84 35) (118 144 82 20) (119 144 84 0) (120 144 79 34) (121 144 82 0) (122 144 79 0) (123 144 77 21) (124 144 52 24) (125 144 58 13) (126 144 77 0) (127 144 75 25) (128 144 72 24) (129 144 75 0) (130 144 72 0) (131 144 77 29) (132 144 77 0) (133 144 78 22) (134 144 78 0 144 77 36) (135 144 77 0) (136 144 79 38) (137 144 48 26) (138 144 77 21) (139 144 79 0) (140 144 75 29) (141 144 58 0) (142 144 77 0) (143 144 75 0) (144 144 72 28) (145 144 72 0) (146 144 70 26) (147 144 72 23) (148 144 70 0) (149 144 52 0) (150 144 48 0) (151 144 67 37) (152 144 67 0) (153 144 65 28) (154 144 72 0) (155 144 65 0) (156 144 63 31) (157 144 63 0) (158 144 43 21) (159 144 60 18) (160 144 60 0) (161 144 65 41) (162 144 65 0) (163 144 67 45) (164 144 65 25) (165 144 67 0) (166 144 63 41) (167 144 65 0) (168 144 63 0 144 60 29) (169 144 60 0) (170 144 58 24) (171 144 43 0 144 36 31) (172 144 60 30) (173 144 58 0) (174 144 55 23) (175 144 55 0) (176 144 58 37) (177 144 55 18) (178 144 58 0) (179 144 55 0) (180 144 53 12) (181 144 53 0) (182 144 55 20) (183 144 42 18) (184 144 36 0) (185 144 42 0) (186 144 41 30) (187 144 55 0) (188 144 59 39) (189 144 60 0) (190 144 58 28) (191 144 59 0) (192 144 57 44 144 58 0) (193 144 51 30) (194 144 65 37) (195 144 57 0) (196 144 41 0) (197 144 65 0) (198 144 67 45) (199 144 51 0) (200 144 70 33) (201 144 67 0) (202 144 70 0) (203 144 72 55) (204 144 72 0) (205 144 63 54) (206 144 75 56 144 67 52 144 57 57) (207 144 57 0) (208 144 67 0) (209 144 63 0) (210 144 75 0) (211 144 64 61) (212 144 58 49) (213 144 68 46 144 77 67) (214 144 77 0) (215 144 78 65) (216 144 79 72 144 64 0) (217 144 78 0) (218 144 68 0) (219 144 58 0) (220 144 67 34) (221 144 63 33 144 77 56) (222 144 57 40) (223 144 79 0) (224 144 77 0 144 75 33) (225 144 72 38 144 75 0) (226 144 72 0) (227 144 84 63) (228 144 82 23) (229 144 79 30 144 67 0) (230 144 63 0) (231 144 82 0) (232 144 79 0) (233 144 57 0) (234 144 77 25) (235 144 75 35) (236 144 77 0) (237 144 42 24) (238 144 42 0) (239 144 43 29) (240 144 84 0) (241 144 43 0) (242 144 36 21) (243 144 72 22) (244 144 75 0) (245 144 72 0) (246 144 77 23) (247 144 77 0) (248 144 79 40) (249 144 77 21) (250 144 79 0) (251 144 77 0) (252 144 72 25) (253 144 36 0) (254 144 72 0) (255 144 75 33) (256 144 75 0) (257 144 76 40) (258 144 75 24) (259 144 76 0) (260 144 72 32) (261 144 75 0) (262 144 72 0) (263 144 67 21) (264 144 67 0) (265 144 70 19) (266 144 58 18) (267 144 52 31) (268 144 70 0) (269 144 72 29) (270 144 67 34) (271 144 67 0) (272 144 67 17) (273 144 67 0) (274 144 65 17) (275 144 65 0) (276 144 63 27) (277 144 63 0) (278 144 64 15) (279 144 60 26) (280 144 60 0) (281 144 60 21) (282 144 48 18) (283 144 60 0) (284 144 58 0) (285 144 64 0 144 60 25) (286 144 52 0) (287 144 72 0) (288 144 60 0) (289 144 48 0) (290 144 54 58) (291 144 63 58 144 72 51) (292 144 63 0) (293 144 64 32) (294 144 72 0) (295 144 64 0) (296 144 65 80) (297 144 72 51) (298 144 65 0) (299 144 72 0) (300 144 44 35) (301 144 72 44) (302 144 66 70) (303 144 66 0) (304 144 72 0) (305 144 54 0) (306 144 72 49) (307 144 66 69) (308 144 72 0) (309 144 66 0 144 44 0) (310 144 66 33) (311 144 53 51 144 72 52) (312 144 67 92 144 43 45) (313 144 66 0) (314 144 72 0) (315 144 67 0) (316 144 69 64) (317 144 69 0) (318 144 72 78) (319 144 72 0) (320 144 75 82) (321 144 75 0) (322 144 76 86) (323 144 76 0) (324 144 77 102) (325 144 77 0) (326 144 77 88) (327 144 77 0) (328 144 77 88) (329 144 77 0) (330 144 75 25) (331 144 75 0) (332 144 76 53) (333 144 75 25) (334 144 72 55) (335 144 76 0) (336 144 75 0 144 67 48) (337 144 72 0) (338 144 67 0) (339 144 77 68) (340 144 76 65) (341 144 75 50) (342 144 77 0) (343 144 72 59) (344 144 76 0) (345 144 75 0) (346 144 67 62) (347 144 72 0) (348 144 67 0) (349 144 77 57) (350 144 76 68) (351 144 75 48) (352 144 77 0) (353 144 53 0) (354 144 72 47) (355 144 76 0) (356 144 43 0) (357 144 75 0 144 67 33) (358 144 72 0) (359 144 67 0) (360 144 77 57) (361 144 76 65) (362 144 75 35) (363 144 72 44) (364 144 77 0) (365 144 76 0) (366 144 75 0) (367 144 72 0 144 67 37) (368 144 43 30) (369 144 65 35) (370 144 67 0) (371 144 65 0) (372 144 72 28) (373 144 63 35) (374 144 63 0) (375 144 64 23) (376 144 60 22) (377 144 36 29) (378 144 43 0) (379 144 72 0) (380 144 36 0) (381 144 72 24) (382 144 60 0) (383 144 60 18) (384 144 64 0) (385 144 44 21) (386 144 54 20) (387 144 65 30) (388 144 72 0) (389 144 72 29) (390 144 60 0) (391 144 54 0) (392 144 60 17) (393 144 65 0) (394 144 44 0) (395 144 63 30) (396 144 60 0) (397 144 53 23) (398 144 43 19) (399 144 63 0) (400 144 64 19) (401 144 60 18) (402 144 53 0) (403 144 43 0) (404 144 43 17) (405 144 43 0) (406 144 36 22) (407 144 72 0) (408 144 64 0) (409 144 60 0) (410 144 36 0)))
 (((1 1 80) (2 3 95) (3 1 90) (4 3 0) (5 0 10) (6 0 10) (7 1 35) (8 1 9) (9 1 11) (10 1 35) (11 0 60) (12 0 15) (13 0 90) (14 1 70) (15 0 80) (16 1 80) (17 3 75) (18 0 10) (19 6 45) (20 1 20) (21 0 25) (22 0 50) (23 0 5) (24 0 15) (25 0 45) (26 0 75) (27 3 25) (28 0 35) (29 0 15) (30 0 25) (31 0 45) (32 0 30) (33 1 75) (34 0 55) (35 1 50) (36 1 5) (37 1 80) (38 0 55) (39 1 15) (40 1 30) (41 1 85) (42 0 10) (43 1 25) (44 0 85) (45 0 45) (46 0 60) (47 0 80) (48 0 10) (49 1 5) (50 0 80) (51 1 60) (52 0 20) (53 0 40) (54 0 35) (55 0 85) (56 0 30) (57 1 40) (58 0 10) (59 0 60) (60 0 20) (61 0 70) (62 0 60) (63 0 85) (64 0 75) (65 4 20) (66 3 35) (67 0 89) (68 4 21) (69 0 5) (70 0 90) (71 0 25) (72 0 30) (73 0 40) (74 0 60) (75 0 55) (76 0 35) (77 0 5) (78 1 65) (79 0 15) (80 1 15) (81 0 5) (82 1 85) (83 0 5) (84 0 76) (85 0 4) (86 1 46) (87 0 10) (88 0 99) (89 0 6) (90 0 20) (91 1 70) (92 0 10) (93 1 15) (94 2 94) (95 0 31) (96 3 25) (97 0 4) (98 0 81) (99 0 30) (100 2 30) (101 0 10) (102 0 85) (103 3 85) (104 0 25) (105 0 55) (106 0 30) (107 0 5) (108 6 75) (109 0 10) (110 3 15) (111 0 84) (112 0 76) (113 3 0) (114 2 80) (115 2 10) (116 1 25) (117 0 54) (118 1 16) (119 0 65) (120 1 25) (121 1 15) (122 0 15) (123 0 5) (124 1 50) (125 0 65) (126 1 10) (127 1 70) (128 2 25) (129 1 10) (130 0 75) (131 0 10) (132 0 35) (133 0 49) (134 0 31) (135 0 74) (136 0 46) (137 0 55) (138 0 25) (139 0 59) (140 0 16) (141 0 70) (142 0 50) (143 0 35) (144 0 55) (145 0 60) (146 0 55) (147 0 5) (148 0 65) (149 0 35) (150 0 30) (151 0 30) (152 0 80) (153 0 45) (154 1 70) (155 0 20) (156 1 65) (157 0 20) (158 0 80) (159 0 40) (160 0 45) (161 0 90) (162 0 5) (163 0 23) (164 0 42) (165 0 30) (166 3 90) (167 0 10) (168 0 50) (169 0 15) (170 0 35) (171 0 15) (172 0 75) (173 0 15) (174 0 89) (175 1 40) (176 0 6) (177 2 0) (178 0 90) (179 1 40) (180 0 15) (181 0 75) (182 0 10) (183 0 65) (184 0 14) (185 0 91) (186 0 20) (187 0 70) (188 0 5) (189 0 40) (190 0 35) (191 0 99) (192 0 6) (193 0 80) (194 0 5) (195 0 35) (196 3 70) (197 0 45) (198 0 20) (199 0 15) (200 0 60) (201 1 35) (202 0 40) (203 0 80) (204 0 3) (205 0 7) (206 0 60) (207 0 10) (208 0 35) (209 0 25) (210 0 45) (211 0 35) (212 0 15) (213 1 25) (214 0 49) (215 0 41) (216 0 87) (217 0 8) (218 0 70) (219 0 55) (220 0 50) (221 0 20) (222 0 10) (223 0 89) (224 0 16) (225 0 10) (226 0 65) (227 1 0) (228 0 35) (229 1 25) (230 1 5) (231 1 35) (232 1 55) (233 1 35) (234 1 70) (235 1 40) (236 1 85) (237 0 95) (238 1 15) (239 1 15) (240 0 25) (241 3 55) (242 0 5) (243 1 60) (244 0 80) (245 1 75) (246 0 35) (247 1 10) (248 1 15) (249 0 90) (250 0 35) (251 0 25) (252 0 10) (253 0 85) (254 0 90) (255 0 70) (256 0 45) (257 1 30) (258 0 20) (259 0 95) (260 0 15) (261 0 65) (262 0 90) (263 1 0) (264 0 55) (265 0 90) (266 0 35) (267 0 15) (268 0 45) (269 0 35) (270 0 35) (271 0 45) (272 0 70) (273 0 80) (274 1 34) (275 0 26) (276 0 5) (277 0 30) (278 0 5) (279 0 39) (280 1 16) (281 0 5) (282 0 99) (283 0 6) (284 0 50) (285 0 35) (286 0 80) (287 0 70) (288 0 30) (289 0 35) (290 0 15) (291 0 85) (292 0 30) (293 1 65) (294 0 15) (295 0 15) (296 0 75) (297 0 65) (298 0 50) (299 0 10) (300 0 60) (301 0 80) (302 0 5) (303 0 85) (304 0 75) (305 1 30) (306 0 35) (307 0 60) (308 0 5) (309 0 4) (310 0 16) (311 0 54) (312 0 31) (313 0 55) (314 0 15) (315 0 30) (316 0 5) (317 0 90) (318 0 60) (319 1 40) (320 0 35) (321 1 50) (322 0 45) (323 1 5) (324 1 40) (325 2 55) (326 0 90) (327 2 60) (328 0 90) (329 0 5) (330 0 75) (331 0 45) (332 4 45) (333 0 35) (334 0 35) (335 0 80) (336 0 29) (337 0 16) (338 0 95) (339 0 40) (340 2 90) (341 0 5) (342 1 10) (343 0 40) (344 0 40) (345 0 10) (346 0 20) (347 1 10) (348 0 20) (349 0 20) (350 1 5) (351 0 70) (352 0 20) (353 0 80) (354 0 24) (355 0 86) (356 0 40) (357 0 10) (358 0 35) (359 0 55) (360 0 95) (361 0 20) (362 0 70) (363 0 80) (364 1 80) (365 0 20) (366 0 5) (367 0 90) (368 0 15) (369 0 5) (370 0 35) (371 0 60) (372 1 85) (373 0 55) (374 2 99) (375 0 11) (376 3 5) (377 0 5) (378 3 10) (379 0 15) (380 0 10) (381 0 50) (382 0 48) (383 0 42) (384 1 15) (385 0 64) (386 4 16) (387 7 30) (388 0 15) (389 0 5) (390 0 30) (391 0 20) (392 0 0))
  ((1 144 72 68) (2 144 72 0) (3 144 75 57) (4 144 75 0) (5 144 76 86 144 48 24) (6 144 52 31) (7 144 58 16) (8 144 76 0) (9 144 77 94) (10 144 77 0) (11 144 75 60) (12 144 76 84) (13 144 75 0) (14 144 76 0) (15 144 72 68) (16 144 72 0) (17 144 65 49) (18 144 67 39) (19 144 65 0) (20 144 67 0) (21 144 58 0) (22 144 52 0) (23 144 60 23) (24 144 48 0) (25 144 62 18) (26 144 62 0) (27 144 60 0) (28 144 65 29 144 41 36) (29 144 51 20) (30 144 66 35) (31 144 65 0) (32 144 66 0) (33 144 65 38) (34 144 65 0) (35 144 63 52) (36 144 63 0) (37 144 63 20) (38 144 63 0) (39 144 60 27) (40 144 60 0) (41 144 60 25) (42 144 60 0) (43 144 58 26) (44 144 51 0) (45 144 60 41 144 58 0) (46 144 41 0) (47 144 55 32) (48 144 55 0) (49 144 53 30) (50 144 53 0) (51 144 51 24) (52 144 51 0) (53 144 60 0) (54 144 43 29 144 51 27) (55 144 60 20) (56 144 60 0) (57 144 51 0) (58 144 51 26) (59 144 60 31) (60 144 51 0) (61 144 52 28) (62 144 52 0) (63 144 60 0) (64 144 43 0) (65 144 36 36) (66 144 52 30) (67 144 60 26) (68 144 60 0) (69 144 72 72) (70 144 65 74) (71 144 65 0) (72 144 66 42) (73 144 36 0) (74 144 72 0) (75 144 66 0) (76 144 52 0) (77 144 65 63) (78 144 72 63) (79 144 72 0) (80 144 65 0) (81 144 72 45) (82 144 66 67) (83 144 72 0) (84 144 66 0) (85 144 72 41) (86 144 67 67) (87 144 72 0) (88 144 67 0) (89 144 58 42) (90 144 69 66) (91 144 72 30) (92 144 69 0) (93 144 72 0) (94 144 72 46) (95 144 60 59) (96 144 58 0) (97 144 63 34) (98 144 60 0) (99 144 63 0) (100 144 64 16) (101 144 53 23) (102 144 38 29) (103 144 53 0 144 38 0) (104 144 39 26) (105 144 54 22) (106 144 64 0) (107 144 39 0) (108 144 54 0) (109 144 40 24) (110 144 55 20) (111 144 60 31) (112 144 60 0) (113 144 72 0) (114 144 72 92) (115 144 72 0) (116 144 40 0) (117 144 75 86) (118 144 55 0) (119 144 75 0) (120 144 77 86) (121 144 77 0) (122 144 51 27) (123 144 78 86) (124 144 41 24) (125 144 78 0) (126 144 79 92) (127 144 79 0) (128 144 84 98) (129 144 84 0) (130 144 84 26) (131 144 84 0) (132 144 82 26) (133 144 79 43) (134 144 82 0) (135 144 77 33 144 79 0) (136 144 77 0) (137 144 75 46) (138 144 75 0) (139 144 77 25) (140 144 75 25) (141 144 77 0) (142 144 75 0) (143 144 71 16) (144 144 71 0) (145 144 70 17) (146 144 70 0 144 72 22) (147 144 70 34) (148 144 72 0) (149 144 67 35) (150 144 70 0) (151 144 67 0) (152 144 65 38) (153 144 65 0) (154 144 63 26) (155 144 63 0) (156 144 60 29) (157 144 60 0) (158 144 65 23) (159 144 66 33 144 65 0) (160 144 65 15) (161 144 66 0) (162 144 63 29) (163 144 65 0) (164 144 41 0) (165 144 63 0) (166 144 65 22) (167 144 65 0) (168 144 67 31) (169 144 67 0) (170 144 65 35) (171 144 63 45) (172 144 65 0) (173 144 60 25) (174 144 63 0) (175 144 63 22 144 60 0) (176 144 51 0) (177 144 54 53) (178 144 63 0) (179 144 60 31) (180 144 60 0) (181 144 62 40) (182 144 63 53) (183 144 62 0) (184 144 63 0) (185 144 64 34) (186 144 64 0) (187 144 65 34) (188 144 66 49) (189 144 65 0) (190 144 66 0) (191 144 67 58) (192 144 67 0) (193 144 44 31 144 68 47) (194 144 69 23) (195 144 68 0) (196 144 72 61 144 69 0) (197 144 71 19) (198 144 71 0) (199 144 54 0) (200 144 44 0) (201 144 53 18 144 43 29) (202 144 72 0) (203 144 75 32) (204 144 76 57) (205 144 53 0) (206 144 75 0) (207 144 75 48) (208 144 43 0) (209 144 76 0) (210 144 72 28) (211 144 75 0) (212 144 72 0) (213 144 67 20) (214 144 67 0) (215 144 70 23) (216 144 43 33) (217 144 70 0) (218 144 72 28) (219 144 70 17) (220 144 67 45) (221 144 70 0) (222 144 67 0) (223 144 65 30) (224 144 65 0) (225 144 43 0) (226 144 36 31) (227 144 63 25) (228 144 63 0) (229 144 64 22) (230 144 60 16) (231 144 60 0) (232 144 60 22) (233 144 60 0) (234 144 60 18) (235 144 60 0) (236 144 60 18) (237 144 60 0) (238 144 60 25) (239 144 64 0) (240 144 36 0) (241 144 39 39) (242 144 60 0) (243 144 54 21) (244 144 72 0) (245 144 69 29) (246 144 69 0) (247 144 72 66) (248 144 72 0) (249 144 75 67) (250 144 54 0) (251 144 75 0) (252 144 39 0) (253 144 77 68) (254 144 77 0) (255 144 78 68) (256 144 78 0) (257 144 79 43) (258 144 82 46) (259 144 79 0) (260 144 82 0) (261 144 84 86) (262 144 84 0) (263 144 87 82) (264 144 87 0) (265 144 89 90) (266 144 89 0) (267 144 53 46) (268 144 38 44) (269 144 90 76) (270 144 91 30) (271 144 91 0) (272 144 90 0) (273 144 91 92) (274 144 91 0) (275 144 94 53) (276 144 95 58) (277 144 96 45) (278 144 95 0) (279 144 96 0) (280 144 94 0) (281 144 96 78) (282 144 95 80) (283 144 96 0) (284 144 95 0) (285 144 94 16) (286 144 94 0) (287 144 94 23) (288 144 91 39) (289 144 94 0) (290 144 89 33) (291 144 91 0) (292 144 89 0) (293 144 87 39) (294 144 84 31) (295 144 87 0) (296 144 38 0) (297 144 84 0) (298 144 89 29) (299 144 89 0 144 53 0) (300 144 91 35) (301 144 89 25 144 91 0) (302 144 87 27) (303 144 89 0) (304 144 87 0) (305 144 89 62) (306 144 89 0) (307 144 87 23) (308 144 44 27) (309 144 54 23) (310 144 87 0) (311 144 89 27) (312 144 87 25) (313 144 89 0) (314 144 84 27) (315 144 87 0) (316 144 84 0) (317 144 79 31) (318 144 79 0) (319 144 82 34) (320 144 82 0) (321 144 54 0 144 84 54) (322 144 84 0 144 44 0) (323 144 53 34 144 79 41) (324 144 79 0) (325 144 43 48) (326 144 72 29) (327 144 72 0) (328 144 77 80) (329 144 78 41) (330 144 77 0) (331 144 77 63) (332 144 78 0) (333 144 77 0) (334 144 75 20) (335 144 77 48) (336 144 77 0) (337 144 72 27) (338 144 75 0) (339 144 72 0) (340 144 70 34) (341 144 70 0) (342 144 72 49) (343 144 70 16 144 53 0) (344 144 67 46) (345 144 70 0) (346 144 67 0) (347 144 65 28) (348 144 65 0) (349 144 43 0) (350 144 63 27) (351 144 72 0) (352 144 60 29) (353 144 63 0) (354 144 60 0) (355 144 42 28) (356 144 65 32) (357 144 43 34 144 66 49) (358 144 65 0 144 42 0) (359 144 66 0) (360 144 65 31) (361 144 65 0) (362 144 63 21) (363 144 63 0) (364 144 65 38) (365 144 36 25) (366 144 65 0) (367 144 43 0 144 67 41) (368 144 65 23) (369 144 67 0) (370 144 63 43) (371 144 65 0) (372 144 63 0 144 60 28) (373 144 72 50) (374 144 60 0) (375 144 41 20) (376 144 36 0) (377 144 41 0) (378 144 42 19) (379 144 42 0 144 63 23) (380 144 43 22) (381 144 66 18) (382 144 63 0) (383 144 66 0) (384 144 67 19) (385 144 64 1) (386 144 60 23) (387 144 31 21) (388 144 64 0) (389 144 67 0 144 60 0) (390 144 72 0) (391 144 31 0) (392 144 43 0)))
 (((1 0 65) (2 2 45) (3 0 85) (4 2 14) (5 2 26) (6 5 25) (7 1 5) (8 1 54) (9 6 11) (10 0 35) (11 0 10) (12 0 60) (13 0 25) (14 1 25) (15 0 10) (16 0 45) (17 0 95) (18 2 15) (19 0 5) (20 0 25) (21 0 5) (22 2 50) (23 1 44) (24 0 26) (25 1 0) (26 2 90) (27 0 40) (28 6 59) (29 8 31) (30 2 45) (31 0 15) (32 2 40) (33 0 4) (34 2 96) (35 0 15) (36 2 80) (37 0 5) (38 2 85) (39 1 10) (40 0 5) (41 4 75) (42 5 30) (43 1 80) (44 2 80) (45 0 70) (46 0 20) (47 0 50) (48 2 15) (49 0 25) (50 3 30) (51 0 10) (52 0 60) (53 0 55) (54 0 30) (55 0 15) (56 2 10) (57 0 30) (58 2 50) (59 0 10) (60 0 45) (61 1 75) (62 2 50) (63 1 5) (64 1 20) (65 0 25) (66 0 5) (67 0 40) (68 0 15) (69 0 45) (70 0 65) (71 0 60) (72 0 25) (73 0 20) (74 0 50) (75 0 20) (76 1 95) (77 0 70) (78 1 50) (79 1 30) (80 0 60) (81 1 30) (82 0 10) (83 0 10) (84 3 20) (85 1 10) (86 4 95) (87 1 85) (88 0 25) (89 0 30) (90 1 90) (91 1 65) (92 0 10) (93 1 30) (94 0 50) (95 1 95) (96 0 10) (97 1 55) (98 0 65) (99 2 50) (100 1 40) (101 1 17) (102 2 98) (103 5 80) (104 0 90) (105 1 30) (106 1 65) (107 1 5) (108 1 15) (109 1 15) (110 1 40) (111 0 70) (112 0 5) (113 0 70) (114 0 35) (115 0 50) (116 0 4) (117 0 41) (118 0 85) (119 0 40) (120 1 10) (121 0 90) (122 0 15) (123 1 55) (124 0 15) (125 1 80) (126 4 55) (127 0 70) (128 2 40) (129 0 60) (130 0 15) (131 0 90) (132 0 5) (133 0 35) (134 0 5) (135 0 75) (136 1 20) (137 0 65) (138 1 94) (139 0 76) (140 1 60) (141 0 65) (142 4 0) (143 0 30) (144 1 80) (145 2 20) (146 0 15) (147 0 20) (148 3 45) (149 0 30) (150 0 10) (151 0 10) (152 0 5) (153 0 45) (154 0 45) (155 2 90) (156 3 35) (157 0 25) (158 4 60) (159 1 15) (160 1 45) (161 2 55) (162 3 99) (163 0 51) (164 0 10) (165 12 45) (166 0 15) (167 0 70) (168 0 75) (169 0 5) (170 1 5) (171 0 80) (172 0 15) (173 1 15) (174 0 70) (175 0 10) (176 1 10) (177 0 5) (178 0 65) (179 0 5) (180 1 15) (181 0 15) (182 0 49) (183 0 21) (184 1 15) (185 1 25) (186 1 50) (187 0 5) (188 0 65) (189 0 40) (190 0 35) (191 0 20) (192 0 45) (193 0 5) (194 3 49) (195 0 11) (196 0 10) (197 0 25) (198 2 55) (199 0 10) (200 0 5) (201 0 70) (202 0 40) (203 1 10) (204 0 5) (205 1 40) (206 0 10) (207 0 30) (208 0 15) (209 0 60) (210 0 70) (211 0 10) (212 0 95) (213 0 50) (214 2 5) (215 0 35) (216 5 80) (217 0 25) (218 4 40) (219 0 15) (220 0 24) (221 0 6) (222 2 95) (223 0 5) (224 0 5) (225 1 75) (226 0 50) (227 0 25) (228 2 70) (229 0 15) (230 0 5) (231 0 5) (232 0 10) (233 0 10) (234 2 85) (235 3 5) (236 0 5) (237 0 10) (238 1 45) (239 0 85) (240 0 15) (241 0 4) (242 0 6) (243 0 35) (244 0 50) (245 0 35) (246 2 65) (247 3 45) (248 0 85) (249 0 30) (250 1 30) (251 4 85) (252 0 95) (253 0 10) (254 1 95) (255 1 40) (256 1 25) (257 0 20) (258 0 50) (259 0 90) (260 0 45) (261 0 80) (262 0 25) (263 1 50) (264 0 20) (265 1 90) (266 0 30) (267 1 10) (268 0 70) (269 0 60) (270 1 80) (271 0 0))
  ((1 144 60 18) (2 144 60 0) (3 144 63 60) (4 144 63 0 144 64 36) (5 144 48 29) (6 144 58 28) (7 144 60 32 144 64 0) (8 144 58 0) (9 144 60 0) (10 144 65 35) (11 144 66 47) (12 144 65 0) (13 144 66 0) (14 144 65 25) (15 144 63 24) (16 144 65 0) (17 144 63 0) (18 144 65 46) (19 144 65 0) (20 144 41 26) (21 144 63 26) (22 144 48 0) (23 144 60 22) (24 144 60 0) (25 144 63 0) (26 144 63 20) (27 144 63 0) (28 144 51 21) (29 144 41 0) (30 144 69 56) (31 144 69 0) (32 144 68 47) (33 144 68 0) (34 144 67 41) (35 144 51 0 144 67 0) (36 144 65 33 144 48 21) (37 144 72 32) (38 144 65 0) (39 144 63 23) (40 144 63 0) (41 144 64 19) (42 144 58 18) (43 144 64 0) (44 144 72 0) (45 144 65 44) (46 144 65 0) (47 144 66 42) (48 144 66 0 144 67 58) (49 144 67 0) (50 144 72 61) (51 144 70 28) (52 144 72 0) (53 144 69 54) (54 144 70 0) (55 144 69 0) (56 144 67 30) (57 144 67 0) (58 144 75 40) (59 144 75 0) (60 144 76 46) (61 144 58 0) (62 144 76 0) (63 144 77 94) (64 144 77 0) (65 144 76 66) (66 144 42 25) (67 144 52 24 144 48 0) (68 144 75 50) (69 144 76 0) (70 144 72 27) (71 144 75 0) (72 144 72 0) (73 144 67 17) (74 144 69 12) (75 144 69 0) (76 144 67 0) (77 144 71 12) (78 144 71 0) (79 144 72 74) (80 144 52 0) (81 144 72 0) (82 144 51 23) (83 144 41 27) (84 144 42 0) (85 144 67 24) (86 144 67 0) (87 144 70 59) (88 144 67 26) (89 144 70 0) (90 144 67 0) (91 144 70 68) (92 144 70 0) (93 144 67 34) (94 144 67 0) (95 144 65 30) (96 144 65 0) (97 144 63 23) (98 144 63 0) (99 144 60 23) (100 144 60 0) (101 144 65 24) (102 144 65 0) (103 144 65 29) (104 144 65 0) (105 144 41 0 144 65 22) (106 144 65 0) (107 144 65 31) (108 144 65 0) (109 144 65 30) (110 144 65 0) (111 144 63 25) (112 144 63 0) (113 144 64 60) (114 144 63 22) (115 144 64 0) (116 144 51 0) (117 144 60 34) (118 144 63 0) (119 144 60 0) (120 144 55 40) (121 144 48 25) (122 144 58 27) (123 144 55 0) (124 144 58 0) (125 144 60 49) (126 144 36 26) (127 144 53 20) (128 144 53 0) (129 144 55 24) (130 144 55 0) (131 144 58 26) (132 144 58 0) (133 144 55 18) (134 144 53 23) (135 144 55 0) (136 144 53 0) (137 144 51 28) (138 144 51 0) (139 144 52 1) (140 144 48 0) (141 144 52 0) (142 144 52 44) (143 144 48 20) (144 144 52 0) (145 144 36 0) (146 144 44 33) (147 144 48 0) (148 144 60 0) (149 144 44 0) (150 144 53 36) (151 144 58 41) (152 144 62 56) (153 144 52 38) (154 144 52 0) (155 144 58 0 144 59 34) (156 144 65 30) (157 144 43 33 144 62 0) (158 144 59 0) (159 144 53 0) (160 144 53 19) (161 144 53 0) (162 144 55 28) (163 144 31 49) (164 144 55 0) (165 144 65 0) (166 144 66 88 144 72 88) (167 144 67 96) (168 144 66 0) (169 144 72 0) (170 144 67 0) (171 144 67 49 144 72 52) (172 144 67 0) (173 144 72 0) (174 144 67 65 144 72 52) (175 144 67 0) (176 144 72 0) (177 144 67 53) (178 144 72 37) (179 144 72 0) (180 144 67 0) (181 144 67 59) (182 144 72 30) (183 144 72 0) (184 144 67 0) (185 144 72 33 144 67 37) (186 144 72 0) (187 144 67 0) (188 144 72 26) (189 144 67 37) (190 144 72 0) (191 144 66 42) (192 144 67 0) (193 144 65 23) (194 144 66 0) (195 144 65 0) (196 144 72 36) (197 144 31 0) (198 144 63 19) (199 144 63 0) (200 144 60 25) (201 144 72 0) (202 144 43 0) (203 144 60 0) (204 144 42 23) (205 144 63 30) (206 144 63 0) (207 144 60 29) (208 144 43 32) (209 144 42 0) (210 144 60 0) (211 144 63 26) (212 144 72 19) (213 144 63 0) (214 144 64 14) (215 144 36 24) (216 144 43 0) (217 144 64 0) (218 144 60 23) (219 144 36 0) (220 144 41 28) (221 144 65 44) (222 144 69 45 144 72 0) (223 144 60 0) (224 144 69 0) (225 144 72 57) (226 144 41 0) (227 144 65 0) (228 144 60 35) (229 144 44 21) (230 144 63 32) (231 144 54 20) (232 144 66 32) (233 144 60 0) (234 144 72 0) (235 144 72 28) (236 144 60 21) (237 144 63 0) (238 144 66 0) (239 144 54 0) (240 144 63 27) (241 144 60 0 144 44 0) (242 144 53 28) (243 144 67 24) (244 144 72 0) (245 144 63 0) (246 144 64 19) (247 144 72 28) (248 144 43 26) (249 144 64 0) (250 144 67 0) (251 144 72 0) (252 144 75 74) (253 144 76 51) (254 144 75 0) (255 144 76 0) (256 144 77 98) (257 144 77 0) (258 144 75 22) (259 144 75 0) (260 144 75 18) (261 144 72 41) (262 144 75 0) (263 144 72 0 144 67 25) (264 144 67 0) (265 144 70 31) (266 144 70 0) (267 144 72 40) (268 144 53 0 144 43 0) (269 144 72 0) (270 144 48 30) (271 144 48 0)))
))













;;; ============================================
;;; Fichier 5-Beats.lisp / 27 fevrier 2003
;;; ============================================
;;; ex 6-Voicings.lisp


#|



;;; PROBLEME: rejouer un sequence de beats labelises dans OM

;(mf-info->chord-seq l) donne:
;#<chord-seq #x113B622E>

;il y a 2 fonctions disponibles dans OM, mais pas visibles dans les menus :  
; (defmethod chord-seq->mf-info ((self chord-seq))  
; (defmethod mf-info->chord-seq ((self list))   
;Dans les preferences (menu file) tu peux regler un param global "delta" qui contrle 
;l'aggrgation de dates quasi simultanes en accords. 

; (mf-info midifile) donne une liste de 5uplets (pitch onset dur vel canal)
; Fonctions de UserLibrary:LZ 2.1:LZ sources:LZ.lisp
; - midi->cross prend en argument soit midifile, soit liste-5uplets mise dans une liste
; - lzify prend en argument le resultat de midi->cross,
; et effectue l'analyse lz
; - lzgenerate prend en argument le resultat de lzify,
; et genere une nouvelle sequence
; - cross->chordseq prend en argument le resultat de lzgenerate,
; et le traduit en chordseq

;(mf-info->chord-seq l) coupe les durees pour les aligner sur l'inter-onset; 
;Normalement tu peux desactiver cela en inhibant le keyword :legato comme ci-dessous : 
 
(defmethod mf-info->chord-seq ((self list))  
 (let* ((chords (make-quanti-chords self *global-deltachords*))
        (lonset (mapcar #'offset chords))
        (last-note (first (inside (first (last chords))))))
   (setf lonset (append lonset (list (+ (extent->ms last-note) (first (last lonset))))))
   (make-instance 'chord-seq
     :lmidic chords
     :lonset lonset  ;;;
     :legato 100 )))


;;;-----------------------------
;;; Pour tester le son dans OM: reglage des instruments cf. Algomix et DJHarm0.0
;;; - dans le menu du Workspace, faire File/Preferences, puis cliquer l'icone MidiShare
;;; -> Global Output par defaut est SY77
;;; -> choisir  IAC Bus #1


(defun choix-inst (canal instrument)
  (send-ctrl canal 32 19)            ;;; Unity banque 19-mars.uds
  (send-pgm canal instrument)) 

(defun init-inst ()
  (choix-inst 0 3)   ;;; piano: Wurli
  (choix-inst 1 7)   ;;; bass:  Fretless
  (choix-inst 9 11)  ;;; drums: GM drums
  (send-ctrl 0 7 120)
  (send-ctrl 1 7 120)        ;;; control change 7 = volume   Midi: piano127
  (send-ctrl 9 7 127))

(defun send-pgm (ca n)
   (let ((event (midishare::MidiNewEv midishare::typeProgChange)))	; ask for a new note event
     (unless (%null-ptr-p event)	; if the allocation was succesfull
       (midishare::chan event ca)			; set the midi channel to 0 (means channel 1)
       (midishare::port event 0)			; set the destination port to Modem
       (midishare::pgm event n)
       (midishare::MidiSendIm *refnum* event))	; send the note immediatly
     ))	

(defun send-ctrl (ca n val)
   (let ((event (midishare::MidiNewEv midishare::typeCtrlChange)))	; ask for a new note event
     (unless (%null-ptr-p event)	; if the allocation was succesfull
       (midishare::chan event ca)			; set the midi channel to 0 (means channel 1)
       (midishare::port event 0)			; set the destination port to Modem
       (midishare::ctrl event n)
       (midishare::field event 1 val)
       (midishare::MidiSendIm *refnum* event))	; send the note immediatly
     ))	



;;; formate-liste-events->liste-beats
;;; Elements pour vieille version qui ne marche pas

(defun cherche-accords (un-beat)
  (loop for element in un-beat
        if (= (fifth element) 13) collect (ajoute-chiffre (traduc-deg (first element)) (fourth element))))

;;; ATTENTION: ne gere pas les enharmonies (Ex: g# et non ab)
;;; -> (c c# d eb e f f# g g# a bb b)

(defun traduc-deg (i)
  (case (mod i 12) (0 'c) (1 'c#) (2 'd) (3 'eb) (4 'e) (5 'f) (6 'f#) (7 'g) (8 'g#) (9 'a) (10 'bb) (11 'b)))

(defun ajoute-chiffre (deg i)
  (cons deg (case i (1 ()) (2 (list 'm7)) (3 (list 7)))))

(defun duree-inter-beat (liste-5uplets)   ;;; duree entre beat init / beat suivant ou dernier noteoff
  (let ((date-init (caar liste-5uplets)) (max-time 0) (interbeat 0))
    (do ((l (cdr liste-5uplets) (cdr l)))
        ((or (null l) (= (cadr (car l)) 248))
         (setf interbeat (if (null l) (- max-time date-init) (- (caar l) date-init)))
         interbeat) 
      (setf max-time (max max-time (+ (second (car l)) (third (car l))))))))

(defun regroupe-beat-5uplet (liste-5uplets)
  (cond ((or (null liste-5uplets)                                 ;;; arret: soit liste vide, 
             (and (null (cdr liste-5uplets))                      ;;;        soit dernier element = clock
                  (= (length (car liste-5uplets)) 2))) ())   
        (t (let* ((d (caar liste-5uplets))
                  (interbeat (duree-inter-beat liste-5uplets)) 
                  (tmp (1er-beat-5uplet-avec-clock liste-5uplets d (+ d interbeat))) 
                  (beat (car tmp)) 
                  (reste (cadr tmp)))
             (if (null beat) (regroupe-beat-5uplet reste)   ;;; BUG: le beat peut etre vide??????????????????
                 (cons beat (regroupe-beat-5uplet reste)))))))

(defun 1er-beat-5uplet-avec-clock (liste-5uplets date-init date-max)
  (1er-beat-aux (cdr liste-5uplets) date-init date-max () (cdr liste-5uplets)))

(defun 1er-beat-aux (l date-init date-max beat reste)
  (cond ((or (null l) (= (length (car l)) 2)) 
         (list (reverse beat) reste))
        (t (let* ((h (car (first l))) 
                  (o (max (second (car l)) date-init)) 
                  (d (third (car l)))   ;;; duree note
                  (v (fourth (car l))) 
                  (c (fifth (car l))))
             (cond ((<= (+ o d) date-max)                 ;;; cas d'une note a l'interieur du beat
                    (let ((new-5uplet (list h 
                                            (- o date-init) 
                                            d 
                                            v 
                                            c)))
                      (1er-beat-aux (cdr l) date-init date-max (cons new-5uplet beat) (cdr reste))))
                   (t (let* ((new-dur (- date-max o))     ;;; cas d'une note depassant sur le beat suivant
                             (new-ev1 (list h 
                                            (- o date-init) 
                                            new-dur 
                                            v 
                                            c))
                             (new-ev2 (list h               ;;; reliquat de note reporte dans le beat suivant
                                            date-max
                                            (- d new-dur)
                                            v
                                            c)))
                        (1er-beat-aux (cdr l) date-init date-max (if (> new-dur 10) ;;; ignore notes trop proches du beat suivant
                                                                   (cons new-ev1 beat) 
                                                                   beat) 
                                                                 (sort (cons new-ev2 (cdr reste)) #'classe-date)))))))))


(defun classe-date (x y)
  (let ((d1 (if (= (length x) 2) (first x) (second x)))
        (d2 (if (= (length y) 2) (first y) (second y)))
        (type2 (if (= (length y) 2) 'beat 'note)))
    (or (< d1 d2)
        (and (= d1 d2)    ;;; meme date => beat < note
             (eq type2 'note)))))

(defun note-off->duree (liste-ev)
  (loop for l on liste-ev
        with pitchs-vus = nil
        if (= (length (car l)) 2) collect (car l) into liste-clocks     ;;; clock=(date 248)
        else
        if (not (member (third (car l)) pitchs-vus)) 
        append (note-off->duree-pitch l (third (car l))) into liste-notes   ;;; note=(pitch date duree vel can)
        and do (push (third (car l)) pitchs-vus) end
        finally return (sort (append liste-clocks liste-notes) #'classe-date)))

(defun note-off->duree-pitch (liste-ev pitch)
  (let ((l (filtre-pitch liste-ev pitch)))    ;;; gerer le cas de la derniere note sans NoteOff
    (loop while (cdr l) 
          for element1 = (first l)
          for element2 = (second l)
          if (> (fourth element1) 0)
          collect (list (third element1) (first element1) (- (first element2) (first element1)) (fourth element1) (- (second element1) 144))
          and do (setf l (cddr l))
          else do (setf l (cdr l)))))

(defun filtre-pitch (liste pitch)
  (loop for element in liste
        if (and (> (length element) 2) (= (third element) pitch)) collect element))


;;; ============================================
;;; VOICINGS "RAIN"
;;; Ajout de phrases live a liste de beats harmo

;(setf liste-beat-live (live->beat live))
;(setf play-beat-live (regroupe-beat liste-beat-live))

(defun ajoute-beat-live (liste-beat)
  (let ((liste-live ()) (liste-impro *baseimpro*) (res ()))
    (do ((l liste-beat (cdr l)))
        ((null l) (reverse res))
      (when (null liste-impro) (setf liste-impro *baseimpro*))
      (when (null liste-live) (setf liste-live (live->beat (car liste-impro))) (setf liste-impro (cdr liste-impro)))
      (setf res (cons (mixage-acc (car l) (car liste-live)) res))
      (setf liste-live (cdr liste-live)))))

(defun mixage-acc (couple-acc-beat beat-live)
  (let ((new-5uplets (append (cadr couple-acc-beat) beat-live)))
    (list (car couple-acc-beat) (sort new-5uplets #'(lambda (x y) (< (cadr x) (cadr y)))))))

(defun live->beat (2-coll)
  (let ((liste-5uplets (2-coll->liste-5uplets 2-coll)))
    (beat-5uplet liste-5uplets)))

(setf phrase2-base         ;;; pour tester (debut 2eme phrase d'impro sur "Rain")
'(((1 0 67) (2 0 49) (3 0 46) (4 0 80) (5 0 25) (6 0 45) (7 0 45) (8 0 60) (9 0 30) (10 0 35) (11 0 29) (12 0 23) (13 1 3) (14 0 10) (15 0 60) (16 0 35) (17 0 80) (18 0 35) (19 0 25) (20 0 80) )
  ((1 248) (2 146 65 36) (3 146 65 0) (4 146 66 35) (5 146 66 0) (6 146 67 34) (7 146 67 0) (8 146 68 32) (9 146 68 0) (10 146 69 60) (11 248) (12 146 69 0) (13 146 70 33) (14 146 70 0) (15 146 71 59) (16 146 71 0) (17 146 72 37) (18 146 73 33 146 72 0) (19 146 73 0) (20 146 74 46) )
))

;;; ============================================
;;; Transformation des blocs harmo en beats
;;; ============================================

(defun grille->beat (liste-blocs)
  (let ((res ()))
    (do ((l liste-blocs (cdr l)))
        ((null l) (reverse res))
      (setf res (append (reverse (bloc->beat (car l))) res)))))

(defun bloc->beat (m)
  (let* ((liste-acc (bloc-accords m))
         (liste-5uplets (faire-5uplets m))
         (l1 (beat-accords liste-acc))
         (l2 (beat-5uplet liste-5uplets)))
    (setf l2 (longueur-min l2 l1))            ;;; bug dans conversion ->liste-5uplets (notes trop longues a la fin)
    (om::mat-trans (list l1 l2))))

(defun longueur-min (l lcourte) (if (null lcourte) () (cons (car l) (longueur-min (cdr l) (cdr lcourte)))))

(defun faire-5uplets (m)
  (let ((5-listes (list (bloc-haut m) (bloc-onset m) (bloc-dur m) (bloc-vel m) (bloc-canal m))))
    (2-coll->liste-5uplets (formate-5-listes->2-coll 5-listes))))

(defun beat-accords (liste-acc)
  (cond ((null liste-acc) ())
        (t (let ((new-acc (creer-accord (ote-marque (accord-degre (caar liste-acc))) (accord-chiffre (caar liste-acc)))))
             (if (= (cadr (car liste-acc)) 1)
               (cons new-acc (beat-accords (cdr liste-acc)))
               (cons new-acc (cons new-acc (beat-accords (cdr liste-acc)))))))))

(defun beat-5uplet (liste-5uplets)
  (let ((l liste-5uplets) (res ()))
    (do ((d 0 (+ d 484)))
        ((null l) (reverse res))
      (let* ((tmp (1er-beat-5uplet l d)) (beat (car tmp)) (reste (cadr tmp)))
        (setf res (cons beat res))
        (setf l reste)))))

(defun 1er-beat-5uplet (liste-5uplets date-init) 
  (1er-beat-5uplet-avec-clock liste-5uplets date-init (+ date-init 484)))



(setf ex-2-coll    ;;; arrangement de grille
'(((1 2 42) (2 2 42) (3 2 42) (4 2 42) (5 4 84) (6 4 84) (7 4 84) (8 2 42) (9 1 21) (10 1 21) (11 2 42) (12 4 84) (13 0 16) (14 2 26) (15 4 84) (16 2 42) (17 2 42) (18 2 42) (19 2 42) (20 1 21) (21 1 21) (22 1 21) (23 0 8) (24 1 13) (25 0 16) (26 2 42) (27 2 42) (28 2 42) (29 2 42) (30 0 16) (31 2 42) (32 2 42) (33 2 42) (34 2 42) (35 0 0)) 
((1 144 57 69 144 61 69 144 63 69 144 65 69 144 68 69 145 35 97) (2 145 47 97 145 35 0) (3 145 35 97 145 47 0) (4 145 47 97 145 35 0) (5 144 56 69 144 62 69 144 66 69 144 70 69 145 40 97 145 47 0 144 57 0 144 61 0 144 63 0 144 65 0 144 68 0) (6 144 55 69 144 61 69 144 65 69 144 69 69 145 39 97 144 56 0 144 62 0 144 66 0 144 70 0 145 40 0) (7 144 54 69 144 58 69 144 59 69 144 63 69 145 32 97 144 55 0 144 61 0 144 65 0 144 69 0 145 39 0) (8 145 44 97 145 32 0) (9 145 32 97 145 44 0) (10 145 44 97 145 32 0) (11 144 55 69 144 59 69 144 62 69 144 66 69 144 71 69 145 31 97 145 44 0 144 54 0 144 58 0 144 59 0 144 63 0) (12 145 43 97 145 31 0) (13 145 38 97) (14 145 43 0) (15 144 56 69 144 62 69 144 66 69 144 70 69 145 40 97 145 38 0 144 55 0 144 59 0 144 62 0 144 66 0 144 71 0) (16 144 55 69 144 59 69 144 61 69 144 66 69 145 33 97 144 56 0 144 62 0 144 66 0 144 70 0 145 40 0) (17 145 45 97 145 33 0) (18 144 52 69 144 56 69 144 58 69 144 63 69 145 30 97 145 45 0 144 55 0 144 59 0 144 61 0 144 66 0) (19 145 37 97 145 30 0) (20 145 42 97 145 37 0 144 63 0) (21 144 64 69) (22 145 42 0) (23 144 68 69) (24 144 64 0) (25 144 68 0 144 52 0 144 56 0 144 58 0) (26 144 51 69 144 55 69 144 57 69 144 59 69 144 62 69 145 29 97) (27 145 41 97 145 29 0) (28 145 29 97 145 41 0) (29 145 41 97 145 29 0) (30 145 41 0 144 51 0 144 55 0 144 57 0 144 59 0 144 62 0) (31 144 56 69 144 60 69 144 62 69 144 64 69 144 67 69 145 34 97) (32 145 46 97 145 34 0) (33 145 34 97 145 46 0) (34 145 46 97 145 34 0) (35 145 46 0 144 56 0 144 60 0 144 62 0 144 64 0 144 67 0)))
)

|#