(in-package :om)


;;; changed to 500 in microplayer.lisp !!
(setf *max-buf-size* 50000)



#|

;;; corrig dans le kernel 

;============================================================================================================
;;; debug OM

;;; raaaaaaaahhhhh
;;; > Error in process Initial: value #<simple-vector 12> is not of the expected type string.
;;; > While executing: #<ccl::standard-kernel-method initialize-instance :after (menu-item)>


(defmethod ccl::window-title ((self t)) "whatever")
(defmethod enforce-string ((self string))  self)
(defmethod enforce-string ((self vector))
  (loop with str = (make-string (length self))
        for i from 0 to (1- (length self)) do (setf (elt str i) (elt self i))
        finally return str))

(in-package :om-api)
(defun om-new-leafmenu (title action &optional rac)
   (let ((newmenu (make-instance 'menu-item :menu-item-title (om::enforce-string title) :menu-item-action action)))
     (when rac
       (set-command-key newmenu rac))
     newmenu))
(in-package :om)


|#


;============================================================================================================
;;; envoyer sur le port 3000
;(osc-send '((\toto 1 2 3)) "169.254.190.131" 3007)



;;; OSC receive process
;;; waits for messages in the form of
;;;           /lisp func-name arg1 arg2 ...
;;; or        /lisp-string "<S-expr>"
;;; or        /omsend obj-name method-name arg1 arg2 ...
;;; if method-name is a slot name, performs (setf (slot-value obj method-name) arg1) where obj is the object referred
;;; by obj-name. All names are packaged in :om.
;;; 

#|

;;; intgr dans le kernel sous le nom de receive-packet

(in-package :oa)
(defun receive-packet-1 (endpoint buffer length)
  (ccl::rlet ((unit-data :TUnitdata)
         (addr :TNetBuf)
         (opt :TNetBuf)
         (udata :TNetBuf)
         (source :INetAddress)
         (flag :OTFlags))
    (setf (cl-user::pref addr :TNetBuf.maxlen) (ccl::record-length :INetAddress)
          (cl-user::pref addr :TNetBuf.buf) source
          (cl-user::pref opt :TNetBuf.maxlen) 0 
          (cl-user::pref opt :TNetBuf.buf) (ccl::%null-ptr)
          (cl-user::pref udata :TNetBuf.maxlen) length  
          (cl-user::pref udata :TnetBuf.buf) buffer
          (cl-user::pref unit-data :TUnitData.addr) addr
          (cl-user::pref unit-data :TUnitData.opt) opt
          (cl-user::pref unit-data :TUnitData.udata) udata)
      (if (eql  #$kOTNoError (#_OTRcvUData endpoint unit-data flag)) 
        (cl-user::pref (cl-user::pref unit-data :tunitdata.udata) :tnetbuf.len)
        nil)))
(in-package :om)


|#




;;; handles arriving OSC Packets, routes messages to Lisp functions or methods
(defun OSC-listen (endpoint buffer)
   (let ((result nil))
     (loop while t do
           (handler-case
             (let ((bufsize (oa::receive-packet endpoint buffer *max-buf-size*))
                   bundle)
               (if (null bufsize)
                 (process-allow-schedule)
                 (progn
                   (setf bundle (parse-buffer buffer 0 bufsize))
                   ;(print (list "=====" bundle))
                   (osc-route-bundle bundle)
                   )))
             (error (any)
                    (error any)
                    )))))

(defun osc-route-bundle (bundle)
  (handler-case
    (loop for item in bundle collect
          (cond
           ((stringp (car item)) 
            (cond ((string-equal (car item) "/mo") (funcall #'handle-osc-midi-evt (cdr item)))
                  ((string-equal (car item) "/ph") (funcall #'handle-osc-midi-phrase (cdr item)))
                  ((string-equal (car item) "/omsend") (osc-method-invoke item))
                  ((string-equal (car item) "/lisp") (print item) 
                   (execute-message item)
                   )
                  ((string-equal (car item) "/lisp-string") (execute-message-from-string item))
                  (t (format t "~D~" item))))
           ((consp (car item)) (osc-route-bundle item))
           (t nil))
          )
    (error (any) (print "Error trying to route OSC message") (print any) NIL))
  )



(defun osc-method-invoke (invocation)
  (let ((object (symbol-value (intern  (string-upcase  (second invocation)) :om)))
        (method  (intern  (string-upcase  (third invocation)) :om)))
    (if (slot-exists-p  object method)
      (setf (slot-value object method) (fourth invocation))
      (apply  (symbol-function method) object (cdddr invocation)))))



(defclass osc-listener ()
  ((buffer :accessor buffer)
   (endpoint :accessor endpoint)
   (process :accessor process)))


(defun new-osc-listener (port bufsize name)
  (let ((self (mki 'osc-listener)))
    (setf (buffer self) (#_newptrclear bufsize)
          (endpoint self) (om-make-receive-connection port)
          (process self) (cl-user::process-run-function (list :name name) #'OSC-listen  (endpoint self)   (buffer self)))
    self))


(defmethod kill-osc-listener ((self osc-listener))
  (kill-receive (process self)  (endpoint self) (buffer self))
  (process-enable (process self)))



;--------------------------------------------
;

(in-package :oa)


;;; these 2 function sshould be modified in the kernel
;;; for now, removing bind_endpoint because it looks for opentransport.lisp


#|
; this is just for the 'print'
; needs opentransport.lisp ?
(defun bind-endpoint (endpoint host port )    
  (ccl::rlet ((errP :osstatus))
    (let* ((bindreq (#_OTAllocInContext endpoint #$T_BIND #$T_ADDR errP (ccl::%null-ptr)))
           (bindret (#_OTAllocInContext endpoint #$T_BIND #$T_ADDR errP (ccl::%null-ptr)))
           (status (cl-user::pref errP :osstatus)))
      (declare (dynamic-extent bindreq bindret))
      (let* ((netbuf (cl-user::pref bindreq :tbind.addr)))
        (declare (dynamic-extent  netbuf))
        (setf (cl-user::pref netbuf :tnetbuf.len) (ccl::record-length :inetaddress))
        (#_OTInitInetAddress (cl-user::pref netbuf :tnetbuf.buf) port host)
        (setq status (#_OTBind endpoint bindreq bindret)))
      (format t "binded to port ~a" (cl-user::pref (cl-user::pref (cl-user::pref bindret :tbind.addr) :tnetbuf.buf) :inetaddress.fport))
      (unless (ccl::%null-ptr-p bindreq) (#_OTFree bindreq #$T_BIND))
      (unless (ccl::%null-ptr-p bindret) (#_OTFree bindret #$T_BIND))
      status)))

|#

;;; this is in OpenTRansportProvider.lisp
(defconstant $AF_INET 2)


; this is for having several ongoing osc-out connections (1911, 1912)
; added parameter connport

(defun om-make-send-connection2 (host port connport)
  (make-instance 'UDPsocket
    :host (ccl::make-record :inetaddress
                            :faddresstype #$AF_INET
                            :fhost (string2host (ccl::string host))
                            :fport port)
    :endpoint (new-udp-conn connport))
  )

;--------------------------------------------


(in-package :om)

(defclass osc-end-point ()
  ((connport :accessor connport :initarg :connport)
   (port :accessor port :initarg :port)
   (host :accessor host :initarg :host)
   (conn :accessor conn)
   (buf :accessor buf)
   (ptr :accessor ptr)))


(defmethod initialize-instance ((self osc-end-point) &rest initargs)
    (declare (ignore initargs))
    (call-next-method)
    (setf (conn self)
          (oa::om-make-send-connection2 (host self) (port self) (connport self))
          (buf self)
          (om-make-pointer *max-buf-size*)
          (ptr self)
          (om-make-pointer *max-buf-size*))
    (osc::OSC_initBuffer (buf self) *max-buf-size* (ptr self))
    self)

(defun new-osc-end-point (host port connport)
  (make-instance 'osc-end-point :host host :port port :connport connport))

(defmethod send-osc ((self osc-end-point) bundle)
  (unless (null (conn self))
    (let ((tt (osc-make-time-tag 0 1)))
      ;(osc::OSC_initBuffer (buf self) *max-buf-size* (buf self))
      (write-a-bundle bundle (buf self) tt)
      (om-send-udp-packet (conn self) (osc::OSC_getPacket (buf self))
                          (osc::OSC_packetSize (buf self)))
      (osc::OSC_resetBuffer (buf self))
      )))

(defmethod close-osc-end-point ((self osc-end-point))
  (when (conn self)
    (om-close-udp-connection (conn self))
    (osc::OSC_resetBuffer (buf self))
    (om-free-pointer (ptr self)) 
    (setf (conn self) nil)
    t))



#|
(setf x (new-osc-end-point "127.0.0.1" 3101 1910))
(setf y (new-osc-end-point "127.0.0.1" 3102 1911))

(loop do (print (time  (send-osc y l))))
(send-osc y (list (list '/ma (ms:midigettime))))



(setf l (loop for i from 1 to 20 collect (list '/mt  1000 1000 1000 1000 1000 1000 1000 10000)))

(close-osc-end-point x)
(close-osc-end-point y)


|#