(in-package :om)


(defclass improviser (agent)
  ( (oracle :accessor oracle :initarg :oracle)
    (continuity :initform 0 :initarg :continuity :accessor continuity)
    (max-continuity :initform 8 :initarg :max-continuity :accessor max-continuity)
    (start-play :initform nil :accessor start-play :initarg :start-play )
    (stop :initform nil :accessor stop :initarg :stop)
    (gindex :initform 0  :accessor gindex :initarg :gindex :type integer)
    (durseg :initform 0  :accessor durseg :initarg :durseg :type integer)
    (blocmode :initform nil  :accessor blocmode :initarg :blocmode)t
    (startOnPhrase :initform nil  :accessor startOnPhrase :initarg :startOnPhrase)
    (blocStartPhrase :initform -1  :accessor blocStartPhrase :initarg :blocStartPhrase)
    
    ; en index sur l'oracle
    (CurRegion :initform (list 1 1) :accessor CurRegion :initarg :CurRegion)
    
    ; en pourcentage de la longueur de l'oracle
    (CurRegion% :initform (list 0 100) :accessor CurRegion% :initarg :CurRegion%) 
    (AbsoluteRegions :initform NIL :accessor AbsoluteRegions :initarg :AbsoluteRegions)

    (PoursuiteMode :initform NIL :accessor PoursuiteMode :initarg :PoursuiteMode)

    (Poursuite :initform 5000 :accessor Poursuite :initarg :Poursuite)

    (*impro-tabou-states* :initform NIL :accessor  *impro-tabou-states* :initarg :*impro-tabou-states*)
    (*suffix-quality-thresh* :initform 0.25 :accessor *suffix-quality-thresh* :initarg :*suffix-quality-thresh*)
    (*min-suffix-length* :initform *min-suffix-length* :accessor *min-suffix-length* :initarg :*min-suffix-length*)
    (*Tabou-list-length* :initform 8 :accessor *Tabou-list-length* :initarg :*Tabou-list-length*)
    (*proba-if-1-sol* :initform 0.5 :accessor *proba-if-1-sol* :initarg :*proba-if-1-sol*)
    (*Close-edge-dist* :initform 15 :accessor *Close-edge-dist* :initarg :*Close-edge-dist*)
    
    (*regional-impro* :initform NIL :accessor *regional-impro* :initarg :*regional-impro*)
    
    )
  )



(defmethod suppleance<-> ((oracle oracle) (etat integer))
  (loop for state = (gethash etat (hashsuppl-> oracle)) then (gethash state (hashsuppl<-> oracle))
        while state
        append  (cons state (suppleance<-> oracle state ))))

(defmethod otext ((self improviser) (etat integer))
  (otext (oracle self) etat))

(defmethod PhraseBeginning ((self improviser) (etat integer))
  (startPhrase (otext (oracle self) etat)))

(DefAgentMessage reset-main :now ((self improsupervizer))
  (let ((awake-learn (awake-p (a-learner 0))) (awake-impro (awake-p (a-improvizer 0))))
    (stop-impro self)
    (stop-learning self)
    (let ((oracle (make-instance 'coracle :comparateur 'CompareEvents :lrsMode t)))
      (setf (oracle (a-improvizer 0)) oracle
            (oracle (a-learner 0)) oracle))
    (reinitialize-instance (a-improvizer 0) :curRegion (list 1 1)
                           :CurRegion% (list 0 100) :*impro-tabou-states* nil
                           :*regional-impro* nil
                           )
    ;(setf (continuity (a-improvizer 0)) 0)
    ;(setf (gindex (a-improvizer 0)) 0)
    ;(setf (durseg (a-improvizer 0)) 0)
    ;(setf (curRegion (a-improvizer 0)) (list 1 1))
    ;(setf (curRegion% (a-improvizer 0)) (list 0 100))
    ;(setf (*impro-tabou-states* (a-improvizer 0)) nil)
    (synchronize-max-om-time)
    (when awake-learn (start-learning self))
    (when awake-impro (start-impro self))))

(defmethod clean-up ((self improviser))
  (empty-queue (agent-listening-queue self))
  (reinitialize-instance self 
                         :gindex 0 :durseg 0 :stop nil :continuity 0))




(defmethod RegionStart% ((self improviser))
  (max 1 (round (* (/ (first (CurRegion% self)) 100) (maxetat self)))))

(defmethod RegionEnd% ((self improviser))
  (min (maxetat self) (round (* (/ (second (CurRegion%  self)) 100) (maxetat  self)))))

(defmethod RegionStart ((self improviser)) (first (CurRegion self)))
(defmethod RegionEnd ((self improviser)) (second (CurRegion self)))


(defmethod RegionStartIndex ((self improviser))
  (if (AbsoluteRegions self)
    (first (CurRegion self))
    (RegionStart% self)))

(defmethod RegionEndIndex ((self improviser))
  (if (AbsoluteRegions self)
    (second (CurRegion self))
    (RegionEnd% self)))

(defmethod ImproLeftBound ((self improviser))
  (if (*regional-impro* self)
    (RegionStartIndex self)
    1))

(defmethod ImproRightBound ((self improviser))
  (if (*regional-impro* self)
    (RegionEndIndex self)
    (MaxEtat self)))



(defmethod BufTOffset ((self improviser) i)
  ;; the audio buffer offset should be stored in the crossevt object, not in the midi events
  (loop for evt in (midiset (otext (oracle self) i))
        for offset = (seventh evt)
        when (plusp offset) minimize offset))


(defmethod BufTOffset ((self oracle) i)
  ;; the audio buffer offset should be stored in the crossevt object, not in the midi events
  (loop for evt in (midiset (otext  self i))
        for offset = (seventh evt)
        when (plusp offset) minimize offset))


(defmethod PhraseNum ((self improviser) i)
  (phraseNumber (otext (oracle self) i)))



;-------------------------------------------

(defmethod suffix-in-region ((self improviser) (suffix integer))
;(print (list suffix (ImproLeftBound self)(ImproRightBound self)))
  (<= (max 1 (1- (ImproLeftBound self))) suffix (1- (ImproRightBound self))))


(defmethod move-linearly ((self improviser))
  ;(print (list (gindex self) (ImproLeftBound self) (ImproRightBound self)))
  (if (and (>= (gindex self) (ImproLeftBound self))
           (< (gindex self) (ImproRightBound self)))
    (impro-output-1-event self (1+ (gindex self)))
    (impro-failure self)))

#|
(defmethod move-to-end-scan  ((self improviser))
;(print (list (gindex self) (second (scanregion self))(ImproRightBound self)))
  (loop for i from (gindex self) to (min (second (scanregion self)) (ImproRightBound self))
        do (move-linearly self)))
|#

(defmethod move-to-end-scan  ((self improviser))
;(print (list (gindex self) (second (scanregion self))(ImproRightBound self)))
  (loop for i from (gindex self) to  (second (scanregion self))
        ; this is because there might be a failure -> gindex:=0
        if (> (gindex self) 0)  do (move-linearly self)
        else do (return)))


(defmethod filter-all-suffixes ((self improviser) bwsuffixes fwsuffixes bw-fwsuffixes)
  ;(print (list bwsuffixes fwsuffixes bw-fwsuffixes)) 
  ;(print (list  fwsuffixes bw-fwsuffixes)) 
  (let ((best-candidates 
         (firstn 
          (sort (loop for s in (nconc  bwsuffixes fwsuffixes bw-fwsuffixes)
                      if (and (suffix-in-region self (SSuffix s))
                              (<= (SQuality s) (*suffix-quality-thresh* self) )
                              (not (= (Sindex s) (SSuffix s)))
                              (or (*regional-impro* self)
                                  (and (not (< (- (maxetat self) (SSuffix s)) 
                                               (*Close-edge-dist* self)))
                                       (or (not (close-to-the-edge? self))
                                           (< (SSuffix s) (SIndex s)))))
                          (not (< (Slength s) 
                                  (if (close-to-the-edge? self)
                                    1 
                                    (*min-suffix-length* self))))
                          (<= (SQuality s) 
                              (if (close-to-the-edge? self)
                                0.5
                                (*suffix-quality-thresh* self) )))
                      collect s) 
                #'> :key #'SLength)
          *max-nb-jump-candidates*)))
    (dprint "best Candidate NA : ~a~%" (mapcar #'Slength best-candidates))
    (if (and best-candidates (null (rest best-candidates))) ; only one ?
      (with-proba (*proba-if-1-sol* self)
        (progn (dprint "--------1 solution, I take it ~%")
               (first best-candidates))
        (progn (dprint "--------1 solution, I DON'T take it ~%")
               nil))
      (stoch-choose-suffix   best-candidates)
      )))



(defmethod continue-impro ((self improviser))
  (if (not (time-to-scan-ahead self))
    (move-linearly self)
    (let* ((bwsuffixes (all-suffixes-bw self (scanregion self)))
           (fwsuffixes (all-suffixes-fw self (scanregion self)))
           (bwfwsuffixes (all-suffixes-bw-fw self bwsuffixes))
           (choice (filter-all-suffixes self bwsuffixes fwsuffixes bwfwsuffixes)))
      (if (null choice)
        ;(progn (setf (continuity self) 0) (move-linearly self))
        (move-to-end-scan self)
        (move-to-suffix self choice)))))



(defmethod all-suffixes-bw ((self improviser) (scanregion list))
  (loop for index from (first scanregion) to (second scanregion)
        nconc
        (loop for supp = (suppleance self index) then (suppleance self supp)
              for previous = index then (suppleance self previous)
              while (and supp (> supp 0))
              for dur-ref = (suffixduration self index (lrs  self previous))
              for dur-suffix = (suffixduration self supp (lrs  self previous))
              if (not (memq supp (*impro-tabou-states* self)))
              collect (list (suffix-quality self index supp (lrs self previous) dur-ref dur-suffix)
                            index
                            supp
                            (lrs self previous)
                            dur-ref
                            dur-suffix)
              )))

(defmethod all-suffixes-fw ((self improviser) (scanregion list))
  (loop for index from (first scanregion) to (second scanregion)
        nconc 
        (loop for supp in (suppleance<-> (oracle self) index)
              for dur-ref = (suffixduration self index (lrs self supp))
              for dur-suffix = (suffixduration self supp (lrs self supp))
              if (not (memq supp (*impro-tabou-states* self)))
              collect (list (suffix-quality self index supp (lrs self supp) dur-ref dur-suffix)
                            index
                            supp
                            (lrs self supp)
                            dur-ref
                            dur-suffix))))

#|
(defmethod all-suffixes-bw-fw ((self improviser) (scanregion list))
  (loop for index2 from (first scanregion) to (second scanregion)
        for index = (suppleance self index2)
        nconc
        (and index 
             (> index 0)
             (loop for supp in (suppleance<-> (oracle self) index)
                   for dur-ref = (suffixduration self index2 (min (lrs self supp)(lrs self index2)))
                   for dur-suffix = (suffixduration self supp (min (lrs self supp)(lrs self index2)))
                   if (not (memq supp (*impro-tabou-states* self)))
                   collect (list (suffix-quality self index2 supp (lrs self supp) dur-ref dur-suffix)
                                 index2
                                 supp
                                 (min (lrs self supp)(lrs self index2))
                                 dur-ref
                                 dur-suffix)))))
|#

(defmethod all-suffixes-bw-fw ((self improviser) (suffixes-bw list))
  (loop for s in suffixes-bw
        for index = (third s)
        for index2 = (second s)
        nconc
        (and index 
             (> index 0)
             (loop for supp in (suppleance<-> (oracle self) index)
                   for dur-ref = (suffixduration self index2 (min (lrs self supp)(lrs self index2)))
                   for dur-suffix = (suffixduration self supp (min (lrs self supp)(lrs self index2)))
                   if (not (memq supp (*impro-tabou-states* self)))
                   collect (list (suffix-quality self index2 supp (lrs self supp) dur-ref dur-suffix)
                                 index2
                                 supp
                                 (min (lrs self supp)(lrs self index2))
                                 dur-ref
                                 dur-suffix)))))
        


(defmethod task  ((self improviser))
  (if (or (stop self) (<= (maxetat (oracle self)) 0))
    (process-allow-schedule)
    (cond
     ;; new impro
     ((zerop (gindex self))
      (setf (continuity self) 0)
      ;(setf   *impro-tabou-states*  nil)
      (cond 
       ((and (blocmode self) (>= (blocStartPhrase self) 0))
        (start-new-impro-on-phrase-nb self))
       
       ((StartOnPhrase self)
        (start-new-impro-on-phrase self))
       
       (t
        (start-new-impro-in-region self))))
     
     ;; continuing   
     (t ; (in-continuity self)
      (continue-impro self))))
  
  (unless (blocmode self)
    (process-allow-schedule))
  ;(when (> (durseg self) *max-impro-ahead* ) (setf (durseg self) 0) (process-allow-schedule) )
  )



(defmethod close-to-the-edge? ((self improviser))
  (>=
   (gindex self) 
   (- (maxetat self)
      (max (*Close-edge-dist* self) (round (max-continuity self) *scanregion-divisor* )))))



(defmethod move-to-suffix  ((self improviser) suffix)
  (loop for i from (1+ (gindex self)) to (SIndex suffix)
        do (impro-output-1-event self i))
  (setf (continuity self) 0)
  (dprint "~%~%Jumping from ~a to ~a length ~a qual ~,2f ~%~%" 
          (Sindex suffix) (1+ (SSuffix suffix)) (Slength suffix) (Squality suffix))
  (impro-output-1-event self (1+ (SSuffix suffix)))
  (push (SSuffix suffix) (*impro-tabou-states* self))
  (when (> (length (*impro-tabou-states* self)) (*Tabou-list-length* self)) 
    (setf  (nthcdr (*Tabou-list-length* self) (*impro-tabou-states* self))  nil))
  )

#|
(defmethod start-new-impro-in-region  ((self improviser))
  (let* ((left (ImproLeftBound self))
         (right (ImproRightBound self))
         (start (+ left (random (1+ (-  right left))))))
    (dprint "Starting at : ~a~%" start)
    (impro-output-1-event self start)))
|#


(defmethod start-new-impro-in-region  ((self improviser))
  (let* ((left (RegionStartIndex self))
         (right (RegionEndIndex self))
         (start (+ left (random (1+ (-  right left))))))
    (dprint "Starting at : ~a~%" start)
    (impro-output-1-event self start)))


#|
(defmethod start-new-impro-in-region-exact  ((self improviser))
  (dprint "Starting at : ~a~%" (ImproLeftBound self))
  (impro-output-1-event self (ImproLeftBound self)))
|#


(defmethod start-new-impro-in-region-exact  ((self improviser))
  (dprint "Starting at : ~a~%" (RegionStartIndex self))
  (impro-output-1-event self (RegionStartIndex self)))



;; starts on phrase beginning
(defmethod start-new-impro-on-next-phrase  ((self improviser))
;(print (StartOnPhrase self))
  (let ((left  (ImproLeftBound self)))
    (catch
      'tag-fblm
      (loop for i from (max 1 (min left (1- (MaxEtat (oracle self))))) to (1- (MaxEtat (oracle self)))
            do (when (startPhrase (otext (oracle self) i))
                 (impro-output-1-event self i)
                 (format t "~%Starting on phrase ~a~%" (phraseNumber (otext (oracle self) i)))
                 (throw 'tag-fblm i)))
      (loop for i from (max 1 (min left (1- (MaxEtat (oracle self))))) downto 1
            do (when (startPhrase (otext (oracle self) i))
                 (impro-output-1-event self i)
                 (format t "~%Starting on phrase ~a~%" (phraseNumber (otext (oracle self) i)))
                 (throw 'tag-fblm i)))
      (impro-failure self))))





#|
(defmethod start-new-impro-on-phrase ((self improviser))
  (if (absoluteRegions self)
    (start-new-impro-in-region-exact self)
    (start-new-impro-on-next-phrase self) ))

|#

(defmethod start-new-impro-on-phrase ((self improviser))
    (start-new-impro-in-region-exact self))



;------------------------------------------------

(defmethod task ((self osc-midi-player))
  (let ((event nil)  bundle)
    (if (>= (cursegdur self) (segdur self))
      (if (not (ready-for-next-seg self))
        (process-allow-schedule)
        (progn 
          (let ((av (- (next-time self)  (get-internal-real-time)))) 
            (when (< av 100) (format t  "~%short avance : ~a~%" av)))
          (setf (seg-onset self)
                (max (next-time self) (+ (get-internal-real-time) 100)))
          (send-osc-midi (list (list '/ma 'start)))
          ;(dprint "SENDING BUNDLE ~%")
;(print (cursegdur self))
          (setf bundle (loop for evt in (unslice (nreverse (segment self)) (seg-onset self))
                             collect (osc-note-at evt)))
          (send-osc-midi  bundle)
          (send-osc-midi (list (list '/ma 'stop)))
          (setf (next-time self) (+ (seg-onset  self) (cursegdur self))
                (cursegdur self) 0
                (segment self) nil)))
      (if (null (setf event (listens self)))
        (process-allow-schedule)
        (progn
          (incf (cursegdur self) (duration event))
          (push event (segment self))
          (process-allow-schedule) )))))



;------------------------------------------------
; Bloc mode


(defun New-Bloc-Improvizer (improviser)
  (make-instance 'improviser :oracle (oracle improviser) :state :asleep
                 :startOnPhrase (startOnPhrase improviser)
                 :max-continuity (max-continuity improviser)
                 :curRegion (copy-list (CurRegion improviser))
                 :CurRegion% (copy-list (CurRegion% improviser))
                 :*impro-tabou-states* nil
                 :*regional-impro* (*regional-impro* improviser)
                 :AbsoluteRegions (AbsoluteRegions improviser)
                 :PoursuiteMode   (PoursuiteMode improviser)
                 :Poursuite (Poursuite improviser)
                 :*suffix-quality-thresh* (*suffix-quality-thresh* improviser)
                 :*min-suffix-length* (*min-suffix-length* improviser)
                 :*Tabou-list-length* (*Tabou-list-length* improviser)
                 :*proba-if-1-sol* (*proba-if-1-sol* improviser)
                 :*Close-edge-dist* (*Close-edge-dist* improviser) ))

                 

(defmethod New-bloc-impro ((self ImproSupervizer) startphrase)
  (setf (a-improvizer 1)
        (new-bloc-improvizer  (a-improvizer 0))
        (a-unslicer 1)
        (new-unslicer "unslicer-1")
        (a-player 2)
        (new-Bosc-midi-player "Bosc-player"))
  (setf (blocmode (a-improvizer 1)) T 
        (blocStartPhrase (a-improvizer 1)) startphrase
         )
  (connect (a-improvizer 1) :toport 4)
  (connect (a-unslicer 1) :fromport 4)
  (connect (a-unslicer 1) :toport 5)
  (connect (a-player 2) :fromport 5))


;-------------------------------------------------


(setf *max-play-ahead* 150)
(setf *max-impro-ahead* 100)




(defmethod task ((self improsupervizer))
  (event-dispatch)
  (let ((playahead (look-time-ahead (a-player 1))))
    (cond
     ((>= playahead *max-play-ahead*) ;(print playahead)
      (too-fast (a-improvizer 0)) )
     (t (too-slow (a-improvizer 0)))))
  (when (and (a-improvizer 1) ; ongoing bloc improvizer
             (eq (bloc-impro-state self) 'terminated)
             )
    (kill-bloc-impro self)
    (print "BLOC SENT")
    )
  (when (and (PoursuiteMode (a-improvizer 0)) (> (poursuite (a-improvizer 0)) 0))
    (set-poursuite-region (a-improvizer 0)))
  
  ;(sleep .050)
  (process-allow-schedule)                
  )


(defmethod set-poursuite-region ((self improviser))
  (when (> (MaxEtat self) 0)
    (loop for i from (Maxetat self) downto 1
          with base = (+ (duration (otext (oracle self) (Maxetat self))) (BufTOffset self (Maxetat self)))
          for offset = (BufTOffset self i)
          do (when (>= (- base offset) (poursuite self))
               (setf (first (CurRegion self)) i)
               (loop-finish))
          finally (when (<= i 0) (setf (first (CurRegion self)) 1)))
    (setf (second (curRegion self)) (Maxetat self))))

;--------------------------------
; OSC Interface

; this one in %
(defun OMaxImpRange (min max)
  (setf (CurRegion%  (a-improvizer 0) ) (list min max)))


; this one in time
; shoud use dichotomic search
(defun OMaxSetTimeRange (tmin tmax)
  (let ((self (a-improvizer 0)))
    (loop for i from 0 to (1- (maxetat self))
          for j from 1
          for t1 =  0 then (BufTOffset self i)
          for t2 =  (BufTOffset self j)
          if (<= t1 tmin t2) do (setf (first (CurRegion self)) (max i 1))
          if (<= t1 tmax t2) do (setf (second (CurRegion self)) (max i 1)) (return)  )
    (when (> (first (CurRegion self)) (second (CurRegion self)))
      (dprint "Uncoherent Region selection, setting to 0-max~%")
      (setf (first (CurRegion self)) 1
            (second (CurRegion self)) (max 1 (1- (maxetat self)))))
    (format t "~%Setting Region to ~d ~d~%" (first (CurRegion self)) (second (CurRegion self)))))

; this one in phrase numbers
#|
(defun OMaxSetPhraseRange (tmin tmax)
  (let ((self (a-improvizer 0)))
    (loop for i from 1 to (1- (maxetat self))
          for j from 2
          ;for lastphrase = (PhraseNum self j)
          with p1 with p2
          when (and (null p1) (<= (PhraseNum self i) tmin (PhraseNum self j)))
          do (setf p1 j)
          when (<= (PhraseNum self i) tmax (PhraseNum self j)) 
          do (setf p2 j) (loop-finish)
          finally 
          do (setf (first (CurRegion self)) (or p1 1) (second (CurRegion self)) (or p2 j)) (return)  )
    (when (> (first (CurRegion self)) (second (CurRegion self)))
      (dprint "Uncoherent Region selection, setting to 1-max~%")
      (setf (first (CurRegion self)) 1
            (second (CurRegion self)) (max 1 (1- (maxetat self)))))
    (format t "~%Setting Region to ~d ~d~%" (first (CurRegion self)) (second (CurRegion self)))))
|#



(defun OMaxSetPhraseRange (tmin tmax)
  (let ((self (a-improvizer 0)))
    (loop for i from 1 to (maxetat self)
          with p1 with p2
          do
          (when (and (PhraseBeginning self i) (= (PhraseNum self i) tmin))
            (setf p1 i))
          (when (and (PhraseBeginning self i) (= (PhraseNum self i) (1+ tmax)) (> i 1))
            (setf p2 (1- i))
            (loop-finish))
          finally (setf (first (CurRegion self))  (or p1 1) 
                        (second (CurRegion self)) (or p2 (max 1 (maxetat self)))))
    (format t "~%Setting Region to ~d ~d~%" (first (CurRegion self)) (second (CurRegion self)))))

(defun OMaxSetTimePhraseRange (tmin tmax)
  (let ((self (a-improvizer 0))
        (left 2) (right 1) p1 p2)
    (loop for i from 0 to (1- (maxetat self))
          for j from 1
          for t1 =  0 then (BufTOffset self i)
          for t2 =  (BufTOffset self j)
          if (<= t1 tmin t2) do (setf left (max i 1))
          if (<= t1 tmax t2) do (setf right j) (return)  )
    (cond ((> left right)
           (dprint "Uncoherent Region selection, setting to 1-max~%")
           (setf left 1
                 right (max 1 (1- (maxetat self)))))
          (T  (loop for i from left downto 1
                    do (when (startPhrase (otext (oracle self) i))
                         (setf (first (CurRegion self)) i)
                         (setf p1 (PhraseNumber (otext (oracle self) i)))
                         (return)))
              (loop for i from right to (maxetat self)
                    do (when (startPhrase (otext (oracle self) i))
                         (setf (second (CurRegion self)) i)
                         (setf p2 (PhraseNumber (otext (oracle self) i)))
                         (return))
                    finally (setf (second (CurRegion self)) (maxetat self)))))
    (format t "~%Setting Region to ~a ~a phrases ~a ~a~%" 
            (first (CurRegion self)) (second (CurRegion self))
            p1 p2 )))



(defun OMaxToggleRegionalImpro (onoff)
  (setf (*regional-impro* (a-improvizer 0)) (= onoff 1)))


(defun OMaxSetPoursuite (dur)
  (setf (poursuite (a-improvizer 0)) dur))

(defun OMaxSetImproMode (mode)
  (case mode
    (1 (setf (AbsoluteRegions (a-improvizer 0)) T
             (poursuiteMode  (a-improvizer 0)) nil))
    
    (2 (setf (AbsoluteRegions (a-improvizer 0)) NIL))
    
    
    (3 (setf (AbsoluteRegions (a-improvizer 0)) T
             (poursuiteMode (a-improvizer 0)) T))))




;RegionalImpro on / off
;si on soit AbsoluteRegions, soit % regions, soit poursuite


(defun OMaxSetQuality (quality)
  ; 1 excellent 2 moyen (defaut) 3 low
  (let ((self (a-improvizer 0)))
    (setf (*impro-tabou-states* self) nil)
    (case quality
      (1 
       (setf (*suffix-quality-thresh* self) 0.205)
       (setf (*min-suffix-length* self) 4)
       (setf (*Tabou-list-length* self) 8)
       (setf (*proba-if-1-sol* self) 0.5) )
      (2
       (setf (*suffix-quality-thresh* self) 0.25)
       (setf (*min-suffix-length* self) 3)
       (setf (*Tabou-list-length* self) 8)
       (setf (*proba-if-1-sol* self) 0.5) )
      (3
       (setf (*suffix-quality-thresh* self) 0.35)
       (setf (*min-suffix-length* self) 2)
       (setf (*Tabou-list-length* self) 5)
       (setf (*proba-if-1-sol* self) 0.75) )
      (4
       (setf (*suffix-quality-thresh* self) 0.5)
       (setf (*min-suffix-length* self) 1)
       (setf (*Tabou-list-length* self) 2)
       (setf (*proba-if-1-sol* self) 0.99) )
      
      )))



;;;--------------------------------------------------------

; compatibility with old oracles

(defclass* orchestre ()
  (
   (improvizer-array :initform ()
                     :initarg :improvizer-array :accessor improvizer-array)
   (nb-improvizers :initform 4 :initarg :nb-improvizers :accessor nb-improvizers)
   (nbeatsaccord :initform 1 :initarg :nbeatsaccord :accessor nbeatsaccord)
   (dureebeat :initform 484 :initarg :dureebeat :accessor dureebeat)
   (grille :initform nil :initarg :grille :accessor grille)
   (blues? :initform nil :initarg :blues? :accessor blues?)
    ))



;;;--------------------------------------------------------


(defun OMaxInitSession ()
  
  (if *supervizer*
    (print "KILL SESSION FIRST !!")
    (progn
      (print "Initializing Impro Session")
      
      (setf *supervizer* (make-instance 'improSupervizer :state :asleep))
      (setf (time-origin *supervizer*) (get-internal-real-time))
      
      (setf (osc-in-host) *osc-in-host*
            (osc-out-host) *osc-out-host*
            (osc-out-time-port) *osc-out-time-port*
            (osc-out-midi-port) *osc-out-midi-port* )
      
      
      
      (let* (
             ;(ls (new-ms-listener "ms-listener" 0))
             (ol (new-osc-midi-listener "osc-listener"))
             (sl (new-polySlicer  "Slicer-0"))
             (or (neworacle))
             (ln (new-learner  or))
             (im (new-improvizer or))
             (un (new-unslicer "Unslicer-0"))
             ;(pl (new-ms-player "MS-Play-0" 0))
             (op (new-osc-midi-player "osc-play")))
        
        (setf (a-oracle 0) or
              (a-learner 0) ln
              (a-improvizer 0) im
              (a-slicer 0) sl
              (a-unslicer 0) un
              ;(a-player 0) pl
              (a-player 1) op
              ;(a-listener 0) ls
              )
        
        (setf *osc-midi-listener* ol (a-listener 1) ol)
        
        ;(connect ls :toport 0)
        (connect ol :toport 0)
        (connect sl :fromport 0)
        (connect sl :toport 1)
        (connect ln :fromport 1)
        (connect im :toport 2)
        (connect un :fromport 2)
        (connect un :toport 3)
        ;(connect pl :fromport 3)
        (connect op :fromport 3)
        )
      
      (synchronize-max-om-time)
      
      ;(send-osc-time (list (list '/mt (ms:MidiGetTime))))
      
      ;(osc-send (list (list '/mt (timeOrigin))) (osc-out-host) (osc-out-time-port))
      
      ;(silent (a-player 0))
      
      (setf *clone-array* (make-array *nb-clones* :initial-element nil))
      
      (resume *supervizer*)
      
      (print "OMAX INITIALISATION OK")
      )))

(defun OMaxKillSession ()
  (and *supervizer* (kill *supervizer*))
  ;(kill *osc-midi-listener*)
  (setf *supervizer* nil)
  (print "OMAX QUITTING OK")
  )


;-------------------------------------------------------------------------------------------


(defvar *osc-out-info-port* 3010)


(defun omaxon () 
  (setf *osc-listener-msg* (new-osc-listener 3005 *max-buf-size* "osc-listener-3005"))
  (setf *osc-listener-midi* (new-osc-listener 3006 *max-buf-size* "osc-listener-3006"))
  (setf *osc-time-end-point* (new-osc-end-point *osc-out-host* *osc-out-time-port* 1911))
  (setf   *osc-midi-end-point* (new-osc-end-point *osc-out-host* *osc-out-midi-port* 1912))
  (setf   *Bosc-midi-end-point* (new-osc-end-point *osc-out-host* *Bosc-out-midi-port* 1913))
  (setf   *osc-info-end-point* (new-osc-end-point *osc-out-host* *osc-out-info-port* 1914))
  )

(defun OMaxOff ()
  (and *supervizer* (OmaxKillSession))
  (loop for process in *all-processes* 
        do (unless (some #'(lambda (critical) (string= (process-name process) critical))
                         '("osc-listener-3006"  "osc-listener-3005"  "Listener"  "Initial" ))
             (process-kill process)))
  (kill-osc-listener *osc-listener-msg*)
  (kill-osc-listener *osc-listener-midi*)
  (close-osc-end-point *osc-midi-end-point*)
  (close-osc-end-point *osc-time-end-point*)
  (close-osc-end-point *Bosc-midi-end-point*)
  (close-osc-end-point *osc-info-end-point*)
  )


(defmacro send-osc-info (bundle)
  `(send-osc *osc-info-end-point* ,bundle))

(defmethod send-osc-oracle-info ((self oracle))
  (when (> (maxetat self) 0)
    (send-osc-info (list (list '/oi 'start 
                               (BufTOffset self 1)
                               (+ (BufTOffset self (maxetat self)) (duration (otext self (maxetat self)))))))
    (loop for i from 1 to (maxetat self)
          when (startPhrase (otext self i))
          do (send-osc-info (list (list '/oi (PhraseNumber (otext self i)) (BufTOffset self i)))))
    (send-osc-info (list (list '/oi 'stop)))))


;(send-osc-oracle-info (oracle (a-improvizer 0)))

(DefAgentMessage wake-clone :now ((self improsupervizer) n)
  (if (or (> n *nb-clones*) (null  (aref *clone-array* (1- n))))
    (Format t "Clone nb ~d is empty !~%" n)
    (let ((awake-impro (awake-p (a-improvizer 0))))
      (stop-impro self)
      (setf (oracle (a-improvizer 0)) (aref *clone-array* (1- n)))
      (reset (a-improvizer 0))
      (reset (a-unslicer 0))

      (send-osc-oracle-info (oracle (a-improvizer 0)))

      ;(reset (a-player 0))
      (reset (a-player 1))
      (synchronize-max-om-time)
      (when awake-impro (start-impro self)))))


(DefAgentMessage wake-main :now ((self improsupervizer))
  (let ((awake-impro (awake-p (a-improvizer 0))))
    (stop-impro self)
    (setf (oracle (a-improvizer 0)) (oracle (a-learner 0)))
    (reset (a-improvizer 0))
    (reset (a-unslicer 0))
    ;(reset (a-player 0))
    (reset (a-player 1))
    (send-osc-oracle-info (oracle (a-improvizer 0)))
    (synchronize-max-om-time)
    (when awake-impro (start-impro self))))



;---------------------------------------------------------


(DefAgentMessage load-oracle-n :now ((self improsupervizer) filename clone-nb)
  (print "LOADING ORACLE ............")
  (let*((archive (load-oracle-direct filename)))
    (when (and archive (or (typep archive 'coracle) (typep archive 'orchestre)))
      (let* ((oracle (if (typep archive 'coracle) 
                       archive 
                       (change-class (aref (improvizer-array archive) 0) 'coracle))))
        (when (typep archive 'orchestre)
          (ConvertUsingAudioOffsets oracle))

        (reinitialize-instance oracle :lock (make-lock 'impro-lock)) 
        ; the lock is not omng-saved
        (setf (aref *clone-array* (1- clone-nb)) oracle)))
    (print "ORACLE LOADED ............")
    ))


(defmethod ConvertUsingAudioOffsets ((self oracle))
  (loop for i from 0 to (1- (maxetat self))
        for j from 1 to (maxetat self)
        for evt = (otext self j)
        for offset = 200 then (+ offset (duration (otext self i)))
        do (setf (phraseNumber evt)
                 10
                 (MidiSet evt)
                 (loop for midiEvt in (MidiSet evt)
                       collect (nconc midiEvt (list '10 offset)))))
  (setf (startPhrase (otext self 1)) T))
