(in-package :om)


(setf *beat-ratios*
      '((0 1000)
        (0 1/2 1000)
        (0 1/3 2/3 1000)
        (0 1/4 1/2 3/4 1000)
        (0 1/5 2/5 3/5 4/5 1000)
        (0 1/6 2/6 3/6 4/6 5/6 1000) 
        (0 1/7 2/7 3/7 4/7 5/7 6/7 1000)
        (0 1/8 2/8 3/8 4/8 5/8 7/8 1000)))


(defmethod get-qMidiSet ((self beat))
  (loop for event in (MidiSet self)
        with (qonsets durunit) = (quantize-onsets 
                                  (loop for MEvent in (midiset self) collect (MEOnset MEvent)) 
                                  (duration self))
        for qonset in qonsets
        collect (let ((qMidiSet (copy-list event))) (setf (MeOnset qMidiSet) qonset (MEDur qMidiSet) (AlignDur (MEDUr qMidiSet) durunit))  qMidiSet)))


(defmethod set-qMidiSet ((self beat))
  (loop for event in (MidiSet self)
        with (qonsets durunit) = (quantize-onsets 
                                  (loop for MEvent in (midiset self) collect (MEOnset MEvent)) 
                                  (duration self))
        for qonset in qonsets
        collect (let ((qMidiSet (copy-list event))) (setf (MeOnset qMidiSet) qonset (MEDur qMidiSet) (AlignDur (MEDUr qMidiSet) durunit))  qMidiSet)
        into qset
        finally (setf (qmidiset self) qset (qDivision self) (round   (duration self) durunit)))
  self)


(defun alignDur (dur durunit)
  (* durunit (max 1 (floor dur durunit))))

(defun quantize-onsets (onsets beatdur)
  (loop for ratios in *beat-ratios*
        with min-dist = 100000
        with best-ratios and best-qonsets and best-durunit
        for (distance qonsets durunit) = (onset-distance onsets ratios beatdur)
        if (< distance min-dist) do (setf min-dist distance best-qonsets qonsets best-durunit durunit)
        finally return (list best-qonsets best-durunit)))



(defun onset-distance (onsets ratios beatdur)
  (setf ratios (mapcar #'(lambda (r) (round (* r beatdur)))  ratios))
  (let ((durunit (if (third ratios) (second ratios) beatdur)))
    (let ((qonsets
           (loop for onset in onsets
                 collect 
                 (loop until  (<= (first ratios) onset (second ratios))
                       do (pop ratios)
                       finally return (if (> (abs (- onset (first ratios))) (abs (- onset (second ratios))))
                                        (second ratios)
                                        (first ratios))))))
      (list
       (loop for onset in onsets
             for ronset in qonsets
             for diff = (- onset ronset)
             sum (* diff diff) into sum
             finally return (sqrt sum))
       qonsets
       durunit))))

