(in-package :om)



;;; une performance est un ensemble d'orchestre
;;; qui peuvent commuter

(defclass* performance ()
  ((orc-array :initform () :initarg :orc-array :accessor orc-array)
   (param-array :initform () :initarg :param-array :accessor param-array)
   (type-array :initform () :initarg :type-array :accessor type-array)
   (nb-orcs :initform 4 :initarg :nb-orcs :accessor nb-orcs)
   (cur-orc :initform 0 :initarg :cur-orc :accessor cur-orc)
   ))


(defun new-performance (nborc)
  (let ((self (make-instance 'performance)))
    (setf (nb-orcs self) nborc)
    (setf (orc-array self) (make-array nborc)) 
    (setf (param-array self) (make-array nborc))
    (setf (type-array self) (make-array nborc))
    self))


(defun charge-perf-orc (numorc)
  (let ((old-orc (aref (orc-array ms::*performance*) numorc))
        (orchestre (om::load-orchestre-from)))
    (when (neq orchestre :cancel)
      (when (eq (type-of orchestre) 'improvizer)
        (setf orchestre (mk-orc-from-impro orchestre)))
      (let ((*nbeatsaccord* (nbeatsaccord old-orc))
            ;(*dureebeat* (dureebeat old-orc))
            (*grille* (grille old-orc))
            (*blues?* (blues? old-orc)))
        (setf (aref (orc-array ms::*performance*) numorc) orchestre)
        (setf (nbeatsaccord orchestre) 
              ;;ms::*nbeatsaccord*
              *nbeatsaccord*
              (dureebeat orchestre) ms::*dureebeat*  ;; take the current performance *dureebeat*
              (grille orchestre) *grille*
              (blues? orchestre) *blues?*)
        (format t "~%Loading orchestra ~a type ~a~%" numorc (aref (type-array ms::*performance*) numorc))
        ms::*performance*))))


(defun charge-perf-orc-direct (numorc file)
  (let ((old-orc (aref (orc-array ms::*performance*) numorc))
        (orchestre (om::load-orchestre-direct file)))
    (when (neq orchestre :cancel)
      (when (eq (type-of orchestre) 'improvizer)
        (setf orchestre (mk-orc-from-impro orchestre)))
      (let ((*nbeatsaccord* (nbeatsaccord old-orc))
            ;(*dureebeat* (dureebeat old-orc))
            (*grille* (grille old-orc))
            (*blues?* (blues? old-orc)))
        (setf (aref (orc-array ms::*performance*) numorc) orchestre)
        (setf (nbeatsaccord orchestre) 
              ;;ms::*nbeatsaccord*
              *nbeatsaccord*
              (dureebeat orchestre) ms::*dureebeat*  ;; take the current performance *dureebeat*
              (grille orchestre) *grille*
              (blues? orchestre) *blues?*)
        (format t "~%Loading orchestra ~a type ~a~%" numorc (aref (type-array ms::*performance*) numorc))
        ms::*performance*))))


;;; fonctions commandes par Max


(defvar ms::*performance* nil)
 
(defun reset-performance (nborc)
  (setf ms::*performance* (new-performance nborc)))




;; initialise l'orchestre num-orc avec
;; type : 0 free 1 freeE 2 defautbeat 3 rain 4 BluesBb 5 toutpiti 6 dicidence 7 goodbye
;;; -> RAJOUT TYPE "DEFAUT" en mode beat (4 mesures =  16 beats, accord C)

(defun om::set-perf-orc (num-orc type)
  (case type
    (0 
     (let ((orchestre (cree-free)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (param-array ms::*performance*) num-orc) nil
             (aref (type-array ms::*performance*) num-orc) "FREE")))
    (1     
     (let ((orchestre (cree-freeE)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (param-array ms::*performance*) num-orc) nil
             (aref (type-array ms::*performance*) num-orc) "FREE-ESTRADA")))
    (2 
     (let ((orchestre (cree-defautbeat)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (type-array ms::*performance*) num-orc) "DEFAUT")))
    (3 
     (let ((orchestre (cree-rain)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (type-array ms::*performance*) num-orc) "RAIN")))
    (4 
     (let ((orchestre (cree-BluesBb)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (type-array ms::*performance*) num-orc) "Blues Bb")))
    (5 
     (let ((orchestre (cree-toutpiti)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (type-array ms::*performance*) num-orc) "Toutpiti")))
    (6
     (let ((orchestre (cree-dicidence)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (type-array ms::*performance*) num-orc) "DICIDENCE")))

    (7
     (let ((orchestre (cree-goodbye)))
       (setf (aref (orc-array ms::*performance*) num-orc) orchestre
             (aref (type-array ms::*performance*) num-orc) "GOODBYE PORKPIE HAT")))


    )
  (format t "~%Setting orchestra ~a to type ~a~%" num-orc (aref (type-array ms::*performance*) num-orc))
  t)
 

 


;;; demande l'orchestre num-orc

(defun switch-perf-orc (num-orc)
  (setf ms::*orchestre* (aref (orc-array ms::*performance*) num-orc)
        ms::*oracle1* (aref (improvizer-array (aref (orc-array ms::*performance*)  num-orc)) 0)
        ms::*oracle2* (aref (improvizer-array (aref (orc-array ms::*performance*)  num-orc)) 1)
        ms::*oracle3* (aref (improvizer-array (aref (orc-array ms::*performance*)  num-orc)) 2)
        ms::*oracle4* (aref (improvizer-array (aref (orc-array ms::*performance*)  num-orc)) 3)
        ms::*oracle-courant* ms::*oracle1*
       ms::*oracle-player* ms::*oracle2*)
  (setf ms::*nbeatsaccord* (nbeatsaccord ms::*orchestre*)  
        ms::*dureebeat* (dureebeat ms::*orchestre*) 
        ms::*grille* (grille ms::*orchestre*)  
        ms::*blues?* (blues? ms::*orchestre*) )
  (setf (cur-orc ms::*performance*) num-orc)
  (format t "Switching to orchestra ~a type ~a ~%" num-orc (aref (type-array ms::*performance*) num-orc))
  ms::*performance*)



(defun set-cur-orc-dureebeat (dureebeat)
  (setf (reftempo (aref (improvizer-array (aref (orc-array ms::*performance*) 
                                                (cur-orc ms::*performance*)))
                        0))
        dureebeat))




;;; a l'initialisation, performance a 2 orchestre
;;; free sur le premier et rain sur le second

(reset-performance 2)
(set-perf-orc 0 0)
(set-perf-orc 1 2)
(switch-perf-orc 0)




     

     
     

  




;(load-orchestre-from)
;(charge-orchestre)
;(inspect (new-performance 4))