(in-package :ccl)

(defclass semaphore ()
  ;; Sorry, brain-dead design, but allows two processes to synchronize.
  ;; We like to OpenMCL threads, etc.
  ((lock
    :initform (make-lock)
    :reader semaphore-lock)
   (value
    :initform nil
    :accessor semaphore-value)))

(defun make-semaphore ()
  (make-instance 'semaphore))

(defmethod signal-semaphore ((semaphore semaphore))
  (with-lock-grabbed  ((semaphore-lock semaphore))
    (setf (semaphore-value semaphore) t)))

(defmethod wait-on-semaphore ((semaphore semaphore))
  (ccl:process-wait
     "semaphore wait"
     #'(lambda (s)
         (declare (ignore proc))
         (with-lock-grabbed  ((semaphore-lock s))
           (let ((value (semaphore-value s)))
             (when value
               (setf (semaphore-value s) nil)
               t))))
     semaphore))

(export '(make-semaphore signal-semaphore wait-on-semaphore) :ccl)



(in-package cl-user)
(defpackage mp
  (:nicknames :mp)
  (:use )
  (:export make-process process-preset process-enable make-process-lock with-process-lock 
           process-unlock process-kill process-reset process-disable
           maake-gate open-gate close-gate gate-open-p process-lock
           process-run-function wait-for-input-available ) )

(defpackage excl
  (:nicknames :excl)
  (:use )
  (:export without-interrupts))

(defpackage sys
  (:nicknames :sys)
  (:use )
  (:export ))

(defpackage ipc
  (:nicknames :ipc)
  (:use )
  (:export ))








(defmacro excl::without-interrupts (&body body) `(ccl::without-interrupts ,. body))

(defmacro mp::make-process-lock (&body body) `(ccl::make-lock ,. body))

(defmacro mp::process-preset (&body body) `(ccl::process-preset ,. body))

(defmacro mp::process-reset (&body body) `(ccl::process-reset ,. body))

(defmacro mp::process-disable (&body body) `(ccl::process-disable ,. body))

(defmacro mp::process-kill (&body body) `(ccl::process-kill ,. body))

(defmacro mp::process-lock (&body body) `(ccl::process-lock ,. body))

(defmacro mp::process-enable (&body body) `(ccl::process-enable ,. body))

(defmacro mp::make-process (&body body) `(ccl::make-process ,. body))

(defmacro mp::with-process-lock (&body body) `(ccl::with-lock-grabbed ,. body))

(defmacro mp::process-unlock (&body body) `(ccl::process-unlock ,. body))

(defmacro mp::process-run-function (&body body) `(ccl::process-run-function ,. body))

(defun mp::wait-for-input-available (x) t)

(defun mp::make-gate (open)
  (let ((gate (make-array '(1) :element-type '(signed-byte 32))))
    (setf (aref gate 0)
          (if open 1 0))
    gate))

(defun mp::open-gate (gate)
  (declare (type (simple-array (signed-byte 32) (*)) gate))
  (ccl::without-interrupts (setf (aref gate 0) 1)))

(defun mp::close-gate (gate)
  (declare (type (simple-array (signed-byte 32) (*)) gate))
  (ccl::without-interrupts (setf (aref gate 0) 0)))

(defun mp::gate-open-p (gate)
  (declare (type (simple-array (signed-byte 32) (*)) gate))
  (not (zerop (the fixnum (aref gate 0)))))

