(in-package :nc)


;;; autonomous (running permanently) active (handling messages) objects
;;; GA 8/5/06



(defclass autonomous-active-object (autonomous-object active-object)
  ((task :initform #'(lambda (obj) (format t "Aut. Active object ~a running~%~%" obj) (sleep 2)) :accessor task)
   (state :initform :working :accessor state)
   (loop-test :initform T :accessor loop-test)
   (alive :initform t :accessor alive)
   )
  )


(defmethod schedule ((sched standard-scheduler) (obj active-object) message)
(print "XXX schedule")
  (enqueue (mail-queue obj) message)
  (unless (active-p obj)
    (setf (active-p obj) t)
    (mp:process-run-function (list :name (symbol-name (class-name (class-of obj)))
				   :quantum ccl::*default-quantum*)
			     #'active-loop obj)))

(defmethod unschedule ((sched standard-scheduler) (obj active-object))
  (setf (active-p obj) nil))


(defmethod schedule ((sched standard-scheduler) (obj autonomous-active-object) message)
(print "*** schedule")
  (enqueue (mail-queue obj) message)
  (unless (active-p obj)
    (setf (active-p obj) t)))


(defmethod active-loop ((obj autonomous-active-object))
  (loop while (print (autonomous-test obj))
        do
        ;;; check for message
        (loop while (print (active-test obj))
              do (active-body obj))
        ;;; do main task
        (when (eq (state self) :working) (autonomous-body obj)))
  (process-reset (process self)) )

(defmethod autonomous-test ((obj autonomous-active-object)) 
  (print "****")
  (loop-test obj))

(defmethod autonomous-body :around ((obj autonomous-active-object))
  (with-simple-restart (abort "Let autonomous-active object ~a resume." obj)
    (call-next-method)))

(defmethod autonomous-body ((obj autonomous-active-object))
  (funcall (task obj) obj))

(defmethod terminate ((obj autonomous-active-object))
  (clean-terminate obj)
  (kill obj))

(defmethod resurrect ((obj autonomous-active-object))
  (setf (loop-test obj) T)
  (setf (process obj) 
        (mp:make-process 
          (string (class-name (class-of obj)))))
  (mp:process-preset (process obj)  #'active-loop obj)
  (mp:process-enable (process obj)))


(defmethod reset  ((obj autonomous-active-object))
  (format t "Resetting active object ~a ~%" obj))

(defpargeneric clean-terminate :now (aao))

(defmethod clean-terminate ((aao autonomous-active-object))
    (setf (loop-test aao) nil)
    (process-wait "terminate" 
                  #'(lambda (obj) (string= (process-whostate (process obj)) "exhausted"))
                  aao)
    t)


(defpargeneric stop-loop :now (aao))
(defmethod stop-loop ((aao autonomous-active-object))
      (setf (loop-test aao) nil))



(defmethod terminate ((obj autonomous-active-object))
  (stop-loop obj)
  (
  






#|

(setf aao (make-instance 'autonomous-active-object))

(reset aao)

(terminate  aao)
(resurrect aao)

(kill aao)

(reset aao)

(stop-loop  aao)

((process-enable (process aao))

(process-kill (first ccl::*all-processes*))
(process-enable (first ccl::*all-processes*))

(inspect aao)

(process-whostate (process aao))

(makunbound 'aao)

|#

