(in-package :nc)


(defvar *iac-maxnb-clients* 32)

(defclass iac-central ()
  ((agents-ports :accessor agents-ports  :initform (make-array *iac-maxnb-clients* :initial-element 0))
   (ports-agents :accessor ports-agents  :initform (make-array *iac-maxnb-clients* :initial-element nil) )
   (queues :accessor queues :initform (make-array *iac-maxnb-clients*))
   )
  )


(defvar *iac-central* (make-instance 'iac-central))


;;; task de l'agent self. in et out vu de l'agent.

(agent-connect agent  :outport 0)
(agent-connect :inport 0 :outport 1)
(agent-connect :inport 1 )
(agent-connect :inport 1 :outport 2)


-> agent id


(defmethod iac-register ((agent agent))
  (loop for i from 0
        while (< i *iac-maxnb-clients*)
        when (eq 0 (aref (agents-ports *iac-central*) i))
        do (setf (aref (agents-ports *iac-central*) i) nil
                 (aref (queues *iac-central*) i) (make-lockable-queue))
        and return i
        finally (when (= i *iac-maxnb-clients*)
                  (error "Iac-central : too many agents"))))


(defmethod iac-unregister ((agent-id number))
  (setf (aref (agents-ports *iac-central*) agent-id) 0)
  (iac-disconnect-from-all agent-id)
  (setf (queues agent-id) nil)
)
              

(defmethod iac-connect-to-port ((agent-id number) (port number))
  (pushnew port (aref (agents-ports *iac-central*) agent-id)))

(defmethod iac-connect-from-port ((agent-id number) (port number))
  (pushnew agent-id  (aref (ports-agents *iac-central*) port)))

(defmethod iac-discconnect-to-port ((agent-id number) (port number))
  (setf (aref (agents-ports *iac-central*) agent-id)
        (remove port (aref (agents-ports *iac-central*) agent-id))))

(defmethod iac-disconnect-from-port ((agent-id number) (port number))
  (setf (aref (ports-agents *iac-central*) port)
        (remove agent-id (aref (ports-agents *iac-central*) port))))

(defmethod iac-disconnect-from-all ((agent-id number))
  (loop for i from 0 to (1- *iac-maxnb-clients*)
        do (iac-disconnect-from-port  agent-id i)))


(defmethod iac-write ((agent-id number) (port number) event)
  (loop for target-agent-id in (aref (ports-agents *iac-central*) port)
           do (enqueue (queues target-agent-id) event))) ;; or (copy event ) ???

(defmethod iac-read ((agent-id number) )
  (if (empty-queue-p (queues agent-id))
    (process-allow-schedule)
    (dequeue (queues agent-id))))
  

(defmethod iac-broadcast ((agent-id number) event)
  (loop for port in (aref (agents-ports *iac-central*) agent-id)
        do (loop for target-agent-id in (aref (ports-agents *iac-central*) port)
              do (enqueue (queues target-agent-id) event)))) ;; or (copy event ) ???


;;; on ne put lire que sur un port ?????
  


        


  ; register agent
  ; -> agent-ID 
)


(defmethod iac-connec ((agent agent) & key (inport 0) (outport 1))
  ; update tables
)


(defmethod iac-speak ((agent agent) event)
  ; 


(iac-register agent)




(agent-connect 


(setf evt (listen self))
(speak self value)




(defmacro listen (agent)
  `(let ((queue (listen-queue *event-router* ,agent)))
     (if (empty-queue-p queue)
       (process-allow-schedule)
       (dequeue queue))))

(defmacro speak (agent value)
  `(let ((queue (speak-queue *event-router* ,agent)))
     (enqueue queue ,value)))


(



