;;; Fichier NewnewMarc.lisp / 3 avril 2005

(in-package :midishare)

; 1-2-Arrange.lisp
; mettre *k* a 0 car dans Max, initialise a 0

(setq *k* 0)


; 1-5-Steedman.lisp

(setf *delaigrammaire* 4)
(setf *longueurgrammaire* 11)

(defun om::setdelaigrammaire (val) (setf *delaigrammaire* val))
(defun om::setlongueurgrammaire (val) (setf *longueurgrammaire* val))


; NewMarc.lisp

(defun fonction-generique (seq-inst)
  (case (car seq-inst)
    (1
     (let ((type-morceau (cadr seq-inst)))  ;;; type-morceau = 0 free, 1 free estrada, 2, 3, ... grille avec beat
       (om::switch-perf-orc type-morceau)
       (setf *mode-beat* (= type-morceau 1))))
    (2
     (let ((num-orc (cadr seq-inst))
           (type-morceau (caddr seq-inst)))  ;;; type-morceau = 0 free, 1 free estrada, 2, 3, ... grille avec beat
       (om::set-perf-orc num-orc type-morceau)))
    (3
     (let ((dureebeat (+ (* 100 (cadr seq-inst)) (caddr seq-inst))))
       (om::set-cur-orc-dureebeat dureebeat)
       (setf *dureebeat* dureebeat)
       ))
    (4         ;;; FONCTION GENERIQUE POUR RECEPTIONNER ACCORDS
     (let ((deg (cadr seq-inst)) (chif (caddr seq-inst)))
       (print (list deg chif))
       (setf *accord* (ajoute-chiffre (traduc-deg deg) chif))         ;cf. 6-Voicings.lisp
       ))   ;;; la mise dans table se fait dans cree-free, car *Voicing-mode* = t
    (5
     (let ((numcase (cadr seq-inst)))
       (fonction-grammaireportion (+ numcase *delaigrammaire*))    ;;; 4 = delai de calcul
       )) 
    (6
     (switch-prolifere (eq (cadr seq-inst) 1)))
    
    ))

; 1-5-Steedmanportion.lisp

(defun fonction-grammaireportion (numcase)
  (fonction-reecriture 82 *grilletmp* numcase))

(defun fonction-reecriture (id grille numcase)
  (let* ((groupage (portion-grille grille numcase (+ numcase *longueurgrammaire*)))   ;;; 4 = longueur de portion
         (debut (first groupage)) (oldmilieu (second groupage)) (fin (third groupage))
         (newmilieu (annule-div-grille (reecriture oldmilieu *k*))))
    (setf *grilletmp* (append debut newmilieu fin))  ;;; *grilletmp* mis a jour a chaque substi. (toujours sans rotation)
    (let* ((oldgroupage (portion-grille *grille* numcase (+ numcase *longueurgrammaire*)))
           (oldaccords (extrait-accords (second oldgroupage) ;(if *blues?* (forcer-septieme (second oldgroupage))
                                                             ;     (second oldgroupage)) 
                                        numcase))
           (newaccords (extrait-accords newmilieu   ;(if *blues?* (forcer-septieme newmilieu)
                                                    ;   newmilieu)  
                                        numcase))
           (liste-chgts (compare-accords oldaccords newaccords)))
      (joue-accords-om->max 83 liste-chgts newaccords)) 
    (let* ((rotation-grille (if (and (null newmilieu) (null fin)) debut   ;;; pas de rajout de /
                                (append newmilieu fin (list '/) (butlast debut))))
           (piano-bass-voicings (virtual-boogie rotation-grille *table-arrangements* *duree-mes*)))
      (setf *genere-quoi* 'grammaire)
      (5-listes->max id piano-bass-voicings)   ;;; 82 = identifiant des sequences calculees par "grammaireportion"
)))

; NewMarc.lisp

(defun fonction-grammaire ()
  ;(let* ((liste-numcase-accords (extrait-accords *grille* 1))
  ;       (liste-chgts (compare-accords liste-numcase-accords liste-numcase-accords)))
  ;    (joue-accords-om->max 83 liste-chgts liste-numcase-accords))
  (fonction-reecriture 60 *grille* 1))



;;; CASES DANS MAX:
;;; ---------------
;;; numerotees de 1 a 24 (lignes 1-8, 9-16, 17-24)

;;; *nbeatsaccord* = 2 -> accords par demi-mesure
;;; *nbeatsaccord* = 1 -> accords par temps


; Cree.lisp

(in-package :om)

(defun cree-defautbeat ()          ;;; BPM=298, 16 beats, duree beat = 201 ms
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 1)
         (*dureebeat* 201)
         (*grille* ms::*grille-defautbeat*)
         (*blues?* nil))
    (let* ((liste-numcase-accords (ms::extrait-accords ms::*grille-defautbeat* 1))
           (liste-chgts (ms::compare-accords liste-numcase-accords liste-numcase-accords)))
      (ms::joue-accords-om->max 83 liste-chgts liste-numcase-accords))
    (setf ms::*grilletmp* *grille*)
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre) *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle nil)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    (format t "Creation orchestre Defautbeat... BPM=298, 8 beats~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))

(defun cree-bluesBb ()        ;;; BPM=112, 48 beats
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 2)
         (*dureebeat* 536)
         (*grille* ms::*grille-BluesBb*)
         (*blues?* t))
    (let* ((liste-numcase-accords (ms::extrait-accords (ms::forcer-septieme ms::*grille-BluesBb*) 1))
           (liste-chgts (ms::compare-accords liste-numcase-accords liste-numcase-accords)))
(print liste-numcase-accords)
      (ms::joue-accords-om->max 83 liste-chgts liste-numcase-accords))
    (setf ms::*grilletmp* *grille*)
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre)
          *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle nil)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    
    (format t "Creation orchestre blues en Bb sur Ziste... BPM=112, 48 beats~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))


(in-package :midishare)

; dans 1-3-Affiche.lisp
;-> determine format d'affichage

; ATTENTION: il peut arriver que certains accords soient absents
; (cf. grille2-2-grille.mid)
; dans ce cas, voir le piano canal 1 pour restituer


; ATTENTION: ON OUBLIE LA DERNIERE GRILLE

(defun recupere-accords (lpitch lvelo ldur duree-demimesure nb-mesures)
;  (setf *nbeatsaccord* 2)     
  (let ((res ()) (grille ()) (k 0))   ;;; k = nbre de demi-mesures
    (do ((l1 lpitch (cdr l1)) (l2 lvelo (cdr l2)) (l3 ldur (cdr l3)))
        ((null l1) (reverse res))
      (let ((d (round (/ (caar l3) duree-demimesure))))
        (setf k (+ k d))
        (when (> k (* 2 nb-mesures))
          (setf k d)
          (setf res (cons (reverse grille) res))
          (setf grille ()))
        (let ((acc (ajoute-chiffre (traduc-deg (caar l1)) (caar l2))))
          (setf grille (if (<= d 2) (cons (list acc d) grille)
                           (append (list (list acc 2) (list acc 2)) grille))   ; pour traiter bizarres d=4
                ))))))


(defun affiche-ligne (n)
;  (if (= n 2)
;    (format t "|__________|__________|~%")
    (format t "|__________|__________|__________|__________|~%")
;    (format t "|____________________|____________________|____________________|____________________|~%")
;)
)

(defun affiche-bordure (n)
;  (if (= n 2)
;    (format t "~%_______________________~%")
    (format t "~%_____________________________________________~%")
;    (format t "~%_____________________________________________________________________________________~%")
;)
)



; NewMarc.lisp

(defun virtual-boogie (grille table-arrangements duree-mes) 
  (when *blues?* (setf grille (forcer-septieme  grille)))
  (let* ((grille-avec-dur (determine-durees grille))
         (liste-blocs (arrange grille-avec-dur () (mapcar #'car table-arrangements) table-arrangements duree-mes))
         (l (met-intermittence liste-blocs
             ;(mapcar #'rajouter-syncopes liste-blocs)
                               )))

(print grille-avec-dur)
    (list (fait-haut l) (fait-onset l) (fait-dur l) (fait-vel l) (fait-canal l))))

;avec (forcer-septieme grille) dans 1-2-Arrange.lisp (au debut)


; Dans Max: defautbeat est remplace par "vide"
; car quand on passe a free puis qu'on revient a beat, il ne memorise pas la grille

(setf *grille-defautbeat*  ())
;  '((bb) / (bb) / (bb) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))


(setf *grille-momentsnotice*
'(
(e m7) (a 7) / (f m7) (bb 7) / (eb) / (ab m7) (db 7) /
(d m7) (g 7) / (eb m7) (ab 7) / (db) / (d m7) (g 7) /
(c m7) (b 7) / (bb m7) (eb 7) / (ab) / (ab m7) (db 7) /
(g m7) (c 7) / (ab m7) (db 7) / (gb) / (f m7) (bb 7) /

(e m7) (a 7) / (f m7) (bb 7) / (eb) / (ab m7) (db 7) /
(d m7) (g 7) / (eb m7) (ab 7) / (db) / (d m7) (g 7) /
(c m7) (b 7) / (bb m7) (eb 7) / (ab) / (ab m7) (db 7) /
(g m7) (c 7) / (f m7) (bb 7) / (eb) / (f m7) / (g m7) /
(f m7) / (eb) (f m7) / (g m7) (f m7) / (eb) / (eb)
))




; 1-1-Steedman

; modifier cette fonction pour qu'elle puisse traiter TOUS les accord
; dd au lieu de c#, etc.
; -> (normalise deg) dans 1-2-Arrange.lisp "Adaptation des hauteurs"

(defun fonction (d int)
  (let* ((dnorm (normalise d))
         (l '(c c# d eb e f f# g g# a bb b))) 
    (list (nth int (member dnorm (append l l))) '*)))




;;; 1-1-Steedman

;;; grammaire AVEC accords m7

(defvar *grammaire0*
  '((1-1 (/ (x) /) (/ (x) (x) /))
    (1-2 (/ (x 7) /) (/ (x) (x 7) /))
    
    (3a-1 (w (x 7)) (((D x) 7) (x 7)))
    
    (4-1 (((D x) 7) (x 7)) (((Stb x) 7) (x 7)))
    (4-2 (((D x) 7) (x)) (((Stb x)) (x)))
    
    (3a-11 (w / (x 7)) (((D x) 7) / (x 7)))
    
    (4-11 (((D x) 7) / (x 7)) (((Stb x) 7) / (x 7)))
    (4-21 (((D x) 7) / (x)) (((Stb x)) / (x)))
    ))


(setf *grammaire1*
  '(
;;; regles de division
    (1-1 (/ (x) /) (/ (x) (x) /))
    (1-2 (/ (x 7) /) (/ (x) (x 7) /))
    (1-3 (/ (x m7) /) (/ (x) (x m7) /))

;;; regles de substitution   
    (3a-1 (w (x 7)) (((D x) 7) (x 7)))
    (3a-2 (w (x 7)) (((D x) m7) (x 7)))   ; intro m7

    (3b-1 (w (x m7)) (((D x) 7) (x m7)))
    
    (4-1 (((D x) 7) (x 7)) (((Stb x) 7) (x 7)))
    (4-2 (((D x) 7) (x)) (((Stb x)) (x)))
    (4-3 (((D x) 7) (x m7)) (((Stb x)) (x m7)))
   
    (3a-11 (w / (x 7)) (((D x) 7) / (x 7)))
    (3a-21 (w / (x 7)) (((D x) m7) / (x 7)))
 
    (3b-11 (w / (x m7)) (((D x) 7) / (x m7)))
   
    (4-11 (((D x) 7) / (x 7)) (((Stb x) 7) / (x 7)))
    (4-21 (((D x) 7) / (x)) (((Stb x)) / (x)))
    (4-31 (((D x) 7) / (x m7)) (((Stb x) m7) / (x m7)))
    ))

(setf *grammaire* *grammaire1*)


;;; 1-2-Arrange.lisp

;;; TABLE D'ARRANGEMENT DE "RAIN"

(setq *table-rain*        ;;; version avec accords sur canal OM=13 (Max=14)
                                  ;;; degre=haut 0-11, chiffre=velo 1=Maj, 2=m7, 3=7
      '(((((b m7) 1) ((e 7) 1))
         (((11 35 66 62 61 57) (47) (4 34 73 56) (46)) (0 242 469 726)
          ((469 242 469 953 953 469) (242) (469 242 469 469) (242))
          ((2 97 69 69 69 69) (97) (3 97 69 69) (97)) ((13 1 0 0 0 0) (1) (13 1 0 0) (1))))
        ((((c# 7) 2))
         (((1 37 70 63 59 58 53) (37) (65) (37) (68)) (0 242 605 726 847)
          ((953 242 469 953 953 953 953) (469) (233) (242) (121))
          ((3 97 69 69 69 69 69) (97) (69) (97) (69)) ((13 1 0 0 0 0 0) (1) (0) (1) (0))))
        ((((g# m7) 2))
         (((8 32 63 59 58 54) (44) (32) (44)) (0 469 726 847)
          ((953 469 953 953 953 953) (242) (121) (121)) ((2 97 69 69 69 69) (97) (97) (97))
          ((13 1 0 0 0 0) (1) (1) (1))))
        ((((g# 7) 2))
         (((8 32 65 62 60 58 54) (44) (32) (44)) (0 242 469 726)   ;;;;(16 258 500 742)
          ((953 242 953 953 953 953 953) (242) (242) (242)) ((3 97 69 69 69 69 69) (97) (97) (97))
          ((13 1 0 0 0 0 0) (1) (1) (1))))
        ((((b 7) 2))
         (((11 35 68 63 61 57) (42) (47) (69) (73)) (0 242 469 605 847)
          ((953 242 469 953 953 953) (242) (242) (250) (121)) ((3 97 69 69 69 69) (97) (97) (69) (69))
          ((13 1 0 0 0 0) (1) (1) (0) (0))))
        ((((f#) 2))
         (((6 30 70 65 61 58 54) (42) (37)) (0 242 726) ((953 242 953 953 953 953 953) (469) (242))
          ((1 97 69 69 69 69 69) (97) (97)) ((13 1 0 0 0 0 0) (1) (1))))
        ((((c# m7) 2))
         (((1 37 63 59 56 52) (37) (37)) (0 242 726) ((953 242 953 953 953 953) (469) (242))
          ((2 97 69 69 69 69) (97) (97)) ((13 1 0 0 0 0) (1) (1))))
        ((((c#) 2))
         (((1 37 63 60 56 53) (37) (37)) (0 242 726) ((953 242 953 953 953 953) (469) (242))
          ((1 97 69 69 69 69) (97) (97)) ((13 1 0 0 0 0) (1) (1))))
        ((((b m7) 1))
         (((11 35 66 62 61 57) (47)) (0 242) ((469 242 469 469 469 469) (242)) ((2 97 69 69 69 69) (97))
          ((13 1 0 0 0 0) (1))))
        ((((b 7) 1))
         (((11 35 68 63 61 57) (47)) (0 242) ((469 242 469 469 469 469) (242)) ((3 97 69 69 69 69) (97))
          ((13 1 0 0 0 0) (1))))
        ((((f#) 1))
         (((6 30 70 65 61 58 54) (42)) (0 242) ((469 242 469 469 469 469 469) (242))
          ((1 97 69 69 69 69 69) (97)) ((13 1 0 0 0 0 0) (1))))
        ((((e m7) 1))
         (((4 40 66 62 59 55)) (0) ((469 469 469 469 469 469)) ((2 97 69 69 69 69)) ((13 1 0 0 0 0))))
        ((((e 7) 1))
         (((4 40 70 66 62 56)) (0) ((469 469 469 469 469 469)) ((3 97 69 69 69 69)) ((13 1 0 0 0 0))))
        ((((e) 1))
         (((4 40 71 68 66 63) (52)) (0 242) ((469 242 469 469 469 469) (242)) ((1 97 69 69 69 69) (97))
          ((13 1 0 0 0 0) (1))))))



;;; TABLE D'ARRANGEMENT DE "GOODBYE PORK PIE HAT"


(setq *table-goodbye*    ;;; pour Goodbye Pork Pie Hat

'(
#|
;;; voicings Lubat 1er octobre 2004
 ((((bb m7) 2)) 
  (((10 46 56 60 65 68 72)) (0) ((968 953 953 953 953 953)) ((2 80 80 80 80 80 80)) ((13 0 0 0 0 0 0))))
 ((((bb m7) 1)) 
  (((10 46 56 60 65 68 72)) (0) ((484 469 469 469 469 469)) ((2 80 80 80 80 80 80)) ((13 0 0 0 0 0 0))))
 ((((f 7) 2)) 
  (((5 41 51 57 63 67 71)) (0) ((968 953 953 953 953 953)) ((3 80 80 80 80 80 80)) ((13 0 0 0 0 0 0))))
 ((((f 7) 1)) 
  (((5 41 51 57 63 67 71)) (0) ((484 469 469 469 469 469)) ((3 80 80 80 80 80 80)) ((13 0 0 0 0 0 0))))
 ((((eb) 2)) 
  (((3 39 50 58 62 67 70)) (0) ((968 953 953 953 953 953)) ((1 80 80 80 80 80 80)) ((13 0 0 0 0 0 0))))
 ((((eb) 1)) 
  (((3 39 50 58 62 67 70)) (0) ((484 469 469 469 469 469)) ((1 80 80 80 80 80 80)) ((13 0 0 0 0 0 0))))
; ((((c# 7) 2))    ;;; sonne tres epais
;  (((1 37 44 51 53 55 59 61 63 65)) (0) ((968 953 953 953 953 953 953 953 953)) ((3 80 80 80 80 80 80 80 80 80)) ((13 0 0 0 0 0 0 0 0 0))))
; ((((c# 7) 1)) 
;  (((1 37 44 51 53 55 59 61 63 65)) (0) ((484 469 469 469 469 469 469 469 469)) ((3 80 80 80 80 80 80 80 80 80)) ((13 0 0 0 0 0 0 0 0 0))))
 ((((c m7) 2)) 
  (((0 48 55 58 62 67 70 74)) (0) ((968 953 953 953 953 953 953)) ((2 80 80 80 80 80 80 80)) ((13 0 0 0 0 0 0 0))))
 ((((c m7) 1)) 
  (((0 48 55 58 62 67 70 74)) (0) ((484 469 469 469 469 469 469)) ((2 80 80 80 80 80 80 80)) ((13 0 0 0 0 0 0 0))))
|#

;;; voicings initiaux     (953=968-10ms pour NoteOff)
 ((((f 7) 2)) 
  (((5 41 51 57 59)) (0) ((968 953 953 953)) ((3 80 80 80 80)) ((13 0 0 0 0))))
 ((((f 7) 1)) 
  (((5 41 51 57 59)) (0) ((484 469 469 469)) ((3 80 80 80 80)) ((13 0 0 0 0))))

; ((((c m7) 2))       ; moche (trop aigu)
;   (((0 48 63 67 74)) (0) ((968 953 953 953)) ((2 80 80 80 80)) ((13 0 0 0 0)))) 
; ((((c m7) 1))
;  (((0 48 63 67 74)) (0) ((484 469 469 469)) ((2 80 80 80 80)) ((13 0 0 0 0))))

 ((((c# 7) 2)) 
  (((1 49 59 63 68)) (0) ((968 953 953 953)) ((3 80 80 80 80)) ((13 0 0 0 0))))
 ((((c# 7) 1)) 
  (((1 49 59 63 68)) (0) ((484 469 469 469)) ((3 80 80 80 80)) ((13 0 0 0 0))))
 ((((eb) 2)) 
  (((3 39 46 55 62 67)) (0) ((968 953 953 953 953)) ((1 80 80 80 80 80)) ((13 0 0 0 0 0))))
 ((((eb) 1)) 
  (((3 39 46 55 62 67)) (0) ((484 469 469 469 469)) ((1 80 80 80 80 80)) ((13 0 0 0 0 0))))
 ((((bb m7) 2)) 
  (((10 46 56 62 67 70)) (0) ((968 953 953 953 953)) ((2 80 80 80 80 80)) ((13 0 0 0 0 0))))
 ((((bb m7) 1)) 
  (((10 46 56 62 67 70)) (0) ((484 469 469 469 469)) ((2 80 80 80 80 80)) ((13 0 0 0 0 0))))
 ((((f#) 2)) 
  (((6 42 53 58 65)) (0) ((968 953 953 953)) ((1 80 80 80 80)) ((13 0 0 0 0))))
 ((((f#) 1)) 
  (((6 42 53 58 65)) (0) ((484 469 469 469)) ((1 80 80 80 80)) ((13 0 0 0 0))))
 ((((f 7) 2)) 
  (((5 41 51 57 65)) (0) ((968 953 953 953)) ((3 80 80 80 80)) ((13 0 0 0 0))))
 ((((f 7) 1)) 
  (((5 41 51 57 65)) (0) ((484 469 469 469)) ((3 80 80 80 80)) ((13 0 0 0 0))))


;;; nouvelles positions 19/10/04:

; ((((c m7) 2))      
;   (((0 36 51 58 63)) (0) ((968 953 953 953)) ((2 80 80 80 80)) ((13 0 0 0 0)))) 
; ((((c m7) 1))
;  (((0 36 51 58 63)) (0) ((484 469 469 469)) ((2 80 80 80 80)) ((13 0 0 0 0))))

; ((((b m7) 2))       
;   (((0 46 56 61 65)) (0) ((968 953 953 953)) ((2 80 80 80 80)) ((13 0 0 0 0)))) 
; ((((b m7) 1))
;  (((0 46 56 61 65)) (0) ((484 469 469 469)) ((2 80 80 80 80)) ((13 0 0 0 0))))

))

; F7  (b5)
      
; 59=si2
; 57=la2
; 51=mib2
; 41=fa1
   
;;; VERSION CONCERT A L'ESTAM (2 octobre 2004)
;;; aucune regle ne genere de m7
;;; bug du Bbm7 joue Bb7+13, qui sonne tres bien debut 2e ligne "Goodbye"
;--------------------------------------------------
;Cm7      C#7      Eb7M    Bbm7    Gb7M     F7

;74=re4   68=sol#3 67=sol3 70=sib3 65=fa3   65=fa3
;67=sol3  63=re#3  62=re3  67=sol3 58=sib2  57=la2
;63=mib3  59=si2   55=sol2 62=re3  53=fa2   51=mib2
;48=do2   49=do#2  46=sib1 56=lab2 42=solb1 41=fa1
;                  39=mib1 46=sib1

;7e?     3ce?             Bb7+13??? 
;--------------------------------------------------

;;; nouvelles positions:

;Cm7      Bbm7(4)

;63=mib3  63=mib3
;58=sib2  61=reb3
;51=mib2  56=lab2
;36=do1   46=sib1


;;; au collectage des voicings, rajouter rythme
;;; sur les accords durant 1/2 mesure (968 ms)




; ATTENTION: cette fonction de 1-2-Arrange.lisp donne une duree fausse
; si une note duree plus longtemps qu'une note attaquee plus tard

(defun calcul-duree-totale (m)
  (+ (car (reverse (bloc-onset m))) (caar (reverse (bloc-dur m)))))


#|
(defun calcul-duree-totale (m)
  (let* ((lonset (bloc-onset m)) 
         (ldur (mapcar #'(lambda (l) (apply #'max l)) (bloc-dur m)))
         (lfin (mapcar #'+ lonset ldur)))
    (apply #'max lfin)))

|#



(setq *table-biotechnobop*        ;;; version avec accords sur canal OM=13 (Max=14)    
                                  ;;; degre=haut 0-11, chiffre=velo 1=Maj, 2=m7, 3=7

; duree demi-case = 469 ms (= 484-15)
;    - case a la demi-mesure "Rain"      ----> demi-case = 1 beat (BPM=124) = 484 ms moins 15 ms
;    - mais si case a la mesure "Blues"  ----> demi-case = 2 beats
; duree quart de case = 242 ms en val. exacte
; duree case = 953 ms (= 968-15) ----> = duree mesure si case a la mesure
; duree 2 cases = 1921 ms (= 1936-15) ----> = duree 2 mesures si case a la mesure

'(
; sequences:
       ((((b m7) 1) ((e 7) 1))
         (((11 35 66 62 61 57) (47) (4 34 73 56) (46)) (0 242 469 726)
          ((469 242 469 953 953 469) (242) (469 242 469 469) (242))
          ((2 97 69 69 69 69) (97) (3 97 69 69) (97)) ((13 1 0 0 0 0) (1) (13 1 0 0) (1))))


       ((((c# 7) 2) ((c# 7) 2))   ; basse descendante
         (((1 25 70 63 59 58 53)          (37)  (35)  (65)  (34)  (68) (32) (30)   (29)  (32)   ) 
          (0                              242   484    605  726  847   968   1210  1452  1694    )
          ((1921 227 469 953 953 953 953) (227) (227) (233) (227) (121) (227) (227) (227) (227)   )
          ((3 97 69 69 69 69 69)          (97)  (97)  (69)  (97) (69)  (97)  (97)  (97)  (97)    ) 
          ((13 1 0 0 0 0 0)               (1)   (1)   (0)   (1) (0)    (1)   (1)   (1)   (1)    )
          ))


        ;((((g# 7) 2) ((g# 7) 2))  ; basse stagnante
        ; (((8 32 65 62 60 58 54)          (39)  (37) (36)   (34)  (32)  (30)  (32)      ) 
        ;  (0                              242   484  726    968   1210  1452  1694    ) 
        ;  ((1921 227 953 953 953 953 953) (227) (242) (242)  (227) (227) (227) (227)   ) 
        ;  ((3 97 69 69 69 69 69)         (97)  (97)  (97)    (97)  (97)  (97)  (97)   )
        ;  ((13 1 0 0 0 0 0)              (1)   (1) (1)      (1)   (1)   (1)   (1)   )
        ;  ))


        ;((((g# 7) 2) ((g# 7) 2))  ; basse descendante
        ; (((8 32 65 62 60 58 54)          (44)  (42) (41)   (39)  (37)  (36)  (39)      ) 
        ;  (0                              242   484  726    968   1210  1452  1694    ) 
        ;  ((1921 227 953 953 953 953 953) (227) (242) (242)  (227) (227) (227) (227)   ) 
        ;  ((3 97 69 69 69 69 69)         (97)  (97)  (97)    (97)  (97)  (97)  (97)   )
        ;  ((13 1 0 0 0 0 0)              (1)   (1) (1)      (1)   (1)   (1)   (1)   )
        ;  ))

        ;((((g# 7) 2) ((g# 7) 2))  ; basse stagnante
        ; (((8 32 65 62 60 58 54)          (39)  (37) (36)   (34)  (32)  (30)  (32)      ) 
        ;  (0                              242   484  726    968   1210  1452  1694    ) 
        ;  ((1921 227 953 953 953 953 953) (227) (242) (242)  (227) (227) (227) (227)   ) 
        ;  ((3 97 69 69 69 69 69)         (97)  (97)  (97)    (97)  (97)  (97)  (97)   )
        ;  ((13 1 0 0 0 0 0)              (1)   (1) (1)      (1)   (1)   (1)   (1)   )
        ;  ))





; accords longs
        ((((c# 7) 2))
         (((1 37 70 63 59 58 53) (37) (65) (37) (68)) (0 242 605 726 847)
          ((953 242 469 953 953 953 953) (469) (233) (242) (121))
          ((3 97 69 69 69 69 69) (97) (69) (97) (69)) ((13 1 0 0 0 0 0) (1) (0) (1) (0))))
        ((((g# m7) 2))
         (((8 32 63 59 58 54) (44) (32) (44)) (0 469 726 847)
          ((953 469 953 953 953 953) (242) (121) (121)) ((2 97 69 69 69 69) (97) (97) (97))
          ((13 1 0 0 0 0) (1) (1) (1))))
        ((((g# 7) 2))
         (((8 32 65 62 60 58 54) (44) (32) (44)) (0 242 469 726)   ;;;;(16 258 500 742)
          ((953 242 953 953 953 953 953) (242) (242) (242)) ((3 97 69 69 69 69 69) (97) (97) (97))
          ((13 1 0 0 0 0 0) (1) (1) (1))))
        ((((b 7) 2))
         (((11 35 68 63 61 57) (42) (47) (69) (73)) (0 242 469 605 847)
          ((953 242 469 953 953 953) (242) (242) (250) (121)) ((3 97 69 69 69 69) (97) (97) (69) (69))
          ((13 1 0 0 0 0) (1) (1) (0) (0))))
        ((((f#) 2))
         (((6 30 70 65 61 58 54) (42) (37)) (0 242 726) ((953 242 953 953 953 953 953) (469) (242))
          ((1 97 69 69 69 69 69) (97) (97)) ((13 1 0 0 0 0 0) (1) (1))))
        ((((c# m7) 2))
         (((1 37 63 59 56 52) (37) (37)) (0 242 726) ((953 242 953 953 953 953) (469) (242))
          ((2 97 69 69 69 69) (97) (97)) ((13 1 0 0 0 0) (1) (1))))
        ((((c#) 2))
         (((1 37 63 60 56 53) (37) (37)) (0 242 726) ((953 242 953 953 953 953) (469) (242))
          ((1 97 69 69 69 69) (97) (97)) ((13 1 0 0 0 0) (1) (1))))

; accords courts
        ((((b m7) 1))
         (((11 35 66 62 61 57) (47)) (0 242) ((469 242 469 469 469 469) (242)) ((2 97 69 69 69 69) (97))
          ((13 1 0 0 0 0) (1))))
        ((((b 7) 1))
         (((11 35 68 63 61 57) (47)) (0 242) ((469 242 469 469 469 469) (242)) ((3 97 69 69 69 69) (97))
          ((13 1 0 0 0 0) (1))))
        ((((f#) 1))
         (((6 30 70 65 61 58 54) (42)) (0 242) ((469 242 469 469 469 469 469) (242))
          ((1 97 69 69 69 69 69) (97)) ((13 1 0 0 0 0 0) (1))))
        ((((e m7) 1))
         (((4 40 66 62 59 55)) (0) ((469 469 469 469 469 469)) ((2 97 69 69 69 69)) ((13 1 0 0 0 0))))
        ((((e 7) 1))
         (((4 40 70 66 62 56)) (0) ((469 469 469 469 469 469)) ((3 97 69 69 69 69)) ((13 1 0 0 0 0))))
        ((((e) 1))
         (((4 40 71 68 66 63) (52)) (0 242) ((469 242 469 469 469 469) (242)) ((1 97 69 69 69 69) (97))
          ((13 1 0 0 0 0) (1))))))

(setf *table-arrangements* 

*table-biotechnobop*)
;*table-goodbye*)


















#|
;10 avril 2005: grilles pour exemple application de regles (mediations)
; Regle 1: C7 Fm7 -> Gbm7 Fm7
; Regle 2: Fm7 Bb7 -> B7 Bb7
; Regle 3: Gbm7 -> Db7 / Gbm7


(setf *grille-defautbeat* 
  '((bb) / (c 7) / (f m7) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))

; Regle 2: STOP
(setf *grille-defautbeat* 
  '((bb) / (c 7) / (b 7) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))

; Regle 1:
(setf *grille-defautbeat* 
  '((bb) / (f# m7) / (f m7) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))

(setf *grille-defautbeat* 
  '((bb) / (f# m7) / (b 7) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))

(setf *grille-defautbeat* 
  '((bb) / (c# 7) (f# m7) / (b 7) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))

; Regle 3:
(setf *grille-defautbeat* 
  '((bb) / (c# 7) (f# m7) / (f m7) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))


|#