(in-package :om)


(defclass orchestre ()
  (
   (improvizer-array :initform ()
                     :initarg :improvizer-array :accessor improvizer-array)
   (nb-improvizers :initform 4 :initarg :nb-improvizers :accessor nb-improvizers)
   (nbeatsaccord :initform 1 :initarg :nbeatsaccord :accessor nbeatsaccord)
   (dureebeat :initform 484 :initarg :dureebeat :accessor dureebeat)
   (grille :initform () :initarg :grille :accessor grille)
   (blues? :initform nil :initarg :blues? :accessor blues?)
    ))


(defmethod save-orchestre-as ((self orchestre))
  (catch-cancel
    (let* ((name (choose-new-file-dialog :prompt "Save Orcehstre As...")))
      (when name
        (WITH-OPEN-FILE (out name :direction :output  :if-does-not-exist :create :if-exists :supersede
                             :external-format :|TEXT|)
          (prin1 '(in-package :om) out)
          (prin1 (omng-save  self) out))))))



(defmethod load-improvizer-into ((self orchestre) (numin integer)(numout integer) )
  (let ((orchestre (load-orchestre-from)))
    (when (neq orchestre :cancel)
      (let ((improvizer (aref (improvizer-array orchestre) numin)))
        (setf (aref (improvizer-array self) numout) improvizer)
        (format t "Loaded improvizer ~a at position ~a in orchestra~%" numin numout)
        improvizer))))


#|
(defmethod reset-free-oracle-0 ()
  (let ((orchestre (cree-free)))
    (setf (aref (improvizer-array ms::*orchestre*) 0)
          (aref (improvizer-array orchestre) 0))
    (setf ms::*oracle-courant* (aref (improvizer-array ms::*orchestre*) 0)
          ms::*oracle1* ms::*oracle-courant*)
    (format t "Reset free oracle 0 in free orchestra~%")
    t))
|#


(defmethod load-orchestre-from ()
  (catch-cancel
    (let ((name (choose-file-dialog)))
      (when name
        (WITH-OPEN-FILE (in name :direction :input  :if-does-not-exist :nil)
          (eval (read in)) (eval (read in)))))))


(defmethod load-orchestre-direct (file)
  (catch-cancel
    (WITH-OPEN-FILE (in file :direction :input  :if-does-not-exist :nil)
      (eval (read in)) (eval (read in)))))

(defun new-orchestre ()
  (make-instance 'om::orchestre 
    :improvizer-array 
    (make-array 4 :initial-contents 
                (list (om::NewImprovizer)(om::NewImprovizer)
                      (om::NewImprovizer)(om::NewImprovizer) ))))


(defmethod mk-orc-from-impro ((self improvizer))
  (let* ((orchestre (new-orchestre)))
    (setf (aref (improvizer-array orchestre) 0) self)
    orchestre))


#|
(setf midishare::*orchestre*
      (make-instance 'orchestre 
        :improvizer-array 
        (make-array 4 :initial-contents 
                    (list midishare::*oracle1* midishare::*oracle2* midishare::*oracle3* midishare::*oracle4*))))
|#

