(in-package :om)

(defun estr-analyse (chord)
  (let ((intl (x->dx 
               (sort (loop for note in chord
                           for note2 = (mod (round note 100) 12)
                           with result
                           if (not (member note2 result)) collect note2 and do (push note2 result)
                           finally return result)
                     '<)
               )))
    (nconc intl (list (- 12 (apply '+ intl))))))


(defun estr-compare (ch1 ch2)
  (loop for i in ch1
        while ch2
        if (member i ch2)
        do (setf ch2 (remove  i ch2 :count 1)) and sum 1))

(defun dist-estrada (ch1 ch2)
  (let* ((ch1 (estr-analyse ch1))
         (ch2 (estr-analyse ch2)))
    (- (max (length ch1) (length ch2)) (estr-compare ch1 ch2))))
         


; On part de l'accord chord
; Pour chaque note de l'accord, on la compare au reste de l'accord
; Si on trouve un intervalle de quinte, la basse de cette quinte est la basse de l'accord
; Sinon, on fait la mme opration avec la tierce majeure (4)
; si on ne trouve ni 5te ni 3ceM alors, on prend la note la plus grave de l'accord comme basse 
(defun hindem (chord)
  (setq soluce nil)
  (loop for note in chord
        do 
        (loop for note2 in (member note chord :test #'equal)
              do 
              (if (= (mod (abs (- note2 note)) 12) 7)
                (progn (setq soluce (min note2 note))
                       (return soluce))))
        (if soluce
          (return soluce)
          (loop for note in chord
                do 
                (loop for note2 in (member note chord :test #'equal)
                      do 
                      (if (= (mod (abs (- note2 note)) 12) 4)
                        (progn (setq soluce (min note2 note))
                               (return soluce))))
                (if soluce
            (return soluce)
          (return (apply #'min chord)))))))





#|
(analyse1 '(6000 6300 6500 6800 7000 7200))

(estr-compare '(2 2 2 3) '(2 3 3 2 2 4) )
   

(time (loop for i from 1 to 150 do (dist-estrada'(6000 6700 7300 7900 8700 5200 4200 6700 6400 7700) 
                   '(6000 4700 5200 6400 6800 5500 6700 8000 8700 7600))))

(loop for i from 1 to 10 sum i)
|#