;;; ==================================================
;;; Fichier 1-5-Steedmanportion.lisp / 13 octobre 2004
;;; ==================================================

(in-package :midishare)


(defun fonction-grammaireportion (numcase)
  (fonction-reecriture 82 *grilletmp* numcase))

(defun fonction-reecriture (id grille numcase)
  (let* ((groupage (portion-grille grille numcase (+ numcase 4)))   ;;; 4 = longueur de portion
         (debut (first groupage)) (oldmilieu (second groupage)) (fin (third groupage))
         (newmilieu (annule-div-grille (reecriture oldmilieu *k*))))
    (setf *grilletmp* (append debut newmilieu fin))  ;;; *grilletmp* mis a jour a chaque substi. (toujours sans rotation)
    (let* ((oldgroupage (portion-grille *grille* numcase (+ numcase 4)))
           (oldaccords (extrait-accords (second oldgroupage) numcase))
           (newaccords (extrait-accords newmilieu numcase))
           (liste-chgts (compare-accords oldaccords newaccords)))
      (joue-accords-om->max 83 liste-chgts newaccords)) 
    (let* ((rotation-grille (if (and (null newmilieu) (null fin)) debut   ;;; pas de rajout de /
                                (append newmilieu fin (list '/) (butlast debut))))
           (piano-bass-voicings (virtual-boogie rotation-grille *table-arrangements* *duree-mes*)))
      (setf *genere-quoi* 'grammaire)
      (5-listes->max id piano-bass-voicings)   ;;; 82 = identifiant des sequences calculees par "grammaireportion"
)))

;(fonction-grammaireportion 3)

 ;;; envoi a Max d'une sequence correspondant a la duree totale de la boucle (d'ou rotation de la grille)

;;; pb: si la portion traitee etait deja substituee, impossible de revenir a un stade moins substitue
;;; => reecriture-portion s'applique a *grilletmp*
;;; alors que reecriture s'applique a *grille*


;;; ============================================
;;; FORMAT DES DONNEES D'ACCORDS DE OM VERS MAX
;;; ============================================
;;; au debut: (127 3 id) id = pour identifier la sequence dans Max, id = 83
;;; data = liste d'entiers-octet, du type:
;;;      (127 6 indice d1 c1)  -> 1 accord dans la case
;;;      (127 6 indice d1 c1 d2 c2)  -> 2 accords dans la case
;;;      (127 6 indice d1 c1 d2 c2 d3 c3 d4 c4)  -> 4 accords dans la case
;;; indice = numero de case (version ad hoc pour "Goodbye")
;;;      (127 7 numeros de cases substituees pour chgt couleur)
;;; a la fin: (127 0 127) 


(defun joue-accords-om->max (id liste-chgts liste-numcases-accords)
  (envoie-event-om->max *iac2* (list 127 3 id))
  (when (not (null liste-chgts)) (envoie-event-om->max *iac2* (append (list 127 7) liste-chgts)))
  (let ((paquet (apply #'append (mapcar #'(lambda (couple)
                                            (append (list 127 6 (car couple)) (cadr couple)))
                                        liste-numcases-accords))))
    (envoie-event-om->max *iac2* (append paquet (list 127 0 127)))))


;;; 1-1-Steedman.lisp
;;; (reecriture grille k) renvoie la grille substituee dans le meme format

;;; numcase compte a partir de 1, "milieu" = entre numcase1 compris, et numcase2 non compris

(defun portion-grille (grille numcase1 numcase2)
  (let ((debut ()) (milieu ()) (fin ()) (n 1))
    (do ((l grille (cdr l)))
        ((null l) (mapcar #'reverse (list debut milieu fin)))
      (cond ((< n numcase1) (setf debut (cons (car l) debut)))
            ((< n numcase2) (setf milieu (cons (car l) milieu)))
            (t (setf fin (cons (car l) fin))))
      (when (equal (car l) '/) (setf n (1+ n))))))


;(portion-grille *grille* 3 5)

(defun extrait-accords (grille numcase)
  (let ((liste-cases (groupe-cases grille)) (res ()) (num numcase))
    (do ((l liste-cases (cdr l)))
        ((null l) (reverse res))
      (setf res (cons (list num (apply #'append (mapcar #'label->pitch-vel (car l)))) res))
      (setf num (1+ num)))))

(defun groupe-cases (grille)
  (let ((res ()) (case ()))
    (do ((l grille (cdr l)))
        ((null l) (if (null case) (reverse res)
                      (reverse (cons (reverse case) res))))
      (if (equal (car l) '/)
        (progn (setf res (cons (reverse case) res))
               (setf case ()))
        (setf case (cons (car l) case))))))


(defun degroupe-cases (liste-cases)
  (apply #'append (cons (car liste-cases)
                        (mapcar#'(lambda (c) (cons '/ c)) (cdr liste-cases)))))


(defun label->pitch-vel (acc)
  (list (deg->pitch (sans-marque acc)) (chif->vel (accord-chiffre acc))))

(defun deg->pitch (deg)
  (case deg (c 0) ((c# dd) 1) (d 2) ((d# eb) 3) (e 4) (f 5) ((f# gb) 6) (g 7) ((g# ab) 8) (a 9) ((a# bb) 10) (b 11)))

(defun chif->vel (chif) (case chif (nil 1) (m7 2) (7 3) (t 1)))

(defun compare-accords (liste-numcases-accords1 liste-numcases-accords2)
  (let ((liste-chgts ()))
    (do ((l1 liste-numcases-accords1 (cdr l1)) (l2 liste-numcases-accords2 (cdr l2)))
        ((null l1) (apply #'append (reverse liste-chgts)))
      (if (not (equal (cadr (car l1)) (cadr (car l2)))) 
        (setf liste-chgts (cons (list (car (car l1)) 1) liste-chgts))
        (setf liste-chgts (cons (list (car (car l1)) 0) liste-chgts))))))























#|
(defclass* harmonizer ()
   (
    (RefHarmGrid :initform nil :initarg :RefHarmGrid :accessor RefHarmGrid)
    (HarmGridLength :initform 48 :initarg :HarmGridLength :accessor HarmGridLength)
    (Beats/Measure :initform 4 :initarg :Beats/Measure :accessor Beats/Measure)
    (RefTempo :initform 536 :initarg :RefTempo :accessor RefTempo) ; in ms
    ))

|#


#|
(defclass* orchestre ()
  (
   (improvizer-array :initform ()
                     :initarg :improvizer-array :accessor improvizer-array)
   (nb-improvizers :initform 4 :initarg :nb-improvizers :accessor nb-improvizers)
   (nbeatsaccord :initform 1 :initarg :nbeatsaccord :accessor nbeatsaccord)
   (dureebeat :initform 484 :initarg :dureebeat :accessor dureebeat)
   (grille :initform ms::*grille-rain* :initarg :grille :accessor grille)
   (blues? :initform nil :initarg :blues? :accessor blues?)
   ))

(defclass* improvizer (pythie)
   (
    (context :initform () :initarg :context :accessor context)
    (continuity :initform 0 :initarg :continuity :accessor continuity)
    (max-continuity :initform 8 :initarg :max-continuity :accessor max-continuity)
    (start-region :initform '(0 100) :initarg :start-region :accessor start-region)
    (fwsuffix :initform T :initarg :fwsuffix :accessor fwsuffix)
    (bwsuffix :initform T :initarg :bwsuffix :accessor bwsuffix)
    (bestSuffixMode :initform T :initarg :bestSuffixMode :accessor bestSuffixMode)
    (useEstrada :initform nil :initarg :useEstrada :accessor useEstrada)
    (useHindemith :initform nil :initarg :useHindemith :accessor useHindemith)
    (RefHarmGrid :initform nil :initarg :RefHarmGrid :accessor RefHarmGrid)
    (HarmGridLength :initform 48 :initarg :HarmGridLength :accessor HarmGridLength)
    (Beats/Measure :initform 4 :initarg :Beats/Measure :accessor Beats/Measure)
    (RefTempo :initform 536 :initarg :RefTempo :accessor RefTempo) ; in ms
    ))


(defclass* event ()
  (
   (MidiSet :initform () :initarg :MidiSet :accessor MidiSet)
   (duration :initform 500 :initarg :duration :accessor duration)
   (data :initform nil :initarg :data :accessor data)
   ))

(defclass* beat (event)
  (
   (HarmLabel :initform () :initarg :HarmLabel :accessor HarmLabel)
   (RelHarmLabel :initform () :initarg :RelHarmLabel :accessor RelHarmLabel)
   (NumBeat :initform 1 :initarg :NumBeat :accessor NumBeat) ; in the measure
   (RefHarmLabel :initform 1 :initarg :RefHarmLabel :accessor RefHarmLabel) ; label before substitution
   (StartPhrase :initform () :initarg :StartPhrase :accessor StartPhrase) ; booleen
   (QMidiSet :initform () :initarg :QMidiSet :accessor QMidiSet) ; quantized midiset
   (Qdivision :initform 1 :initarg :Qdivision :accessor Qdivision)
   (Density :initform 1 :initarg :Density :accessor Density)
   ))


|#