;;; ============================================
;;; OVOX Fev 2006
;;; ============================================

(in-package :midishare)

(setf *Ovox-mode* T *mode-beat* nil *Ofon-mode* nil)

(om::set-rec-min 50) ;;; vrifier avec Georges

(defun om::omax ()
  (setf *suite?* t)
  (setf *numbeat* 0)
  (MidiConnect *refnum* 0 -1)			; connect MCL to MidiShare
  (MidiConnect 0 *refnum* -1)			; connect MidiShare to MCL
  (MidiFlushEvs *refnum*)			; flush old events in the rcv fifo
  (let ((seq-tmp ()) (date-init (MidiGetTime)) (accord-init ())
        (seq-inst ()) (clock-ev ()) (clock-ev-date ()) 
        (accord-ev ()) (bool-enreg nil) (bool-inst nil)
        (seq-bend-tmp nil) (syll-counter 0) (seq-syll nil))
    (loop while (and *suite?* *midishare*) do 
          (do ((event (MidiGetEv *refnum*) (MidiGetEv *refnum*)))	;read all the events
              ((%null-ptr-p event))		                        ; in the rcv fifo (defaut port 0=iac1)
            ;(setf clock-ev nil)
            (when (member (type event) (list typeNote typeKeyOn typeClock typePitchBend))
              (when (eq (type event) typeClock) 
                (setf clock-ev event)      ;;; dernier clock recu, nil=>non mesure
                (setf clock-ev-date (date event)) ; l'event est freed en fin de boucle !!!!
                (setf *numbeat* (1+ *numbeat*)))
              
              (when (and (member (type event) (list typeNote typeKeyOn))   ;;; dernier accord NoteOn recu 
                         (= (chan event) 13) ;;; canal OM=13 (Max=14) -> accords de la grille
                         (> (vel event) 0))
                (setf accord-ev (list (pitch event) (vel event))) )           
              (if (and (member (type event) (list typeNote typeKeyOn))
                       (member (chan event) '(14 15)))
                (case (chan event)
                  (15                                    ;;; canal OM=15 (Max=16) -> instructions
                   (case (pitch event)
                     ;------------------------------------------------------------------------------------------
                     (61 (setf bool-enreg t)      ;;;............... debut enregistrement
                      ; si mode beat, l'origine des dates est le beat courant sinon l'evenement debut enreg.
                      (setf date-init 
                            (if *mode-beat* clock-ev-date (date event)))
                      (setf seq-tmp () seq-bend-tmp ())
                      (setf accord-init accord-ev)
                      (setf *numbeatinit* *numbeat*))
                     ;------------------------------------------------------------------------------------------
                     (62 (setf bool-enreg nil)    ;;;............... fin enregistrement
                      (when seq-tmp
                        (if  (< (caar (last seq-tmp)) *min-rec-dur*)
                          (format t "~%Phrase tro courte (~D ms), non enregistree~%" (caar (last seq-tmp)))
                          (progn 
                            (format t "~%Recu phrase de ~a evenements~% " (length seq-tmp))
                            (setf seq-tmp (flush-note-off (- (date event) date-init) (reverse seq-tmp)))
                            
                            (cond
                         (*mode-beat*               ;;; CAS HARMONICO-METRIQUE => clock init
                               (setf seq-tmp (cons '(0 248)                     
                                                   (cons (list 10 157 (car accord-init) (cadr accord-init));;; accord precedent phrase live
                                                         seq-tmp))) 
                               (setf seq-tmp (formate-liste-events->liste-beats  seq-tmp))     ;;; cf. 6-Voicings.lisp
                               (om::learn-beat-list *oracle-courant* seq-tmp *numbeatinit*)  ;;; AJOUTER NUMERO CLOCK
                               )
                         (*ovox-mode*
                               (let ((clocks-beats (formate-voxlist>liste-beats  seq-tmp)))
                                 (om::learn-vox-beat-list *oracle-courant* (second clocks-beats) (first clock-beats) (- (date event) date-init))  
                                 
                                 )
                           (*ofon-mode*
                                 (setf seq-tmp (cadr (list-ev->quintuples seq-tmp)))   ;;; !!!!!!!!VERSION FREE!!!!!
                                 (let ((prevmaxetat (om::maxEtat *oracle-courant*)))
                                   (om::learn-event-list *oracle-courant* (om::mf->crossEvents (list seq-tmp)))
                                   (om::learn-bend-list *oracle-courant* prevmaxetat (reverse seq-bend-tmp)))
                                 )
                                )
                         (t ; mode free
                               (setf seq-tmp (cadr (list-ev->quintuples seq-tmp)))   ;;; !!!!!!!!VERSION FREE!!!!!
                               (om::learn-event-list *oracle-courant* (om::mf->crossEvents (list seq-tmp)))
                               )
                              )
                            (format t "ajoutee dans l'oracle"))))
                      (setf seq-tmp () seq-bend-tmp ()))
                     ;------------------------------------------------------------------------------------------
                     
                     (82 (setf bool-enreg nil)    ;;;............... fin enregistrement SANS garder seq-tmp
                      (setf seq-tmp ()))
                     
                     ;------------------------------------------------------------------------------------------
                     (80 (setf bool-inst t))                   ;;; debut appel generique de fonction
                     (81 (print "toto")(when (not (null seq-inst))           ;;; fin appel generique de fonction
                                         (fonction-generique seq-inst)
                                         (setf seq-inst ())
                                         (setf bool-inst nil)))
                     ;------------------------------------------------------------------------------------------
                     (58 (setf bool-inst t))                   ;;; debut donnees choix oracle
                     (59 (when (not (null seq-inst))           ;;; fin donnees choix oracle
                           (fonction-choixoracle seq-inst)
                           (setf seq-inst ())
                           (setf bool-inst nil)))
                     ;------------------------------------------------------------------------------------------
                     (60 (fonction-grammaire))
                     (57 (fonction-affichegrille))
                     (63 (setf bool-inst t))                   ;;; debut donnees grammaire
                     (64 (when (not (null seq-inst))           ;;; fin donnees grammaire
                           (fonction-controlegrammaire seq-inst)
                           (setf seq-inst ())
                           (setf bool-inst nil)))
                     ;------------------------------------------------------------------------------------------
                     (69 (format t "Code 69 recu (free impro)~%")
                      (fonction-free)
                      )
                     (70 (setf bool-inst t))                   ;;; debut donnees free (sans clock)
                     (71 (when (not (null seq-inst))           ;;; fin donnees free (sans clock)
                           (fonction-controlefree seq-inst)
                           (setf seq-inst ())
                           (setf bool-inst nil)))
                     ;------------------------------------------------------------------------------------------
                     (50 (setf *numbeat* 0))
                     ))
                  (14                             ;;; canal OM=14 (Max=15) -> donnees pour instructions 
                   (setf seq-inst (cons (pitch event) seq-inst)))
                  )
                
                ;;; EVENT AUTRE QUE FONCTION OU DATA
                (if (eq (type event) typePitchBend)
                  (let ((bendval (+ 8192 (bend event))))
                    (push (list (chan event) bendval) seq-bend-tmp))
                  ;; Ofon pitch bend sur canal 234
                  (when bool-enreg 
                    ;(print (type event))
                    (setf seq-tmp  (cons (cons (- (date event) date-init)
                                               (if (eq (type event) typeClock)
                                                 (list 248)
                                                 (list (+ 144 (chan event)) (pitch event) (vel event))))
                                         seq-tmp)))
                  )))
            (MidiFreeEv event)
            )))
  (and *midishare* (MidiConnect 0 *refnum* 0))	
  (and *midishare* (MidiConnect  *refnum* 0 0))
  )


(defun formate-voxlist>liste-beats (seq-live)             
  (let* ((5u (list-ev->quintuples (copy-tree seq-live)))   ;;; a cause des modifications physiques
         (clocks (first 5u)) (quint (second 5u)))
    (list clocks
          (set-relative-time-beat clocks (cut-beat-events clocks (quintuples->beats clocks quint))))))


(in-package :om)

(defclass* voxbeat (beat)
  (
   ))


(in-package :om)

(defmethod learn-vox-beat-list ((self improvizer) (beats list) (clocks list) (end-time number))
  (let ((beat-list (make-vox-beat-list beats))
        (beat-durs (nconc (x->dx (mapcar #'first clocks)) (list (- end-time (first (last clocks)))))))
    
    (when beat-list (setf (StartPhrase (first beat-list)) T))
    (loop for beat in beat-list  
          for dur in beat-durs 
          do 
          (setf (duration beat) dur )
          (set-qMidiSet beat)
          (setf (density beat) (beat-density beat))
          (learn-event self beat))
    self))

(defun make-vox-beat-list (list-of-beats)
  (mapcar 'make-vox-beat list-of-beats))

(defun make-vox-beat (beat-list)
  (make-instance 'voxbeat :MidiSet (second beat-list)))


(setf levts   
      '((0 248) (10 157 10 2) (0 155 80 95) (137 155 80 0) (147 155 81 55) (232 155 80 61) (262 155 81 0) (337 155 78 58) (342 155 80 0) (427 155 78 0) (462 157 10 0) 
        (462 248) (462 155 80 67) (464 157 3 3) (752 155 78 79) (787 155 80 0) (940 157 3 0) 
        (940 248) (947 157 8 2) (1227 155 75 64) (1262 155 78 0) (1367 155 75 0) 
        (1422 248) (1902 157 8 0) 
        (1902 248) (1902 155 73 58) (1904 157 1 3) (2042 155 73 0) 
        (2380 248) (2387 155 73 82) (2635 155 75 60) (2667 155 73 0) (2807 155 75 0) (2862 157 1 0) 
        (2862 248) (2867 157 6 1) 
        (3342 248) (3820 157 6 0) 
        (3820 248) (3827 157 8 3) 
        (4302 248) (4782 157 8 0) 
        (4782 248) (4787 157 11 3) (4807 157 11 0)))

(ms::formate-voxlist>liste-beats levts)

