(in-package :om)

(setf *MINIMUM-STACK-OVERFLOW-SIZE* (* 32768 64))


(defclass* coracle (improvizer)
  ((lock  :initform (make-lock 'impro-lock)  :accessor lock :initarg :lock)
   ;help finding phrases, phrase number cache
   (phrase-alist :initform nil  :accessor phrase-alist :initarg :phrase-alist )
   ))


(defclass improviser (agent)
  ( (oracle :accessor oracle :initarg :oracle)
    (continuity :initform 0 :initarg :continuity :accessor continuity)
    (max-continuity :initform 8 :initarg :max-continuity :accessor max-continuity)
    (start-play :initform nil :accessor start-play :initarg :start-play )
    (stop :initform nil :accessor stop :initarg :stop)
    (gindex :initform 0  :accessor gindex :initarg :gindex :type integer)
    (durseg :initform 0  :accessor durseg :initarg :durseg :type integer)
    (blocmode :initform nil  :accessor blocmode :initarg :blocmode)t
    (startOnPhrase :initform nil  :accessor startOnPhrase :initarg :startOnPhrase)
    (blocStartPhrase :initform -1  :accessor blocStartPhrase :initarg :blocStartPhrase)
    
    ; en index sur l'oracle
    (CurRegion :initform (list 1 1) :accessor CurRegion :initarg :CurRegion)
    
    ; en pourcentage de la longueur de l'oracle
    (CurRegion% :initform (list 0 100) :accessor CurRegion% :initarg :CurRegion%) 
    (AbsoluteRegions :initform NIL :accessor AbsoluteRegions :initarg :AbsoluteRegions)

    (PoursuiteMode :initform NIL :accessor PoursuiteMode :initarg :PoursuiteMode)

    (Poursuite :initform 5000 :accessor Poursuite :initarg :Poursuite)

    (*impro-tabou-states* :initform NIL :accessor  *impro-tabou-states* :initarg :*impro-tabou-states*)
    (*suffix-quality-thresh* :initform 0.25 :accessor *suffix-quality-thresh* :initarg :*suffix-quality-thresh*)
    (*min-suffix-length* :initform *min-suffix-length* :accessor *min-suffix-length* :initarg :*min-suffix-length*)
    (*Tabou-list-length* :initform 8 :accessor *Tabou-list-length* :initarg :*Tabou-list-length*)
    (*proba-if-1-sol* :initform 0.5 :accessor *proba-if-1-sol* :initarg :*proba-if-1-sol*)
    (*Close-edge-dist* :initform 15 :accessor *Close-edge-dist* :initarg :*Close-edge-dist*)
    
    (*regional-impro* :initform NIL :accessor *regional-impro* :initarg :*regional-impro*)


    ;;; Recombination Candisate search

    (SLTEscapeTag :initform (list 'SLTEscapeTag)  :accessor SLTEscapeTag :initarg :SLTEscapeTag )

    ; solution list temp data

    (recsolutions :initform (cons nil nil)  :accessor recsolutions :initarg :recsolutions )
    (maxRecSolNb :initform 6  :accessor maxRecSolNb :initarg :maxRecSolNb )
    (recSolNb :initform 0  :accessor recSolNb :initarg :recSolNb )
    (RecSolImproved :initform nil  :accessor RecSolImproved :initarg :RecSolImproved )
    (MinSolRlength :initform 1000  :accessor MinSolRlength :initarg :MinSolRlength )

    ; Search critical state

    (RecCritical :initform nil  :accessor RecCritical :initarg :RecCritical )

    ; limitate 1-length suffix search
    (onecounter :initform 0  :accessor onecounter :initarg :onecounter )
    (maxonecount :initform 100  :accessor maxonecount :initarg :maxonecount )

    ; keep track of time take for slt exploration
    (exploretime :initform 0  :accessor exploretime :initarg :exploretime )


    )
  )



(defclass CrossEvent (event)
  ((StartPhrase :initform () :initarg :StartPhrase :accessor StartPhrase)
   (EndPhrase :initform () :initarg :EndPhrase :accessor EndPhrase)
   (phraseNumber :initform  0 :initarg :phraseNumber :accessor phraseNumber)
   (virFun :initform  nil :initarg :virFun :accessor virFun)
   (endSection :initform  nil :initarg :endSection :accessor endSection)   
   ))


(defvar *SLength-distribution* #(1 2 3 25 50 80 130 210 340 550 900 1450 2000))


;bug in segment initialization

(defun new-osc-midi-player (name)
  (make-instance 'osc-midi-player :name name  :cursegdur 0 :segment nil :seg-onset 0))

(defmethod clean-up ((self osc-midi-player))
  (empty-queue (agent-listening-queue self))
  (reinitialize-instance self  :cursegdur 0 :segment nil :seg-onset 0 :next-time 0)
  self)



;;;  Comparison function is now based on virfun plus categorized length of chords


(defmethod vfun ((Event CrossEvent))
  (or (virfun event)
      (let ((m1 (mapcar #'(lambda (x) (abs (MEPitch x))) (MidiSet Event))))
            (setf (virfun event)
                  (mod (virtual-fundamental m1 50) 1200))
            (virfun event))))

        

#|
(defmethod CompareEvents ((Event1 CrossEvent) (Event2 CrossEvent))
  
  (let* ((m1 (mapcar #'(lambda (x) (abs (MEPitch x))) (MidiSet Event1)) )
         (m2 (mapcar #'(lambda (x) (abs (MEPitch x))) (MidiSet Event2)) ))
         (and
          ( = (floor (log (length m1) 2)) (floor (log (length m2) 2)))
          (= (mod (virtual-fundamental m1 50) 1200) (mod (virtual-fundamental m2 50) 1200))
          )))
|#


(defmethod CompareEvents ((Event1 CrossEvent) (Event2 CrossEvent))
  (and (= (vfun event1) (vfun event2))
       ( = (floor (log (length (midiset event1)) 2)) (floor (log (length (midiset event2)) 2)))))


;;; must set lrs before setting suppleance

(defmethod ajouter-objet ((self oracle) (objet t))
  (let ((m (maxetat self)) )
    (when (>= (1+ m) (length (vectext self)))
      (setf (vectext self) (adjust-array (vectext self) (+ 500 (length (vectext self)))))
      (when (lrsmode self) (setf (veclrs self) (adjust-array (veclrs self) (+ 500 (length (veclrs self)))))))
    
    (creer-etat self (1+ m))
    (setf (otext self (1+ m)) objet)
    (setf (transition self m objet) (1+ m))
    (loop for etat = (suppleance self m) then (suppleance self etat)
          with Pi1 = m
          while (and (> etat -1)
                     (null (transition self etat objet)))
          do (setf (transition self etat objet) (1+ m)
                   Pi1 etat)
          finally
          (let ((sp (if (= etat -1)  0 (transition self etat objet))))
            (when sp 
              (when (lrsMode self)
                (setf (lrs self (1+ m)) (LenghrepeatedSuffix self Pi1 sp)))
              (setf (suppleance self (1+ m)) sp))))
    self))


;;; forward suppleances must be ordered by lrs


(defmethod (setf suppleance) ((etat2 integer) (oracle oracle) (etat integer) )
  (setf (gethash etat (hashsuppl oracle))
        etat2)
  (if (null (gethash etat2 (hashsuppl-> oracle)))
    (setf (gethash etat2 (hashsuppl-> oracle))
          etat)
    (loop
      for state2 = etat2 then state1
      for state1 = (gethash etat2 (hashsuppl-> oracle)) then (gethash state1 (hashsuppl<-> oracle))
      while state1
      while (< (lrs oracle etat) (lrs oracle state1))
      finally (progn
                (if (= state2 etat2)
                  (setf (gethash state2 (hashsuppl-> oracle)) etat)
                  (setf (gethash state2 (hashsuppl<-> oracle)) etat))
                (setf (gethash etat (hashsuppl<-> oracle)) state1)))))

; direct forward suppleances
(defmethod Suppleance--> ((self improviser) state)
  (loop
    with oracle = (oracle self)
    for state1 = (gethash state (hashsuppl-> oracle)) then (gethash state1 (hashsuppl<-> oracle))
    while state1
    collect state1 ))
  

;;; ==========================================================================================
;;; continuous vs recombination switch
;;; ==========================================================================================


#|
(defmethod continue-impro ((self improviser))
  (if (not (time-to-scan-ahead self))
    (move-linearly self)
    (let ((choice (GetRecombination self)))
;(print (list 'found choice))
      (if (null choice)
        ;(progn (setf (continuity self) 0) (move-linearly self))
        (move-to-end-scan self)
        (move-to-suffix self choice)))))
|#



(defmethod move-to-suffix  ((self improviser) suffix)
  (loop for i from (1+ (gindex self)) to (first suffix)
        do (impro-output-1-event self i))
  (dprint "~%~%c: ~a Jumping from ~a to ~a length ~a qual ~,2f ~%~%" 
          (continuity self) (first suffix) (1+ (second suffix)) (third suffix) (fourth suffix))
  (setf (continuity self) 0)
  (impro-output-1-event self (1+ (second suffix)))
  (push (second suffix) (*impro-tabou-states* self))
  (when (> (length (*impro-tabou-states* self)) (*Tabou-list-length* self)) 
    (setf  (nthcdr (*Tabou-list-length* self) (*impro-tabou-states* self))  nil))
  )



;;; ==========================================================================================
;;; Recombination Candidates Search Strategy
;;; ==========================================================================================



;;; MACROS

(defmacro SLTSons (s i)
  `(suppleance-->  ,s ,i)
  )

(defmacro repeatlength (s i)
  `(lrs ,s ,i))

(defmacro SLTFather (s i)
  `(let ((supp (suppleance  (oracle ,s) ,i)))
     (if (> supp 0) supp nil)))

(defmacro SLTIncreaseParseCounter (s) 
  `(incf (SLTParseCounter  ,s)))

(defmacro SLTEscapeSearch (s)
  `(throw (SLTEscapeTag ,s) t))

(Defmacro SLTCatch (s &body body)
  `(catch (SLTEscapeTag ,s)
     ,. body ))

(defmacro RLengthThresh (s)
  `(if (RecCritical ,s)
     1
     (*min-suffix-length* ,s))
  )

(defmacro RhythmQuality (s)
  `(if (RecCritical ,s)
     0.5
     (*suffix-quality-thresh* ,s))
  )

(defmacro ProbIfOneSol (s)
  `(if (RecCritical ,s)
     1
     (*proba-if-1-sol* ,s))
  )


(defmacro IndexInImproBounds (s)
  `(and (>= (gindex ,s) (ImproLeftBound ,s))
        (< (gindex ,s) (ImproRightBound ,s))))


;------------------------------------------------------------------------------------



;;; GetRecombination explores the candidates indexes for a recombination switch
;;; Candidates are along a segment  following the last continuous index generated
;;; builds a vector with the N better recombination targets
;;; chooses one stochastically (or NIL if none)

(defmethod GetRecombination ((self improviser))
  (InitRecSearch self)
  (ExploreRecCandidates self)
  (DrawARecombination self))


;;; ExploreRecCandidates dives into the SLT for each candidate and forages for targets.
;;; Candidates are looked in a decreasing recombination power order.

#|
(defmethod ExploreRecCandidates ((self improviser))
  (catch 'explorerecs
    (loop for RecCandidate in (SortedRecCandidates self)
          until (RecSearchNotImprovable self)
          do
          (progn 
            (let ((av (- (next-time (a-player 1))  (get-internal-real-time)))) 
              (when (< av 400) 
                ;(format t  "~%cancel search : ~a~%" av)
                (format t ". ")
                (throw 'exploreRecs nil)))
            (setf (RecSolImproved self) nil)
            (SLTSearch self RecCandidate)))))
|#

#|
(defmethod ExploreRecCandidates ((self improviser))
  (catch 'explorerecs
    (loop for RecCandidate in (SortedRecCandidates self)
          until (RecSearchNotImprovable self)
          do
          (progn 

            (setf (RecSolImproved self) nil)
            (SLTSearch self RecCandidate)))))
|#




;;; RecSearchNotImprovable is True when the solution vector is full and the last 
;;; candidate exploration did not improve it.

(defmethod RecSearchNotImprovable ((self improviser))
  (and (RecSearchComplete self) (RecSearchDoesNotImprove self)))


;;; SLTSearch explores an SLT starting at some candidate point.
;;; Going from the biggest LRS (context length) targets to the smallest

;;; SLTSons devrait tre class du plus grand LRS au plus petit et les LRS gaux dans un ordre 
;;; alatoire

#|
(defmethod SLTSearch ((self improviser) i)
  (setf (onecounter self) 0)
  ;(format t "~%search ~d~%" (RLengthThresh self))
  (SLTCatch self
    (loop for k in (SLTSons self i)
          while (>= (RepeatLength self k) (RLengthThresh self))
          do  (SLTSearchSubtree self i k (RepeatLength self k)))
    (loop for ii = i then j
          for j = (SLTFather self i) then (SLTFather self j)
          while j
          while (>= (repeatlength self ii) (rlengththresh self))
          do
          ;(print (list ii j))
          ;(when (= i j) (print (list 'consider i j)))
          (SLTConsiderSolution self i j (repeatlength self ii))
          (loop for k in (SLTSons self j)
                while (>= (min (repeatlength self k) (repeatlength self ii)) (rlengththresh self))
                ;when (=  i k) do (print (list i ii k))
                when (/= k ii)  do  (SLTSearchSubtree self i  k (min (repeatlength self k) (repeatlength self ii)))))))

;;; descending research in an SLT subtree

(defmethod  SLTSearchSubtree ((s improviser) i j rlength)
  (when (= rlength 1) 
    (incf (onecounter s)) 
    (when (> (onecounter s) (maxonecount s)) (setf (onecounter s) 0) (SLTEscapeSearch s)))
  ;(format t "~d " rlength)
  ;(when (= i j) (print (list 'consider i j)))
  ;(SLTIncreaseParseCounter s)
    (SLTConsiderSolution s i j rlength)
  (loop for l in (SLTSons s j)
        do (SLTSearchSubtree s i l rlength)))


|#
;;; now we have a recombination candidate/target (i, j)
;;; must see if its rhythm quality is OK, and if it respects the region constraints
;;; if, due to its LRS, the target cannot improve the solution vector, then abandon the SLT.



#|
(defmethod SLTConsiderSolution ((s improviser) i j rlength)
  (let ((av (- (next-time (a-player 1))  (get-internal-real-time)))) 
    (when (< av 100) (format t  "~%cancel search : ~a~%" av)
          (throw 'exploreRecs s)))

  (when (SLTSolutionCannotImprove s i j rlength)
    (SLTEscapeSearch s))
  (let ((RhythmQuality (SLTFilterSolution s i j rlength)))
    (when RhythmQuality
      (SLTStoreSolution s i j rlength RhythmQuality))))


|#


#|
(defmethod SLTConsiderSolution ((s improviser) i j rlength)
  ;(prin1 ". ")
  (when  (SLTSolutionCannotImprove s i j rlength)
    (SLTEscapeSearch s))
  (let ((RhythmQuality  (SLTFilterSolution s i j rlength)))
    (when RhythmQuality
      ;(print (recsolutions s))
      (SLTStoreSolution s i j rlength RhythmQuality))))
|#



;--------------------------------------------------------------------------------------------

(defmethod InitRecSearch  ((self improviser))
  (setf (recsolutions self) (cons nil nil)
        (recSolNb self) 0
        (RecSolImproved self) nil 
        (MinSolRlength self) 1000))


#|
(defmethod SortedRecCandidates ((self improviser))
  (sort
   (loop for index from (first (scanregion self)) to (second (scanregion self))
         when (>= (RecPotential self index)  (min 2 (*min-suffix-length* self)))
         collect index)
   #'(lambda (i j) (> (RecPotential self i) (RecPotential self j)))))
|#


(defmethod SortedRecCandidates ((self improviser))
;(print (list "scanreg" (scanregion self)))
  (sort
   (loop for index from (first (scanregion self)) to (second (scanregion self))
         when (>= (RecPotential self index)  (max 2 (RLengthThresh self)))
         collect index)
   #'(lambda (i j) (> (RecPotential self i) (RecPotential self j)))))





(defmethod RecPotential ((self improviser) i)
  (if  (suppleance-> self i) 
    (lrs self (suppleance-> self i))
    (if (suppleance self i)
      (lrs self i)
      0 )))


(defmethod RecSearchComplete ((self improviser))
  (>= (recSolNb self) (maxRecSolNb self)))



(defmethod RecSearchDoesNotImprove ((self improviser))
  (null (RecSolImproved self))
  )



;;; Store a solution candidate/target i,j in the solution list
;;; sol list = (nil sol1 sol2 ... )
;;; sol = (index target rlength)

                                           
(defmethod SLTStoreSolution ((self  improviser) i j rlength RhythmQuality)
;(print (recsolutions self))
  (loop for prev = (recsolutions self) then soll
        for soll = (rest (recsolutions self)) then (rest soll)
        for count from 1 to (maxRecSolNb self)
        while prev
        ;; attention, test trop simple,
        ;; va toujours garder les derniers index trouvs pour des NA gaux
        ;; chang, i lne garde qu eles premiers
        if  (or (null soll)
                (> rlength (third (first soll)))
                (and (= rlength (third (first soll)))
                     (< RhythmQuality (fourth (first soll) ))))
        do (progn 
;(print (list RhythmQuality rlength (and soll (third (first soll))) (and soll (fourth (first soll) ))))
             (setf (cdr prev) (cons (list i j rlength RhythmQuality) soll))
             (incf (recSolNb self))
             (setf (RecSolImproved self) T
                   (MinSolRlength self) (min rlength (MinSolRlength self)))
             (loop-finish))))


(defmethod SLTSolutionCannotImprove ((self improviser) i j rlength)
  (declare (ignore i j ))
  (and (RecSearchComplete self)
       (< rlength (MinSolRLength self))))



(defmethod SLTFilterSolution ((self  improviser) i j rlength)
  (let ((RhythmQuality))
    (if (and  (suffix-in-region self j)
             (not (memq j (*impro-tabou-states* self)))
             
             (<=  (setf RhythmQuality
                        (abs (log (/ 
                                    (suffixduration self i rlength)
                                   (suffixduration self j rlength)))))
                  (RhythmQuality self)))
      RhythmQuality
      nil)))


(defmethod suffixduration ((self improviser) (index integer) (sufflength integer))
  (loop for i from 0 to (min 16 (1- sufflength))
        for j = (- index i)
        while (> j 0)
        sum (duration (otext  (oracle self) j))))


#|
(defmethod DrawARecombination ((self improviser))
  (and (rest (recsolutions self))
       (stochastic-choice  
        (mapcar 
         #'(lambda (l)
             (aref *SLength-distribution* (min (1- (third l)) (1- (length *SLength-distribution*)))))
         (rest (recsolutions self)))
        (rest (recsolutions self)))))
|#



(defmethod DrawARecombination ((self improviser))
  (if (rest (recsolutions self)) ; at least one sol
    (if (null (cddr (recsolutions self))) ; singleton
      (with-proba  (ProbIfOneSol self)
        (progn (dprint "--------1 solution, I take it ~%")
               (cadr (recsolutions self)))
        (progn (dprint "--------1 solution, I DON'T take it ~%")
               nil))
      ; more than 1 sol
      (loop for l in (rest (recsolutions self))
            for i from 1 to (maxRecSolNb self)
            collect  (aref *SLength-distribution* 
                           (min (1- (third l)) 
                                (1- (length *SLength-distribution*)))) into sol1
            collect l into sol2
            finally return (stochastic-choice  sol1 sol2)))
    (dprint "No candidates~%")))



(defun stochastic-choice (ProbaVector Values)
  (when *OMaxDebug*
    (dprint "~%Best candidates ~a~%" (mapcar #'third values)))
  (loop with random-value = (random (float (apply #'+ probavector)))
        for i from 0 to (1- (length ProbaVector))
        sum (nth i ProbaVector) into SumProba
        if (> sumproba random-value) return (nth i values)
        finally return (first (last values))))


#|
(defmethod time-to-scan-ahead ((self improviser))
  (cond ((close-to-the-edge? self)
         (dprint "~%Close to the edge~%")
         (setf (RecCritical self) T)
         T)
        ( (>=  (continuity self) 
               (- (max-continuity self) 
                  (round (max-continuity self) *scanregion-divisor* )))
          (setf (RecCritical self) nil)
          T)
        (t nil)))
|#
         
  


(defmethod close-to-the-edge? ((self improviser))
  (or (not (IndexInImproBounds self))
      (>=
       (gindex self) 
       (- (ImproRightBound self)
          (max (*Close-edge-dist* self) (round (max-continuity self) *scanregion-divisor* ))))))

(defmethod scanregion ((self improviser))
  (list (gindex self) 
        ;(min (ImproRightBound self)
        (+ (gindex self) 
           (* 2 (round (max-continuity self) 
                       *scanregion-divisor* )))))

(defmethod move-to-end-scan  ((self improviser))
;(print (list (gindex self) (second (scanregion self))(ImproRightBound self)))
  (loop for i from (gindex self) to  (second (scanregion self))
        ; this is because there might be a failure -> gindex:=0
        if (> (gindex self) 0)  do (move-linearly self)
        else do (return)))


#|
(defmethod move-linearly ((self improviser))
  ;(print (list (gindex self) (ImproLeftBound self) (ImproRightBound self)))
  (if (and (>= (gindex self) (ImproLeftBound self))
           (< (gindex self) (ImproRightBound self)))
    (impro-output-1-event self (1+ (gindex self)))
    (impro-failure self)))
|#


;;; ==========================================================================================
;;; ==========================================================================================



(defmethod impro-failure ((self improviser))
  (dprint "Impro failure at ~a ~%" (gindex self))
  (setf (*impro-tabou-states* self) nil)
  (setf (gindex self) 0 (continuity self) 0)
  ;(process-allow-schedule)
)

(defmethod move-linearly ((self improviser))
  ;(print (list (gindex self) (ImproLeftBound self) (ImproRightBound self)))
  (if (and (>= (gindex self) (ImproLeftBound self))
           (< (gindex self) (ImproRightBound self)))
    (impro-output-1-event self (1+ (gindex self)))
    (impro-failure self)))

(defmethod continue-impro ((self improviser))
  (if (not (time-to-scan-ahead self))
    (move-linearly self)
    (let ((choice (GetRecombination self)))
;(print (list 'found choice))
      (if (null choice)
        ;(progn (setf (continuity self) 0) (move-linearly self))
        (move-to-end-scan self)
        (move-to-suffix self choice)))))


#|
(defmethod continue-impro ((self improviser))
    (move-linearly self)
    )
|#



(defmethod time-to-scan-ahead ((self improviser))
  (cond ((close-to-the-edge? self)
         (dprint "~%Close to the edge~%")
         (setf (RecCritical self) T)
         T)
        ( (>=  (continuity self) 
               (- (max-continuity self) 
                  (round (max-continuity self) *scanregion-divisor* )))
          (setf (RecCritical self) nil)
          T)
        (t nil)))

(defmethod start-new-impro-in-region  ((self improviser))
  
  (let* ((left (RegionStartIndex self))
         (right (RegionEndIndex self))
         ; this max is because th eregion could change between the computation
         ; of left and right ! this is bad concurrent programming !
         (start (+ left (random (1+ (-  (max right left) left))))))
    (dprint "Starting at : ~a~%" start)
    (impro-output-1-event self start)
    
    ))

(defmethod impro-output-1-event ((self improviser) (index integer))
  (talk self (otext (oracle self) index))
  (setf (gindex self) index)
  (incf  (continuity self))
  ;(dprint "~a(~a)~%" index (continuity self))
  (incf (durseg self) (duration (otext (oracle self) index))))


(setf *max-impro-ahead* 150)

(defmethod task  ((self improviser))
;(print "improviser")
  (if (or (stop self) (<= (maxetat (oracle self)) 0))
    (process-allow-schedule)
    (progn
      (cond
       ;; new impro
       ((zerop (gindex self))
        (setf (continuity self) 0)
        ;(setf   *impro-tabou-states*  nil)
        (cond 
         ((and (blocmode self) (>= (blocStartPhrase self) 0))
          (start-new-impro-on-phrase-nb self))
         
         ((StartOnPhrase self)
          (start-new-impro-on-phrase self))
         
         (t
          (start-new-impro-in-region self))))
       
       ;; continuing   
       (t ; (in-continuity self)
        (continue-impro self)))
      
      (unless (blocmode self)
        ;(process-allow-schedule)
        )
;(print (list 'durseg (durseg self) 'timeahead (look-time-ahead (a-player 1))))
      
      (when (> (durseg self) *max-impro-ahead* ) 
        (setf (durseg self) 0) 
        (process-allow-schedule) )
       )))


(setf *max-play-ahead* 300)

(defmethod task ((self improsupervizer))
  (event-dispatch)
  (let ((playahead (+ (look-time-ahead (a-player 1)) (look-time-ahead (a-unslicer 0)))))
    (cond
     ((>= playahead *max-play-ahead*)  
      (too-fast (a-improvizer 0)) )
     (t (too-slow (a-improvizer 0)))))
  (when (and (a-improvizer 1) ; ongoing bloc improvizer
             (eq (bloc-impro-state self) 'terminated)
             )
    (kill-bloc-impro self)
    (print "BLOC SENT")
    )
  (when (and (PoursuiteMode (a-improvizer 0)) (> (poursuite (a-improvizer 0)) 0))
    (set-poursuite-region (a-improvizer 0)))
  ;(sleep .050)
  ;(process-allow-schedule)                
  )


(defmethod look-time-ahead ((self unslicer))
  (let ((queue (agent-listening-queue self)))
    (if (null queue) 0 (queue-duration queue))
    ))


(defmethod task ((self osc-midi-player))
  (let ((event nil)  bundle)
    ;(ready-for-next-seg self)
    ;(print (segment self))
    (if (>= (cursegdur self) (segdur self))
      (if (not (ready-for-next-seg self))
        (process-allow-schedule)
        (progn 
          (let ((av (- (next-time self)  (get-internal-real-time)))) 
            (when (< av 100) (format t  "~%short avance : ~a~%" av)))
          (setf (seg-onset self)
                (max (next-time self) (+ (get-internal-real-time) 100)))
          (send-osc-midi (list (list '/ma 'start)))
          ;(dprint "SENDING BUNDLE ~%")
          ;(print (cursegdur self))
          ;(setf toto (get-internal-real-time))
          (setf bundle (loop for evt in (unslice (nreverse (segment self)) (seg-onset self))
                             collect (osc-note-at evt)))
          (send-osc-midi  bundle)
          (send-osc-midi (list (list '/ma 'stop)))
          (setf (next-time self) (+ (seg-onset  self) (cursegdur self))
                (cursegdur self) 0
                (segment self) nil)
          ;(print (list "Time to send:" (- (get-internal-real-time) toto )))
          ))
      
      (progn ;(print (list "timeahead" (look-time-ahead (a-player 1))))
             (if (null (setf event (listens self)))
               (process-allow-schedule)
               (progn 
                 ;(print (list "eat " (duration event) "timeahead" (look-time-ahead (a-player 1))))
                 (incf (cursegdur self) (duration event))
                 (push event (segment self))
               ;(process-allow-schedule) 
                 ))))))

;;; ==========================================================================================
;;; ==========================================================================================



;;; -----------------------------------------------------------------------------------------------
;;; Reading the oracle backwards

(defclass BImproviser (improviser) ())


(defmethod close-to-the-edge? ((self Bimproviser))
  (or (not (IndexInImproBounds self))
      (<=
       (gindex self) 
       (+ (ImproLeftBound self)
          (max (*Close-edge-dist* self) (round (max-continuity self) *scanregion-divisor* ))))))

(defmethod move-linearly ((self Bimproviser))
  ;(print (list (gindex self) (ImproLeftBound self) (ImproRightBound self)))
  (if (and (> (gindex self) (ImproLeftBound self))
           (<= (gindex self) (ImproRightBound self)))
    (impro-output-1-event self (1- (gindex self)))
    (impro-failure self)))


(defmethod scanregion ((self Bimproviser))
  (list (gindex self) 
        ;(min (ImproRightBound self)
        (- (gindex self) 
           (* 2 (round (max-continuity self) 
                       *scanregion-divisor* )))))


(defmethod SortedRecCandidates ((self Bimproviser))
;(print (list "scanreg" (scanregion self)))
  (sort
   (loop for index from (first (scanregion self)) downto (second (scanregion self))
         when (>= (RecPotential self index)  (max 2 (RLengthThresh self)))
         collect index)
   #'(lambda (i j) (> (RecPotential self i) (RecPotential self j)))))

(defmethod move-to-end-scan  ((self Bimproviser))
;(print (list (gindex self) (second (scanregion self))(ImproRightBound self)))
  (loop for i from (gindex self) downto  (second (scanregion self))
        ; this is because there might be a failure -> gindex:=0
        if (> (gindex self) 0)  do (move-linearly self)
        else do (return)))


(defmethod SLTFilterSolution ((self  Bimproviser) i j rlength)
  (let ((RhythmQuality))
    (if (and (> (- j rlength) 0)
             (> (1+ (- i rlength)) 0)
             (suffix-in-region self j)
             (not (memq j (*impro-tabou-states* self)))
             
             (<=  (setf RhythmQuality
                        (abs (log (/ 
                                   (suffixduration self i rlength)
                                   (suffixduration self j rlength)))))
                  (RhythmQuality self)))
      RhythmQuality
      nil)))

(defmethod move-to-suffix  ((self Bimproviser) suffix)
  (let ((rlength (min (third suffix) 16)))
    (loop for i from (1- (gindex self)) downto  (1+ (- (first suffix) rlength))
          do (impro-output-1-event self i))
    (setf (continuity self) 0)
    (dprint "~%~%Jumping from ~a to ~a length ~a qual ~,2f ~%~%" 
            (1+ (- (first suffix) rlength))
            (- (second suffix) rlength)
            rlength (fourth suffix))
    (impro-output-1-event self (- (second suffix) rlength))
    (push (second suffix) (*impro-tabou-states* self))
    (when (> (length (*impro-tabou-states* self)) (*Tabou-list-length* self)) 
      (setf  (nthcdr (*Tabou-list-length* self) (*impro-tabou-states* self))  nil))
    ))

(defmethod start-new-impro-in-region-exact  ((self Bimproviser))
  (dprint "Starting at : ~a~%" (RegionStartIndex self))
  (impro-output-1-event self (RegionEndIndex self)))


(defun OMaxToggleBackw (onoff)
  (if (zerop onoff) 
    (change-class (a-improvizer 0) 'Improviser)
    (change-class (a-improvizer 0) 'BImproviser)))


  
;;; -----------------------------------------------------------------------------------------------
;;; Transformation sur les slices, juste avant le recollage

(defclass UnSlicer (agent)
  ((name :initform "ms-player" :accessor name :initarg :name :type string)
   (waiting-list :accessor waiting-list :initarg :waiting-list :initform ())
   (new-waiting-list :accessor new-waiting-list :initarg :new-waiting-list :initform ())
   
   (KbdMirror :initform nil :accessor KbdMirror :initarg :KbdMirror)
   (AffineTrans :initform (list 1 0) :accessor AffineTrans :initarg :AffineTrans)
   (RTempo :initform 1.0 :accessor RTempo :initarg :RTempo)
   
   
   ))

#|
(defmethod task ((self unslicer))
  (let ((event (listens self)))
    (if (null event) 
      (process-allow-schedule) 
      (progn
        (setf event (transform-slice self (clone-object event)))
        (loop for ME in (midiset event)
              with new-midiset = nil
              initially  (setf (new-waiting-list self) nil)
              do (cond ((plusp (MEPitch ME))
                        (push ME (new-waiting-list self))
                        (push ME new-midiset))
                       ((minusp (MEPitch ME))
                        (let ((waiting (find ME (waiting-list self)
                                             :test #'(lambda (m1 m2) 
                                                       (and (= (abs (MEPitch m1)) (abs (MEPitch m2))) 
                                                            (= (MEChannel m1) (MEChannel m2)))))))
                          ;(print (list ME waiting))
                          (cond 
                           (waiting
                            (setf (MEDur waiting) (+ (MEDur waiting) (MEDur ME)))
                            (push waiting (new-waiting-list self)))
                           (t (setf (MEPitch ME) (abs (MEPitch ME)))
                              (push ME (new-waiting-list self))
                              (push ME new-midiset)))))) ; might be empty if only running notes
              finally (progn (setf (Midiset event) new-midiSet) 
                             ;(analyse-slice event)
                             (talk self event)
                             ;(pushr event *crosslist*)
                             ))))
    (setf (waiting-list self) (new-waiting-list self))))
|#


#|

 tester mieux pour le backward

((plusp (MEPitch ME))
 
 (let ((waiting (find ME (waiting-list self)
                      :test #'(lambda (m1 m2) 
                                (and (= (abs (MEPitch m1)) (abs (MEPitch m2))) 
                                     (= (MEChannel m1) (MEChannel m2)))))))
   (cond 
    (waiting
     (setf (MEDur waiting) (+ (MEDur waiting) (MEDur ME)))
     (push waiting (new-waiting-list self)))
    (t (setf (MEPitch ME) (abs (MEPitch ME)))
       (push ME (new-waiting-list self))
       (push ME new-midiset)))) )
|#





(defun OMaxToggleKbdMirror (onoff)
  (if (zerop onoff) 
    (setf (KbdMirror (a-unslicer 0)) nil)
    (setf (KbdMirror (a-unslicer 0)) T)))

; y = ax + b
(defun OMaxSetAffine (a b)
  (setf (AffineTrans (a-unslicer 0)) (list a b)))


(defun OMaxSetTempo (r) 
  (setf (RTempo (a-unslicer 0)) r))


(defmethod transform-slice ((self unslicer) (evt crossevent)) 
  (when (KbdMirror self) (DoKbdMirror evt))
  (when (not (and (zerop (second (AffineTrans self)))
                  (= 1 (first (AffineTrans self)))))
    (doAffineTrans evt  (first (AffineTrans self)) (second (AffineTrans self))))
  (when (/= (RTempo self) 1.0)
    (doChangeTempo evt (RTempo self)))
  evt)
    
    
; inversion du clavier
(defmethod DoKbdMirror ((self crossevent)) 
  (loop for m in (midiset self)
        for p = (abs (MEPitch m))
        for sign = (/ p (abs p))
        do (setf (MEPitch m)
                 (* sign
                    (cond ((<=  52 p 71)
                           (case (floor (- p 52) 5)
                             (0 (+ 24 (mod p 12)))
                             (1 (+ 48 (mod p 12)))
                             (2 (+ 72 (mod p 12)))
                             (3 (+ 84 (mod p 12)))))
                          ((>= p 72)
                           (+ 48 (- p 72)))
                          ((<= p 48)
                           (+ 48 (- p 24)))
                          (t p)))))
  self)

; transformation affine y = ax + b

(defmethod doAffineTrans ((self crossevent) a b) 
  (loop for m in (midiset self)
        for p = (abs (MEPitch m))
        for sign = (/ p (abs p))
        for octave = (floor p 12)
        do (setf (MEPitch m)
                 (* sign (+ (* 12 octave) (mod (+ b (* a  p)) 12)))))
  self)



; changement du tempo


(defmethod doChangeTempo((self crossevent) r) 
  (setf (duration self) (round (* r (duration self) )))
  (loop for m in (midiset self)
        for dur = (MEDur m)
        do (setf (MEdur m) (round (* dur r))))
  self)


; ======================================================================================
; Switching d'oracles


(DefAgentMessage wake-clone :now ((self improsupervizer) n)
  (if (or (> n *nb-clones*) (null  (aref *clone-array* (1- n))))
    (Format t "Clone nb ~d is empty !~%" n)
    (let ((awake-impro (awake-p (a-improvizer 0))))
      (stop-impro self)

(OMaxSetTimeRange 0 0)
(OMaxToggleRegionalImpro 0)
(OMaxSetQuality 3)
(setf (*impro-tabou-states* (a-improvizer 0)) nil)


      (setf (oracle (a-improvizer 0)) (aref *clone-array* (1- n)))
      (reset (a-improvizer 0))
      (reset (a-unslicer 0))

      (send-osc-oracle-info (oracle (a-improvizer 0)))

      ;(reset (a-player 0))
      (reset (a-player 1))
      (synchronize-max-om-time)
      (when awake-impro (start-impro self)))))


(DefAgentMessage wake-main :now ((self improsupervizer))
  (let ((awake-impro (awake-p (a-improvizer 0))))
    (stop-impro self)

(OMaxSetTimeRange 0 0)
(OMaxToggleRegionalImpro 0)
(OMaxSetQuality 3)
(setf (*impro-tabou-states* (a-improvizer 0)) nil)


    (setf (oracle (a-improvizer 0)) (oracle (a-learner 0)))
    (reset (a-improvizer 0))
    (reset (a-unslicer 0))
    ;(reset (a-player 0))
    (reset (a-player 1))
    (send-osc-oracle-info (oracle (a-improvizer 0)))
    (synchronize-max-om-time)
    (when awake-impro (start-impro self))))

(DefAgentMessage reset-main :now ((self improsupervizer))
  (let ((awake-learn (awake-p (a-learner 0))) (awake-impro (awake-p (a-improvizer 0))))

    ;(loop while (listens (a-listener 1)) do (print "---"))

    (stop-impro self)
    (stop-learning self)
    (reset (a-listener 1))
    (reset (a-player 1))


(OMaxSetTimeRange 0 0)
(OMaxToggleRegionalImpro 0)
(OMaxSetQuality 3)
(setf (*impro-tabou-states* (a-improvizer 0)) nil)


(loop while (listens (a-listener 1)) do (print "---"))

    (let ((oracle (make-instance 'coracle :comparateur 'CompareEvents :lrsMode t)))
      (setf (oracle (a-improvizer 0)) oracle
            (oracle (a-learner 0)) oracle))
    (reinitialize-instance (a-improvizer 0) :curRegion (list 1 1)
                           :CurRegion% (list 0 100) :*impro-tabou-states* nil
                           :*regional-impro* nil
                           )
    ;(setf (continuity (a-improvizer 0)) 0)
    ;(setf (gindex (a-improvizer 0)) 0)
    ;(setf (durseg (a-improvizer 0)) 0)
    ;(setf (curRegion (a-improvizer 0)) (list 1 1))
    ;(setf (curRegion% (a-improvizer 0)) (list 0 100))
    ;(setf (*impro-tabou-states* (a-improvizer 0)) nil)
    (synchronize-max-om-time)
    (when awake-learn (start-learning self))
    (when awake-impro (start-impro self))))






(DefAgentMessage load-oracle-n :now ((self improsupervizer) filename clone-nb)
  (print "LOADING ORACLE ............")
  (let ((archive (load-oracle-direct filename)) (clone-awake nil) (main-awake nil))
    (when (and archive (or (typep archive 'coracle) (typep archive 'orchestre)))
      (let ((oracle (if (typep archive 'coracle) 
                      archive 
                      (change-class (aref (improvizer-array archive) 0) 'coracle))))
        (when (typep archive 'orchestre)
          (ConvertUsingAudioOffsets oracle))
        (when (> (maxetat oracle) 0)
          
          (reinitialize-instance oracle :lock (make-lock 'impro-lock)) 
          
          (print "ORACLE LOADED ............")
          
          (when (and (>= clone-nb 1) 
                     (eq (aref *clone-array* (1- clone-nb))
                         (oracle (a-improvizer 0))))
            ; clone n is current improvizer
            (setf clone-awake T))
          
          (when (and (zerop clone-nb) 
                     (eq (oracle (a-improvizer 0) ) (oracle (a-learner 0))))
            ; main is current improvizer
            (setf main-awake T))
          
          ; the lock is not omng-saved
          (cond
           ((>= clone-nb 1) (setf (aref *clone-array* (1- clone-nb)) oracle))
           (T ; loading into MAIN
            (stop-learning *supervizer*)
            
            (send-osc-info (list (list '/mi
                                       ;(BufTOffset oracle 1)
                                       (PhraseNumber (otext oracle (maxetat oracle)))
                                       (+ (BufTOffset oracle (maxetat oracle)) (Bduration (otext oracle (maxetat oracle)))))))
            
            (setf (oracle (a-learner 0)) oracle )
            (start-learning *supervizer*))))
        (when clone-awake (wake-clone self clone-nb))
        (when main-awake (wake-main self))    
        ))))


;;; -----------------------------------------------------------------------------------
;;; simplify the improvisatyion modes scheme

(defun OMaxToggleRegionalImpro (onoff)
  (setf (*regional-impro* (a-improvizer 0)) (= onoff 1)))


(defun OMaxSetPoursuite (dur)
  (setf (poursuite (a-improvizer 0)) dur))

(defun OMaxSetImproMode (mode)
  (case mode
    (1 
     ; must toggle again..
     (OMaxToggleRegionalImpro 1)
     (setf (AbsoluteRegions (a-improvizer 0)) T
           (poursuiteMode  (a-improvizer 0)) nil))
    ; never used anymore
    (2 (setf (AbsoluteRegions (a-improvizer 0)) NIL))
    
    
    (3 
     (OMaxToggleRegionalImpro 1)
     (setf 
      (AbsoluteRegions (a-improvizer 0)) T
      (poursuiteMode (a-improvizer 0)) T))))





;;; --------------------------------------------------------------------------------------------
;;; Add a save oracle function for oracles resulting from a clone operation in the max interface

; /lisp SaveClone nom_de_fichier numro_de_clone ?


(defun SaveClone (name cloneNb) (save-clone *supervizer* name cloneNb))

(DefAgentMessage save-clone :now ((self improsupervizer) filename cloneNb)
  (let ( (oracle  (aref *clone-array* (1- cloneNb))))
    (and oracle
         (> (maxetat oracle) 0)
         (process-run-function "SavingFile"
                               #'(lambda (oracle)
                                   (print "SAVING CLONE ...................")
                                   (WITH-OPEN-FILE (out filename :direction :output  :if-does-not-exist :create :if-exists :supersede
                                                        :external-format :|TEXT|)
                                     (prin1 '(in-package :om) out)
                                     (prin1 (omng-save  oracle) out))
                                   (Print "SAVED")
                                   (process-kill *current-process*)
                                   )
                               oracle))
    T))



;----------------------------------------------
; new scheme for initsession



(defun OMaxInitSession ()
  
  (when *supervizer*
    (print "KILLING SESSION FIRST ....")
    (OMaxKillSession)
    (sleep .5))
  
  (print "INITIALIZING NEW OMAX SESSION...")
  
  
  (setf *supervizer* (make-instance 'improSupervizer :state :asleep))
  (setf (time-origin *supervizer*) (get-internal-real-time))
  
  (setf (osc-in-host) *osc-in-host*
        (osc-out-host) *osc-out-host*
        (osc-out-time-port) *osc-out-time-port*
        (osc-out-midi-port) *osc-out-midi-port* )
  
  
  
  (let* (
         ;(ls (new-ms-listener "ms-listener" 0))
         (ol (new-osc-midi-listener "osc-listener"))
         (sl (new-polySlicer  "Slicer-0"))
         (or (neworacle))
         (ln (new-learner  or))
         (im (new-improvizer or))
         (un (new-unslicer "Unslicer-0"))
         ;(pl (new-ms-player "MS-Play-0" 0))
         (op (new-osc-midi-player "osc-play")))
    
    (setf (a-oracle 0) or
          (a-learner 0) ln
          (a-improvizer 0) im
          (a-slicer 0) sl
          (a-unslicer 0) un
          ;(a-player 0) pl
          (a-player 1) op
          ;(a-listener 0) ls
          )
    
    (setf *osc-midi-listener* ol (a-listener 1) ol)
    
    ;(connect ls :toport 0)
    (connect ol :toport 0)
    (connect sl :fromport 0)
    (connect sl :toport 1)
    (connect ln :fromport 1)
    (connect im :toport 2)
    (connect un :fromport 2)
    (connect un :toport 3)
    ;(connect pl :fromport 3)
    (connect op :fromport 3)
    )
  
  (synchronize-max-om-time)
  
  ;(send-osc-time (list (list '/mt (ms:MidiGetTime))))
  
  ;(osc-send (list (list '/mt (timeOrigin))) (osc-out-host) (osc-out-time-port))
  
  ;(silent (a-player 0))
  
  (setf *clone-array* (make-array *nb-clones* :initial-element nil))
  
  (resume *supervizer*)
  
  (print "OMAX INITIALISATION OK")
  )

(defun OMaxKillSession ()
  (and *supervizer* (kill *supervizer*))
  ;(kill *osc-midi-listener*)
  (setf *supervizer* nil)
  (print "OMAX QUITTING OK")
  )




;;; --------------------------------------------------------------------------------------------
;;; handling the last note problem



(defun osc-route-bundle (bundle)
  (handler-case
    (loop for item in bundle collect
          (cond
           ((stringp (car item)) 
            (cond ((string-equal (car item) "/mo") (funcall #'handle-osc-midi-evt (cdr item)))
                  ((string-equal (car item) "/sp") (funcall #'handle-osc-midi-stop-evt (cdr item)))
                  ((string-equal (car item) "/ph") (funcall #'handle-osc-midi-phrase (cdr item)))
                  ((string-equal (car item) "/omsend") (osc-method-invoke item))
                  ((string-equal (car item) "/lisp") (print item) 
                   (execute-message item)
                   )
                  ((string-equal (car item) "/lisp-string") (execute-message-from-string item))
                  (t (format t "~D~" item))))
           ((consp (car item)) (osc-route-bundle item))
           (t nil))
          )
    (error (any) (print "Error trying to route OSC message") (print any) NIL))
  )

(defun handle-osc-midi-stop-evt (date) ; (date)
  (dprint "Received Stop event at buffer time: ~a~%~%" (first date))
  (osc-midi-arrived *osc-midi-listener* (list -1 -1 -1 -1 (first date) )))


(defun StopPlayEvent (event)
  (minusp (first event)))


;---------------------

; waking an empty oracle

(defmethod send-osc-oracle-info ((self oracle))
  (cond
   ((> (maxetat self) 0)
    (send-osc-info (list (list '/oi 'start 
                               (BufTOffset self 1)
                               (+ (BufTOffset self (maxetat self)) (Bduration (otext self (maxetat self)))))))
    (loop for i from 1 to (maxetat self)
          when (startPhrase (otext self i))
          do (send-osc-info (list (list '/oi (PhraseNumber (otext self i)) (BufTOffset self i)))))
    )
   (T
    (send-osc-info (list (list '/oi 'start  0 0)))
    (send-osc-info (list (list '/oi 0 0)))))
  (send-osc-info (list (list '/oi 'stop))))


(defmethod BufTOffset ((self improviser) i)
  (CrossEvtAudioOnset (otext (oracle self) i)))


(defmethod BufTOffset ((self oracle) i)
  (CrossEvtAudioOnset (otext  self i)))





;---------------------


(defmethod eat-note-off ((self polySlicer) (MEnoteoff list))
  (let ((running (find-running-note self MENoteoff)))
    (setf (last-offset self) (MEOnset MENoteOff))
    ; hack :: use the dur field to store the noteoff date 
    ; if not set by a noteoff, this dur field is by default 0
    (when running 
      (setf (MEDur running) (MEOnset Menoteoff) )
      (push (cons running MENoteOff) (complete-notes self))))
  self)





(defmethod CrossEvtAudioOnset ((self crossevent))
  ;; the audio buffer offset should be stored in the crossevt object, not in the midi events
  (loop for evt in (midiset self)
        minimize (MEAudioOnset evt) into minOnset
        do (when (and (plusp (MEPitch evt)) (zerop (MeOnset evt)))
             (return (MEAudioOnset evt)))
        finally (return minOnset)))




(defmethod unslice ((self list) start-time)
  (loop for evt in self
        with delay = 0
        ;do (analyse-slice evt)

;do (when (> (length (midiset evt)) 1) (print  (midiset evt)))

        if (not (pause-event-p  evt))
        nconc (loop for note in (MidiSet evt)
                     do ;(setf (MEChannel note) 1)
                     (setf (MEOnset note) (+ start-time delay (MEOnset note)))
                     (unless (MEPhrase note) ;; old oracle without audio dates
                       (let ((last (last note)))
                         (setf (cdr last) (list 0 0))))
                     
                     collect (let ((noteoff (copy-list note)))
                               (setf (MEVel noteoff) 0)
                               (setf (MEOnset noteoff) (+ (MeOnset note) (MEDur note)  -2))
                               ;(setf (MEOnset noteoff) (+ (MeOnset note) (MEDur note) ))
                               (setf (MEAUdioOnset noteoff) (+  (MeAudioOnset note) (MEDur note)))
                               noteoff))
        into note-offs
        sum (duration evt) into delay
        ; events are already sorted by onset inside each slice
        ; this nconc is suposedly dangerous, but should work (concatenates all the midisets..)
        finally return  (nconc (loop for event in self nconc (Midiset event))
                                     note-offs)))



(defmethod unslice-1 ((self crossevent) start-time timemax)
  ;(analyse-slice self)
  (loop for note in (MidiSet self)
        do 
        (setf (MEOnset note) (+ start-time (MEOnset note)))
        (let ((noteoff-date
               (if (<= (+ (MeOnset note) (MEDur note)) timemax)
                 (+ (MeOnset note) (MEDur note))
                 (if (>= (- timemax (MEOnset note)) 500)
                   timemax
                   (+ (MEOnset note) 500)))))
          (setf (MEdur note) (- noteoff-date (MEonset note))))
        collect
        (progn
          (unless (MEPhrase note) ;; old oracle without audio dates
            (let ((last (last note)))
              (setf (cdr last) (list 0 0))))
          note) 
        into notes
        collect 
        (let ((noteoff (copy-list note)))
          (setf (MEVel noteoff) 0
                (MEOnset noteoff) (+ (MeOnset note) (MEdur note) -2)
                (MEAUdioOnset noteoff) (+  (MeAudioOnset note) (MEDur note)))
          noteoff)
        into noteoffs
        finally return (nconc notes noteoffs)))




;==========================================================================
;;; handling compactslices and short end of section event



; keep last-slice as model for optional short slice at end of sections 
(defclass PolySlicer (agent)
  ((name :accessor name :initarg :name)
   (magnet1 :initform 0 :accessor magnet1 :initarg :magnet1 :type integer)
   (magnet2 :initform 0 :accessor magnet2 :initarg :magnet2 :type integer) 
   (delta-t :initform 50 :accessor delta-t :initarg :delta-t :type integer)
   (running-notes :initform nil :accessor running-notes :initarg :running-notes :type list)
   (complete-notes :initform nil :accessor complete-notes :initarg :complete-notes :type list)
   (mindur :initform 50 :accessor mindur :initarg :mindur :type integer)
   (prev-phrase-nb :initform -1 :accessor prev-phrase-nb :initarg :prev-phrase-nb :type integer)
   (last-offset :initform 0 :accessor last-offset :initarg :last-offset :type integer)
   (lastSliceDur :initform 0  :accessor lastSliceDur :initarg :lastSliceDur )
   ))


;; unslice on behalf of  playslice options

(defmethod task ((self unslicer))
  (let ((event (listens self)) )
    (if (null event) 
      (process-allow-schedule) 
      (progn
        (setf event (transform-slice self (prepare-slice (clone-object event)  )))
        (loop for ME in (midiset event)
              with new-midiset = nil
              initially  (setf (new-waiting-list self) nil)
              do (cond ((plusp (MEPitch ME))
                        (push ME (new-waiting-list self))
                        (push ME new-midiset))
                       ((minusp (MEPitch ME))
                        (let ((waiting (find ME (waiting-list self)
                                             :test #'(lambda (m1 m2) 
                                                       (and (= (abs (MEPitch m1)) (abs (MEPitch m2))) 
                                                            (= (MEChannel m1) (MEChannel m2)))))))
                          ;(print (list ME waiting))
                          (cond 
                           (waiting
                            (setf (MEDur waiting) (+ (MEDur waiting) (MEDur ME)))
                            (push waiting (new-waiting-list self)))
                           (t 
                            ; a negative pitch (continuation) has to be interpreted as a starting note
                            ; only if the cont'ed note doesnt end inside the slice
                            ; the audio onset in this case has been corrected in output-slice-1
                            (when  (not (< (MEDur ME) (duration event)))
                              (setf (MEPitch ME) (abs (MEPitch ME)))
                              (push ME (new-waiting-list self))
                              (push ME new-midiset))))))) 
              ; might be empty if only running notes
              finally (when  new-midiSet
                        (setf (Midiset event) (nreverse new-midiSet) )
                        (talk self event)
                        ))))
    (setf (waiting-list self) (new-waiting-list self))))




; learn end section slice with 2000ms silence or not
; if not, take the last slice duration



; compatibility with bloc play

(defmethod New-bloc-impro ((self ImproSupervizer) startphrase)
  (setf (a-improvizer 1)
        (new-bloc-improvizer  (a-improvizer 0))
        (a-unslicer 1)
        (new-bloc-unslicer (a-unslicer 0))
        (a-player 2)
        (new-Bosc-midi-player "Bosc-player"))
  (setf (blocmode (a-improvizer 1)) T 
        (blocStartPhrase (a-improvizer 1)) startphrase
         )
  (when (>= startphrase 0)
    (setf (*regional-impro* (a-improvizer 1)) nil
          (poursuitemode (a-improvizer 1)) nil ))
  (connect (a-improvizer 1) :toport 4)
  (connect (a-unslicer 1) :fromport 4)
  (connect (a-unslicer 1) :toport 5)
  (connect (a-player 2) :fromport 5))

(defmethod new-bloc-UnSlicer ((self unslicer))
  (make-instance 'UnSlicer 
    :name "Bosc-unslicer"
    :KbdMirror (KbdMirror self)
    :AffineTrans (AffineTrans self)
    :RTempo (RTempo self)
    ; :compactSlice (compactSlice self)
  ))


; new interface messages









;------------------------------------------------------------------------------------




; code in EndSection the duration of the previous event in case of long endSection Event

(defvar *ShortenEndSection* NIL)
(defvar *CompactSlices* NIL)
(defvar *MidiGuitarMode* NIL)


; this duration shortens the end section events
(defmethod duration ((self crossevent))
  (or 
   (and *ShortenEndSection* (endSection self))
    (slot-value self 'duration)))

; this duration is the real (buffer compatible) duration
(defmethod Bduration ((self crossevent))
  (slot-value self 'duration))


(defmethod eat-note-off ((self polySlicer) (MEnoteoff list))
  (let* ((running (find-running-note self MENoteoff))
         (already-complete (assq running (complete-notes self))))
    (setf (last-offset self) (MEOnset MENoteOff))
    ; hack :: use the dur field to store the noteoff date 
    ; if not set by a noteoff, this dur field is by default 0
    (when running 
      (setf (MEDur running) (MEOnset Menoteoff) )
      (if already-complete
        (setf (cdr already-complete) MEnoteoff)
        (push (cons running MENoteOff) (complete-notes self)))))
  self)


(defmethod eat-note-on ((self polySlicer) (MEnoteon list))
  (cond
   ((or (StopPlayEvent MEnoteon)
        (not (in-time-window1 self  MENoteOn)))
    (setf (magnet2 self) (MEOnset MeNoteOn))
    ;(check-note-off self)
    (when (running-notes self) ;(format t "~d " (length (running-notes self)))
      (output-slice2 self (StopPlayEvent MEnoteon) )
      (if (StopPlayEvent MEnoteon)
        (setf (lastSliceDur self) 0)
        (setf (lastSliceDur self) (- (magnet2 self) (magnet1 self))))
      (when (StopPlayEvent MEnoteon)
        (format T "~%Section Boundary~%")))
    (reset-note-off self)       
    (setf (magnet1 self) (magnet2 self))
    (remove-old-notes self)
    (if (StopPlayEvent MEnoteon)
      (progn (setf (running-notes self) nil) (magnet1 self) 0 (magnet2 self) 0)
      (add-to-run-notes self MENoteOn)))
   (T ; (in-time-window1 self  MENoteOn)
    ;(setf (MEOnset MeNoteOn) (magnet1 self))
    (add-to-run-notes self MeNoteOn))
   (t ))
  self)

(defmethod add-to-run-notes ((self polySlicer) (MEnoteon list))
  (setf (running-notes self)
        (delete-if 
         #'(lambda (note)
             (and (= (MEPitch note) (MEPitch MENoteOn))
                  (= (MEChannel note) (MEChannel MENoteOn))))
         (running-notes self)))
  (pushr  MeNoteOn (running-notes self)))




(defmethod output-slice2 ((self polySlicer) StopPlayEvent)
  (let ((cross (mki 'crossevent)) (phrasenb (or (MEPhrase (first (running-notes self))) 0))
        (dur (- (magnet2 self) (magnet1 self))))
    (setf (duration cross) 
          dur
          (EndSection cross)
          (and StopPlayEvent (if (zerop (lastSliceDur self)) dur (lastSliceDur self)))
          (MidiSet cross)
          (loop for note in  (running-notes self)
                do (when (>= (MEOnset note) (magnet1 self)) (setf phrasenb (or (MEPhrase note) 0)))
                collect 
                ; hack : MEDur encodes the date of the note-off
                (new-midi-event  
                 (if (< (MEOnset note) (magnet1 self))
                   (- (MEPitch note))
                   (MEPitch note))
                 (max 0 (- (MEOnset note) (magnet1 self))) ; onset from the slice start
                 (if (zerop (MEDur note)) 
                   ; note traverses the slice
                   (min dur (- (MAgnet2 self) (MEOnset note)))
                   ; note ends in the slice
                   (min (- (magnet2 self) (magnet1 self))
                        (min (- (MEDur note) (Magnet1 self)) (- (MEDur note) (MEOnset note)))))
                 (MEVel note) 
                 (MEChannel note)
                 (or (MEPhrase note) 0)
                 (or (MEAUdioOnset note) 0)))
          (startPhrase cross)
          (/= phrasenb (prev-phrase-nb self))
          (phraseNumber cross)
          phrasenb
          (prev-phrase-nb self) phrasenb)
    ; notes that come from before the slice must have an audio onset aligned
    ; with the note that begins the slice (the local onset 0)
    (loop for evt in  (MidiSet cross)
          with audioOnset = (CrossEvtAudioOnset cross)
          do (setf (MEAudioOnset evt) (max audioOnset (MEAudioOnset evt))))

#|
(when (not (some #'(lambda (x) (zerop (second x))) (midiset cross)))
  (print "ZERO PROBLEM")
  (break) )
|#
    (when (>= dur (mindur self)) (talk self cross))
    cross))



#|
(defmethod prepare-slice ((self crossevent) )
  (when  (or *CompactSlices* (and *ShortenEndSection* (EndSection self)))
    (loop for event in (midiset self)
          do (setf (MEOnset event) 0
                   (MEDur event)  (duration self))))
  self)
|#



(defmethod prepare-slice ((self crossevent))
  (when  (and *ShortenEndSection* (EndSection self))
    (loop for event in (midiset self)
          do (setf (MEOnset event) 0
                   (MEDur Event) (min (MEDur Event) (duration self)))))
  (when   *CompactSlices*
    (loop for event in (midiset self)
          do (setf (MEOnset event) 0)
          (unless (< (MEDur Event) (/ (duration event) 2))
            (setf  (MEDur Event) (duration self)))))
  self)


;; need to copy crossevents better

(defmethod clone-object ((self CrossEvent))
  (let ((clone (copy-instance self)))
    (setf (MidiSet clone) (copy-tree (MidiSet  self)))
    clone))



;; interface messages

(defun OMaxSetShortEndSections (onoff)
  (let ((awake-impro (awake-p (a-improvizer 0))))
    (stop-impro *supervizer*)
    (setf *ShortenEndSection*  (not (zerop onoff)))
    (when awake-impro (start-impro *supervizer*))))

(defun OMaxSetCompactSlices (onoff)
  (setf *CompactSlices* (not (zerop onoff)))
)


;;-----------------------------------------------
;; bug in region select

(defun OMaxSetTimeRange (tmin tmax)
  (let ((self (a-improvizer 0)))
    (loop for i from 0 to (1- (maxetat self))
          for j from 1
          for t1 =  0 then (BufTOffset self i)
          for t2 =  (BufTOffset self j)
          with foundmin = nil
          if (<= t1 tmin t2) do (setf (first (CurRegion self)) (max i 1)) (setf foundmin T)
          if (<= t1 tmax t2) do (setf (second (CurRegion self)) (max i 1)) (return)
          finally 
          (when (not foundmin) (setf (first (CurRegion self)) (maxetat self)))
          (setf (second (CurRegion self)) (maxetat self)))
    (when (> (first (CurRegion self)) (second (CurRegion self)))
      (dprint "Uncoherent Region selection, setting to 0-max~%")
      (setf (first (CurRegion self)) 1
            (second (CurRegion self)) (max 1  (maxetat self))))
    (format t "~%Setting Region to ~d ~d~%" (first (CurRegion self)) (second (CurRegion self)))))


;--------------------------------------------------------

(defmethod start-new-impro-on-phrase-nb  ((self improviser))
  (catch
    'tag-fblm
    (loop for i from 1 to (maxetat (oracle self))
          if (and (startPhrase (otext (oracle self) i))
                  (= (phraseNumber (otext (oracle self) i)) (blocStartPhrase self)))
          do (progn (format t "Bloc starting at phrase ~d~%" (phraseNumber (otext (oracle self) i))) 
                    (impro-output-1-event self i)
                    (throw 'tag-fblm i)))
    (impro-failure self)))


;----------------------------------------------------------

; performance optimization
; efficient computation of regions
; phrase nb cache
; limitation in time and nb of exploration in sltsearch


;; this is for getting the same performances in background as in foreground

(setf ccl:*background-sleep-ticks* 1)
(setf *FOREGROUND-SLEEP-TICKS* 1)


#|

; system defaults
(setf ccl:*background-sleep-ticks* 5)
(setf ccl:*IDLE-SLEEP-TICKS* 5)
(setf *FOREGROUND-SLEEP-TICKS* 0)
|#

#|
; super overdrive

(setf ccl:*background-sleep-ticks* 0)
(setf *FOREGROUND-SLEEP-TICKS* 0)
|#

#|
(setf ccl:*background-sleep-ticks* 2)
(setf *FOREGROUND-SLEEP-TICKS* 2)
|#



(defmethod task  ((self learner))
  (let ((event))
    (setf event  (listens self))
    (if (null event) 
      (process-allow-schedule) 
      (progn
        (setf *current-improvizer* (oracle self)) ;; this doesn't work concurrently !
        (with-lock-grabbed ((lock (oracle self)))
          (setf (last-learned self) event)
          (ajouter-objet (oracle self) event)
          (when (startPhrase event)
            (push (cons (phraseNumber event) (maxetat (oracle self)))  (phrase-alist (oracle self))))
          )))))


(defmethod find-phrase ((self improviser) (phraseNb number))
  (let ((index (rest (assq phraseNb (phrase-alist (oracle self))))))
    (or index
        (loop for i from 1 to (maxetat (oracle self))
              if (and (startPhrase (otext (oracle self) i))
                      (= (phraseNumber (otext (oracle self) i)) phraseNb))
              do (progn (push (cons phraseNb i) (phrase-alist (oracle self)))
                        (return i))
              finally do (return nil)))))

(defmethod start-new-impro-on-phrase-nb  ((self improviser))
  (let ((index (find-phrase self (blocStartPhrase self))))
    (if index
      (impro-output-1-event self index)
      (progn (print "Did not find phrase. Starting at 1")
             (impro-output-1-event self 1)))))



;; doesn't need to listen so often
(defun OSC-listen (endpoint buffer)
  (loop while t do
        (let ((bufsize  (oa::receive-packet endpoint buffer *max-buf-size*))
              bundle)
          (if (null bufsize)
           (sleep 0.010)
             (progn
               (setf bundle (parse-buffer buffer 0 bufsize))
               ;(print (list "=====" bundle))
               (osc-route-bundle bundle)
               )))))


#|
(defmethod SLTSearch ((self improviser) i)
  ;(print i)
;(setf *scount* 0)
  (setf (exploretime self) (get-internal-real-time))
   (setf (onecounter self) 0)
   ;(format t "~%search ~d~%" (RLengthThresh self))
   (SLTCatch self
     (loop for k in (SLTSons self i)
           while (>= (RepeatLength self k) (RLengthThresh self))
           do  (SLTSearchSubtree self i k (RepeatLength self k)))
     (loop for ii = i then j
           for j = (SLTFather self i) then (SLTFather self j)
           while j
           while (>= (repeatlength self ii) (rlengththresh self))
           do
           ;(print (list ii j))
           ;(when (= i j) (print (list 'consider i j)))
           (SLTConsiderSolution self i j (repeatlength self ii))
           (loop for k in (SLTSons self j)
                 while (>= (min (repeatlength self k) (repeatlength self ii)) (rlengththresh self))
                 ;when (=  i k) do (print (list i ii k))
                 when (/= k ii)  do  (SLTSearchSubtree self i  k (min (repeatlength self k) (repeatlength self ii))))))   
   )

; maximum time for a single SLTSearch

;(defvar *maxSLtSearchTime* 10)

;;; descending research in an SLT subtree

(defmethod  SLTSearchSubtree ((s improviser) i j rlength)
  (when  (>  (- (get-internal-real-time) (exploretime s)) 
             *maxSLtSearchTime*) 
    ;(print 'ESCAPETIME)
    (SLTEscapeSearch s))
  ; limit number of exploration in any case 
  (when T ; (= rlength 1) 
     (incf (onecounter s)) 
     (when (> (onecounter s) (maxonecount s)) 
;(format t "On 100 exploration, ~a retained~%~%" *scount*)
       (setf (onecounter s) 0) (SLTEscapeSearch s)))
   ;(format t "~d " rlength)
   ;(when (= i j) (print (list 'consider i j)))
   ;(SLTIncreaseParseCounter s)
   (SLTConsiderSolution s i j rlength)
   (loop for l in (SLTSons s j)
         do (SLTSearchSubtree s i l rlength)))



(defmethod SLTConsiderSolution ((s improviser) i j rlength)
  ;(prin1 ". ")
  (when  (SLTSolutionCannotImprove s i j rlength)
    (SLTEscapeSearch s))
  (let ((RhythmQuality  (SLTFilterSolution s i j rlength)))
    (when RhythmQuality
      ;(print (recsolutions s))
;(incf *scount*)
      (SLTStoreSolution s i j rlength RhythmQuality))))


|#


#|
(defun dichotomic-search (vector value min max)
  (let ((half (+ min (floor (- max min) 2))))
    (if (>= min max)
      min
      (if (<= (aref vector half) value (aref vector (1+ half)))
        (if (= value (aref vector (1+ half))) (1+ half) half)
        (if (<= (- max min) 1)
          (if (> value (aref vector max)) max min)
          (if (< value (aref vector half))
            (dichotomic-search vector value min half)
            (dichotomic-search vector value (1+ half) max)))))))
|#


(defmethod find-state-at-time ((self coracle) time min max)
  ;(print (list min max))
  (let ((half (+ min (floor (- max min) 2))))
    (if (>= min max)
      min
      (if (<= (BufTOffset self half) time (BufTOffset self (1+ half)))
        (if (= time (BufTOffset self (1+ half))) (1+ half) half)
        (if (<= (- max min) 1)
          (if (> time (BufTOffset self max)) max min)
          (if (< time (BufTOffset self half))
            (find-state-at-time self time min half)
            (find-state-at-time self time (1+ half) max)))))))




; (dichotomic-search #( 0  1200 1350 13250 1000 1375 3000 3100  4000) 4000 1 8)


(defun OMaxSetTimeRange (tmin tmax)
  (let ((self (a-improvizer 0)))
    (setf (first (CurRegion self))
          (find-state-at-time (oracle self) tmin 1 (maxetat self))
          (second (CurRegion self))
          (find-state-at-time (oracle self) tmax 1 (maxetat self)))
    (format t "~%Setting Region to ~d ~d~%" (first (CurRegion self)) (second (CurRegion self))) ))
    

(defun OMaxSetPhraseRange (tmin tmax)
  (let* ((self (a-improvizer 0))
         (p1 (find-phrase self tmin))
         (p2 (find-phrase self (1+ tmax))))
    (setf (first (CurRegion self))  (or p1 1) 
          (second (CurRegion self)) (if p2 (1- p2) (max 1 (maxetat self))))
    (format t "~%Setting Region to ~d ~d~%" (first (CurRegion self)) (second (CurRegion self)))))


;----------------------------------------------------------------
;; this because slicer kept the last phrase number when resetting or reloading main 
(defmethod clean-up  ((self polyslicer))
  (empty-queue (agent-listening-queue self))
  (reinitialize-instance self  :running-notes nil :complete-notes nil :last-offset 0 :prev-phrase-nb -1 :magnet1 0 :magnet2 0)
  self)



;----------------------------------------------------------------
; new scheme for handling search performance

(setf ccl:*background-sleep-ticks* 1)
(setf *FOREGROUND-SLEEP-TICKS* 1)


#|

; system defaults
(setf ccl:*background-sleep-ticks* 5)
(setf ccl:*IDLE-SLEEP-TICKS* 5)
(setf *FOREGROUND-SLEEP-TICKS* 0)
|#

#|
; super overdrive

(setf ccl:*background-sleep-ticks* 0)
(setf *FOREGROUND-SLEEP-TICKS* 0)
|#

#|
(setf ccl:*background-sleep-ticks* 2)
(setf *FOREGROUND-SLEEP-TICKS* 2)
|#

(defmethod task ((self improsupervizer))
  (event-dispatch)
  (let ((playahead (+ (look-time-ahead (a-player 1)) (look-time-ahead (a-unslicer 0)))))
    (cond
     ((>= playahead *max-play-ahead*)  
      (too-fast (a-improvizer 0)) )
     (t (too-slow (a-improvizer 0))
        (setf (exploretime (a-improvizer 0)) (get-internal-real-time)))))
  (when (and (a-improvizer 1) ; ongoing bloc improvizer
             (eq (bloc-impro-state self) 'terminated)
             )
    (kill-bloc-impro self)
    (print "BLOC SENT")
    )
  (when (and (PoursuiteMode (a-improvizer 0)) (> (poursuite (a-improvizer 0)) 0))
    (set-poursuite-region (a-improvizer 0)))
  ;(sleep .050)
  ;(process-allow-schedule)                
  )



(defmethod ExploreRecCandidates ((self improviser))
  (setf (exploretime self) (get-internal-real-time))
  (catch 'ExploreCandidates
    (loop for RecCandidate in (SortedRecCandidates self)
          until (RecSearchNotImprovable self)
          do
          (progn 
            
            (setf (RecSolImproved self) nil)
            (SLTSearch self RecCandidate)))))


(defmethod SLTSearch ((self improviser) i)
  (setf (onecounter self) 0)
  (SLTCatch self
    (loop for k in (SLTSons self i)
          while (>= (RepeatLength self k) (RLengthThresh self))
          do  (SLTSearchSubtree self i k (RepeatLength self k)))
    (loop for ii = i then j
          for j = (SLTFather self i) then (SLTFather self j)
          while j
          while (>= (repeatlength self ii) (rlengththresh self))
          do
          ;(print (list ii j))
          ;(when (= i j) (print (list 'consider i j)))
          (SLTConsiderSolution self i j (repeatlength self ii))
          (loop for k in (SLTSons self j)
                while (>= (min (repeatlength self k) (repeatlength self ii)) (rlengththresh self))
                ;when (=  i k) do (print (list i ii k))
                when (/= k ii)  
                do  (SLTSearchSubtree self i  k 
                                      (min (repeatlength self k) (repeatlength self ii)))))))

; maximum time for a single SLTSearch

(defvar *maxSLtSearchTime* 50)
(defvar *maxSLtSearchNodes* 100)

;;; descending research in an SLT subtree

(defmethod  SLTSearchSubtree ((s improviser) i j rlength)
  (let ((elapsed (- (get-internal-real-time) (exploretime s))))
    (when (> elapsed *maxSLtSearchTime*)
      ;(print (list 'cancel_search elapsed))
      (throw  'ExploreCandidates s))
    ; limit number of exploration in any case 
    (when T ; (= rlength 1) 
      (incf (onecounter s)) 
      (when (> (onecounter s) *maxSLtSearchNodes*) 
        (SLTEscapeSearch s)))
    (SLTConsiderSolution s i j rlength)
    (loop for l in (SLTSons s j)
          do (SLTSearchSubtree s i l rlength))))



#|
(defmethod SLTConsiderSolution ((s improviser) i j rlength)
  ;(prin1 ". ")
  (when  (SLTSolutionCannotImprove s i j rlength)
    (SLTEscapeSearch s))
  (let ((RhythmQuality  (SLTFilterSolution s i j rlength)))
    ; when sol complete and we are not doing better
    ; take new candidate only with 1/8 chance
    (when (and RhythmQuality
               (or (not (RecSearchComplete s))
                   (and (= rlength (MinSolRLength s))
                        (< (random 100) 13)
                        )))
      (SLTStoreSolution s i j rlength RhythmQuality))))
|#



(defmethod SLTConsiderSolution ((s improviser) i j rlength)
  ;(prin1 ". ")
  (when  (SLTSolutionCannotImprove s i j rlength)
    (SLTEscapeSearch s))
  (let ((RhythmQuality  (SLTFilterSolution s i j rlength)))
    (when RhythmQuality
      ;(print (recsolutions s))
;(incf *scount*)
      (SLTStoreSolution s i j rlength RhythmQuality))))





; experimental

#|
(defmethod SLTSolutionCannotImprove ((self improviser) i j rlength)
  (declare (ignore i j rlength))
  (and (RecSearchComplete self)
       (not (> rlength (MinSolRLength self)))
       (or (< rlength (MinSolRLength self))
           (< (random 100) 75))
       ))
|#


;--- interface

(defun OMaxSpeedNormal ()
  (setf *maxSLtSearchTime* 50)
  (setf *maxSLtSearchNodes* 100)
  (setf ccl:*background-sleep-ticks* 1)
  (setf *FOREGROUND-SLEEP-TICKS* 1)
  )


(defun OMaxSpeedUp1 ()
  (setf *maxSLtSearchTime* 30)
  (setf *maxSLtSearchNodes* 50)
  (setf ccl:*background-sleep-ticks* 1)
  (setf *FOREGROUND-SLEEP-TICKS* 1)
  )

(defun OMaxSpeedUp2 ()
  (setf *maxSLtSearchTime* 25)
  (setf *maxSLtSearchNodes* 25)
  ; too dangerous
  ;(setf ccl:*background-sleep-ticks* 0)
  ;(setf *FOREGROUND-SLEEP-TICKS* 0)
  )


(defun OMaxImproAvance (avance)
  (setf  *max-play-ahead* avance))



;-----------------------------------------------------------------------------
; experimental
; better sort before virfun
; better count only "good pitches" in slices for comparison (i.e. sustained notes must hold 
; during whole slice

(defmethod SliceMainPitches ((self crossevent))
  (sort 
   (loop for e in (midiset self)
         if (or (plusp (MePitch e))
                (= (MEDur e) (duration self))
                )
         collect (abs (MePitch e)))
   #'<))

(defmethod CompareEvents ((Event1 CrossEvent) (Event2 CrossEvent))
  (let ((p1 (SliceMainPitches event1))(p2 (SliceMainPitches event2)))
;(print (list p1 p2))
    (and (= (vfun2 event1 p1) (vfun2 event2 p2))
         ( = (floor (log (length p1) 2)) (floor (log (length p2) 2))))))

(defmethod vfun2 ((Event CrossEvent) (mainpitches list))
  (or (virfun event)
      (progn 
        (setf (virfun event)
              (mod (virtual-fundamental mainpitches 50) 1200))
        (virfun event))))




