(in-package :om)


(defun cree-free ()         
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array  orchestre) 0)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle t)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    (format t "Creation d'un orchestre free")
    orchestre
    ))


(defun cree-freeE ()         
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array  orchestre) 0)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle t)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    (setf (useEstrada oracle) t)
    (setf (useHindemith oracle) t)
    (format t "Creation d'un orchestre free estrada")
    orchestre
    ))

;;; Mode beat
;;; Les grilles sont definies a la fin du fichier

(defun cree-rain ()          ;;; BPM=125, 16 beats
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 1)
         (*dureebeat* 484)
         (*grille* ms::*grille-rain*)
         (*blues?* nil))
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre) *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle nil)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    (format t "Creation orchestre Rain... BPM=125, 16 beats~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))


(defun cree-bluesBb ()        ;;; BPM=112, 48 beats
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 2)
         (*dureebeat* 536)
         (*grille* ms::*grille-BluesBb*)
         (*blues?* t))
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre)
          *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle nil)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    
    (format t "Creation orchestre blues en Bb sur Ziste... BPM=112, 48 beats~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))


(defun cree-dicidence ()         ;;; BPM=188, 128 beats (32 mesures)
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 2)
         (*dureebeat* 319)
         (*grille* 
          ms::*grille-dicidence*)
         (*blues?* nil))
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre)
          *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    
    (setMaxCont oracle 16)
    (set-best-suffix-mode oracle t)
    (set-start-region oracle '(0 100))
    (set-suffix-law oracle '(t t))
    
    (format t "Creation orchestre Dicidence... BPM=188, 128 beats~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))




(defun cree-toutpiti ()             ;;; BPM=118, 96 beats (3*8 mesures, partie A A B)
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 2)
         (*dureebeat* 508)
         (*grille* 
          ms::*grille-toutpiti*)
         (*blues?* nil))
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre)
          *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle nil)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    (format t "Creation orchestre Tout piti... BPM=118, 96 beats (3*8 mesures)~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))



(defun cree-defautbeat ()          ;;; BPM=298, 16 beats, duree beat = 201 ms
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 2)
         (*dureebeat* 201)
         (*grille* ms::*grille-defautbeat*)
         (*blues?* nil))
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre) *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle nil)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    (format t "Creation orchestre Defautbeat... BPM=298, 8 beats~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))


(defun cree-goodbye ()          ;;; BPM=77, 48 beats,  duree beat = 779 ms
  (let* ((orchestre (new-orchestre))
         (oracle (aref (improvizer-array orchestre) 0))
         (*nbeatsaccord* 1)     ;/2)
         (*dureebeat* 779)
         (*grille* ms::*grille-goodbye*)
         (*blues?* nil))
    (setf (nbeatsaccord orchestre) *nbeatsaccord* (dureebeat orchestre) *dureebeat* (grille orchestre) *grille* (blues? orchestre) *blues?*)
    (setf (Beats/Measure oracle) 4)
    (setf (RefTempo oracle) *dureebeat*)
    (setf (RefHarmGrid oracle) (ms::enleve-marque* (ms::duplique-beat *grille* *nbeatsaccord*)))
    (setf (HarmGridLength oracle) (length (RefHarmGrid oracle)))
    (setMaxCont oracle 4)
    (set-best-suffix-mode oracle nil)
    (set-start-region oracle '(90 100))
    (set-suffix-law oracle '(t t))
    (format t "Creation orchestre Defautbeat... BPM=298, 8 beats~%")
    (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
    (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
    orchestre
    ))



;;; ========================================================
;;; Definition des principales grilles
;;; ========================================================
;;; Les grilles peuvent etre representees 
;;; - a la mesure
;;; - a la demi-mesure ("Rain", "Goodbye Pork Pie Hat")
;;; L'unite de division pour les substitutions est la "case" (notee entre deux /)
;;; - case = mesure        => *nbeatsaccord* = 2
;;; - case = demi-mesure   => *nbeatsaccord* = 1

(in-package :midishare)

(setf *grille-rain*
'((b m7) (e 7) / (bb m7) (eb 7) / (g# m7) / (c# 7) / (f#) / (g# 7) / (b 7) / (bb 7)))
;;; Kerri Chandler, d'apres "Round Midnight" mesures 4, 5, 6, 7


(defvar *grille-bluesBb* 
  '((bb) / (bb) / (bb) / (bb 7) /
    (eb) / (eb) / (bb) / (bb 7) /
    (f) / (eb) / (bb) / (f 7)))

(defvar *grille-dicidence* '((f m7) / (g 7) / (c m7) / (c m7) / (f m7) / (g 7) / (c m7) / (c m7)  /
                             (f m7) / (g 7) / (c m7) / (c m7)  / (f m7) / (g 7) / (c m7) / (c 7)  /
                             (f m7) / (bb 7) / (eb) / (g#) / (d 7) / (g 7) / (c m7) / (c 7) /
                             (f m7) / (bb 7) / (eb) / (g#) / (d 7) / (g 7) / (c m7) / (c m7)
                             ))


(defvar *grille-toutpiti*
  '((f) / (f) / (f 7) / (bb) /
    (bb m7) (eb 7) / (a m7) (d 7) / (g m7) (c 7) / (f) /
    (f) / (f) / (f 7) / (bb) /
    (bb m7) (eb 7) / (a m7) (d 7) / (g m7) (c 7) / (f) /
    (c 7) / (f) / (c 7) / (f) / 
    (c 7) / (f) / (c 7) / (f)))

(setf *grille-defautbeat* 
  '((c) / (c) / (c) / (c)))

(setf *grille-goodbye*                    ;;; interbarre = demi-mesure
      '((f 7) / (c# 7) / (f#) / (b 7) / (eb 7) / (c# 7) / (eb 7) / (f 7) /
        (bb m7) / (g# 7) / (g m7) / (c 7) / (d 7) / (g 7) / (c# 7) / (f#) /
        (bb 7) / (c# 7) / (c 7) / (eb 7) / (f 7) / (c# 7) / (f#) / (b 7)))









#|
;;; Vieux chargements non utilises

(defun om::charge-ziste ()          ;;; BPM=112, 16 beats
  (setf *nbeatsaccord* 1)
  (setf *dureebeat* 535)
  (setf *grille*                     ;;; interbarre = demi-mesure
        '((bb) / (bb) / (bb) / (bb 7) / (bb) / (bb) / (bb) / (bb 7)))
;;; Lubat-Minvielle
  (setf *blues?* nil)
  (setf *oracle-courant* (om::NewImprovizer))
  ;;;;;(charge-baseziste)   ;;; ancienne base d'impro
  (format t "Chargement de Ziste... BPM=112, 16 beats~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

(defun om::charge-ornithology ()          ;;; BPM=230, 64 beats (16 mesures)
  (setf *nbeatsaccord* 2)                 ;;; / X / = 2 * 4 beats (tempo dedouble)
  (setf *dureebeat* 261)
  (setf *grille* 
        '((g) / (g) / (g m7) / (c 7) / (f) / (f) / (f m7) / (bb 7) / 
          (eb 7) / (d 7) / (g m7) (c m7) / (g m7) / (b m7) / (e 7) / (a m7) / (d 7)))    ;;; seulement 16 mes/
          ;(g) / (g) / (g m7) / (c 7) / (f) / (f) / (f m7) / (bb 7) / 
          ;(eb 7) / (d 7) / (g m7) (c m7) / (g) / (g) / (g) / (g) / (g)))
  (setf *blues?* nil)
  (setf *k* 0)                               ;;; pas de substitution
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement Ornithology... BPM=230, 64 beats (16 mesures)~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

(defun om::charge-sweeterlove ()          ;;; BPM=120, 16 beats (4 mesures)
  (setf *nbeatsaccord* 4)
  (setf *dureebeat* 500)
  (setf *grille* 
        '((c# m7) / (b m7) / (f# m7) / (a m7) (g m7)))
  (setf *blues?* nil)
  (setf *k* 0)                               ;;; pas de substitution
  (setf *oracle-courant* (om::NewImprovizer))
  (format t "Chargement Sweeter Love... BPM=120, 16 beats (4 mesures)~%")
  (format t "Nbre de beats par demi-interbarre de grille (1 ou 2) = ~a~%Duree du beat = ~a ms~%Remise a zero de l'oracle~%" *nbeatsaccord* *dureebeat*)
  (when *blues?* (format t "Harmonies bluesy dans la table d'arrangement~%"))
)

|#