;;===========================================================================
;OM API 
;Multiplatform API for OpenMusic
;Macintosh version (Digitool Macintosh Common Lisp - MCL)
;
;Copyright (C) 2004 IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Jean Bresson and Augusto Agon
;;===========================================================================

;;===========================================================================
;DocFile
; METAOBJECT PROGRAMMING UTILITIES 
;;===========================================================================


(in-package :om-api)
;;;=========================
;;; export :
;;;=========================
(export '(
          class-instance-slots
          class-class-slots
          class-direct-instance-slots
          class-direct-class-slots
          get-class-default-initargs
          ;;;save-initargs
          get-class-precedence-list
          function-spec-p
          function-name
          method-name
          om-remove-method-definition
          copy-instance
          eql-specializer?
          eql-specializer-object
          ) :om-api)
;;;=========================

(defun method-name (method)
  (ccl::method-name method))



(defmethod class-instance-slots ((class t))
  (ccl::class-instance-slots class))

(defmethod class-class-slots ((class t))
  (ccl::class-class-slots class))

(defmethod class-direct-instance-slots ((class t))
  (ccl::class-direct-instance-slots class))

(defmethod class-direct-instance-slots ((class t))
  (ccl::class-direct-instance-slots class))

(defmethod class-direct-class-slots ((class t))
  (ccl::class-direct-class-slots  class))

     
(defun OM-REMOVE-METHOD-DEFINITION (method)
  (remove-method (fdefinition (method-name method)) method))

    
(defun get-class-default-initargs (class)
  (ccl::%class-default-initargs class))


;(defun save-initargs (list)
;  (loop for item in list
;      for value = (funcall (second item))
;        append (eval `(list ,(car item) ',(omng-save value t)))))


(defun get-class-precedence-list (class)
   (ccl::class-precedence-list class))

(defun function-spec-p (spec)
  (ccl::function-spec-p spec))


(defun eql-specializer? (method-specializer)
  (consp method-specializer))


#|
(defun eql-specializer-object (eql-specializer)
  (cadr eql-specializer))
|#


(in-package :ccl)

(defmethod shared-initialize :after ((spec effective-slot-definition)
				     slot-names
				     &key type
				     &allow-other-keys)
  (declare (ignore slot-names))
  (unless (eq type t)
    (setf (slot-value spec 'type-predicate)
          (if (equal (type-of (slot-value spec 'class )) 'om::omstandardclass)
            #'(lambda (value) t)
            
	    (or (and (typep type 'symbol)
		     (type-predicate type))
                (handler-case
                  (let* ((ctype (specifier-type type)))
                    #'(lambda (value) (%%typep value ctype)))
                  (parse-unknown-type (c)
                                      (declare (ignore c))
                                      #'(lambda (value)
                                          ;; If the type's now known, install a new predicate.
                                          (let* ((nowctype (specifier-type type)))
                                            (unless (typep nowctype 'unknown-ctype)
                                              (setf (slot-value spec 'type-predicate)
                                                    #'(lambda (value) (%%typep value nowctype))))
                                            (%%typep value nowctype))))))))))