(in-package :om)

(defun parse-graphic-class-options (args)
   (let (metaclass restargs)
     (loop while args do
           (cond
            ((equal (caar args) :metaclass)            
             (setf metaclass  (second (pop args))))
            (t (push (pop args) restargs))))
     (values restargs metaclass)))

(defmacro omg-defclass (Name Superclass Slots &rest Class-Options)
  (multiple-value-bind (new-options metaclass) 
                       (parse-graphic-class-options class-options)
    `(defclass ,name ,superclass ,slots 
       (:metaclass standard-class)
       ,.new-options)))


;------
(defmacro om-with-redefinitions (&body body)
  `(let ((ccl::*warn-if-redefine* nil)
         (ccl::*suppress-compiler-warnings* t)
         (ccl::*load-verbose* nil))
     ,@body))

