(in-package :om)





;===============================================================
;copy

(defmethod omNG-copy ((self t))
   "Return an expresion that produce a copy of 'self' when it is valued."
   (cond
    ;((om-color-p self) (om-copy-color self))
    ;((om-point-p self) (om-copy-point self))
    ((omclass-p  (class-of self))
     (let* ((theclass (class-name (class-of self)))
            (slots (mapcan #'(lambda (slot)
                               (list (string2initarg (string (first slot))) 
                                     (omNG-copy (slot-value self (first slot))))) 
                           (get-initargs-of-class theclass))))
       `(make-instance ',theclass ,.slots)))
    ((equal (class-name (class-of (class-of self))) 'standard-class)
     (let* ((theclass (class-name (class-of self)))
            (slots (mapcan #'(lambda (slot)
                               (list `(setf (slot-value copy ',(first slot)) 
                                            ,(omNG-copy (slot-value self (first slot)))))) 
                           (get-init-slots-of-class theclass))))
       `(let ((copy (make-instance ',theclass)))
          ,.slots
          copy)))
    (t self)))


(defmethod omNG-copy ((self function)) self)

(defmethod omNG-copy ((self hash-table)) (omng-save self))

(defmethod omNG-copy ((self null))  nil)

(defmethod omNG-copy ((self symbol)) `',self)

(defmethod omNG-copy ((self list)) `(list ,@(mapcar #'omNG-copy self)))

(defmethod omNG-copy ((self cons)) 
  (if (quoted-form-p self)
    `',(omng-copy (second self))
    (if (null (cdr (last self)))
       (call-next-method)
       `(cons ,(omng-save (first (last self))) ,(omng-save (cdr (last self)))))))



(defmethod* clone ((self t)) 
   :icon 205 
   :indoc '("The object to copy")
   :doc "Make a copy of an object"
   (eval (omng-copy self)))

#|
(defmethod* clone ((self simple-container))
  (copy-container self))
|#
 
