(in-package :nc)


;;--------------------------------------------------------------------------------
;;; name       : 
;;; description: 
;;; notes      :
;;; contact    : me (Michael Trowe)
;;; copyright  :
;;; history    : 
;;; contents   :
;;;--------------------------------------------------------------------------------

(defvar *image* "/opt/cl/acl-5-01/climcomposer")
(defvar *tmp-dir* (namestring (translate-logical-pathname "nclos:tmp")))
(defvar *starter* (namestring (translate-logical-pathname "nclos:ncl-starter")))
(defvar *port* 8122)
(defvar *master-port* ())
(defvar *master-host* ())
(defvar *master-p* t)
(defvar *local-host*)
(defvar *manager* ())
(defvar *init-file* (namestring (translate-logical-pathname "nclos:ld-actors.sys")))
(defvar *debug* t)
(defvar *localspace* ())
#+ALLEGRO-V5.0.1
(let ((EXCL:*ENABLE-PACKAGE-LOCKED-ERRORS* nil))
(defclass manager ()  
  ((stream :accessor nstream
	   :initform (make-server-stream))
   (spaces :accessor spaces
	   :initform ())
   (systems :accessor systems
	    :initform ())
   (receivers :accessor receivers
	      :initform ())
   (objstore :accessor objstore
	     :initform (make-instance 'objstore)))))

#-ALLEGRO-V5.0.1
(defclass manager ()  
  ((stream :accessor nstream
	   :initform (make-server-stream))
   (spaces :accessor spaces
	   :initform ())
   (systems :accessor systems
	    :initform ())
   (receivers :accessor receivers
	      :initform ())
   (objstore :accessor objstore
	     :initform (make-instance 'objstore))))


(defmessage space-added (new-space)
  :receive-action (setf (spaces *manager*)
		    (cons new-space (spaces *manager*))))

(defmessage system-added (name options specifications)
  :receive-action (eval `(defpsystem ,name ,options ,@specifications)))

;;; Initialize the new objspaces just started:
;;; - Establish a connection to those spaces which won't do it themselves.
;;; - Accept the connections of those spaces which try to establish one.
;;; - Receive the systems: define them and load them, if necessary.
(defmessage init (passive-hosts number-of-hosts systems)
  :receive-action (progn 
		    (loop for host-and-port in passive-hosts
		        do (establish-connection (car host-and-port) (cdr host-and-port)))
		    (connect-to-spaces (- number-of-hosts
					  (length passive-hosts)
					  1))
					; minus 1, because you have to subtract the 
					; local space.
		    (setf (systems *manager*) systems)
		    (loop for system in systems
			do (eval `(excl::defsystem ,(first system)
			      ,(second system) ,@(third system))))
		    (loop for system in systems
			when (eq (fourth system) :loaded)
			do (excl::load-system (first system)))))

(defmessage system-loaded (system-name load-args)
  :receive-action (apply #'excl::load-system system-name load-args))


(defun start-virtual-machine (hostlist &key (image *image*)
					    form)
  
  (start-spaces image form hostlist)
  (connect-to-spaces (length hostlist))
  (initialize-spaces (spaces *manager*)))

;;; (*) Sonst wird (load "ld-actors") geschickt, was nicht evaluiiert 
;;; werden kann, wenn rsh in fi-subproc.el (emacs) gewaehlt wird
;;; wenn dort local erkannt wird, sind die #\\ falsch.
(defvar *string-char-handling* nil)
(defun start-spaces (image form hostlist)
  (let ((unique-lisp-file-ext (gentemp 'F)))
    (when (not (probe-file *tmp-dir*))
      (excl::run-shell-command (format nil "mkdir ~S" *tmp-dir*)))
    (with-open-file (stream (concatenate 'string *tmp-dir* "/tmp" 
					 (string unique-lisp-file-ext)
					 ".lisp")
		     :if-exists :supersede
		     :direction :output 
		     :if-does-not-exist :create)
      (setq form 
	`(let ((*terminal-io* excl::*initial-terminal-io*)
	       (*query-io* excl::*initial-terminal-io*))
	   (load  ,*init-file*)
	   (eval (list 'progn
		       (list 'setf (intern "*MASTER-HOST*" "NC") 
			     ,*local-host*)
		       (list 'setf (intern "*MASTER-P*" "NC") nil)
		       (list 'setf (intern "*PORT*" "NC") 8130)
		       (list 'setf (intern "*MASTER-PORT*" "NC") ,*port*)
		       
		       (list (intern "ENSURE-OS" "NC"))))
	   ,form))
      (print form)
      (let ((*package* "USER")) 
      ;;; (*)

	(loop for char across 
	      
	      (format nil "~S~% ~%" form)
	    do
	      (when (and       
		     *string-char-handling*
		     (char= char #\"))
		(write-char #\\ stream))
	      (write-char  char stream))))

    (loop for host in hostlist
	do 
	  (start-image image host unique-lisp-file-ext))))

#+ALLEGRO-V5.0
(defun connect-to-spaces (number-of-spaces)
  (loop for x from 1 to number-of-spaces
      do (wait-for-input-available (nstream *manager*))
      do (connect-to-space (nstream *manager*))))


(defun connect-to-spaces (number-of-spaces)
  (loop for x from 1 to number-of-spaces
      do (:wait-for-input-available (nstream *manager*))
      do (connect-to-space (ipc::stream-read (nstream *manager*)))))

(defun connect-to-space (stream &optional (host (read stream)) (port (read stream)))
  (let ((space  (make-instance 'objspace
		  :host host
		  :port port
		  :stream stream)))
    (push space (spaces *manager*))
    (push (make-instance 'receiver :objspace space :stream stream) 
	  (receivers *manager*))))

(defun initialize-spaces (spacelist)
  (loop with number-of-hosts =(length spacelist)
      for spaces on spacelist
      while spaces
      do (kernel-send (first spaces)
		      (init-message :passive-hosts (mapcar #'(lambda (space)
							       (cons (host space)
								     (port space)))
							   (rest spaces))
				    :number-of-hosts number-of-hosts
				    :systems (systems *manager*)))))

(defun start-image (image host &optional (unique-lisp-file-ext (gentemp)))
  (format t "rsh ~a '~a ~a ~a ~a ~a ~a ~a' &" 
				  host 
				  *starter*
				  (if *debug*
				      "emacs"
				    "raw")
				  image
				  (sys::getenv "DISPLAY")
				  *tmp-dir*
				  (gentemp 'E)
				  unique-lisp-file-ext
				  )
  (excl::run-shell-command (format nil "rsh ~a '~a ~a ~a ~a ~a ~a ~a' &" 
				  host 
				  *starter*
				  (if *debug*
				      "emacs"
				    "raw")
				  image
				  (sys::getenv "DISPLAY")
				  *tmp-dir*
				  (gentemp 'E)
				  unique-lisp-file-ext
				  ))) ;;; auch an xon
  
(defmethod add-system ((manager manager) name options specifications)
  (let ((system (assoc name (systems manager))))
    (if system
	(setf (cdr system) (list options specifications :unloaded))
      (setf (systems manager) 
	(cons (list name options specifications :unloaded)
	      (systems manager))))
    (when *master-p*
      (loop for space in (spaces manager)
	  do (kernel-send space
			  (system-added-message :name name
						:options options
						:specifications specifications))))))

(defun ensure-os ()
  (unless *manager*
    (setf *local-host* (sys::getenv "HOST"))
    (setf *manager* (make-instance 'manager))
    (unless *master-p* 
      (establish-connection *master-host* *master-port*)))
  *manager*)
      
#-ALLEGRO-V5.0.1  
(defun establish-connection (host port)
  
  (let ((stream 
	 (make-instance 'ipc::tcp-client-stream
					   #+ALLEGRO-V5.0.1
					   :remote-host 
					   #-ALLEGRO-V5.0.1		  
					   :host host
					   #+ALLEGRO-V5.0.1
					   :local-port
					   #-ALLEGRO-V5.0.1
					   :port port)))
    (connect-to-space stream host port)
    (print *local-host* stream) 
    (print *port* stream)
    (finish-output stream)))


#+ALLEGRO-V5.0.1
(defun establish-connection (host port)
  (let ((stream 
	 (change-class 
	  (socket:make-socket 
;;;	   :connect :active
	   :remote-port port 
	   :remote-host host
	   :format :bivalent)
	  'ipc::tcp-client-stream)))
    (connect-to-space stream host port)
    (print *local-host* stream) 
    (print *port* stream)
    (finish-output stream)))

;;; geht nicht fuer andere
#-ALLEGRO-V5.0.1
(defun make-server-stream ()
  (let ((stream))
    (loop
	until (handler-case (setf stream 
			      (make-instance 'ipc::tcp-server-stream 
					   :host
					   *local-host*
					   :port *port*))
	      (error (cond) ())
	      (:no-error (cond) t))
	do (incf *port*))
    stream))

#+ALLEGRO-V5.0.1
(defun make-server-stream ()
  (let ((stream))
    (loop
	until (handler-case (setf stream  
;;; vgl. cl-http/acl501/server/tcp.lisp 			      
			      ;;; kommt so auch nicht wieder
			      (change-class 
			       (socket:make-socket 
			       :connect :passive ;;;:active kommt nicht wieder
			       :local-port *port* :reuse-address t 
			       :local-host *local-host*
			       :format :bivalent)
			       'ipc::tcp-server-stream))
		(error (cond) ())
		(:no-error (cond) t))
	do (incf *port*))
    stream))



#+ALLEGRO-V5.0
(defun establish-connection (host port)
  (let ((stream (make-socket-stream host port)))

    (connect-to-space stream host port)
    (print *local-host* stream) 
    (print *port* stream)
    (finish-output stream)))

#+ALLEGRO-V5.0
(defun make-socket-stream (host port)
  (let ((s (acl-socket:make-socket :remote-host host :remote-port port)))
    (accept-connection s)))

#+ALLEGRO-V5.0
(defun make-server-stream ()
  (let ((stream))
    (loop
      until (handler-case (setf stream (make-socket-stream *local-host*
							    *port*))
	      (error (cond) ())
	      (:no-error (cond) t))
	do (incf *port*))
    stream))

(defun kill-machine (&key hard) 
  (loop for receiver in (receivers *manager*)
      do (kill receiver))
  (loop for space in (spaces *manager*)
      do (kill space))
  (if hard
      (progn (close (nstream *manager*))
	     (setf *manager* ())
	     (ensure-os))
    (progn (reset (objstore *manager*))
	   (setf (receivers *manager*) ())
	   (setf (spaces *manager*) ()))))
	   
       
  
 
  

(defun reset-machine ()
  (loop for receiver in (receivers *manager*)
      do (reset receiver))
  (loop for space in (spaces *manager*)
      do (reset space))
  (reset (objstore *manager*))
  *manager*)
  
(defun kill-space (hostname)
  (let ((space (find hostname (spaces *manager*) :key #'host)))
    (kernel-send space
		 (ncl-exit-message))))

(defmessage ncl-exit ()
  :receive-action (excl::exit nil :quiet t))

(defun connection-lost (manager receiver)
  (let ((space (objspace receiver)))
    (if (string= *master-host* (host space))
	(excl::exit nil :quiet t)	
      (progn (setf (spaces manager) (remove space (spaces manager)))
	     (setf (receivers manager) (remove receiver (receivers manager)))
	     (kill space)))))
;(setf excl:*restart-init-function* #'ensure-os)
   








