;;;-*- Mode: Lisp; Package: COMMON-LISP-USER -*-
;*********************************************************************
;*                                                                   *
;*        OpenGL for MCL loader                                      *
;*                                                                   *
;*********************************************************************
   ;* Author    : Alexander Repenning (alexander@agentsheets.com)    *
   ;*             http://www.agentsheets.com                         *
   ;* Copyright : (c) 1996-2002, AgentSheets Inc.                    *
   ;* Filename  : Load MacOpenGL.lisp                                *
   ;* Updated   : 11/29/02                                           *
   ;* SW/HW     : PowerPC G4, MCL 5.0                                *
   ;* Abstract  : OpenGL for Apple interface with MCL wrapper        *
   ;* Based on  : low level interfaces based on John Wiseman's       *                                                               *
   ;******************************************************************

(defpackage "MCL-INTERFACE" (:use "CL"))

(defpackage "FF" (:use "CL" "MCL-INTERFACE"))
(defpackage "GL" (:use "CL" "MCL-INTERFACE"))



; this is just a simpler loader. Compile the files load faster

(defun LOAD-RELATIVE (Path)
  (load
   (concatenate 
    'string
    (directory-namestring *Loading-File-Source-File*)
    Path)))
    
;; low level interface
(load "api:OpenGL;OpenGL-API;mcl-interface" :verbose t)
(load "api:OpenGL;OpenGL-API;gl" :verbose t)               ;; this will generate some warnings => OK
(load "api:OpenGL;OpenGL-API;gl1-2" :verbose t)

;; high level interface
(load "api:OpenGL;OpenGL-MCL;AGL" :verbose t)
(load "api:OpenGL;OpenGL-MCL;Texture-and-Image-Import" :verbose t)
(load "api:OpenGL;OpenGL-MCL;Camera" :verbose t)
(load "api:OpenGL;OpenGL-MCL;OpenGLforMCL" :verbose t)
(load "api:OpenGL;OpenGL-MCL;GameEngine" :verbose t)

#|
;; low level interface
(ccl::compile&load "api:OpenGL;OpenGL-API;mcl-interface")
(ccl::compile&load "api:OpenGL;OpenGL-API;gl")               ;; this will generate some warnings => OK
(ccl::compile&load "api:OpenGL;OpenGL-API;gl1-2")

;; high level interface
(ccl::compile&load "api:OpenGL;OpenGL-MCL;AGL")
(ccl::compile&load "api:OpenGL;OpenGL-MCL;Texture-and-Image-Import")
(ccl::compile&load "api:OpenGL;OpenGL-MCL;Camera")
(ccl::compile&load "api:OpenGL;OpenGL-MCL;OpenGLforMCL")
(ccl::compile&load "api:OpenGL;OpenGL-MCL;GameEngine")
|#


#|
;; low level interface
(load-relative "OpenGL-API:mcl-interface")
(load-relative "OpenGL-API:gl")               ;; this will generate some warnings => OK
(load-relative "OpenGL-API:gl1-2")

;; high level interface
(load-relative "OpenGL-MCL:AGL")
(load-relative "OpenGL-MCL:Texture-and-Image-Import")
(load-relative "OpenGL-MCL:Camera")
(load-relative "OpenGL-MCL:OpenGLforMCL")
(load-relative "OpenGL-MCL:GameEngine")
|#


