;; OpenGL for MCL trap definition 4/14/01
;; Alexander Repenning
;; these functions are missing (they got introduced in OpenGL 1.1)
;; updated: 12/11/2002 texture

(in-package :gl)


(foreign-function glgentextures (INT (POINTER UNSIGNED-INT)) VOID "glGenTextures")
(foreign-function glistexture (UNSIGNED-INT) UNSIGNED-CHAR "glIsTexture")
(foreign-function glbindtexture (INT UNSIGNED-INT) VOID "glBindTexture")


;;;_______________________________________
;;; Vertex Arrays
;;;_______________________________________

(foreign-define GL_VERTEX_ARRAY                   #x8074)
(foreign-define GL_NORMAL_ARRAY                   #x8075)
(foreign-define GL_COLOR_ARRAY                    #x8076)
(foreign-define GL_INDEX_ARRAY                    #x8077)
(foreign-define GL_TEXTURE_COORD_ARRAY            #x8078)
(foreign-define GL_EDGE_FLAG_ARRAY                #x8079)
(foreign-define GL_VERTEX_ARRAY_SIZE              #x807A)
(foreign-define GL_VERTEX_ARRAY_TYPE              #x807B)
(foreign-define GL_VERTEX_ARRAY_STRIDE            #x807C)
(foreign-define GL_NORMAL_ARRAY_TYPE              #x807E)
(foreign-define GL_NORMAL_ARRAY_STRIDE            #x807F)
(foreign-define GL_COLOR_ARRAY_SIZE               #x8081)
(foreign-define GL_COLOR_ARRAY_TYPE               #x8082)
(foreign-define GL_COLOR_ARRAY_STRIDE             #x8083)
(foreign-define GL_INDEX_ARRAY_TYPE               #x8085)
(foreign-define GL_INDEX_ARRAY_STRIDE             #x8086)
(foreign-define GL_TEXTURE_COORD_ARRAY_SIZE       #x8088)
(foreign-define GL_TEXTURE_COORD_ARRAY_TYPE       #x8089)
(foreign-define GL_TEXTURE_COORD_ARRAY_STRIDE     #x808A)
(foreign-define GL_EDGE_FLAG_ARRAY_STRIDE         #x808C)
(foreign-define GL_VERTEX_ARRAY_POINTER           #x808E)
(foreign-define GL_NORMAL_ARRAY_POINTER           #x808F)
(foreign-define GL_COLOR_ARRAY_POINTER            #x8090)
(foreign-define GL_INDEX_ARRAY_POINTER            #x8091)
(foreign-define GL_TEXTURE_COORD_ARRAY_POINTER    #x8092)
(foreign-define GL_EDGE_FLAG_ARRAY_POINTER        #x8093)
(foreign-define GL_V2F                            #x2A20)
(foreign-define GL_V3F                            #x2A21)
(foreign-define GL_C4UB_V2F                       #x2A22)
(foreign-define GL_C4UB_V3F                       #x2A23)
(foreign-define GL_C3F_V3F                        #x2A24)
(foreign-define GL_N3F_V3F                        #x2A25)
(foreign-define GL_C4F_N3F_V3F                    #x2A26)
(foreign-define GL_T2F_V3F                        #x2A27)
(foreign-define GL_T4F_V4F                        #x2A28)
(foreign-define GL_T2F_C4UB_V3F                   #x2A29)
(foreign-define GL_T2F_C3F_V3F                    #x2A2A)
(foreign-define GL_T2F_N3F_V3F                    #x2A2B)
(foreign-define GL_T2F_C4F_N3F_V3F                #x2A2C)
(foreign-define GL_T4F_C4F_N3F_V4F                #x2A2D)


(foreign-function glEnableClientState (INT) VOID "glEnableClientState")
(foreign-function glDisableClientState (INT) VOID "glDisableClientState")

(foreign-function glVertexPointer (INT INT INT (POINTER FLOAT)) VOID "glVertexPointer")
(foreign-function glColorPointer (INT INT INT (POINTER FLOAT)) VOID "glColorPointer")
(foreign-function glEdgeFlagPointer (INT (POINTER FLOAT)) VOID "glEdgeFlagPointer")
(foreign-function glNormalPointer (INT INT (POINTER FLOAT)) VOID "glNormalPointer")
(foreign-function glIndexPointer (INT INT (POINTER FLOAT)) VOID "glIndexPointer")
(foreign-function glTexCoordPointer (INT INT INT (POINTER FLOAT)) VOID "glTexCoordPointer")


;; drawing


(foreign-function glArrayElement (INT) VOID "glArrayElement")
(foreign-function glDrawElements (INT INT INT (POINTER INT)) VOID "glDrawElements")
(foreign-function glDrawRangeElements (INT INT INT INT INT (POINTER INT)) VOID "glDrawRangeElements")
(foreign-function glDrawArrays (INT INT INT) VOID "glDrawArrays")

;; Tesselation


(foreign-function gluTessBeginPolygon ((POINTER (STRUCT "GLUtriangulatorObj") (POINTER UNSIGNED-CHAR))) VOID "gluTessBeginPolygon")
(foreign-function gluTessEndPolygon ((POINTER (STRUCT "GLUtriangulatorObj"))) VOID "gluTessEndPolygon")
(foreign-function gluTessBeginContour ((POINTER (STRUCT "GLUtriangulatorObj"))) VOID "gluTessBeginContour")
(foreign-function gluTessEndContour ((POINTER (STRUCT "GLUtriangulatorObj"))) VOID "gluTessEndContour")

;______________________
; Textures             |
;______________________/

(foreign-define GL_TEXTURE_PRIORITY               #x8066)

(foreign-function glDeleteTextures (INT (POINTER INT)) VOID "glDeleteTextures")


#| Experiments:

(ff:defun-c-callable bla ((pointer int)) (+ 4 5))
  => bla = pointer 16

(ccl:defccallable bli (:ptr ii :void) (+ 3 4))
  => bli = pointer 32


(PROGN (CCL:DEFTRAP-INLINE
         (GLGENTEXTURES "glGenTextures")
         ((ARG1 :LONG) (ARG2 :POINTER))
         NIL
         'NIL)
       (DEFUN GLGENTEXTURES (ARG1 ARG2)
         (CCL:REQUIRE-TRAP TRAPS::GLGENTEXTURES ARG1 ARG2))
       (EXPORT 'GLGENTEXTURES))


(PROGN (CCL:DEFTRAP-INLINE
         (GLBINDTEXTURE "glBindTexture")
         ((ARG1 :LONG) (ARG2 :UNSIGNED-LONG))
         NIL
         'NIL)
       (DEFUN GLBINDTEXTURE (ARG1 ARG2) (CCL:REQUIRE-TRAP TRAPS::GLBINDTEXTURE ARG1 ARG2))
       (EXPORT 'GLBINDTEXTURE))


(ccl:define-entry-point "glGenTextures" ((ARG1 :LONG) (ARG2 :POINTER)) nil)

(ccl:define-entry-point "glBindTexture" ((GL::ARG1 :LONG) (GL::ARG2 :UNSIGNED-LONG)) nil)

|#

