;;===========================================================================
;OM API 
;Multiplatform API for OpenMusic
;Copyright (C) 2004 IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Jean Bresson and Augusto Agon
;;===========================================================================

;;===========================================================================
;DocFile
;This file define the *api-files* global variable, which contains a list
;with the OM-API file's pathnames.
;;===========================================================================

(in-package :oa)
 
(defvar *api-files* nil)

(defvar *api-directory* nil)
(setf *api-directory* (pathname-directory (truename *load-pathname*)))

(setf *api-files* '(
                    "om-api"
                    "mop"
                    "system"
                    "listener"
                    "tools"
                    "graphics"
                    "movable-object"
                    "windows"
                    "actions"
                    "dialog-items"
                    "icons-picts"
                    "menu"
                    "texteditor"
                    "user-interface"
                    "draganddrop"
                    "tooltips"
                    "libraries"                 
                    "om-special"  
                    
                    ))

(mapc #'(lambda (filename) (compile&load (make-pathname :directory *api-directory* :name filename))) *api-files*)






