;;===========================================================================
;OM API 
;Multiplatform API for OpenMusic
;Macintosh version (Digitool Macintosh Common Lisp - MCL)
;
;Copyright (C) 2004 IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Jean Bresson and Augusto Agon
;;===========================================================================

;;===========================================================================
;DocFile
; METAOBJECT PROGRAMMING UTILITIES 
;;===========================================================================


(in-package :om-api)
;;;=========================
;;; export :
;;;=========================
(export '(
          class-instance-slots
          class-class-slots
          class-direct-instance-slots
          class-direct-class-slots
          get-class-default-initargs
          ;;;save-initargs
          get-class-precedence-list
          function-spec-p
          function-name
          method-name
          arglist
          om-remove-method-definition
          ;copy-instance
          eql-specializer?
          eql-specializer-object
          ) :om-api)
;;;=========================

#|

(setf themet (defmethod met ((self integer)) 3))

(clos::method-visible-names themet)

(defclass sup () 
  ((uno :initform 1 :accessor uno :initarg :uno )
   (dos :initform 2 :accessor dos :initarg :dos :allocation :class)))

(defclass theclass (sup) 
  ((tres :initform 3 :accessor tres :initarg :tres )
   (cua :initform 4 :accessor cua :initarg :cua :allocation :class)))


(hcl::class-slots (find-class 'theclass))


(class-instance-slots (find-class 'theclass))

(class-class-slots (find-class 'theclass))

(class-direct-instance-slots (find-class 'theclass))

(class-direct-class-slots (find-class 'theclass))

(get-class-default-initargs (find-class 'theclass))

(get-class-precedence-list (find-class 'theclass))
|#




(defun method-name (method)
  (clos::generic-function-name (clos::method-generic-function method)))

;(method-name (defmethod sss ((self integer)) self))

(defun class-slot? (slot)
  (equal :CLASS (clos::slot-definition-allocation slot)))

(defmethod class-instance-slots ((class t))
  (loop for item in (hcl::class-slots class)
        when (not  (class-slot? item)) collect item))


(defmethod class-class-slots ((class t))
  (loop for item in (hcl::class-slots class)
        when (class-slot? item) collect item))

(defmethod class-direct-instance-slots ((class t))
  (loop for item in (hcl::class-direct-slots class)
        when (not  (class-slot? item)) collect item))


(defmethod class-direct-class-slots ((class t))
  (loop for item in (hcl::class-direct-slots class)
        when (class-slot? item) collect item))

     
(defun OM-REMOVE-METHOD-DEFINITION (method)
  (remove-method (fdefinition (method-name method)) method))

    
(defun get-class-default-initargs (class)
  (hcl::class-default-initargs class))



(defun get-class-precedence-list (class)
   (hcl::class-precedence-list class))

(defun function-spec-p (spec)
  t
)


(defun eql-specializer? (method-specializer)
  (consp method-specializer))

(defun arglist (fun)
  (function-lambda-list fun))

(defun function-name (fun)
  (if (symbolp fun) (setf fun (fdefinition fun)))
  (if (clos::generic-function-p fun)
      (hcl::generic-function-name fun)
    (system::function-name fun)))







