;;;OpenMusic
;;;
;;;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
;;; 
;;;This program is free software; you can redistribute it and/or
;;;modify it under the terms of the GNU General Public License
;;;as published by the Free Software Foundation; either version 2
;;;of the License, or (at your option) any later version.
;;;
;;;See file LICENSE for further informations on licensing terms.
;;;
;;;This program is distributed in the hope that it will be useful,
;;;but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;GNU General Public License for more details.
;;;
;;;You should have received a copy of the GNU General Public License
;;;along with this program; if not, write to the Free Software
;;;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;;;
;;;Authors: Gerard Assayag and Augusto Agon
;;;
;;;
;;;DocFile
;;;This File contains all dynamic dialogs used in OM.
;;;Last Modifications :
;;;18/10/97 first date.
;;;DocFile
;;;

(in-package :om)


(defun get-funname-dialog ()
  "Get the name, icon and doc for a new Generic function"
  (let ((dialog (om-make-window 'om-dialog
                                :position :centered
                                :window-title "New Generic Function"
                                :size (om-make-point 290 190)
                                :font *om-default-font1*
                                ;:bg-color (om-make-color 0.875 0.875 0.875)
                                :maximize nil :minimize nil :resizable nil :close nil
                                ))
        (scroller (om-make-dialog-item 'om-text-edit-view
                                       (om-make-point 128 40) (om-make-point 154 87) ""
                                       :scrollbars :v 
                                       ))
        (name (om-make-dialog-item 'om-editable-text 
                                   (om-make-point 131 9) (om-make-point 147 19) 
                                   "MyFunction"
                                   ))
        (icon 150))
    (om-set-font scroller *om-default-font1*)
    (om-add-subviews dialog scroller name
                     (om-make-view 'button-icon
                                   :iconID icon
                                   :size (om-make-point 24 24)
                                   :position (om-make-point 131 150)
                                   :action  #'(lambda (item) 
                                                (let ((newicon (choise-icon)))
                                                  (when newicon icon 
                                                        (setf icon newicon)
                                                        (setf (iconID item) icon)
                                                        (om-draw-contents item)))))
                     (om-make-dialog-item 'om-static-text (om-make-point 3 9) (om-make-point 100 16) "Function Name"
                                          :bg-color *om-window-def-color*)
                     (om-make-dialog-item 'om-static-text (om-make-point 3 41) (om-make-point 100 18)  "Documentation"
                                          :bg-color *om-window-def-color*)
                     (om-make-dialog-item 'om-static-text (om-make-point 10 149) (om-make-point 56 16)  "Icon"
                                          :bg-color *om-window-def-color*)
                     (om-make-dialog-item 'om-button (om-make-point 191 134) (om-make-point 72 25)  "cancel" 
                                          :di-action (om-dialog-item-act item
                                                       (om-return-from-modal-dialog dialog nil))
                                          :default-button t)
                     (om-make-dialog-item 'om-button (om-make-point 193 164) (om-make-point 68 22)  "OK" 
                                          :di-action (om-dialog-item-act item
                                                       (om-return-from-modal-dialog dialog (list (om-dialog-item-text name)
                                                                                                 (om-dialog-item-text scroller)
                                                                                                 icon)))
                                          ;:default-button t
                                          )
                     )
    (om-modal-dialog dialog)))



(defun get-classname-dialog ()
  "Get the name, icon and doc for a new Class"
  (let ((dialog (om-make-window 'om-dialog
                                                            ;;;  :window-type :double-edge-box
                                                            :position :centered
                                                            :window-title "New Class"
                                                            :size (om-make-point 290 190)
                                                            :font *om-default-font1*
                                                            :maximize nil :minimize nil :resizable nil :close nil
                                                            ))
        (scroller (om-make-dialog-item 'om-text-edit-view
                                       (om-make-point 128 40) (om-make-point 154 87) ""
                                       :scrollbars :v 
                                       ))
        (name (om-make-dialog-item 'om-editable-text 
                                   (om-make-point 131 9) (om-make-point 147 19) 
                                    "MyClass"
                                   ))
        (icon 136))
    (om-add-subviews dialog scroller name
                     (om-make-view 'button-icon
                                   :iconID icon
                                   :size (om-make-point 24 24)
                                   :position (om-make-point 131 150)
                                   :action  #'(lambda (item) 
                                                (let ((newicon (choise-icon)))
                                                  (when newicon icon 
                                                    (setf icon newicon)
                                                    (setf (iconID item) icon)
                                                    (om-draw-contents item)))))
                                        (om-make-dialog-item 'om-static-text (om-make-point 3 9) (om-make-point 100 16)  "Class Name" 
                                                                                  :bg-color *om-window-def-color*)
                                        (om-make-dialog-item 'om-static-text (om-make-point 3 41) (om-make-point 100 18)  "Documentation"
                                                                                  :bg-color *om-window-def-color*)
                                        (om-make-dialog-item 'om-static-text (om-make-point 10 149) (om-make-point 56 16)  "Icon"
                                                                                  :bg-color *om-window-def-color*)
                                        (om-make-dialog-item 'om-button (om-make-point 191 134) (om-make-point 72 25)  "cancel" 
                                                                                  :di-action (om-dialog-item-act item
                                                                                   (om-return-from-modal-dialog dialog nil)))
                                        (om-make-dialog-item 'om-button (om-make-point 193 164) (om-make-point 68 22)  "OK" 
                                                                                  :di-action (om-dialog-item-act item
                                                                                   (om-return-from-modal-dialog dialog (list (om-dialog-item-text name)
                                                                                                                                                                (om-dialog-item-text scroller)
                                                                                                                                                                icon)))
                                                                                  :default-button t))
    (om-modal-dialog dialog)))



;;;=======================
;;;OM PRESENTATION + About
;;;=======================

(defvar *presentation* nil "The about window.")


(omg-defclass dialog-present (om-no-border-win) 
   ((thepict :initform nil :initarg :thepict :accessor thepict))
   (:documentation "The class of the About OM window.#enddoc#
#thepict# This slot contains the *graph-pres* global variable.#thepict#"))

(defun init-kero-pict ()
  (let ((name (string+ "OpenMusic " *version-string*))) 
   (setf *presentation* (om-make-window 'dialog-present
                                        :window-title "About OpenMusic"
                                        :close nil
                                        :minimize nil
                                        :maximize nil
                                        :resizable nil
                                        :window-show nil
                                        :position :centered 
                                        :size (or (om-get-picture-size *graph-pres*) (om-make-point 20 20))
                                        :subviews (list (om-make-dialog-item 'om-static-text  
                                                                             (om-make-point 58 16) (om-make-point 220 30) 
                                                                             name
                                                                             :font (om-make-font "Arial" 24 :style '(:bold))
                                                                             :bg-color (om-make-color 0.9529412 0.9294118 0.803916)
                                                                             :fg-color (om-make-color 0.384 0.302 0.266)
                                                                             ))
                                        :thepict *graph-pres*
                                        )
         )))

; (init-kero-pict)

(om-add-init-func 'init-kero-pict)


(defmethod om-view-click-handler ((self dialog-present) where)
  "When you click in the about window it is hidden"
  (declare (ignore where))
  (om-hide-window self))

(defmethod om-draw-contents ((self dialog-present)) 
  (let ((pictsize (om-get-picture-size (thepict self))))
    (om-draw-picture self (thepict self) (om-make-point 0 0)  pictsize)
    )
  (call-next-method))

 
;;;(defmethod view-activate-event-handler :after ((self dialog-present)) 
;;;   (unless (equal (menubar) *default-menubar*)
;;;     (set-menubar *default-menubar*)))

;;;(defmethod window-close ((self dialog-present))
;;;   "This window is never closed it is only hidden"
;;;   (window-hide self))


;;;=======================
;;; GHFJFGJ
;;;=======================
(defvar *message-win* nil)

(defun init-message-win ()
  (setf *message-win* (om-make-window 'om-windoid :size (om-make-point 200 100) :position :centered  ;:topmost t
                                      :subviews (list (om-make-dialog-item 'om-static-text 
                                                                           (om-make-point 10 40) (om-make-point 200 50)
                                                                           "bla bla..."
                                                                           :font (om-make-font "Arial" 16 :style '(:bold))))
                                      :window-show nil
                                      :window-title ""
                                      :topmost t))
  *message-win*)

(defun show-message-win (message &key size)
  (when (or (om-window-open-p *message-win*) (init-message-win))
    (om-set-dialog-item-text (car (om-subviews *message-win*)) message)
    (when size (om-set-view-size *message-win* size))
    (om-select-window *message-win*)
    (om-redraw-view *message-win*)
    ;;; (om-get-next-event)
    ))

(defun hide-message-win ()
  (when *message-win* 
    (om-close-window *message-win*)))
    

(om-add-init-func 'init-message-win)


;;;=======================
;;;Dialog for init
;;;=======================
(defun transforme-if-alias (name folders names)
  (if (stringp name)
    (let* ((folders-without-alias (om-directory (OMroot "WorkSpaces;") :directories t :files nil))
           (names-without-alias (mapcar #'(lambda (direc) (name-of-directory direc))
                                        folders-without-alias)))
      (if (member name names-without-alias :test 'equal)
        name
        (let ((position (position name names :test 'equal)))
          (if position
            (list (nth position folders))
            name))))
    name))

; (ws-dialog)

(defun ws-dialog ()
  (let* ((userpref (ompref-file))
         (newuser (not (probe-file userpref)))
         (color *om-window-def-color*)
         (font (om-make-font "arial" 12))
         previous
         )
    (when newuser 
      (create-directory (make-pathname :directory (pathname-directory userpref)))
      (create-file userpref)
      (with-open-file (out userpref :direction :output 
                           :if-does-not-exist :create :if-exists :supersede) 
        (write-line (format nil ";~D" *om-version*) out)
        (prin1 '(in-package :om) out)
        (prin1 '(setf *omprefs* nil) out)
        )
      )
    
    (load userpref)
    (setf previous (get-ompref 'prev-ws))
    
    (let ((win (om-make-window 'om-dialog :size (om-make-point 320 256)
                             :resizable nil :maximize nil :minimize nil
                             :window-title "OpenMusic - Projects"
                             :bg-color color
                             ))
          (i 0)
          install prev exist new)
      (setf i (+ i 20))
      (om-add-subviews win
                         (setf install (om-make-dialog-item 'om-radio-button (om-make-point 20 i) (om-make-point 200 20)
                                                            (str-check "Install Ircam Workspaces")
                                                            :checked-p newuser
                                                            :bg-color color
                                                            :font font
                                                            :radio-button-cluster 'proj
                                                            ))
                         (om-make-dialog-item 'om-text-view (om-make-point 40 (+ i 20)) (om-make-point 290 60)
                                              (format nil "The Ircam workspaces contain lots of examples and tutorials.~%It is advised to use this option the first time you launch OpenMusic.")
                                              :bg-color color
                                              :font (om-make-font "arial" 11))
                         )
        (setf i (+ i 80))
        
        (when (and previous (pathnamep previous) (probe-file previous))
          (om-add-subviews win
                           (setf prev (om-make-dialog-item 'om-radio-button (om-make-point 20 i) (om-make-point 200 20)
                                                "Launch previous workspace"
                                                :checked-p (not newuser)
                                                :bg-color color
                                                :font font
                                                :radio-button-cluster 'proj
                                         ))
                           (om-make-dialog-item 'om-text-view (om-make-point 40 (+ i 20)) (om-make-point 290 40)
                                                (namestring previous)
                                                :bg-color color
                                                :font (om-make-font "arial" 11))
                         )
          (setf i (+ i 55))
          )
        
        
        (om-add-subviews win
                           (setf exist (om-make-dialog-item 'om-radio-button (om-make-point 20 i) (om-make-point 200 20)
                                                "Launch a workspace"
                                                :checked-p (and (not previous) (not newuser))
                                                :bg-color color
                                                :font font
                                                :radio-button-cluster 'proj
                                         ))
                           )
        (setf i (+ i 30))
        (om-add-subviews win
                           (setf new (om-make-dialog-item 'om-radio-button (om-make-point 20 i) (om-make-point 200 20)
                                                "Create a new workspace"
                                                :checked-p nil
                                                :bg-color color
                                                :font font
                                                :radio-button-cluster 'proj
                                         ))
                           )
        
        (om-add-subviews win 
                         (om-make-dialog-item 'om-button (om-make-point 220 220) (om-make-point 60 24) "OK"
                                              :default-button t
                                              :di-action (om-dialog-item-act item
                                                           (declare (ignore item))
                                                           (om-return-from-modal-dialog win 
                                                                                        (cond 
                                                                                         ((and install (om-checked-p install)) 'install)
                                                                                         ((and prev (om-checked-p prev)) 'previous)
                                                                                         ((om-checked-p exist) 'existing)
                                                                                         ((om-checked-p new) 'new)
                                                                                         (t nil))))
                                              )
                         (om-make-dialog-item 'om-button (om-make-point 140 220) (om-make-point 60 24) "Quit"
                                              :di-action (om-dialog-item-act item
                                                           (declare (ignore item))
                                                           (om-return-from-modal-dialog win 'quit))))
        
        (om-modal-dialog win)
        )))




(defun choose-user-ws-folder ()
  (let* ((choix (ws-dialog))
        (dir (cond
              ((equal 'new choix)
               (let* ((prev (get-ompref 'prev-ws))
                      (folder (if prev 
                                (make-pathname :device (pathname-device prev) :directory (butlast (pathname-directory prev))) 
                                (om-user-home)))
                      (ws (om-choose-new-directory-dialog :directory folder)))
                 (if (pathnamep ws) ws (choose-user-ws-folder))
                 ))
              ((equal 'existing choix)
               (let* ((prev (get-ompref 'prev-ws))
                      (folder (if prev 
                                (make-pathname :device (pathname-device prev) :directory (butlast (pathname-directory prev))) 
                                (om-user-home)))
                      (ws (om-choose-directory-dialog :directory folder)))
                 (if (pathnamep ws) ws (choose-user-ws-folder))
                 ))
              ((equal 'previous choix)
               (get-ompref 'prev-ws))
              ((equal 'install choix)
               (install-om-workspaces)
               (choose-user-ws-folder))
              ((equal 'quit choix)
               (om-confirmed-quit))
              (t nil))))
    dir))

(defun show-workspaces-dialog ()
    (let ((initws (catch-cancel (choose-user-ws-folder))))
    (if (not (pathnamep initws))
      (show-workspaces-dialog)
      (let* ((list (om-directory initws))
             dirs files)
        (loop for item in list do
              (if (directoryp item) 
                (push (car (last (pathname-directory item))) dirs)
                (push (pathname-name item) files)))
        (if (or (equal nil list) 
                (and (member "resources" dirs :test 'string-equal) (member "elements" dirs :test 'string-equal)))
          ;;; + tests...
          (init-remote/local initws)
          (if (om-y-or-n-dialog (str-check (format nil "Are you sure this is a OM Workspace ?~%(This folder seems to contain other types of documents)"))) 
            (init-remote/local initws)
            (show-workspaces-dialog)
            ))))))

(defun install-om-workspaces ()
  (let ((targetdir (om-choose-directory-dialog :directory (om-user-home)))
        srcdir)
    (when (probe-file targetdir)
      (show-message-win (format nil "Importing default workspaces... ~%Please wait.") :size (om-make-point 200 140)) 
      (loop for item in (om-directory (OMRoot "WorkSpaces")) do
            (when (directoryp item)
              (let ((tg (make-pathname :device (pathname-device targetdir)
                                       :directory (append (pathname-directory targetdir) (last (pathname-directory item))))))
                (if (probe-file tg) 
                  (om-message-dialog (format nil "~D already exists.~%Please remove it or choose another install diorectory." 
                                             (car (last (pathname-directory item)))))
                  (copy-folder item 
                               (make-pathname :device (pathname-device targetdir)
                                              :directory (append (pathname-directory targetdir) (last (pathname-directory item))))
                           )))))
      (om-hide-window *message-win*)
      )))




;;;==============================
;;;This dialog is diaplyed when you cons an image
;;;It allows you to choise the projects (Music, kernel, etc that you want include in your image
;;;

(defun choise-directories (pathlist)
  (when pathlist
    (let* ((names (loop for item in pathlist collect (name-of-directory item)))
           (dialog (om-make-window 'om-dialog
                                   :position :centered
                                   :size (om-make-point 235 (+ 60 (* 20 (length pathlist))))
                                   :close nil :maximize nil :minimize nil :resizable nil
                                   :window-title "Choose your projects"
                                   :bg-color *om-window-def-color*)) rep)
      (loop for item in names
            for i = 0 then (+ i 1) do
            (let ((newdialog (om-make-dialog-item 'om-check-box (om-make-point 5 (+ 10 (* i 20))) (om-make-point 200 20) 
                                                  item
                                                  :font *om-default-font2*
                                                  :checked-p t
                                                  :bg-color *om-window-def-color*
                                                  :enable (not (string-equal item "basicproject")))))
              (push newdialog rep)
              (om-add-subviews dialog newdialog)))
      (setf rep (reverse rep))
      (om-add-subviews dialog
                       (om-make-dialog-item 'om-button (om-make-point 33 (- (om-point-v (om-interior-size dialog)) 35)) (om-make-point 70 20) 
                                            "Cancel"
                                            :di-action (om-dialog-item-act item 
                                                         (declare (ignore item))
                                                         (om-return-from-modal-dialog dialog nil)))
                       (om-make-dialog-item 'om-button (om-make-point 132 (- (om-point-v (om-interior-size dialog)) 35)) (om-make-point 70 20) 
                                            "OK"
                                            :di-action (om-dialog-item-act item 
                                                         (declare (ignore item))
                                                         (om-return-from-modal-dialog dialog
                                                                                      (loop for item in rep
                                                                                            when (om-checked-p item) collect (om-dialog-item-text item))))
                                            :default-button t))
      (om-modal-dialog dialog))))


;;;==============================


;;;==============================
;;; CHOOSE PICTURE DIALOG

(omg-defclass om-preview-pane (om-view) 
   ((pict :accessor pict :initform nil :initarg :pict)))

(defmethod om-draw-contents ((self om-preview-pane))
   (when (pict self)
     (let ((resize-params (resize-to-fit (om-get-picture-size (pict self)) (om-view-size self))))          
       (om-draw-picture self (pict self) 
                        (second resize-params)
                        (first resize-params)))))


;(choose-resource-dialog :pict)

; Returns (symbol-name pict-hdler kernel-or-user) ou nil
(defun choose-resource-dialog (resource-type &key (kernel t) (user t))
  (if (not user) (setf kernel t))
  (let* ((twoorone (if (and user kernel) 2 1))
         (thedialog (om-make-window 'om-dialog  
                                    :window-title (string+ "Select " (if (equal resource-type :ICON) "an icon" "a picture")) 
                                    :position :centered
                                    :size (om-make-point (+ 220 (* 120 twoorone)) 200) 
                                    :close t :resizable nil :maximize nil :minimize nil
                                    :bg-color *om-window-def-color*))
         (preview (om-make-view 'om-preview-pane :position (om-make-point 10 10) :size (om-make-point 148 148) :bg-color *om-white-color*))
         (listkernel nil) (listuser nil) scrolluser scrollkernel usertxt kerneltxt
         (tmp-pict nil) (resfolder nil) (name nil))
    (when kernel
      (setf listkernel (loop for file in (om-directory  
                                          (OMRoot (string+ "resources;" (if (equal resource-type :ICON) "icon;" "pict;"))) 
                                          :type (if (equal resource-type :ICON) *om-icon-type* *om-pict-type*))
                             when (om-pict-p file)
                             collect (om-namestring (pathname-name file))))
      (setf scrollkernel (om-make-dialog-item 'om-single-item-list 
                                              (om-make-point 180 30) 
                                              (om-make-point 120 128) 
                                              "Kernel Resources"                                  
                                              :di-action 
                                              (om-dialog-item-act item
                                                (if (om-get-selected-item item)
                                                    (setf name (intern (om-get-selected-item item))
                                                          resfolder 'kernel
                                                          tmp-pict (om-load-pixmap (om-get-selected-item item) (if (equal resource-type :ICON) *om-icon-type* *om-pict-type*)
                                                                                   (OMRoot (string+ "resources;" (if (equal resource-type :ICON) "icon;" "pict;")))))
                                                  (setf name nil resfolder nil tmp-pict nil))
                                                
                                                (setf (pict preview) tmp-pict)
                                                (om-invalidate-view preview t)
                                                (om-invalidate-view item t)
                                                (when user (om-invalidate-view scrolluser t))
                                                )
                                              :range listkernel 
                                              :container thedialog
                                              ))
      (setf kerneltxt (om-make-dialog-item 'om-static-text 
                                           (om-make-point 180 10) 
                                           (om-make-point 120 16) 
                                           "OM Resources"                                  
                                           :container thedialog :bg-color *om-window-def-color*))
      )
    (when user
      (setf listuser (loop for file in  (om-directory  
                                         (make-pathname :directory (append (pathname-directory (mypathname *current-workspace*)) 
                                                                           (list "resources" (if (equal resource-type :ICON) "icon" "pict")))) 
                                         :type (if (equal resource-type :ICON) *om-icon-type* *om-pict-type*))
                           when (om-pict-p file)
                           collect (om-namestring (pathname-name file))))
      (setf scrolluser (om-make-dialog-item 'om-single-item-list 
                                            (om-make-point (if kernel 320 180) 30) 
                                            (om-make-point 120 110) 
                                            "User Resources"                                  
                                            :di-action (om-dialog-item-act item
                                                         (if (om-get-selected-item item)
                                                             (setf name (intern (om-get-selected-item item))
                                                                   resfolder 'user
                                                                   tmp-pict (om-load-pixmap (om-get-selected-item item) (if (equal resource-type :ICON) *om-icon-type* *om-pict-type*)
                                                                                            (make-pathname :directory (append (pathname-directory (mypathname *current-workspace*)) 
                                                                                                                              (list "resources" (if (equal resource-type :ICON) "icon" "pict")))))
                                                                   )
                                                           (setf name nil resfolder nil tmp-pict nil))
                                                         
                                                         (setf (pict preview) tmp-pict)
                                                         (om-invalidate-view preview t)
                                                         (om-invalidate-view item t)
                                                         (when kernel 
                                                           (om-invalidate-view scrollkernel t)))
                                            :range listuser
                                            :container thedialog
                                            ))
      (setf usertxt (om-make-dialog-item 'om-static-text 
                                         (om-make-point (if kernel 320 180) 10) 
                                         (om-make-point 120 16) 
                                         "Your Resources"                                  
                                         :container thedialog :bg-color *om-window-def-color*))
      (om-add-subviews thedialog 
                       (om-make-dialog-item 'om-button (om-make-point (if kernel 320 180) 146) (om-make-point 60 24)  "New..." 
                                            :di-action (om-dialog-item-act item
                                                         (let ((newfile (om-choose-file-dialog :prompt "New BMP file")))
                                                           (when newfile
                                                             (if (string-equal (if (equal resource-type :ICON) *om-icon-type* *om-pict-type*) (pathname-type newfile))
                                                                 (let* ((resdir (make-pathname :directory (append (pathname-directory (mypathname *current-workspace*)) 
                                                                                                                  (list "resources" (if (equal resource-type :ICON) "icon" "pict")))))
                                                                        (newname (pathname-name (unique-pathname resdir (pathname-name newfile)))))
                                                                   (om-copy-file newfile (make-pathname :directory (pathname-directory resdir)
                                                                                                        :name newname
                                                                                                        :type (pathname-type newfile)
                                                                                                        ))
                                                                   (setf listuser (append (list newname) listuser))
                                                                   (om-set-item-list scrolluser listuser)
                                                                   (om-select-item-index scrolluser (length listuser))
                                                                   (setf name (intern newname)
                                                                         resfolder 'user
                                                                         tmp-pict (om-load-pixmap newname (if (equal resource-type :ICON) *om-icon-type* *om-pict-type*)
                                                                                                  (make-pathname :directory (append (pathname-directory (mypathname *current-workspace*)) 
                                                                                                                                    (list "resources" (if (equal resource-type :ICON) "icon" "pict")))))
                                                                         )
                                                                   (setf (pict preview) tmp-pict)
                                                                   (om-invalidate-view preview t)
                                                                   (om-invalidate-view scrolluser t)
                                                                   )
                                                               (om-message-dialog "You must choose a .BMP file")))))
                                            )
                       (om-make-dialog-item 'om-button (om-make-point (if kernel 378 238) 146) (om-make-point 70 24)  "Delete" 
                                            :di-action (om-dialog-item-act item
                                                         (when (om-get-selected-item scrolluser)
                                                           (let* ((file (make-pathname :directory (append (pathname-directory (mypathname *current-workspace*)) 
                                                                                                          (list "resources" (if (equal resource-type :ICON) "icon" "pict")))
                                                                                       :name (om-get-selected-item scrolluser)
                                                                                       :type (if (equal resource-type :ICON) *om-icon-type* *om-pict-type*))
                                                                        ))
                                                             (delete-file file)
                                                             (setf listuser (remove (om-get-selected-item scrolluser) listuser))
                                                             (om-set-item-list scrolluser listuser)
                                                             (setf name nil resfolder nil tmp-pict nil (pict preview) nil)
                                                             (om-invalidate-view preview t)
                                                             )))
                                            )
                       )
      )
    
    (om-add-subviews thedialog
                     preview
                     (om-make-dialog-item 'om-button (om-make-point 10 170) (om-make-point 68 24)  "Cancel" 
                                          :di-action (om-dialog-item-act item
                                                       (om-return-from-modal-dialog thedialog nil))
                                          )
                     (om-make-dialog-item 'om-button (om-make-point 90 170) (om-make-point 68 24)  "OK" 
                                          :di-action (om-dialog-item-act item
                                                       (om-return-from-modal-dialog thedialog (list name tmp-pict resfolder))
                                                       ))
                     )
    (om-modal-dialog thedialog)))

;(choose-resource-dialog :pict)

;===========================================
;help windows
;===========================================

(omg-defclass help-item-view (om-view) 
  ((pict :accessor pict :initarg :pict :initform nil)
   (text :accessor text :initarg :text :initform nil)))

(defmethod initialize-instance :after ((self help-item-view) &rest initargs)
  (let ((textl 90))
  (if (stringp (pict self))
    (progn
      (om-add-subviews self (om-make-dialog-item 'om-static-text 
                                                 (om-make-point 0 2) (om-make-point 80 20) (pict self)
                                                 :font *om-default-font3b* :bg-color *om-beige-color*))
      (setf (pict self) nil))
    (progn
      (setf (pict self) (om-load-and-store-picture (pict self) 'full 
                                                   (make-pathname :device (pathname-device *om-pict-folder*)
                                                                  :directory (append (pathname-directory *om-pict-folder*) (list "help")))))
      (loop while (> (om-point-h (om-get-picture-size (pict self))) textl) do (setf textl (+ textl 20)))
      )
    )
  (om-add-subviews self (om-make-dialog-item 'om-static-text 
                                             (om-make-point textl 6) (om-make-point 200 20) (text self)
                                             :font *om-default-font2* :bg-color *om-beige-color*))
  ))



(defmethod om-draw-contents ((self help-item-view))
  (when (pict self) 
    (om-draw-picture self (pict self) (om-make-point 0 0) (om-make-point (om-point-h (om-get-picture-size (pict self))) (om-point-v (om-view-size self)))) 
    ))
  
;(show-help-window "Patch Help" (list *patchhelplist* *patchhelplist2*))

(defvar *help-window* nil)

(defun show-help-window (title helplist)
  "Show the help window for a patch"
  (when *help-window* (om-close-window *help-window*))
  (let* ((maxl (loop for l in helplist maximize (length l))))
    (setf *help-window* (om-make-window 'om-window :window-title title 
                                        :size (om-make-point (+ 4 (* 304 (length helplist))) (+ 12 (* 30 maxl)))
                                        :resizable nil :maximize nil :minimize nil
                                        :bg-color *om-white-color*))
    (loop for h in helplist for i = 0 then (+ i 1) do
          (let ((v (om-make-view 'om-view :size (om-make-point 300 (+ 4 (* 30 maxl))) 
                                 :position (om-make-point (+ (* i 304) 4) 4)
                                 :bg-color *om-beige-color*)))
            (om-add-subviews *help-window* v)
            (loop for elt in h for j = 0 then (+ j 1) do 
                  (om-add-subviews v (om-make-view 'help-item-view 
                                                   :size (om-make-point 292 26) 
                                                   :position (om-make-point 4 (+ 4 (* j 30)))
                                                   :pict (car elt) :text (cadr elt)
                                                   :bg-color *om-beige-color*
                                                   )))))
    ))