;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon


;DocFile
;This file contains the abstract classes for the system definition.
;Last Modifications :
;18/10/97 first date.
;DocFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(in-package :om)

(defvar *genfun-att-list* '(name icon documentation numouts inputs-default 
                            inputs-doc inputs-menus ))

;Used to cons the pop-up-menu for special inputs

(defmethod get-menu-list ((self t)) self)
(defmethod get-menu-list ((self symbol)) (eval self))


(defun get-menu-input (indice list)
   (let (rep)
     (loop for item in list
           while (not rep) do
           (when (= (car item) indice)
             (setf rep item)))
     rep))




(defun parse-defgeneric* (args)
   (let* (icon numouts initvals doc menuins indoc)
     (loop for theargs in args do
           (cond
            ((equal (car theargs) :numouts)  (setf numouts  (second theargs)))
            ((equal (car theargs) :initvals)  (setf initvals (second theargs)))
            ((equal (car theargs) :indoc)     (setf indoc (second theargs)))
            ((equal (car theargs) :doc)       (setf doc (second theargs)))
            ((equal (car theargs) :documentation) (setf doc (second theargs)))
            ((equal (car theargs) :icon)      (setf icon (second theargs)))
            ((equal (car theargs) :menuins)   (setf menuins (second theargs)))))
     (unless numouts (setf numouts 1))
     (unless doc (setf doc "no documentation for this function"))
     (unless icon    (setf icon 150))   ;an icon by default
     (values numouts initvals icon indoc doc menuins)))

(defun remove-om-options (list)
  (loop for item in list
        when (not (or (member (string (car item)) *genfun-att-list* 
                              :test 'string-equal :key 'string) 
                      (equal (car item) :doc)
                      (equal (car item) :generic-function-class)
                      (equal (car item) :method-class))) collect item))


(defmacro defgeneric* (function-name lambda-list &rest options-and-methods &environment env)
   (multiple-value-bind (numouts initvals icon indoc doc menuins)
                        (parse-defgeneric* options-and-methods)
     (unless initvals
         (setf initvals `',(make-list (length lambda-list) :initial-element nil)))
       (unless indoc
         (setf indoc `',(make-list (length lambda-list) :initial-element "no documentation")))
     `(let* ((gen-fun (defgeneric ,function-name ,lambda-list  
                               (:documentation ,doc) 
                               (:generic-function-class ,*def-metaclass-genfun*)
                               (:method-class ,*def-metaclass-method*)
                               ,.(remove-om-options options-and-methods))))
               (setf (numouts gen-fun) ,numouts)
               (setf (inputs-default gen-fun) ,initvals)
               (setf (inputs-doc gen-fun) ,indoc)
               (setf (inputs-menus gen-fun) ',menuins)
               (setf (icon gen-fun) ,icon)
               (setf (name gen-fun) ,(string function-name))
        gen-fun)))
