;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon


;DocFile
;This file defines the class OMLispFun  used to handle lisp functions in OM.
;Last Modifications :
;18/10/97 first date.
;DocFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(in-package :om)

#|
(defclass OMLispFun (OMBasicObject) 
   ((funname :initform nil :initarg :funname :accessor funname))
   (:documentation "This class implements the lisp functions.#enddoc#
#seealso# (OMBoxlispCall) #seealso#
#funname# The symbol name of the function.#funname#"))
|#

(defun omNG-make-new-lispfun (name)
  "this function allox construct an OMLispFun instance from a symbol function name"
  (make-instance 'OMLispFun :name (string name) :funname name :icon 144))

(defmethod get-object-insp-name ((self OMLispFun)) "Lisp Function")

(defmethod get-elements ((self OMLispFun))
   "Lisp function don't have elements" nil)

(defmethod get-class-icon ((self OMLispFun)) 'lispfun-icon-frame)

(defmethod OpenEditorframe ((self OMLispFun))
   "You can not visualize lisp funtions"
   (not (dialog-message "Compiled Lisp Function")))

(defmethod get-documentation ((self OMLispFun))
   (documentation (funname self) 'function))


