;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon


;DocFile
;This file defines classes for dialog-item used to show and edit values.
;Last Modifications :
;18/10/97 first date.
;DocFile

(in-package :om)


;==============
;   TTYBOX 
;==============
;used to show and edit values i. e. inputs default values, etc.

(omg-defclass ttybox (om-static-text-drag) 
   ((open-state :initform t  :initarg :open-state :accessor open-state)
    ))

(defmethod om-view-drag-hilite-p ((self om-static-text-drag)) t)

(defmethod om-component-border ((self ttybox)) nil)  ;;; :line)

;------------EVENTS

  ;;;(defmethod om-view-click-handler ((self ttybox) where)
;;;   (declare (ignore where))
;;;   (cond
;;;    ((om-command-key-p) (om-set-help (not (help-on?))))
;;;    (t (toggle-icon-active-mode (om-view-container self)))))
(defmethod om-view-click-handler ((self ttybox) where)
   (declare (ignore where))
   (toggle-icon-active-mode (om-view-container self)))

;;;(defmethod om-view-doubleclick-handler ((self ttybox) where)
;;;   (declare (ignore where))
;;;   (cond
;;;    ((om-command-key-p) (om-set-help (not (help-on?))))
;;;    (t (open-ttybox self))
;;;    ))
(defmethod om-view-doubleclick-handler ((self ttybox) where)
   (declare (ignore where))
   (open-ttybox self))
    

(defmethod set-value ((self ttybox) value)
   (om-set-dialog-item-text self (format () "~S" value))
   (setf (value (object (om-view-container self))) value))


;------------EDITION
(defmethod open-ttybox-class ((self ttybox)) 'change-text-enter-view)

(defmethod initial-text-ttybox ((self ttybox))
   (cond
    ((equal (class-name (class-of (object (om-view-container self)))) 'OMBoxTypeCall)
     (thestring (object (om-view-container self))))
    (t (format () "~S" (value (object (om-view-container self)))))))

(defmethod text-enter-multiline-p ((self t)) t)

;;;(text-view container) sur le panel
(defmethod open-ttybox ((self ttybox))
   (let* ((thetext (initial-text-ttybox self))
          (panel (om-view-container (om-view-container self)))
          (container (editor panel)))
     (when (text-view container)
       (om-remove-subviews panel (text-view container))
         (setf (text-view container) nil))
     (setf (text-view container) 
       (om-make-dialog-item (open-ttybox-class self)
                            (om-get-text-edit-pos (om-add-points 
                                                   (om-view-position (om-view-container self))
                                                   (om-view-position self)))
                            (om-make-point (om-point-h (om-get-text-edit-size (om-view-size self)))
                                           (max 32 (om-point-v (om-get-text-edit-size (om-view-size self)))))
                            thetext
                             
                            :allow-returns (text-enter-multiline-p self)
                            :focus t
                            :object self
                            :container panel
                            :font *om-default-font1*))
     ))


(omg-defclass change-text-enter-view (edit-text-enter-view) ())


(defmethod om-dialog-item-action ((self change-text-enter-view))
 (exit-from-dialog self (om-dialog-item-text self)))
     

;;;remove text-view from panel
(defmethod exit-from-dialog ((self change-text-enter-view) newtext)
   (handler-bind ((error #'(lambda (c) (declare (ignore c)) 
                            (setf (text-view (editor (om-view-container self))) nil)
                            (om-remove-subviews (panel (editor (om-view-container self))) self)
                            (om-beep)
                                               (om-abort))))
     (let ((*package* (find-package :om))
           (newval (read-from-string newtext)))
       (setf *provisoire-flag* nil)
       (om-set-dialog-item-text (object self) newtext)
       (setf (value (object (om-view-container (object self))))  newval)
       (setf (thestring (object (om-view-container (object self))))  newtext)
       (setf (text-view (editor (om-view-container self))) nil)
       (om-remove-subviews (panel (editor (om-view-container self))) self))))

;----------D&D
(defmethod get-drag-object ((self ttybox)) (om-view-container self))

(defmethod get-pos-in-object ((self ttybox) where)
  (om-add-points (om-view-position self) where))


;================
;  UNDEF-TTYBOX
;================
;a text box for an undefined function

(omg-defclass undef-ttybox (ttybox) ())

;select
(defmethod (setf selected-p) (selected-p (self undef-ttybox))
   (if selected-p
     (progn
       (om-set-part-color self :body *undefbox-color*)
       (om-set-part-color self :text *om-white-color*))
     (progn
       (om-set-part-color self :t\ext *om-black-color*)
        (om-set-part-color self :body *undefbox-color*)))
   ;;;(om-invalidate-view self)
   )


;-----------EDITION

(omg-defclass new-fun-enter-view (edit-text-enter-view) ())   

(defmethod open-ttybox-class ((self undef-ttybox)) 'new-fun-enter-view)
(defmethod initial-text-ttybox ((self undef-ttybox)) "undefined")
(defmethod text-enter-multiline-p ((self undef-ttybox)) nil)

;;;self on panel
(defvar *spec-new-boxes-types* nil)
(defmethod get-new-box-from-type ((type t) position container) nil)

(defmethod exit-from-dialog ((self new-fun-enter-view) newtext)
  (handler-bind ((error #'(lambda (c) (declare (ignore c)) 
                            (setf (text-view (editor (om-view-container self))) nil)
                            (om-remove-subviews (panel (editor (om-view-container self))) self)
                            (om-beep)
                            (om-abort))))
    (let* ((*package* (find-package :om))
           (funname (read-from-string newtext))
           (box (om-view-container (object self)))
           (scroller (om-view-container box))
           (theeditor (editor (om-view-container box)))
           newbox)
      (cond
       ((or (listp funname) (numberp funname) (stringp funname))
        (setf newbox (omNG-make-new-boxcall (get-basic-type 'list) (om-view-position box) (mk-unique-name scroller "list")))
        (setf (value newbox) funname)
        (setf (thestring newbox) newtext)
        (setf (frame-size newbox) (om-make-point (get-name-size newtext) 24)))
       ((special-form-p funname)
        (om-beep-msg  (string+ "Special Lisp form " newtext)))
       
       ((equal funname 'patch)
        (setf newbox (omNG-make-new-boxcall 
                      (make-instance 'OMPatchAbs 
                        :name "mypatch" :icon 210) (om-view-position box) 
                      (mk-unique-name scroller "mypatch"))))
       ((member funname *spec-new-boxes-types*)
        (setf newbox (get-new-box-from-type funname (om-view-position box) scroller))
        )
       ((equal funname 'maquette)
        (setf newbox (omNG-make-new-boxcall 
                      (make-instance 'OMMaqAbs 
                        :name "mymaquette" :icon 265) (om-view-position box) 
                      (mk-unique-name scroller "mymaquette") )))
       ((equal funname 'comment)
        (setf newbox (omNG-make-new-boxcall funname (om-view-position box)  "comment" )))
       ((and (find-class funname nil) (not (equal funname 'list)) (omclass-p (class-of (find-class funname nil))))
        (if (om-shift-key-p)
            (setf newbox  (omNG-make-new-boxcall-slots (find-class funname nil) (om-view-position box) (mk-unique-name scroller "slots")))
          (setf newbox (omNG-make-new-boxcall (find-class funname) (om-view-position box) 
                                              (mk-unique-name scroller (string funname))))))
       ((not  (fboundp funname))
        (om-beep-msg  (string+ "no such function " newtext)))
       ((OMGenfun-p (fdefinition funname))
        (setf newbox (omNG-make-new-boxcall (fdefinition funname) (om-view-position box) 
                                            (mk-unique-name scroller (string funname)))))
       
       (t (setf newbox (omNG-make-new-lispboxcall funname (om-view-position box) 
                                                  (mk-unique-name scroller (string funname))))))
      (when newbox
        (omG-remove-element scroller box)
        (omG-add-element scroller (make-frame-from-callobj newbox))
        )
      (setf (text-view theeditor) nil)
      (om-remove-subviews (panel theeditor) self))))


;==================
; INITFORM-TTYBOX
;==================
;Initform for slots


(omg-defclass initform-ttybox (ttybox OMSimpleFrame) ())

;------------Events
;;;(defmethod om-view-click-handler ((self initform-ttybox) where)
;;;   (declare (ignore where))
;;;   (cond
;;;    ((om-command-key-p) (om-set-help (not (help-on?))))
;;;    ))
(defmethod om-view-click-handler ((self initform-ttybox) where)
   (declare (ignore where)))


;;;(defmethod om-view-doubleclick-handler ((self initform-ttybox) where)
;;;   (declare (ignore where))
;;;   (cond
;;;    ((om-command-key-p) (om-set-help (not (help-on?))))
;;;    (t (open-ttybox self))))
(defmethod om-view-doubleclick-handler ((self initform-ttybox) where)
   (declare (ignore where))
   (open-ttybox self))

(defmethod (setf selected-p) (selected-p (self initform-ttybox))
  (declare (ignore selected-p)) nil)


;------------Edition
;; new : text-view container = panel
(defmethod open-ttybox ((self initform-ttybox))
   (let ((container (editor (om-view-container self))))
     (if (protected-p (object container))
       (om-beep-msg "protected object")
       (progn
         (when (text-view container)
           (om-remove-subviews (panel container) (text-view container))
           (setf (text-view container) nil))
          (setf (text-view container) (om-make-dialog-item 'new-slot-initform-view
                                                           ;(pos-panel2editor (om-view-container self) 
                                                           (om-view-position self)
                                                           (om-view-size self)
                                                           (om-dialog-item-text self)
                                                           :allow-returns nil
                                                           :object self
                                                           :container (panel container)
                                                           :font *om-default-font1*))))))

(omg-defclass new-slot-initform-view (edit-text-enter-view) ())

;;;new : panel au lieu de editor
(defmethod exit-from-dialog ((self new-slot-initform-view) newtext)
   (handler-bind ((error #'(lambda (c) (declare (ignore c)) 
                            (setf (text-view (editor (om-view-container self))) nil)
                            (om-remove-subviews (panel (editor (om-view-container self))) self)
                            (om-beep)
                            (om-abort))))
     (let ((*package* (find-package :om))
           (slot (object (object (object self)))))
       (if (check-type-p (thetype slot) (read-from-string newtext))
         (let ((newval (read-from-string newtext)))
           (omG-change-initform slot newval)
           (om-set-dialog-item-text (object self) newtext)
           (om-set-view-size (object self) (om-make-point (min (get-name-size newtext) 500) (h (object self)))))
         (om-beep-msg "type mismatch"))
       (setf (text-view (editor (om-view-container self))) nil)
       (om-remove-subviews (panel (editor (om-view-container self))) self))))

;------------D&D
(defmethod om-drag-selection-p ((self initform-ttybox) mouse-position)
  (declare (ignore mouse-position))
  nil)

;;; formerly drag-tracking-enter-view
(defmethod om-drag-enter-view ((self initform-ttybox))
  (om-set-part-color self :body *om-black-color*)
  (om-set-part-color self :text *om-white-color*)
  (om-draw-contents self))

;;; formerly drag-tracking-leave-view
(defmethod om-drag-leave-view ((self initform-ttybox)) 
  (om-set-part-color self :text *om-black-color*)
  (om-set-part-color self :body *om-white-color*)
  (om-draw-contents self))


;==============
; NUMBOX
;==============
;; Box for integers

(omg-defclass numbox (ttybox)
  ((value   :initform 0     :initarg :value   :accessor value)
   (min-val :initform 0     :initarg :min-val :accessor min-val)
   (max-val :initform 30000 :initarg :max-val :accessor max-val)
   (afterfun :initform nil :initarg :afterfun :accessor afterfun)))


(defmethod om-component-border ((self numbox)) :line)

;=========================
;events

(defvar *numbox-last-click* nil)
(defmethod om-view-click-handler  ((self numbox) where)
  (setf *numbox-last-click* (om-make-point (om-point-h where) (* -1 (om-point-v where))))
  (om-init-motion-functions self 'numbox-motion 'numbox-release))


(defmethod numbox-motion ((self numbox) pos)
  (let* ((y (om-point-v pos))
         (x (om-point-h pos))
         (first-v (* -1 y)))
    (when (value self)
     (set-value self  (max (min-val self) (min (max-val self)
                                            (+ (value self)
                                               (* (map-mouse-increment self) (- first-v (om-point-v *numbox-last-click*)))))))
     (setf *numbox-last-click* (om-make-point x first-v))
     (om-redraw-view self)
     (item-action-while-drag self))))


(defmethod numbox-release ((view numbox) pos) 
  (item-action-after-drag view)
  (om-invalidate-view view))



;;; pour eviter l'heritage de ttybox...
(defmethod om-view-doubleclick-handler ((self numbox) where)
   nil)

(defmethod map-mouse-increment ((view numbox))
  (cond ((om-option-key-p) 100) 
        ((om-shift-key-p) 10) 
        ((om-command-key-p) 1000)
        (t 1))) 

(defmethod item-action-after-drag ((self numbox))
  (when (afterfun self)
    (funcall (afterfun self) self)))


(defmethod item-action-while-drag ((self numbox))
   (when (om-dialog-item-action-function self)
       (funcall 'om-dialog-item-action self)
    ))



(defmethod om-drag-selection-p ((self numbox) mouse-position)
  (declare (ignore mouse-position))  nil)

(defmethod set-value ((self numbox) value)
   (om-set-dialog-item-text self (format () " ~S" value))
   (setf (value self) value)
  (om-invalidate-view self t))



;;; NUMBOX STYLE POTENTIOMETRE ======================================================

(omg-defclass graphic-numbox (om-view)
  ((pict :accessor pict :initarg :pict :initform nil)
   (pict-size :accessor pict-size :initarg :pict-size :initform (om-make-point 5 5))
   (nbpict :accessor nbpict :initarg :nbpict :initform 0)
   (pict-part :accessor pict-part :initarg :pict-part :initform 0)
   (value   :initform 0     :initarg :value   :accessor value)
   (min-val :initform 0     :initarg :min-val :accessor min-val)
   (max-val :initform 30000 :initarg :max-val :accessor max-val)
   (di-action :initform nil :initarg :di-action :accessor di-action)
   (afterfun :initform nil :initarg :afterfun :accessor afterfun)))

(defmethod initialize-instance ((self graphic-numbox) &rest initargs)
  (call-next-method)
  (setf (pict-part self) (round (* (- (nbpict self) 1) (/ (- (value self) (min-val self)) (- (max-val self) (min-val self)))))))



(defmethod om-draw-contents ((self graphic-numbox))
  (when (pict self)
    (om-draw-picture-part self (pict self) 
                          (om-make-point 0 (* (pict-part self) (om-point-v (pict-size self))))
                          (pict-size self) 
                          (om-make-point 0 0) 
                          (om-view-size self))))


(defvar *gnumbox-last-click* nil)
(defmethod om-view-click-handler  ((self graphic-numbox) where)
  (setf *gnumbox-last-click* (om-make-point (om-point-h where) (* -1 (om-point-v where))))
  (om-init-motion-functions self 'g-numbox-motion 'g-numbox-release))


(defmethod g-numbox-motion ((self graphic-numbox) pos)
  (let* ((y (om-point-v pos))
         (x (om-point-h pos))
         (first-v (* -1 y)))
    (set-value self  (max (min-val self) (min (max-val self)
                                              (+ (value self)
                                                 (* (map-mouse-increment self) (- first-v (om-point-v *gnumbox-last-click*)))))))
    (setf *gnumbox-last-click* (om-make-point x first-v))
    (om-redraw-view self)
    (item-action-while-drag self)))


(defmethod g-numbox-release ((view graphic-numbox) pos) 
  (item-action-after-drag view)
  (om-invalidate-view view))




;;; pour eviter l'heritage de ttybox...
(defmethod om-view-doubleclick-handler ((self graphic-numbox) where)
   nil)

(defmethod map-mouse-increment ((view graphic-numbox))
  (cond ((om-option-key-p) 100) 
        ((om-shift-key-p) 10) 
        ((om-command-key-p) 1000)
        (t 1))) 

(defmethod item-action-after-drag ((self graphic-numbox))
  (when (afterfun self)
    (funcall (afterfun self) self)))

(defmethod item-action-while-drag ((self graphic-numbox))
   (when (di-action self)
       (funcall (di-action self) self)
       ))


(defmethod set-value ((self graphic-numbox) value)
  (setf (pict-part self) (floor (* (- (nbpict self) 1) (/ (- value (min-val self)) (- (max-val self) (min-val self))))))
  (setf (value self) value)
  (om-invalidate-view self t))


;;; NUMBOX + EDIT ======================================================

(omg-defclass edit-numbox (numbox)  
  ((edit :accessor edit :initarg :edit :initform nil)))
(omg-defclass edit-numbox-edit (edit-text-enter-view)  ())
(defmethod open-ttybox-class ((self edit-numbox)) 'edit-numbox-edit)

(defmethod om-view-doubleclick-handler ((self edit-numbox) where)
   (open-ttybox self))

(defmethod open-ttybox ((self edit-numbox))
   (let ((thetext (format nil "~S" (value self)))
         (container (om-view-container self)))
     (om-add-subviews container
                      (setf (edit self) (om-make-dialog-item (open-ttybox-class self)
                                           (om-subtract-points (om-view-position self) (om-make-point 5 6))
                                           (om-add-points (om-view-size self) (om-make-point 10 -6))
                                           thetext
                                           :allow-returns nil
                                           :focus t
                                           :object self
                                           :container (om-view-container self)
                                           :font *controls-font*))
                      )
     ))

(defmethod om-dialog-item-action ((self edit-numbox-edit))
  (exit-from-dialog self (om-dialog-item-text self)))
     

;;;remove text-view from panel
(defmethod exit-from-dialog ((self edit-numbox-edit) newtext)
   (handler-bind ((error #'(lambda (c) (declare (ignore c)) 
                             (om-remove-subviews (om-view-container self) self)
                             (om-beep)
                             (om-abort))))
     (let ((*package* (find-package :om))
           (newval (read-from-string newtext)))
       (set-value (object self) newval)
       (when (afterfun (object self))
         (funcall (afterfun (object self)) (object self)))
       (om-remove-subviews (om-view-container self) self)
       (setf (edit (object self)) nil))))

