;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon

(in-package :om)

;-------SAMPLE-FUN---------
(defmethod* samplefun ((fun symbol) (step number) &optional (xmin 0) (xmax 10) (coeff 1))
  :initvals '(sqrt 1 0 10 1)
  :indoc '("function" "step" "min" "max" "coeff")
  :doc  "Returns the list of values of <fun> as sampled from <xmin> to <xmax> by <step>.
Values are multiplied by <coeff>. The second output return a bpf object that can be
directly connected to the left input of a BPF factory."
  :icon 236
  :numouts 2
  (samplefun (symbol-function fun) step xmin xmax coeff))


(defmethod* samplefun ((fun function) (step number) &optional (xmin 0) (xmax 7) (coeff 1000))
  (let ((rep-list (om* coeff (mapcar fun (arithm-ser xmin xmax step ))) )
        (thebpf (make-instance 'bpf)))
    (cons-bpf thebpf (loop for point in rep-list
                           for x from 0
                           collect (om-make-big-point x (round point))))
    (values rep-list thebpf)))





(defun linear (x0 y0 x1 y1) 
  (let* ((a (/ (- y1 y0) (- x1 x0)))
         (b (- y1 (* x1 a))))
    (eval `(function
            (lambda (x) (+ ,b (* x ,a)))))))

(defmethod* linear-fun ((x0 number) (y0 number) (x1 number) (y1 number)) 
  :initvals '(0 0 1 1)
  :indoc '("x0" "y0" "x1" "y1")
  :icon 236
  :doc "Constructs a linear function
passing through the 2 points (x0 y0) and (x1 y1).
The resulting function can be connected, for example, to samplefun."
  (linear x0 y0 x1 y1))




(defvar *function-package* (omNG-protect-object (omNG-make-new-package "Functions")))

(AddGenFun2Pack  (list 'samplefun 'linear-fun 'samp-board) *function-package*)

(AddPackage2Pack *function-package* *kernel-package*)
