;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon

(in-package :om)


;(let ((path (make-pathname :directory (pathname-directory *load-pathname*))))
;  (setf (logical-pathname-translations "MusicProj")
;    (list (list "**;*.*" "cl:code;projects;2-musicproject;**;"))))


(defvar *MusicProj-files* nil)

(setf *MusicProj-files* 
      '(
        "midi;midi"
        "editor;omicron"
        "editor;scoreeditor;scales"
        "container;tonalite"
        
        
        ;-----------Preferences----------------------------
        "midi;redefinitions"    
        "editor;musicpreferences"
        
        ;-----------Classes--------------------------------
        
        ;;=========
        ;;;"container;loadcontainer"
        ;;; essayer de faire a pour les projets...
        ;;;(setf (logical-pathname-translations "container")     
        ;;;  '(("**;" "code:projects;musicproject;container;**;")))
        "container;scoreobject"
        "container;tree2container" 
        "container;rythme;fringe" 
        "container;rythme;rythme" 
        "container;rythme;grouping"
        "container;rythme;tuplet"      
        "container;rythme;corrections"
        ;;;=========
        
        "classes;sound"       
        "classes;chordseq"
        
        
        ;-----------Functions--------------------------------
        "functions;trees"
        
        ;---------------Midi Jean--------------------------
        "midi;miditools"       
        "midi;midifile"              
        "midi;midifunctions"   
        "midi;midievents"       
        "midi;continuousctrl"       
        "midi;midiconversions"    
        "midi;midicontroller"       
        
        ;-----------Editors--------------------------------
        "container;maquetteinterface"     
        
        "editor;midieditor" 
        "editor;aiffeditor"      
        "editor;audiomix"      
        
        "editor;scoreeditor;rythtools"      
        "editor;scoreeditor;scoreeditors" 
        "editor;scoreeditor;edition"
        "editor;scoreeditor;scorepatch"       
        "editor;scoreeditor;scorepalette"    
        "editor;musminiboxes"           
        ;"editor;scoreeditor;rendering"
        "editor;scoreeditor;scoretools"
        "editor;scoreeditor;extraobjs"
        "editor;scoreeditor;graces"
        
        "editor;scoreeditor;dragagain"     
        
        "editor;scoreeditor;contextmenu"       
        "editor;scoreeditor;pagebreak"
        
        
        
        ;-----------ETF--------------------------------
        "etf;om2finale"           ; translate-score marche pas bien
        "etf;coom"                
        
        ;-------------------OM Interface to Musical Objects----
        "container;scoreominterface"   
        "functions;quantifyom"      
        "functions;maquette2obj"    
        "functions;conversions"       
        
        "players;midiplayer"
        "players;audioplayer"
        
        "classes;music-package"  
        "midi;midipackages"  
        
        ; osc and microplayer
        "osc;send-receive"
        "osc;send"
        "osc;receive"
        "osc;osc-events"
        "players;microplayer"
 
        ;sheet
        "classes;sheet"
        "classes;sheet-persistant"
        "editor;sheet;sheeteditor"
        "editor;sheet;sheetpatcheditor"
        "editor;sheet;drawing-pages"
        
        "editor;sheet;strandhbreak"
        ))


(eval-when (eval compile load)
  (mapc #'(lambda (filename) 
            (compile&load (namestring (make-local-path *load-pathname* filename)))) 
        *MusicProj-files*))


   
     

     
 
     
  