;OpenMusic
;
;Copyright (C) 1997, 1998, 1999, 2000 by IRCAM-Centre Georges Pompidou, Paris, France.
; 
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;See file LICENSE for further informations on licensing terms.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;
;Authors: Gerard Assayag and Augusto Agon


(in-package :om)

;=======

(defmethod edition-values   ((self miniview))
  (get-mini-param self 'cmnpref))

(defmethod edition-values  ((self tempobjframe))
  (get-mini-param self 'cmnpref))

;=======
(defmethod get-mini-zoom    ((self t)) 0.8)
(defmethod get-mini-zoom    ((self miniview)) 0.8)
(defmethod get-mini-zoom   ((self tempobjframe))
   (let* ((musobj (get-mus-ob (object self)))
          (obj-dur (get-obj-dur musobj))
          (pixsize (w self))
          (zomm1pixsize (ms2pixel obj-dur 4 1)))
     (/ pixsize zomm1pixsize)))


(defmethod get-boxsize      ((self simple-score-element))    (om-make-point 65 70))
(defmethod get-boxsize      ((self score-element))    (om-make-point 80 70))

(defmethod mv-font-size  ((self t))   20)

(defmethod mv-view-size  ((value t) self)
   (om-make-point (max 1000 (w self)) 
               (max 1000 (h self))))

(defmethod cons-mini-pict ((self simple-container) frame fontsize size)
  (let ((newfont (om-make-font *heads-font* fontsize)))
    (om-record-pict newfont size
      (cons-mini-obj self frame fontsize size))))

(defmethod get-mini-staff ((self simple-container) view)
   (get-staff-system (get-mini-param view 'staff)))

(defmethod get-win-ed-size  ((self simple-container)) (om-make-point 500 280))

(defmethod mv-deltay ((self simple-container) view staffsys sizefont) 
   (round (+  (inity view) (* -1 (system-offset-in-pix staffsys sizefont))  (* 1.1 sizefont))))

(defmethod cons-mini-obj ((self simple-container) view sizefont size)
  (let* ((staffsys (get-mini-staff self view))
         (scale (get-current-scale (get-mini-param view 'approx)))
         (grapobj (make-graph-form-obj self 0 (top-in-midi staffsys) (/ sizefont 4) 0 scale nil staffsys t))
         (deltay (round (* (score-top-margin view) sizefont))))
    (draw-one-system staffsys 0 deltay
                     (w view) sizefont nil nil nil)
    (draw-object  grapobj view (* 2 sizefont) (- deltay (round (* (posy (car (staff-list staffsys))) (/ sizefont 4)))) 
                  (get-mini-zoom view) 0 (om-point-h size) 0 (om-point-v size) 
                  'midic sizefont t staffsys nil nil)
    (om-draw-line  6 deltay 6 (round (+ deltay (get-system-size staffsys sizefont))))))


;;;;===== synth maq

(defmethod cons-maq-mini-obj ((self chord-seq) (view t) sizefont size)
  (let ((deltay 0)
        (dur (get-obj-dur self))
        (minh 3000) (maxh 9800) range noteh)
    (setf range (round (- maxh minh) 100))
    (setf noteh (round (om-point-v size) range))
    (om-with-fg-color nil (colorframe (object view))
    (loop for chord in (inside self) do
        (let ((x (om-scale  (offset->ms chord) 0 (om-point-h size) 0 dur)))
          (loop for note in (inside chord) do
                (let* ((x1 (round (+ x (om-scale (offset note) 0 (om-point-h size) 0 dur))))
                       (w (round (om-scale (dur note) 0 (om-point-h size) 0 dur)))
                       (x2 (round (+ x1 w)))
                       (y (round (- (om-point-v size) (om-scale (midic note) 0 (om-point-v size) minh maxh)))))
                  ;(om-draw-line x1 (+ deltay y) x2 (+ deltay y))
                  ;(om-draw-line x1 (+ deltay y 1) x2 (+ deltay y 1))
                  (om-fill-rect x1 y w noteh)
                  )
          ))))))

(defmethod cons-maq-mini-obj ((self voice) (view t) sizefont size)
  (cons-maq-mini-obj (objfromobjs self (make-instance 'chord-seq)) view sizefont size))


;;-------For note voices, chords ,etc

(defmethod draw-mini-view ((self t) (value simple-score-element))  
  (when (minipict self)
    (let ((x0 (initx self)) (y0 (inity self))
          (pictsize (om-get-picture-size (minipict self))))
      (om-draw-picture self (minipict self) (om-make-point x0 y0) pictsize))))

(defmethod update-miniview ((self t) (value simple-score-element)) 
   (when (minipict self) (om-kill-picture (minipict self))
         (setf (minipict self) nil))
   (setf (minipict self)  (cons-mini-pict value self (mv-font-size value) (mv-view-size value self)))
   (om-invalidate-view self t))


(defmethod draw-obj-in-rect ((self  simple-score-element) x x1 y y1 edparams  view)
   (let* ((size (om-make-point (- x1 x) (- y1 y)))
            (thepict (cons-mini-pict self view (mv-font-size view) size)))
     (om-draw-picture view thepict (om-make-point x y) size)
     (om-kill-picture thepict) t))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; deux fois MMMMM

(defmethod draw-mini-view ((self t) (value score-element))  
   (when (minipict self)
     (let ((x0 (initx self)) (y0 (inity self))
           (pictsize (om-get-picture-size (minipict self))))
       (om-draw-picture self (minipict self) (om-make-point x0 y0) pictsize))))

(defmethod update-miniview ((self t) (value score-element)) 
   (when (minipict self) (om-kill-picture (minipict self))
         (setf (minipict self) nil))
   (setf (minipict self)  (cons-mini-pict value self (mv-font-size value) (mv-view-size value self)))
   (om-invalidate-view self t))

(defmethod draw-obj-in-rect ((self  score-element) x x1 y y1 edparams  view)
   (let* ((size (om-make-point (- x1 x) (- y1 y)))
            (thepict (cons-mini-pict self view (mv-font-size view) size)))
     (om-draw-picture view thepict (om-make-point x y) size)
     (om-kill-picture thepict) t))



;exceptions por ahora

(defmethod draw-mini-view ((self t) (value rest)) t)
(defmethod update-miniview ((self t) (value rest)) (om-invalidate-view self t))
(defmethod draw-obj-in-rect ((self  rest) x x1 y y1 edparams  view) t)

(defmethod draw-mini-view ((self t) (value group)) t)
(defmethod update-miniview ((self t) (value group)) (om-invalidate-view self t))
(defmethod draw-obj-in-rect ((self  group) x x1 y y1 edparams  view) t)

(defmethod draw-mini-view ((self t) (value measure)) t)
(defmethod update-miniview ((self t) (value measure)) (om-invalidate-view self t))
(defmethod draw-obj-in-rect ((self  measure) x x1 y y1 edparams  view) t)


;------------------------------
;note
;------------------------------
(defmethod Class-has-editor-p  ((self note)) t)
(defmethod get-editor-class ((self note)) 'noteEditor)

(defmethod get-mini-staff ((self note) view)
   (get-staff-system (cond
                      ((> (midic self) 8700) 'G2)
                      ((> (midic self) 5800) 'G)
                      ((> (midic self) 4200) 'F)
                      (t 'F2))))


;-----------------------
;Chord
;-----------------------
(defmethod Class-has-editor-p  ((self chord)) t)
(defmethod get-editor-class ((self chord)) 'chordEditor)


;------------------------------
;voice
;------------------------------
(defmethod Class-has-editor-p  ((self voice)) t)
(defmethod get-editor-class ((self voice)) 'voiceEditor)


(defmethod update-miniview ((self t) (value voice)) 
   (when (minipict self) (om-kill-picture (minipict self))
         (setf (minipict self) nil))
   (setf (minipict self)  (cons-mini-pict value self (mv-font-size value) (mv-view-size value self)))
   (om-invalidate-view self t))



;------------------------------
;poly
;------------------------------

(defmethod Class-has-editor-p  ((self poly)) t )
(defmethod get-editor-class ((self poly)) 'polyEditor)

(defun cons-multi-mini-obj (self view sizefont size) 
  (let* ((staffsys (correct-staff-val self (get-staff-system (get-mini-param view 'staff)) view))
         (scale (get-current-scale (get-mini-param view 'approx)))
         (numvoices (length (inside self)))
         (grapobj (make-graph-form-obj self 0 nil (/ sizefont 4) 0 scale nil staffsys t))
         (deltay (round (* (score-top-margin view) sizefont))))
    
    (draw-score-line  staffsys view 0  deltay (w view) sizefont nil nil nil)
    (draw-object grapobj view (* 2 sizefont) deltay (get-mini-zoom view)
                 0 (om-point-h size) 0 (om-point-v size) 'midic sizefont t staffsys nil nil)
    ))



(defmethod cons-mini-obj ((self poly) view sizefont size)
   (cons-multi-mini-obj self view sizefont size))
;------------------------------
;chordseq
;------------------------------
(defmethod Class-has-editor-p  ((self chord-seq)) t )
(defmethod get-editor-class ((self chord-seq)) 'chordseqEditor)

;------------------------------
;multiseq
;------------------------------
(defmethod Class-has-editor-p  ((self multi-seq)) t )
(defmethod get-editor-class ((self multi-seq)) 'multiseqEditor)


(defmethod update-miniview ((self t) (value multi-seq))
   (when (minipict self) (om-kill-picture (minipict self))
         (setf (minipict self) nil))
   (set-mini-param self 'staff (correct-staff-val value (get-mini-param self 'staff) self)) 
   (setf (minipict self)  (cons-mini-pict value self (mv-font-size value) (mv-view-size value self)))
   (om-invalidate-view self t))


(defmethod cons-mini-obj ((self multi-seq) view sizefont size)
   (cons-multi-mini-obj self view sizefont size))


(defun correct-staff-val (multi staff view)
  (setf staff (list! staff))
  (let ((numcs (length (inside multi)))
        (numsat (length staff))
        (system-space (score-system-space view)))
    (unless (= numcs (length system-space))
      (setf system-space (make-list numcs :initial-element 1))
      (score-system-space view system-space))
    (cond 
     ((> numcs numsat)
      (setf system-space (reverse system-space))
      (setf staff (reverse staff))
      (loop for i from 1 to (- numcs numsat) do
            (push (clone (car staff)) staff)
            (push 1 system-space))
      (setf staff (reverse staff))
      (score-system-space view (reverse system-space)))
     ((< numcs numsat)
      (setf staff (subseq staff 0 numcs))
      (score-system-space view (subseq system-space 0 numcs))))
    staff))

;===============================================
;Methods for MUSIC EDITORS box
;===============================================



;------------------
;AIFF miniview
;------------------

(defmethod draw-mini-view ((self t) (val sound))
  (draw-obj-in-rect val 0 (w self) 0 (h self) (view-get-ed-params self) self))

(defmethod draw-obj-in-rect ((self  sound) x x1 y y1 edparams view)
  (let ((picture (pic-to-draw self)))
    (when picture
      (om-with-fg-color view *om-dark-gray-color*
        (om-draw-picture view picture (om-make-point x y) (om-make-point (- x1 x) (- y1 y)) ))
      (let ((dur (/ (om-sound-n-samples self) (om-sound-sample-rate self)))
            (pos 0)
            (w (w view))
            (h (h view)))
        (om-with-fg-color view *om-red-color*
          (om-with-dashline
            (loop for item in (markers self) do
                  (setf pos (round (* w item) dur))
                  (om-draw-line pos 0 pos h))))
        ))))


(defmethod update-miniview ((self t) (type sound))  (om-invalidate-view self t))


;--------------
;MIDIFILES
;--------------

(defun draw-track-mini (self track minx maxx miny maxy mode)
  (declare (ignore mode))
  (let* ((x-notes (give-notes-in-x-range track minx maxx))
         (notes (sort (give-notes-iny-range x-notes miny maxy) '< :key 'second))
         (ysize (round (h self) (- maxy miny))))
    (drawmini-track-note self (list minx maxx miny maxy)  notes ysize)))

(defun drawmini-track-note (self ranges notes ysize)
  (declare (ignore ysize))
  (loop for note in notes do
        (let* ((topleft (point-to-pixel-with-sizes ranges (om-make-big-point (second note) (first note)) (w self) (h self)))
               (rigth (round  (* (third note) (/ (w self) (second ranges))))))
          (om-fill-rect (om-point-h topleft) (om-point-v topleft) rigth 1))))

(defmethod draw-mini-view ((self miniview) (value MidiFile))
   (if (midifilename value)
     (om-with-focused-view self
       (draw-mini-midi self 5000 value)) (call-next-method)))

(defun draw-mini-midi (self x val) 
   (declare (special *16-color-list*))
   (loop for item in (tracks val)
         for i = 0 then (+ i 1) do
         (om-with-fg-color nil (nth (mod i 15) *16-color-list*)
           (draw-track-mini self item 0 x 24 96 t))))


(defmethod draw-obj-in-rect ((self  midifile) x x1 y y1 edparams  view)
  (loop for item in (tracks self)
         for i = 0 then (+ i 1) do
         (om-with-fg-color nil (nth (mod i 15) *16-color-list*)
           (let* ((x-notes (give-notes-in-x-range item 0 5000))
                  (notes (sort (give-notes-iny-range x-notes 24 96) '< :key 'second))
                  )
             (loop for note in notes do
                   (let* ((topleft (point-to-pixel-with-sizes '(0 5000 24 96) (om-make-big-point (second note) (first note)) (- x1 x) (- y1 y)))
                          (rigth (round  (* (third note) (/ (- x1 x) 5000)))))
                     (when (> (+ rigth (om-point-h topleft)) (- x1 x))
                       (setf rigth (- (- x1 x) (om-point-h topleft))))
                     (om-fill-rect (+ x (om-point-h topleft)) (+ y (om-point-v topleft)) rigth 1)))))))




(defmethod update-miniview ((self t) (type midifile)) 
   (om-invalidate-view self t))



;===============================draw-in maquettes=======================================

  
;======================================================
;USED IN MAQUETTES
;======================================================
(defmethod draw-editor-mode ((self sound) view)
  (om-draw-picture view (pict-sound self) (om-make-point 0 0) (om-make-point (w view) (h view)))
  (draw-carre view nil))

(defmethod draw-editor-mode ((self midifile) view)
  (draw-carre view t)
  (om-with-focused-view view
    (draw-mini-midi view (real-dur self) self)))

;------Music notation

;----note
(defmethod draw-editor-mode ((self note) view) 
   (draw-mini-view view self)
   (draw-carre view))
;-----chord
(defmethod draw-editor-mode ((self chord) view) 
   (draw-mini-view view self)
   (draw-carre view))

;-----voice
(defmethod draw-editor-mode ((self voice) view) 
   (draw-mini-view view self)
   (draw-carre view))

;-----poly
(defmethod draw-editor-mode ((self poly) view) 
   (draw-mini-view view self)
   (draw-carre view))

;-----voice
(defmethod draw-editor-mode ((self chord-seq) view) 
   (draw-mini-view view self)
   (draw-carre view))

;-----poly
(defmethod draw-editor-mode ((self multi-seq) view) 
   (draw-mini-view view self)
   (draw-carre view))



;-------MIDI
(defmethod update-miniview ((self tempobjframe) (value midifile))
   (om-invalidate-view self t))


#|
(defun get-x-size (score)
(let ((ssize (cmn::size score)))
     (loop for item in (cmn::systems score)
           maximize 
           (loop for staff in (cmn::staves item)
                 maximize
                 (let* ((thedata (cmn::staff-data staff))
                        (inside (cddr thedata)))
                   (loop for item1 in inside
                         maximize (* ssize (+ (cmn::dx item1) (cmn::x1 item1)))))))))
|#
#|
(defun get-y-size (score)
   (let ((ssize (cmn::size score)))
     (loop for item in (cmn::systems score)
           minimize 
           (loop for staff in (cmn::staves item)
                 minimize 
                 (* ssize (+ (cmn::dy staff)  (cmn::y0 staff) 1))))))

|#



;===========
(defmethod draw-editor-mode ((self maquette-obj) view)
   (let ((durx (get-obj-dur self)))
     (om-with-focused-view view
       (rectangles&containers self 0 0 (w view) (h view) durx 0))
     (draw-carre view t)))


(defmethod rectangles&containers ((self container) x0 y0 x1 y1 durx i)
   (call-next-method)
   (when (inside self)
     (let ((deltay (round y1 (length (inside self))))) 
       (loop for item in (inside self)
             for posy = 0 then (+ posy deltay) do
             (let ((ofpix (round (* (offset->ms item) x1) durx))
                   (durpix (round (* (get-obj-dur item) x1) durx)))
               (if (zerop durpix) (setf durpix 2))
               (rectangles&containers item  (+ x0 ofpix) (+ y0 posy) (- durpix 1) (- deltay 1)  (extent->ms item)  (+ i 1)))))))

(defmethod rectangles&containers ((self sequence*) x0 y0 x1 y1 durx i)
   (om-with-fg-color nil (nth (mod i 6) *obje-color-list*)
     (om-fill-rect x0 y0 x1 y1))
   (when (inside self)
     (let ((dury (round (* y1 0.8)))) 
       (loop for item in (inside self) do
             (let ((ofpix (round (* (offset->ms item) x1) durx))
                   (durpix (round (* (get-obj-dur item) x1) durx)))
               (if (zerop durpix) (setf durpix 2))
               (rectangles&containers item  (+ x0 ofpix) (+ y0 (round (* y1 0.1))) (- durpix 1) (- dury 1)  (extent->ms item)  (+ i 1)))))))

(defmethod rectangles&containers ((self simple-container)  x0 y0 x1 y1 durx i)
   (om-with-fg-color nil (nth (mod i 6) *obje-color-list*)
     ;(draw-rect x0 y0 x1 y1)
     (om-fill-rect x0 y0 x1 y1)))
                 

(defmethod draw-obj-in-rect ((self  ommaquette) x x1 y y1 edparams  view)
  (om-with-fg-color nil (maq-color (params self)) 
      (let ((durmaq (get-obj-dur self))
            (rangey (max-y-item self)))
        (om-fill-rect x y (- x1 x) (- y1 y))
        (loop for item in (boxes self) do
              (when (boxtempobj-p item)
                (draw-rect-in-rect item  (- x1 x) (- (- y1 y) 5)  x y  durmaq (first rangey) (second rangey) 1 view))))))



(defmethod get-boxsize      ((self chord))    (om-make-point 55 90))
(defmethod get-boxsize      ((self voice))    (om-make-point 130 65))
(defmethod get-boxsize      ((self poly))    (om-make-point 130 65))

(defmethod get-boxsize      ((self chord-seq))    (om-make-point 130 65))
(defmethod get-boxsize      ((self multi-seq))    (om-make-point 130 65))

(defmethod get-boxsize      ((self note))    (om-make-point 55 65))
