(in-package :om)

(defmethod om-get-menu-context ((object t)) nil)

;=============================
(defun propor-menu-context (object)
  (list (om-new-menu "Mode"
                     (om-new-leafmenu "Normal" #'(lambda () (change-score-mode (panel object) 0)))
                     (om-new-leafmenu "Patch" #'(lambda () (change-score-mode (panel object) 1)))
                     (om-new-leafmenu "Page" #'(lambda () (change-score-mode (panel object) 2)))
                     )
        (om-new-leafmenu "Eval" #'(lambda () (eval-score (panel object))))
        (om-new-leafmenu "-" #'(lambda () nil))
        (om-new-leafmenu (if (show-stems (panel object)) "Hide stems" "Show stems")
                         #'(lambda () (show-hide-stems (panel object))))))

(defun simple-menu-context (object)
  (list (om-new-menu "Mode"
                     (om-new-leafmenu "Normal" #'(lambda () (change-score-mode (panel object) 0)))
                     (om-new-leafmenu "Patch" #'(lambda () (change-score-mode (panel object) 1)))
                     (om-new-leafmenu "Page" #'(lambda () (change-score-mode (panel object) 2)))
                     )
        (om-new-leafmenu "Eval"
                         #'(lambda () (eval-score (panel object))))))


(defmethod om-get-menu-context ((object scoreeditor))
  (simple-menu-context object))

(defmethod om-get-menu-context ((object voiceeditor))
  (simple-menu-context object))

(defmethod om-get-menu-context ((object polyeditor))
  (simple-menu-context object))



(defmethod om-get-menu-context ((object chordeditor))
  (propor-menu-context object))

(defmethod om-get-menu-context ((object chordseqeditor))
  (propor-menu-context object))


;----------------------------
;on peut mettre quelques actions ici
;----------------------------


(defmethod om-view-window ((self simple-graph-container))
  (om-front-window))

(defmethod om-view-window ((self grap-extra-objet))
  (om-front-window))


(defmethod menu-item-context ((self simple-graph-container) container)
  ;;; bidouy : on a passe le panel au lieu de where
  (om-popup-menu-context self container)
  (update-panel container)
)

(defmethod menu-item-context ((self grap-extra-objet) where)
   (om-popup-menu-context self))


(defmethod om-get-menu-context ((object simple-graph-container))
  (list (om-new-leafmenu "do nothing"
                         #'(lambda () 
                             (om-beep-msg "to do")))))

(defmethod om-get-menu-context ((object grap-extra-objet))
  (list (om-new-leafmenu "do nothing"
                         #'(lambda () 
                             (om-beep-msg "to do")))))