


(in-package :om)

;Encore le bordel

(defmethod set-edition-params ((self simple-container) box)
   (setf (edition-params box) (get-default-scor-params self)))

(defmethod get-default-scor-params ((self t))
  (pairlis '(approx fontsize staff cmnpref deltapict outport inport 
             zoom notechancolor? grillestep mode winsize winpos score-mode obj-mode show-stems) 
           (list *global-midi-approx* *music-fontsize* *default-satff* (make-instance 'edition-values) (om-make-point 0 0) *Outmidiport* *InMidiPort*
                 1 nil 1000 0 (om-make-point 370 280) (om-make-point 400 20) 0 1 t)))

(defmethod get-default-scor-params ((self note))
  (pairlis '(approx fontsize staff cmnpref deltapict outport inport 
             zoom notechancolor? grillestep mode winsize winpos score-mode obj-mode show-stems) 
           (list *global-midi-approx* *music-fontsize* *default-satff* (make-instance 'edition-values) (om-make-point 0 0) *Outmidiport* *InMidiPort*
                 1 nil 1000 0 (om-make-point 370 280) (om-make-point 300 20) 0 0 t)))


;=====================================================================
;PARAMETRES D'EDITION
;=====================================================================


(defclas fdoc () 
   ((page-list :initform nil)))

(defmethod howmany-pages ((self fdoc))
  (length (page-list self)))

(defmethod howmany-lines ((self fdoc) i)
  (length (line-list (nth i (page-list self)))))

(defclas fpage () 
   ((line-list :initform nil)))

(defclas fline () 
   ((line-info :initform nil)))

; line-info = ( (voice #) ... (voice #) )


(defclass edition-values () 
  ((paper-size :initform (om-make-point 600 800)  :accessor paper-size :initarg :paper-size)
   (top-margin :initform 2  :accessor top-margin :initarg :top-margin)
   (left-margin :initform 1  :accessor left-margin :initarg :left-margin)
   (right-margin :initform 1  :accessor right-margin :initarg :right-margin)
   (bottom-margin :initform 1  :accessor bottom-margin :initarg :bottom-margin)
   (orientation :initform nil  :accessor orientation :initarg :orientation)
   (scale :initform nil  :accessor scale :initarg :scale)
   (system-space :initform '(1)  :accessor system-space :initarg :system-space)
   (line-space :initform 1  :accessor line-space :initarg :line-space)
   (fdoc :initform (make-instance 'fdoc)  :accessor fdoc :initarg :fdoc)
   (title :initform nil  :accessor title :initarg :title)
   (picts-list :initform nil  :accessor picts-list :initarg :picts-list)
   (show-title? :initform nil  :accessor show-title? :initarg :show-title?)
   (show-page? :initform nil  :accessor show-page? :initarg :show-page?)
   (sheet-id :initform nil  :accessor sheet-id :initarg :sheet-id)
   (page-mode :initform nil  :accessor page-mode :initarg :page-mode)))

(defmethod new-ed-params? ((self edition-values)) t)
(defmethod new-ed-params? ((self t)) nil)

(defmethod omNG-save ((self edition-values) &optional (values? nil))
  `(let ((newobj (make-instance ',(type-of self))))
     (setf (paper-size newobj) ,(om-save-point (paper-size self)))
      (setf (top-margin newobj) ,(top-margin self))
      (setf (left-margin newobj) ,(left-margin self))
      (setf (right-margin newobj) ,(right-margin self))
      (setf (bottom-margin newobj) ,(bottom-margin self))
      (setf (orientation newobj) ,(orientation self))
      (setf (scale newobj) ,(scale self))
      (setf (system-space newobj) ',(system-space self))
      (setf (line-space newobj) ,(line-space self))
      (setf (title newobj) ,(title self))
      (setf (show-title? newobj) ,(show-title? self))
      (setf (show-page? newobj) ,(show-page? self))
      (setf (sheet-id newobj) ,(sheet-id self))
      (setf (page-mode newobj) ,(page-mode self))
     newobj))


;==============
(defmethod score-paper-size ((self t) &optional val)
  (if val
    (setf (paper-size (edition-values self)) val)
    (paper-size (edition-values self))))

(defmethod score-top-margin ((self t) &optional val)
  (if val
    (setf (top-margin (edition-values self)) val)
    (top-margin (edition-values self))))

(defmethod score-left-margin ((self t) &optional val)
  (if val
    (setf (left-margin (edition-values self)) val)
    (left-margin (edition-values self))))

(defmethod score-right-margin ((self t) &optional val)
  (if val
    (setf (right-margin (edition-values self)) val)
    (right-margin (edition-values self))))

(defmethod score-bottom-margin ((self t) &optional val)
  (if val
    (setf (bottom-margin (edition-values self)) val)
    (bottom-margin (edition-values self))))

(defmethod score-orientation ((self t) &optional val)
  (if val
    (setf (orientation (edition-values self)) val)
    (orientation (edition-values self))))

(defmethod score-scale ((self t) &optional val)
  (if val
    (setf (scale (edition-values self)) val)
    (scale (edition-values self))))

(defmethod score-system-space ((self t) &optional val)
  (if val
    (setf (system-space (edition-values self)) val)
    (system-space (edition-values self))))

(defmethod score-line-space ((self t) &optional val)
  (if val
    (setf (line-space (edition-values self)) val)
    (line-space (edition-values self))))

(defmethod score-fdoc ((self t) &optional val)
  (if val
    (setf (fdoc (edition-values self)) val)
    (fdoc (edition-values self))))



(defmethod score-title ((self t) &optional val)
  (if val
    (setf (title (edition-values self)) val)
    (title (edition-values self))))

(defmethod score-show-title? ((self t) &optional val)
  (if val
    (setf (show-title? (edition-values self)) val)
    (show-title? (edition-values self))))

(defmethod score-show-page? ((self t) &optional val)
  (if val
    (setf (show-page? (edition-values self)) val)
    (show-page? (edition-values self))))

(defmethod score-sheet-id ((self t) &optional val)
  (if val
    (setf (sheet-id (edition-values self)) val)
    (sheet-id (edition-values self))))

(defmethod score-page-mode ((self t))
  (page-mode (edition-values self)))

(defmethod set-score-page-mode ((self t) val)
  (setf (page-mode (edition-values self)) val))

(defmethod score-picts-list ((self t) &optional val)
  (if val
    (setf (picts-list (edition-values self)) val)
    (picts-list (edition-values self))))


(defmethod score-widht ((self t) size)
  (- (om-point-h (score-paper-size self)) (* size (score-left-margin self)) (* size (score-right-margin self))))
 
(defmethod score-height ((self t) size)
  (- (om-point-v (score-paper-size self)) (* size (score-bottom-margin self)) (* size (score-top-margin self))))


;==============



;;; suppr jean - autocvs 16/08 - deja defini au dessus avec mode obj = 1 (chord) par defaut
#|
(defmethod get-default-scor-params ((self t))
  (pairlis '(approx fontsize staff cmnpref deltapict outport inport 
             zoom notechancolor? grillestep mode winsize winpos palette-mode obj-mode show-stems) 
           (list *global-midi-approx* *music-fontsize* *default-satff* (make-instance 'edition-values) (om-make-point 0 0) *Outmidiport* *InMidiPort*
                 1 nil 1000 0 (om-make-point 370 280) (om-make-point 40 10) 0 0 t)))
|#

(defmethod correct-page-par ((self scoreEditor) par)
  (if (new-ed-params? par) par
      (let ((rep (make-instance 'edition-values)))
        (set-edit-param self 'cmnpref rep)
        rep)))




