(in-package :om)



;================================================
;extra-obj
;================================================

(defclass extra-o ()
   ((object :initform nil :initarg :object :accessor object)
    (levelsize :initform 1 :accessor levelsize)
    (uord :initform 1 :accessor uord)))


(defclass! extra-objet (extra-o)
   ((deltax :initform 0  :initarg :deltax :accessor deltax)
    (deltay :initform 0  :initarg :deltay :accessor deltay)))


(defmethod extra-p ((self extra-objet)) t)
(defmethod extra-p ((self t)) nil)

(defmethod transpose-a ((self extra-objet) trans)
   (setf (deltay self) (+ (deltay self) (* -1 (round trans 100)))))

(defmethod move-in-x ((self extra-objet) trans)
   (setf (deltax self) (+ (deltax self) trans)))

(defmethod click-in-extra ((self extra-objet)) t)


(defmethod general-delete ((view voicePanel) (self extra-objet))
   (setf (extra-obj-list (object self)) (remove self (extra-obj-list (object self)) :test 'equal)))

(defmethod general-delete ((view polyPanel) (self extra-objet))
   (setf (extra-obj-list (object self)) (remove self (extra-obj-list (object self)) :test 'equal)))

(defmethod general-delete ((view scorePanel) (self extra-objet))
   (setf (extra-obj-list (object self)) (remove self (extra-obj-list (object self)) :test 'equal)))

(defmethod add-new-extra ((self t) (mode t))  nil)

(defmethod set-extra-in-list ((extra t) (self t))
   (setf (object extra) self)
   (push extra (extra-obj-list self)))


(defmethod delete-extra ((self extra-objet))
   (when (object self)
     (setf (extra-obj-list (object self)) 
           (remove self (extra-obj-list (object self)) :test 'equal))))

(defmethod score-move-a  ((self extra-objet) panel trans)
  (transpose-a self trans))



;-------------graphic-extra-object---------------

(defclass grap-extra-objet ()
   ((rectangle :initform (list 0 0 0 0 ) :accessor rectangle)
    (reference :initform nil :initarg :reference :accessor reference)
    (selected :initform nil  :accessor selected)
    (gobject :initform nil :initarg :gobject :accessor gobject)))

(defmethod grap-extra-p ((self grap-extra-objet)) t)
(defmethod grap-extra-p ((self t)) nil)

(defmethod draw-score-selection ((self grap-extra-objet) selection system size)
   (if (member (reference self) selection :test 'equal)
     (draw-h-rectangle (rectangle self)  t)))

(defmethod open-extra-editor ((self scorepanel) (gtext grap-extra-objet)) t)


;============================================================
; DIVERS TYPES OF EXTRA OBJECTS
;============================================================

;***************
;TEXT
;***************
(defclass! text-extra (extra-objet)
   ((thetext :initform "text" :initarg :thetext :accessor thetext))
   (:icon 279))

(defmethod text-extra-p ((self text-extra)) t)
(defmethod text-extra-p ((self t)) nil)


(defmethod add-new-extra ((self t) (mode (eql 'text)))
   (let ((newextra (make-instance 'text-extra
                     :object self)))
     (setf (uord newextra) 1)
     (push newextra (extra-obj-list self))))


(defmethod draw-obj-in-rect ((self  text-extra) x x1 y y1 edparams  view)
  (let* ((fontsize 14)
         (thefont (om-make-font *om-def-font-face* fontsize))
         (sizetext (round (get-name-size (thetext self) thefont) 2)))
    (om-with-font thefont
                  (om-draw-string (round (- (+ x (/ (- x1 x) 2)) sizetext)) (round (+ y (/ (- y1 y) 2))) (thetext self))
                  )))

;----------------

(defclass grap-extra-text (grap-extra-objet) ())

(defmethod make-graph-extra-obj ((self text-extra) gobj)
   (make-instance 'grap-extra-text
     :reference  self
     :gobject gobj))
   
(defmethod draw-graph-extra-obj ((self grap-extra-text) view size staff)
   (let* ((grap-obj (gobject self))
          (object (reference self))
          (rect (rectangle grap-obj))
          (fontsize (round size 2.8))
          (text (thetext (reference self)))
          (thefont (om-make-font *om-def-font-face* fontsize))
          (ls (round size 4))
          (sizetext (get-name-size text thefont))
          x y)
     (setf y (cond
              ((= (uord object) 1)
               (+ ls (fourth rect)))
              (t (+ ls (second rect)))))
     (setf x (- (+ (first rect) (round (- (third rect) (first rect)))) (round sizetext 2)))
     (setf y (+ y (* ls (deltay (reference self)))))
     (setf x (+ x (* ls (deltax (reference self)))))
     (om-with-font thefont
                   (om-draw-string x y (thetext (reference self))) 
                   (setf (rectangle self) (list x (- y fontsize) (+ x sizetext) y)))))

;------------------------
(defmethod open-extra-editor ((self scorepanel) (gtext grap-extra-text))
  (let* ((grap-text (reference gtext))
         (editor (om-view-container self))
         (rect (rectangle gtext))
         (size (round (staff-size self) 2.8)))
    (when (text-view editor) (exit-from-dialog (text-view editor) (om-dialog-item-text (text-view editor))))
    (setf (text-view editor) (om-make-dialog-item  'text-edition-class
                                                  (om-make-point (first rect) (second rect))
                                                  (om-get-text-edit-size (om-make-point (- (third rect) (first rect)) (- (fourth rect) (second rect))))
                                                  (thetext grap-text)
                                                  :object grap-text 
                                                  :font (om-make-font *om-def-font-face* size)))
    (om-add-subviews editor (text-view editor))
    (text-view editor)))

(omg-defclass text-edition-class (edit-text-enter-view) 
   ((object :initform nil :initarg :object :accessor object)))

(defmethod exit-from-dialog ((self text-edition-class) newtext)
   
   (handler-bind ((error #'(lambda (c) (declare (ignore c)) 
                            (setf (text-view (editor (om-view-container self))) nil)
                            (om-remove-subviews (editor (om-view-container self)) self)
                            (om-beep)
                            (abort))))
     (setf (thetext (object self)) (om-dialog-item-text self)) 
     (setf (text-view (om-view-container self)) nil)
     (om-remove-subviews (om-view-container self) self)))


;***************
;NOTE-HEAD
;***************
(defclass! head-extra (extra-objet)
   ((thehead :initform (head-1) :initarg :thehead :accessor thehead)
    (deltax :initform 0  :accessor deltax)
    (deltay :initform 0  :accessor deltay))
   (:icon 162))

(defmethod get-slot-in-out-names ((self head-extra)) 
   (values '("self" "thehead")
           '(nil  "Ï")
           '("object or object list" "head" )
           '(nil (( 1 (("rond" (head-1)) ("blanche" (head-1/2)) ("noire" (head-1/4)) ("carre" (head-carre))  
                       ("losange" (head-losange)) ("rect" (head-rect)) 
                       ("triangle" (head-triangle)) ("cercle" (head-cercle))))))))



(defmethod draw-obj-in-rect ((self  head-extra) x x1 y y1 edparams  view)
  (let* ((fontsize 48)
         (thefont (om-make-font *heads-font* fontsize))
         (sizetext (round (get-name-size (thehead self) thefont) 2)))
    (om-with-font thefont
                  (om-draw-string (round (- (+ x (/ (- x1 x) 2)) sizetext)) (round (+ y (/ (- y1 y) 2))) (thehead self))
                  )))

(defmethod head-extra-p ((self head-extra)) t)
(defmethod head-extra-p ((self t)) nil)

(defmethod add-new-extra ((self t) (mode (eql 'rond)))
   (add-head-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'blanche)))
   (add-head-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'noire)))
   (add-head-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'carre)))
   (add-head-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'rombo)))
   (add-head-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'cuadro)))
   (add-head-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'triangle)))
   (add-head-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'bola)))
   (add-head-extra self mode))

(defmethod notesforhead ((self container))
   (loop for item in (inside self)
         append (notesforhead item)))
(defmethod notesforhead ((self simple-score-element)) nil)
(defmethod notesforhead ((self note)) (list self))

(defmethod add-head-extra ((self t) mode)
   (loop for note in (notesforhead self) do
         (let ((newextra (make-instance 'head-extra :object note)))
           (setf (thehead newextra)
                 (cond
                  ((equal mode 'rond) (head-1)) ((equal mode 'blanche) (head-1/2)) ((equal mode 'noire) (head-1/4)) 
                  ((equal mode 'carre) (head-carre))  
                  ((equal mode 'rombo) (head-losange)) ((equal mode 'cuadro) (head-rect)) 
                  ((equal mode 'triangle) (head-triangle)) ((equal mode 'bola) (head-cercle))))
           (setf (extra-obj-list note) (remove-if 'head-extra-p (extra-obj-list note))) 
           (push newextra (extra-obj-list note)))))

(defmethod make-graph-extra-obj ((self head-extra) gobj) nil)

(defun get-extra-head (note)
   (let ((head (find-if 'head-extra-p (extra-obj-list note))))
     (when head
       (thehead head))))

(defmethod set-extra-in-list ((extra head-extra) (self t))
   (loop for note in (notesforhead self) do
         (let ((newextra (clone extra)))
           (setf (object newextra) note)
           (setf (extra-obj-list note) (remove-if 'head-extra-p (extra-obj-list note))) 
           (push newextra (extra-obj-list note)))))

;***************
;CHAR-EXTRAS
;***************

(defclass! char-extra (extra-objet)
   ((thechar :initform (head-1/4) :initarg :thechar :accessor thechar))
   (:icon 303))

(defmethod char-extra-p ((self char-extra)) t)
(defmethod char-extra-p ((self t)) nil)


(defmethod draw-obj-in-rect ((self  char-extra) x x1 y y1 edparams  view)
  (let* ((fontsize 24)
         (thefont (om-make-font *extras-font* fontsize))
         (sizetext (round (get-name-size (thechar self) thefont) 2)))
    (om-with-font thefont
                  (om-draw-string (round (- (+ x (/ (- x1 x) 2)) sizetext)) (round (+ y (/ (- y1 y) 2))) (thechar self))
                  )))


(defmethod add-new-extra ((self t) (mode (eql 'a)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'b)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'c)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'd)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'e)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'f)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'g)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'h)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'i)))
   (add-char-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'j)))
   (add-char-extra self mode))



(defmethod add-char-extra ((self t) mode)
   (let ((newextra (make-instance 'char-extra :object self)))
     (setf (thechar newextra)
           (cond
            ((equal mode 'a) "·") ((equal mode 'b) "@") ((equal mode 'c) "s") ((equal mode 'd) "")  
            ((equal mode 'e) "l") ((equal mode 'f) "m") ((equal mode 'g) "Þ") ((equal mode 'h) "ù") 
            ((equal mode 'i) "è")  ((equal mode 'j) "*"))) 
     (push newextra (extra-obj-list self))))
;--------------------

(defclass grap-extra-char (grap-extra-objet) ())

(defmethod make-graph-extra-obj ((self char-extra) gobj) 
   (make-instance 'grap-extra-char
     :reference  self
     :gobject gobj))
   
(defmethod draw-graph-extra-obj ((self grap-extra-char) view size staff)
   (let* ((grap-obj (gobject self))
          (object (reference self))
          (rect (rectangle grap-obj))
          (fontsize size)
          (text (thechar (reference self)))
          (ls (round size 4))
          (thefont (om-make-font *heads-font* fontsize))
          (sizetext (get-name-size text thefont))
          x y)
     (setf y (+ (* 3 ls) (second rect)))
     (setf x (- (+ (first rect) (round (- (third rect) (first rect)))) (round sizetext 2) ls))
     (setf y (+ y (* ls (deltay (reference self)))))
     (setf x (+ x (* ls (deltax (reference self)))))
     (om-with-font thefont
                   (om-draw-string x y text))
     (setf (rectangle self) (list x (+ (* 2 ls) (- y fontsize)) (+ x sizetext) (+ ls y))))
  )

;***************
;VELOCITIES
;***************


(defclass! vel-extra (extra-objet) 
   ((thechar :initform (dyn-fff) :initarg :thechar :accessor thechar))
   (:icon 492))

(defmethod get-slot-in-out-names ((self vel-extra))
   (values '("self" "deltax" "deltay" "dynamic")
           '(nil 0 0 "ì")
           '("object or object list" "deltax" "deltay" "dynamics" )
           '(nil nil nil (( 3 (("fff" (dyn-fff))  ("ff" (dyn-ff)) ("f" (dyn-f))  
                               ("mf" (dyn-mf)) ("mp" (dyn-mp)) ("ppp" (dyn-ppp)) ("pp" (dyn-pp)) ("p" (dyn-p))))))))


(defmethod draw-obj-in-rect ((self  vel-extra) x x1 y y1 edparams  view)
  (let* ((fontsize 24)
         (thefont (om-make-font *extras-font* fontsize))
         (sizetext (round (get-name-size (thechar self) thefont) 2)))
     (om-with-font thefont
                   (om-draw-string (round (- (+ x (/ (- x1 x) 2)) sizetext)) (round (+ y (/ (- y1 y) 2))) (thechar self))))
  )


(defmethod vel-extra-p ((self vel-extra)) t)
(defmethod vel-extra-p ((self t)) nil)

(defmethod add-new-extra ((self t) (mode (eql 'fff)))
   (add-vel-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'ff)))
   (add-vel-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'f)))
   (add-vel-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'mf)))
   (add-vel-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'mp)))
   (add-vel-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'p)))
   (add-vel-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'pp)))
   (add-vel-extra self mode))
(defmethod add-new-extra ((self t) (mode (eql 'ppp)))
   (add-vel-extra self mode))

(defmethod add-vel-extra ((self t) mode)
   (let ((newextra (make-instance 'vel-extra :object self)))
     (setf (thechar newextra)
           (cond
             ((equal mode 'fff) (dyn-fff)) ((equal mode 'ff) (dyn-ff)) ((equal mode 'f) (dyn-f))  
            ((equal mode 'mf) (dyn-mf)) ((equal mode 'mp) (dyn-mp)) ((equal mode 'ppp) (dyn-ppp))
            ((equal mode 'pp) (dyn-pp)) ((equal mode 'p) (dyn-p)))) 
     (push newextra (extra-obj-list self))
     (set-vel self (get-vel-midi (thechar newextra)))))

(defmethod set-extra-in-list ((extra vel-extra) (self t))
   (setf (object extra) self)
   (push extra (extra-obj-list self))
   (set-vel self (get-vel-midi (thechar extra))))


(defun get-vel-midi (str)
   (let ((pos (position str *cur-dynamic-chars* :test 'string-equal)))
   (cond
    (pos (- (nth pos (cdr *cur-dynamic-list*)) 1))
    (t 10))))


(defmethod! set-vel ((self container) vel)
   (loop for item in (inside self) do (set-vel item vel)))

(defmethod! set-vel ((self note) vel)
   (setf (vel self) vel))

(defmethod! set-vel ((self t) vel) t)
;--------------------

(defclass grap-extra-vel (grap-extra-objet) ())

(defmethod make-graph-extra-obj ((self vel-extra) gobj)
   (make-instance 'grap-extra-vel
     :reference  self
     :gobject gobj))
   
(defmethod draw-graph-extra-obj ((self grap-extra-vel) view size staff)
   (let* ((grap-obj (gobject self))
          (object (reference self))
          (rect (rectangle grap-obj))
          (fontsize (round size 4/3))
          (text (thechar (reference self)))
          (thefont (om-make-font *extras-font* fontsize))
          (ls (round size 4))
          (sizetext (get-name-size text thefont))
          x y)
     (setf y (+ (* 3 ls) (second rect)))
     (setf x (- (+ (first rect) (round (- (third rect) (first rect)))) (round sizetext 2) ls))
     (setf y (+ y (* ls (deltay (reference self)))))
     (setf x (+ x (* ls (deltax (reference self)))))
     (om-with-font thefont
                   (om-draw-string x y text))
     (setf (rectangle self) (list x (+  ls (- y fontsize)) (+ x sizetext) (+ ls y))))
  )


;***************
;LINES
;***************

(defclass! line-extra (extra-objet) ()
   (:icon 490))


(defmethod line-extra-p ((self line-extra)) t)
(defmethod line-extra-p ((self t)) nil)

(defmethod add-new-extra ((self t) (mode (eql 'line)))
   (let ((newextra (make-instance 'line-extra
                     :object self)))
     (push newextra (extra-obj-list self))))

(defmethod draw-obj-in-rect ((self  line-extra) x x1 y y1 edparams  view)
   (om-draw-line (round (+ x (/ (- x1 x) 2))) y (round (+ x (/ (- x1 x) 2))) y1))


(defclass grap-extra-line (grap-extra-objet) ())

(defmethod make-graph-extra-obj ((self line-extra) gobj)
   (make-instance 'grap-extra-line
     :reference  self
     :gobject gobj))
   
(defmethod draw-graph-extra-obj ((self grap-extra-line) view size staff)
   (let* ((grap-obj (gobject self))
          (object (reference self))
          (rect (rectangle grap-obj))
          x y)
     (setf y (fourth rect))
     (setf x (+ (first rect) (round (- (third rect) (first rect)))))
     (om-with-fg-color nil *om-red-color*
       (om-draw-line x y x (- y 100))
       (om-draw-line x y x (+ y 100)))
     (setf (rectangle self) (list (- x 2) (- y 100) (+ x 2) (+ y 100) ))))


;=============================================================================
;=============================================================================

;***************
;PICTS
;***************

(defclass! pict-extra (extra-objet picture) 
   ((factx :initform 1 :accessor factx)
    (facty :initform 1 :accessor facty))
   (:icon 491))

(defmethod pict-extra-p ((self pict-extra)) t)
(defmethod pict-extra-p ((self t)) nil)


(defmethod omNG-save ((self pict-extra) &optional (values? nil))
  `(let ((copy ,(call-next-method)))
     (setf (factx copy) ,(factx self))
     (setf (facty copy) ,(facty self))
     (setf (deltax copy) ,(deltax self))
     (setf (deltay copy) ,(deltay self))
     copy))


(defmethod make-one-instance ((class pict-extra) &rest slots-vals) 
   (let ((val (get-picture-file)))
     (change-class val 'pict-extra)
     (setf (deltax val) (car slots-vals))
     (setf (deltay val) (second slots-vals))
     val))

(defmethod convert-extra ((self pict-extra)) self)

(defmethod omNG-copy ((self pict-extra))
  `(let ((copy ,(call-next-method)))
     (setf (factx copy) ,(factx self))
     (setf (facty copy) ,(facty self))
     (setf (deltax copy) ,(deltax self))
     (setf (deltay copy) ,(deltay self))
     copy))


(defclass grap-extra-pict (grap-extra-objet) ())

(defmethod make-graph-extra-obj ((self pict-extra) gobj)
   (make-instance 'grap-extra-pict
     :reference  self
     :gobject gobj))
   
(defmethod draw-graph-extra-obj ((self grap-extra-pict) view size staff)
  (when view
    (when (thepict (reference self))
      (let* ((picture (thepict (reference self)))
             (grap-obj (gobject self))
             (object (reference self))
             (rect (rectangle grap-obj))
             (ls (round size 4))
             (size-pict (om-get-picture-size picture))
             x y)
        (when picture
          (setf y (+ (* 3 ls) (second rect)))
          (setf x (- (+ (first rect) (round (- (third rect) (first rect)))) (round (om-point-h size-pict) 2) ls))
          (setf y (+ y (* ls (deltay (reference self)))))
          (setf x (+ x (* ls (deltax (reference self)))))
          (om-draw-picture (om-get-current-port) picture (om-make-point x y) size-pict))
        (setf (rectangle self) (list x y (+ x (om-point-h size-pict)) (+ y (om-point-v size-pict)))))
      )))

(defmethod draw-score-selection ((self grap-extra-pict) selection system size)
   (if (member (reference self) selection :test 'equal)
     (draw-h-rectangle (rectangle self) )))

;===========SAVE

(defun get-root-parent (obj)
   (if (parent obj) 
     (get-root-parent (parent obj))  
     obj))

;Una lista de posiciones del objecto en su container mayor
(defun cons-container-path (obj)
   (if (not (parent obj))
     nil
     (let ((parent (parent obj))
           (current obj) rep)
       (loop while parent do
             (push (position current (inside parent) :test 'equal) rep)
             (setf current parent
                   parent (parent current)))
       (reverse rep))))

(defun get-obj-from-container-path (obj path)
   (let ((rep obj))
     (loop for item in path do
           (when (and rep (container-p rep))
             (setf rep (nth item (inside rep)))))
     rep))


(defmethod omNG-save ((self simple-container) &optional (values? nil))
   "Cons a Lisp expression that retunr a copy of self when it is valuated."
   (when (omclass-p (class-of self))
     (let ((theclass (class-name (class-of self)))
           (exeption-p (execption-save-p self))
           ;;; jb 
           (tonalite (tonalite self))
           extralist patchlist muslist)
       (unless (parent self)
         (setf extralist (cons-extra-pairs self))
         (setf muslist (cons-mus-color self))
         (setf patchlist (cons-patch-pairs self)))
       (if exeption-p
         (let* ((intslots (set-difference (get-all-initargs-of-class theclass) (get-all-initargs-of-class exeption-p)
                                          :test 'string-equal :key 'name))
                (slots (mapcar #'(lambda (slot)
                                   `(setf (,(internp (name slot) (symbol-package theclass))  newobj)
                                          ,(omNG-save (funcall (internp (name slot) (slot-package slot))  self) values?))) 
                               intslots)))
           `(let ((newobj ,(save-exepcion self)))
              ,.slots
              (load-port-info newobj ',(get-port self))
              (init-mus-color newobj ,(omng-save muslist))
              (set-extra-pairs newobj ',extralist)
              (set-patch-pairs newobj ',patchlist)
              (set-tonalite newobj ,(omng-save tonalite))  ;;; jb
              newobj))
         (let ((slots (mapcan #'(lambda (slot)
                                  (list (string2initarg (name slot)) 
                                        (eval `(omNG-save (,(internp (name slot) (slot-package slot))  ,self) ,values?)))) 
                              (get-all-initargs-of-class theclass))))
           `(if (find-class ',theclass nil) 
              (let ((newobj (make-instance ',theclass ,.slots :from-file t)))
                (load-port-info newobj ',(get-port self))
                (init-mus-color newobj ,(omng-save muslist))
                (set-extra-pairs newobj ',extralist)
                (set-patch-pairs newobj ',patchlist)
                (set-tonalite newobj ,(omng-save tonalite))  ;;; jb
                newobj)))))))

(defmethod cons-mus-color ((self simple-container))
  (unless (= 0 (om-color-r (mus-color self)) (om-color-g (mus-color self)) (om-color-b (mus-color self)))
    (list (list (reverse (cons-container-path self)) (mus-color self)))))

(defmethod cons-mus-color ((self container))
  (append (call-next-method)
          (loop for item in (inside self)
                append (cons-mus-color item))))

(defmethod cons-extra-pairs ((self simple-container))
  (loop for obj in (extra-obj-list self)
        collect (list (reverse (cons-container-path self)) (omng-save obj))))

(defmethod cons-extra-pairs ((self container))
  (append (call-next-method)
          (loop for item in (inside self)
                append (cons-extra-pairs item))))

(defmethod cons-patch-pairs ((self simple-container))
  (when (mus-patch self)
    (list (list (cons-container-path self) (om-save (mus-patch self))))))

(defmethod cons-patch-pairs ((self container))
  (append (call-next-method)
          (loop for item in (inside self)
                append (cons-patch-pairs item))))

(defmethod set-extra-pairs ((self simple-container) list)
  (loop for item in list do
        (let ((obj (get-obj-from-container-path self (car item))))
          (when obj
            (setf (extra-obj-list obj) (cons (eval (second item)) (extra-obj-list obj)))))))

(defmethod set-patch-pairs ((self simple-container) list)
  (loop for item in list do
        (let ((obj (get-obj-from-container-path self (car item))))
          (when obj
            (setf (mus-patch obj) (eval (second item)))
            (remake-references obj)))))

(defmethod init-mus-color ((self simple-container) list) 
   (loop for item in list do
         (let ((obj (get-obj-from-container-path self (car item))))
           (when obj
             (setf (mus-color obj) (om-correct-color (second item)))))))

(defmethod set-extra-pairs ((self t) list) t)

(defmethod set-patch-pairs ((self t) list) t)

(defmethod init-mus-color ((self t) list) t)



;-----------------------------
(defmethod convert-extra ((self extra-objet)) self)

(defmethod convert-extra ((self t)) nil)

(defmethod convert-extra ((self picture)) 
  (when (thepict self)
    (make-instance 'pict-extra 
      :name (name self)
      :thepict (thepict self))))

;-----------------------------

(defmethod! add-extra ((self simple-container) extras path)
   :icon 162
   (let ((extra1 (loop for item in (list! extras) collect (convert-extra item)))
         (obj (get-obj-from-container-path self path)))
     (when obj
       (loop for item in extra1 do
             (set-extra-in-list (clone item) obj)))))

(defmethod! add-extra-list ((self container) extras mode)
   :icon 162
   :initvals '(nil nil "loop") :indoc '("object" "extra list" "mode")
   :menuins '(( 2 (("loop" "loop")  ("last" "last") ("exact" "exact"))))
   (let* ((objs (inside self))
          (extra1 (loop for item in (list! extras) collect (convert-extra item)))
          (n (length extra1)))
     (loop for item in objs
           for i = 0 then (cond
                           ((string-equal mode "loop") (mod (+ i 1) n))
                           ((string-equal mode "last") (if (< i (- n 1)) (+ i 1) (- n 1)))
                           (t (if (and i (< i (- n 1))) (+ i 1))))
           do
           (when i
             (set-extra-in-list (clone (nth i extra1)) item)))))

(defmethod! add-extra-list ((self simple-container) extras mode) t)

;-----------------------------
(defmethod! get-extras ((self simple-container) mode)
   :icon 162
   :initvals '(nil "all") :indoc '("object" "mode")
   :menuins '(( 1 (("all" "all")  ("head" "head") ("vel" "vel") ("char" "char") 
                  ("text" "text") ("pict" "pict") ("line" "line"))))
   (let* ((extras (get-all-extras self)))
     (loop for item in extras
           when (filtre-extra-p item mode) collect item)))


(defmethod filtre-extra-p ((self extra-objet) test)
   (cond
    ((string-equal test "all") t)
    ((string-equal test "head") (head-extra-p self))
    ((string-equal test "vel") (vel-extra-p self))
    ((string-equal test "char") (char-extra-p self))
    ((string-equal test "text") (text-extra-p self))
    ((string-equal test "pict") (pict-extra-p self))
    ((string-equal test "line") (line-extra-p self))))
;-----------------------------

(defmethod! delete-extras ((self list))
   :icon 162
   :initvals '(nil) 
   :indoc '( "extra list")
   (loop for item in self do
         (delete-extra item)))


(defvar *extrapackage* (omNG-protect-object (omNG-make-new-package "Extras")))


(AddClass2Pack '(text-extra vel-extra head-extra line-extra) *extrapackage* )

(AddGenFun2Pack  '(add-extra add-extra-list get-extras delete-extras) *extrapackage*)


