(in-package :om)


;======================================================
;PALETTE   abstract class
;======================================================

(defun but-function (item)
   (unless (selected-p item)
     (let* ((buttons (buttons (om-view-container item)))
            (ed-view (panel (editor-assoc (om-view-container item))))
            (newval (position item (car buttons)  :test 'equal)))
       (loop for b in (car (buttons (om-view-container item))) do
             (when (selected-p b)
               (setf (selected-p b) nil)
               (om-invalidate-view b t)))
       (setf (selected-p item) t)
       (om-invalidate-view item t)
       (setf (obj-mode ed-view) (nth  newval (object-order ed-view)))
       (off-selection ed-view)
       (setf (selection? ed-view)  nil)
       (set-edit-param (om-view-container ed-view) 'obj-mode  newval)
       (om-invalidate-view ed-view t))))

;Buttons


;=====================
(defvar *bnote* nil)
(defvar *bchord* nil)
(defvar *bgroup* nil)
(defvar *bmes* nil)
(defvar *bvoice* nil)
(defvar *bsys* nil)
(defvar *bfleches* nil)

(defun int-scorepal-buttons ()
   (setf  *bnote* (om-make-view 'choise-icon-button
                                                          :position (om-make-point  0 25)
                                                          :size (om-make-point 26 25)
                                                          :action #'(lambda (item)
                                                                             (but-function item))
                                                          :iconID 267))
   
   (setf *bchord*
      (om-make-view 'choise-icon-button
                                   :position (om-make-point  25 25)
                                   :size (om-make-point 26 25)
                                   :action #'(lambda (item)
                                                      (but-function item))
                                   :iconID 268))
   
   (setf *bgroup*
      (om-make-view 'choise-icon-button
                                   :position (om-make-point  50 25)
                                   :size (om-make-point 26 25)
                                   :action #'(lambda (item)
                                                      (but-function item))
                                   :iconID 269))
   
   (setf *bmes*
      (om-make-view 'choise-icon-button
                                   :position (om-make-point  75 25)
                                   :size (om-make-point 26 25)
                                   :action #'(lambda (item)
                                                      (but-function item))
                                   :iconID 270))
   
   (setf *bvoice*
      (om-make-view 'choise-icon-button
                                   :position (om-make-point  100 25)
                                   :size (om-make-point 26 25)
                                   :action #'(lambda (item)
                                                      (but-function item))
                                   :iconID 271))
   
   (setf *bsys*
      (om-make-view 'choise-icon-button
                                   :position (om-make-point  125 25)
                                   :size (om-make-point 26 25)
                                   :action #'(lambda (item)
                                                      (but-function item))
                                   :iconID 272))
   
   ;Buttons
   (setf *bfleches*
      (list (om-make-view 'button-icon
                                           :position (om-make-point  175 25)
                                           :size (om-make-point 26 25)
                                           :action #'(lambda (item)
                                                              (update-inspector (om-view-container item) 0))
                                           :iconID 275) 
             (om-make-view 'button-icon
                                          :position (om-make-point  200 25)
                                          :size (om-make-point 26 25)
                                          :action #'(lambda (item)
                                                             (but-function item))
                                          :iconID 277)
             (om-make-view 'button-icon
                                          :position (om-make-point  225 25)
                                          :size (om-make-point 26 25)
                                          :action #'(lambda (item)
                                                             (but-function item))
                                          :iconID 276)
             (om-make-view 'button-icon
                                          :position (om-make-point  250 25)
                                          :size (om-make-point 26 25)
                                          :action #'(lambda (item)
                                                             (let* ((selection (selection? (panel (editor-assoc (om-view-container item))))))
                                                               (update-inspector (om-view-container item) (- (length selection) 1))))
                                          :iconID 274)))
   )   

(om-add-init-func 'int-scorepal-buttons)
   
(defun icon-mode-pal (i)
   (case i (1 283) (otherwise 273)))


;==================================================


(omg-defclass music-score-palette (Playing-Palette) 
   ((inspected :initform nil  :accessor inspected)
    (buttons :initform nil :initarg :buttons :accessor buttons)
    (button-mode :initform nil  :accessor button-mode)
    (fleches :initform nil  :accessor fleches)
    (extras-p :initform nil  :accessor extras-p)
    (extras :initform nil  :accessor extras)
    (indexselec :initform 0 :initarg :indexselec :accessor indexselec))
   (:default-initargs :source-name "musicpalette")
   )

(omg-defclass chord-palette (music-score-palette) ()
  (:default-initargs :source-name nil :delta-inpix (om-make-point 150 0)))


(defmethod init-palette ((self music-score-palette))
  (call-next-method)
   (let ((panel (panel (editor-assoc self))))
     ;;; stop les extras
     ;;;(set-button-mode self (extra-palette panel))
     (setf (buttons self) (buttons-list panel))
     (when (buttons self)
     (om-set-view-size self (om-make-point (om-point-h (om-interior-size self)) 50)))
     (unless (mode (editor-assoc self))
       (setf (mode (editor-assoc self)) 7))
     (add-palette-buttons self)
     (when (extra-palette panel)
       (make-extra-palette panel *buttons-score-list*))))


(defmethod info-button-position ((self music-score-palette)) (om-make-point  200 25))

(defmethod set-button-mode ((self music-score-palette) extra-palette)
   (om-add-subviews self 
     (setf (button-mode self)
           (om-make-view 'choise-icon-button
             :position (info-button-position self)
             :size (om-make-point 26 25)
             :action #'(lambda (item)
                         (chage-palette-extra (om-view-container item))
                         (setf (iconID item) (icon-mode-pal (if (extra-palette (panel (editor-assoc self))) 1 0)))
                         (om-invalidate-view item ))
             :iconID (icon-mode-pal (if extra-palette 1 0))))))


(defmethod add-palette-buttons ((self music-score-palette))
   (let* ((ed-view (panel (editor-assoc self)))
          (selected (position (obj-mode ed-view) (object-order ed-view) :test 'string-equal))
          (i 0) (j 25))
   (loop for item in (buttons self) do
         (setf i 0)
         (loop for b in item
               for k = 0 then (+ k 1) do
               (setf (selected-p b)  (= k selected)) 
               (om-set-view-position b (om-make-point i j))
               (setf i (- (+ i (om-point-h (om-view-size b))) 1))
               (om-add-subviews self b))
         (setf j (+ j 25)))))

(defmethod remove-palette-buttons ((self music-score-palette))
  (loop for item in (buttons self) do
        (loop for b in item do
              (om-remove-subviews self b))))
   

(defmethod palette-act ((self music-score-palette) x) 
(unless (call-next-method)
  (when (and (or (= x 7) (= x 8)) (not (= x (mode (editor-assoc self)))))
    (progn 
      (setf (cursor-p (panel (editor-assoc self))) (= x 8))
      (update-panel (panel (editor-assoc self)))
      (setf (mode (editor-assoc self)) x)
      (om-invalidate-view self t)
      ))))


(defmethod get-inspector ((self t)) t)


;;; A FAIRE
(defmethod get-inspector ((self music-score-palette))
   ;;;(update-inspector self 0)
   nil)


(defmethod update-inspector ((self music-score-palette) index)
   (let* ((panel (panel (editor-assoc self)))
          (selection (if (edit-cursor panel) (list (edit-cursor panel))
                         (selection? panel)))
          (controls (get-inspector-info (panel (editor-assoc self)) (nth index selection) 
                                        index (h-size-palette self))))
     (erase-controls self)
     (setf (inspected self) controls)
     ;;; stop les boutons fleches
     ;;;(if (> (length selection) 1)
     ;;;   (add-buttons-fleches self))
     (show-inspector-section self)))

(defmethod add-buttons-fleches ((self music-score-palette))
   (setf (fleches self) *bfleches*)
   (mapc #'(lambda (item)
             (om-add-subviews self item)) *bfleches*))

(defmethod erase-controls ((self music-score-palette))
   (mapc #'(lambda (item)
             (om-remove-subviews self item)) (append (third (inspected self)) (fleches self)))
   (setf (fleches self) nil))

(defmethod h-size-palette ((self music-score-palette))
   (if (extra-palette (panel (editor-assoc self))) 
     (+ 50 (* 25 (length *buttons-score-list*))) 50))

(defmethod reset-inspector ((self music-score-palette))
   (om-set-view-size self (om-make-point  (om-point-h (om-interior-size self))
                                    (h-size-palette self)))
   (erase-controls self)
  (setf (inspected self) nil))

(defmethod show-inspector-section ((self music-score-palette))
   (mapc #'(lambda (item)
             (om-add-subviews self item )) (third (inspected self)))
   (om-set-view-size self (om-make-point (om-point-h (om-interior-size self)) 
                                         (+ (h-size-palette self) (first (inspected self))))))


(defmethod chage-palette-extra ((self music-score-palette))
   (let ((panel (panel (editor-assoc self))))
     (setf (extra-palette panel) (not (extra-palette panel)))
     (setf (extra-mode panel) 'nothing)
     (if (not (extra-palette  panel))
       (remove-extras self)
       (make-extra-palette panel *buttons-score-list*))
     (update-inspector self 0)))


(defmethod remove-extras ((self music-score-palette))
   (loop for item in (extras self) do 
         (om-remove-subviews self item))
   (setf (extras self) nil)
   (let ((palette (palette *global-palette*)) rep)
     (om-set-view-size self (om-make-point (om-point-h (om-interior-size palette)) 
                                     (- (om-point-v (om-interior-size palette)) (* 25 (length *buttons-score-list*))) ))
     ))

;=for voice
(omg-defclass ryth-palette (music-score-palette) ())
(defmethod palette-act ((self ryth-palette) x) (call-next-method))
(defmethod info-button-position ((self ryth-palette)) (call-next-method))

;==============================================================

(defmethod get-inspector-info ((panel scorepanel) (self t) index h0) (list 0 self nil))

(defmethod dur-dialogs ((panel scorepanel) (self note) index h0)
   (list (om-make-dialog-item 'om-static-text (om-make-point 150 (+ h0 8)) (om-make-point 40 16)
                                                    "dur" 
                                                    :bg-color *om-window-def-color*
                                                    :font *om-default-font2*)
         (om-make-dialog-item 'numbox (om-make-point 150 (+ h0 25)) (om-make-point 40 16) (format nil "~D" (dur self)) 
                 :font *om-default-font2*
                 :min-val 0
                 :max-val 10000000
                 :value (dur self)
                 :afterfun #'(lambda (x) 
                               (set-extent-ms self (value x))
                               (update-panel-panel x)))))

(defmethod dur-dialogs ((panel voicepanel) (self note) index h0) nil)
(defmethod dur-dialogs ((panel polypanel) (self note) index h0) nil)

(defmethod get-inspector-info ((panel scorepanel) (self note) index h0)
  (list 50 self
        (append (dur-dialogs panel self index h0)
                (list (om-make-dialog-item 'om-static-text (om-make-point 3 (+ h0 8)) (om-make-point 40 16)
                                                                 "midic" 
                                                                 :bg-color *om-window-def-color*
                                                                 :font *om-default-font2*)
                      (om-make-dialog-item 'om-static-text (om-make-point 100 (+ h0 8)) (om-make-point 40 16)
                                                                "vel" 
                                                                :bg-color *om-window-def-color*
                                                                :font *om-default-font2*)
                      (om-make-dialog-item  'om-static-text (om-make-point 55 (+ h0 8)) (om-make-point 40 16)
                                                                "chan" 
                                                                :bg-color *om-window-def-color*
                                                                :font *om-default-font2*)
                      (om-make-dialog-item 'numbox (om-make-point 55 (+ h0 25)) (om-make-point 18 16)
                                           (format nil "~D" (chan self)) 
                                           :min-val 1
                                           :max-val 16
                                           :value (chan self)
                                           :afterfun #'(lambda (x) 
                                                         (setf (chan self) (value x))
                                                         (update-panel-panel x)))
                      (om-make-dialog-item 'numbox (om-make-point 100 (+ h0 25)) (om-make-point 40 16)
                                           (format nil "~D" (vel self)) 
                                           :font *om-default-font2*
                                           :value (vel self)
                                           :min-val 0
                                           :max-val 127
                                           :afterfun #'(lambda (x) 
                                                         (setf (vel self) (value x))
                                                         (update-panel-panel x)))
                      (om-make-dialog-item 'numbox (om-make-point 3 (+ h0 25)) (om-make-point 40 16)
                                           (format nil "~D" (midic self)) 
                        :font *om-default-font2*
                        :min-val 0
                        :max-val 12700
                        :value (midic self)
                        :afterfun #'(lambda (x) 
                                      (change-midic self (value x))
                                      (update-panel-panel x)))))))

(defmethod get-inspector-info ((panel scorepanel) (self cursor-editor) index h0) (list 0 self nil))

(defmethod get-inspector-info ((panel voicepanel) (self cursor-editor) index h0) 
   (rythm-get-inspector panel self index h0))
  
(defmethod get-inspector-info ((panel polypanel) (self cursor-editor) index h0) 
   (rythm-get-inspector panel self index h0))

(defun rythm-get-inspector (panel self index h0)
   (list 65 self
         (list (om-make-dialog-item 'om-radio-button (om-make-point 3 (+ h0 5)) (om-make-point 200 20)   
                                                          "" 
                                                          :bg-color *om-window-def-color*
                                                          :di-action (om-dialog-item-act x 
                                                                                                                  (setf (meaure-edition-mode panel) 0)
                                                                                                                  (om-select-window (window panel))                                                                                           )
                                                          :radio-button-cluster 'insert-mode
                                                          :font *om-default-font2*
                                                          :checked-p (= (meaure-edition-mode panel) 0))
               (om-make-dialog-item 'om-radio-button (om-make-point 3 (+ h0 25)) (om-make-point 200 20)
                                                         "" 
                                                         :bg-color *om-window-def-color*
                                                         :di-action (om-dialog-item-act x 
                                                                                                                 (setf (meaure-edition-mode panel) 2)
                                                                                                                 (om-select-window (window panel)))                                                
                                                         :radio-button-cluster 'insert-mode
                                                         :font *om-default-font2*
                                                         :checked-p (= (meaure-edition-mode panel) 2))
               (om-make-dialog-item 'om-radio-button (om-make-point 3 (+ h0 45)) (om-make-point 200 20)
                                                         "" 
                                                         :bg-color *om-window-def-color*
                                                         :di-action (om-dialog-item-act x 
                                                                                                                 (setf (meaure-edition-mode panel) 1)
                                                                                                                 (om-select-window (window panel))
                                                                                                                 )
                                                         :radio-button-cluster 'insert-mode
                                                         :font *om-default-font2*
                                                         :checked-p (= (meaure-edition-mode panel) 1))
                (om-make-view 'picture-view
                                             :pict *insertmodes*
                                             :position (om-make-point 25 (+ h0 5))
                                             :size (om-get-picture-size  *insertmodes*))
                (om-make-dialog-item  'om-static-text (om-make-point 150 (+ h0 8)) (om-make-point 90 20)
                                                          "Subdivision "
                                                          :bg-color *om-window-def-color*
                                                          :font *om-default-font2*)
               (om-make-dialog-item 'numbox (om-make-point 150 (+ h0 25)) (om-make-point 18 16) (format nil "~D" (def-subdiv panel))
                                     :font *om-default-font2*
                                                         :min-val 1
                                                         :max-val 16
                                                         :value (def-subdiv panel)
                                                         :afterfun #'(lambda (x) 
                                                                               (setf (def-subdiv panel) (value x))
                                                                               (update-panel-panel x)))))
  )


(defmethod get-inspector-info ((panel scorepanel) (self measure) index h0)
  (let* ((tree (tree self))
         (sign (car tree))
         (h-sig (om-make-dialog-item 'numbox (om-make-point 3 (+ h0 3)) (om-make-point 30 16)
                                     (format nil "~D" (car sign))
                                     :font *om-default-font3b*
                                     :min-val 1
                                     :max-val 1000
                                     :value (car sign)))
         (l-sig (om-make-dialog-item 'numbox (om-make-point 3 (+ h0 20)) (om-make-point 30 16)     
                                     (format nil "~D" (second sign))
                                     :font *om-default-font3b*
                                     :min-val 1
                                     :max-val 1000
                                     :value (second sign))))
    (list 40 self
          (list h-sig l-sig
                (om-make-dialog-item 'om-button (om-make-point 40 (+ h0 10)) (om-make-point 38 16) "set"
                                     :di-action (om-dialog-item-act item
                                                                                             (change-signature panel self (list (value h-sig) (value l-sig))))
                                                          )))))


(defmethod get-inspector-info ((panel scorepanel) (self poly) index h0)
  (let* ((numvoices (length (inside self)))
         (scroller? (> numvoices 12))
         (sizew (if scroller? 305 320))
         (sizeh (if scroller? 240 (* 20 numvoices))))
    (list (+ sizeh 23) self
          (list (om-make-dialog-item 'om-static-text (om-make-point 3 (+ h0 5)) (om-make-point 300 16)
                                                           "Voice       Mute      Channel       Tempo"
                                                           :bg-color *om-window-def-color*
                                                           :font *om-default-font2*)
                (dialogue-voices (inside self) scroller? (om-make-point sizew sizeh) panel h0)))))


(defmethod get-inspector-info ((panel scorepanel) (self voice) index h0)
   (let* ((numvoices 1)
          (scroller? (> numvoices 12))
          (sizew (if scroller? 305 320))
          (sizeh (if scroller? 240 (* 20 numvoices))))
     (list (+ sizeh 23) self
           (list (om-make-dialog-item 'om-static-text (om-make-point 3 (+ h0 5)) (om-make-point 80 16)
                                                            "Voice"
                                                            :bg-color *om-window-def-color*
                                                            :font *om-default-font2*)
                  (om-make-dialog-item 'om-static-text (om-make-point 60 (+ h0 5)) (om-make-point 80 16)
                                                            "Mute"
                                                            :bg-color *om-window-def-color*
                                                            :font *om-default-font2*)
                  (om-make-dialog-item 'om-static-text (om-make-point 100 (+ h0 5)) (om-make-point 80 16)
                                                            "Channel"
                                                            :bg-color *om-window-def-color*
                                                            :font *om-default-font2*)
                  (om-make-dialog-item 'om-static-text (om-make-point 170 (+ h0 5)) (om-make-point 80 16)
                                                            "Tempo"
                                                            :bg-color *om-window-def-color*
                                                            :font *om-default-font2*)
                 (dialogue-voices (list self) scroller? (om-make-point sizew sizeh) panel h0)))))


(defmethod! set-channel ((self list) chan)
   :icon 420
   (loop for item in self collect (set-channel item chan)))

(defmethod! set-channel ((self container) chan)
   (loop for item in (inside self) do (set-channel item chan)))

(defmethod! set-channel ((self note) chan)
   (setf (chan self) chan))

(defmethod! set-channel ((self t) chan) t)


;=============

(omg-defclass voice-name-text (click-and-edit-text) ())

;------------Events
(defmethod do-exit-function ((self voice-name-text) container newtext)
   (when newtext
     (when (equal newtext "") (setf newtext "staff"))
     (om-set-dialog-item-text self newtext)
     (om-add-subviews container self)))

;================

(defun dialogue-voices (voicelist vsc size panel h0)
  (let* ((tabla (om-make-view 'om-scroller
                              :position (om-make-point 3 (+ h0 20)) 
                              :size size 
                              :bg-color *om-window-def-color*
                              :scrollbars (if vsc :v nil) )))
    (loop for i from 0 to (- (length voicelist) 1) do
          (let ((voice (nth i voicelist)))
            (om-add-subviews tabla 
                             (om-make-dialog-item 'om-static-text (om-make-point 0 (+ 3 (* i 20))) (om-make-point 60 20)
                                                                       (format nil "Voice ~D" i)
                                                                       :bg-color *om-window-def-color*
                                                                       :font *om-default-font2b*)
                             (om-make-dialog-item 'om-check-box (om-make-point 60 (* i 20)) (om-make-point 20 20) "" 
                                                  :bg-color *om-window-def-color*)
                             (om-make-dialog-item 'numbox (om-make-point 100 (+ 3 (* i 20))) (om-make-point 30 16) "1"
                                                  :font *om-default-font2*
                                                  :value 1
                                                  :min-val 1
                                                  :max-val 16
                                                  :afterfun #'(lambda (x) 
                                                                (set-channel voice (value x))
                                                                (update-panel panel)))
                             (om-make-dialog-item 'numbox (om-make-point 170 (+ 3 (* i 20))) (om-make-point 30 16)
                                                  (format nil "~D" (tempo voice))
                                                  :font *om-default-font2*
                                                  :value (tempo voice)
                                                  :min-val 10
                                                  :max-val 1000
                                                  :afterfun #'(lambda (x) 
                                                                (setf (tempo voice) (value x))
                                                                (update-panel panel))))))
    tabla))

(defun update-panel-panel (item)
  (update-panel (panel (editor-assoc (om-view-container item)))))



;===========================================================
;BIG PALETTE EXTRA
;===========================================================
(defvar *buttons-score-list* nil)

;(setf *buttons-score-list*
;  (list (list (list 305 *om-default-font1* '(5 18) 'nothing)
;              (list 306 *om-default-font1* '(5 18) 'text)
;              (list 304 *om-default-font1* '(5 18) 'line))
;        (list (list (dyn-fff) (om-make-font *music-font* 18) '(2 18) 'fff)
;              (list (dyn-ff) (om-make-font *music-font* 18) '(5 18) 'ff)
;              (list (dyn-f) (om-make-font *music-font* 18) '(8 18) 'f)
;              (list (dyn-mf) (om-make-font *music-font* 18) '(5 18) 'mf)
;              (list (dyn-mp) (om-make-font *music-font* 18) '(5 18) 'mp)
;              (list (dyn-p) (om-make-font *music-font* 18) '(8 18) 'p)
;              (list (dyn-pp) (om-make-font *music-font* 18) '(5 18) 'pp)
;              (list (dyn-ppp) (om-make-font *music-font* 18) '(2 18) 'ppp))
;        (list (list (head-1) (om-make-font *music-font* 36) '(5 12) 'rond)
;              (list (head-1/2) (om-make-font *music-font* 36) '(8 12) 'blanche)
;              (list (head-1/4) (om-make-font *music-font* 36) '(8 12) 'noire)
;              (list (head-carre) (om-make-font *music-font* 36) '(8 12) 'carre)
 ;             (list (head-losange) (om-make-font *music-font* 36) '(8 12)  'rombo)
 ;             (list (head-rect) (om-make-font *music-font* 36) '(8 12) 'cuadro)
 ;             (list (head-triangle) (om-make-font *music-font* 36) '(8 12) 'triangle)
 ;             (list (head-cercle) (om-make-font *music-font* 36) '(8 12) 'bola))))



;===================
;extra palette window
;===================
(omg-defclass extra-view (icon-view) 
  ((thechar :initform "T" :initarg :thechar :accessor thechar)
   (selected-p :initform nil :initarg :selected-p :accessor selected-p)
   (act :initform nil :initarg :act :accessor act)
   (xy :initform nil :initarg :xy :accessor xy)))

(defmethod om-draw-contents ((self extra-view)) 
  (call-next-method)
  (when (stringp (thechar self))
    (om-with-focused-view self
                          (om-with-font (om-get-font self)
                                        (om-draw-string (car (xy self)) (second (xy self)) (thechar self))
                                        (om-draw-view-outline self)))))

(defmethod om-view-click-handler ((self extra-view) where) 
   (let ((window (om-view-container self)))
     (setf (selected-p  (nth (indexselec window) (extras window))) nil)
     (om-invalidate-view (nth (indexselec window) (extras window)) t)
     (setf (indexselec window) (position self (extras window) :test 'equal)) 
     (setf (selected-p  self) t)
     (om-invalidate-view self t)
     (setf (extra-mode (panel (editor-assoc window))) (act self)) t))

(defmethod om-view-doubleclick-handler ((self extra-view) where) t)

(defun make-extra-palette (self lista)
  (let ((palette (palette *global-palette*)) rep)
    (om-set-view-size palette (om-make-point (om-point-h (om-interior-size palette)) 
                                             (+ (om-point-v (om-interior-size palette)) (* 25 (length lista))) ))
    (loop for list in lista
        for j = 50 then (+ j 25)
        for k = 0 then (+ k 1) do
          (loop for item in list 
              for i = 1 then (+ i 1) do
                (let* ((font (second item))
                       (theview (om-make-view 'extra-view
                                              :iconID (if (numberp (car item)) (car item) 302)
                                              :position (om-make-point  (* (- i 1)  25) j)
                                              :selected-p (and (= i 1) (= j 50))
                                              :size (om-make-point 26 25)
                                              :thechar (car item)
                                              :owner palette
                                              :act (fourth item)
                                              :font font
                                              :xy (third item))))
                  
                  (push  theview rep))))
    (setf (extras palette) (reverse rep))))


