(in-package :om)



(omg-defclass sheetobj-inframe (input-funboxframe) ())
(omg-defclass sheetobj-outframe (outfleche) ())
(defmethod om-view-mouse-enter-handler ((self sheetobj-inframe)) nil)
(defmethod om-view-mouse-leave-handler ((self sheetobj-inframe)) nil)
(defmethod reference ((self sheetobj-inframe)) (object self))
(defmethod reference ((self sheetobj-outframe)) (index self))

(defmethod add-patch-objs ((self trackpanel))
  (loop for item in (track-subviews self) do
        (setf (inputframes item) (loop for inp in (inputs (reference item)) 
                                      collect (om-make-view 'sheetobj-inframe 
                                                            :object inp
                                                            :size (om-make-point 8 8)
                                                            :position (om-make-point (round (w item) 2) 0))
                                      ))
        (loop for inf in (inputframes item) do (om-add-subviews item inf))
        (loop for out in (outs (reference item)) do (om-add-subviews item (om-make-view 'sheetobj-outframe 
                                                                            :index out
                                                                            :bg-color *om-green-color*
                                                                            :size (om-make-point 8 8)
                                                                            :position (om-make-point (round (w item) 2) (- (h item) 8)))))
        ))
        

(defmethod remove-patch-objs ((self trackpanel))
  (loop for item in (track-subviews self) do
        (loop for frame in (om-subviews item) do (om-remove-subviews item frame))
        (setf (inputframes item) nil)
        ))


(defmethod remove-panel-boxes ((self sheetPanel))
   (mapc #'(lambda (elem)
             (unless (equal 'trackpanel (class-name (class-of elem)))
               (om-remove-subviews self elem))) 
         (om-subviews self))
   (mapc #'(lambda (trackp)
             (remove-patch-objs trackp)) 
         (om-subviews self))
   (om-invalidate-view self t))

(defmethod set-panel-boxes ((self sheetPanel))
  (mapc #'(lambda (trackp)
            (add-patch-objs trackp)
            ) (om-subviews self))
  (let ((elements (boxes (object self)))
        (allevts (sheet-get-allobjs-evts self))) 
     (mapc #'(lambda (elem)
               (let ((newframe (make-frame-from-callobj elem)))
                 (om-add-subviews self newframe)
                   (add-subview-extra newframe))) elements)
     (mapc #'(lambda (elem)
               (update-graphic-connections elem (append allevts elements))) (get-subframes self))
     )
  (init-tracks self)
  (update-panel self))


(defmethod om-set-view-size ((self sheet-objectframe) size)
  (call-next-method)
  (let ((lin (round (om-point-h size) (+ 1 (length (inputframes self)))))
        (lout (round (om-point-h size) (+ 1 (length (outs (reference self)))))))
    (loop for in in (inputframes self)
          for i = 1 then (+ i 1) do
          (om-set-view-position in (om-make-point (- (* i lin) 4) 0))
          )
    (loop for out in (find-class-boxes (om-subviews self) 'sheetobj-outframe)
          for i = 1 then (+ i 1) do
          (om-set-view-position out (om-make-point (- (* i lout) 4) (- (h self) 8)))
          )))

;;;========================
;;; SCOREPATCH

(defmethod scorepatch-click-handler ((self sheetPanel) selection where double-click-p)
  (cond 
   ;((om-control-key-p) 
   ; (if selection (menu-item-context selection where)
   ;     (menu-item-context (om-view-container self) where)))
   ;((track-ev-p selection)
   ; (if (om-shift-key-p) 
   ;   (omselect-with-shift self selection)
   ;   (when (not (member (reference selection) (selection? self) :test 'equal))
   ;     (off-selection self)
   ;     (select-note self selection)))
   ; (setf (edit-cursor self) nil)
   ; (om-invalidate-view self t)
   ; )
   ((equal 'sheetobj-outframe (class-name (class-of selection)))
    (drag-out-line selection where))
   ((equal 'sheetobj-inframe (class-name (class-of selection)))
    nil)
   (t (when (or (selection? self) (edit-cursor self))
        (setf (edit-cursor self) nil)
        (make-unselect self)
        (om-invalidate-view self t))
      :call-next-method
      )))


;;; CONNECTIONS

(defmethod recursive-connection ((target boxframe) (source sheet-objectframe))
  (recursive-connection? (object target) (reference source)))

(defmethod recursive-connection ((target sheet-objectframe) (source boxframe))
  (recursive-connection? (reference target) (object source)))

(defmethod recursive-connection ((target sheet-objectframe) (source sheet-objectframe))
   (if (equal target source) t 
       (recursive-connection? (reference target) (reference source))))

(defmethod recursive-connection? ((target t) (source t))
   "Check if there is a cyclic connection when you connect the box 'source' to the box 'target'."
   (let (rep)
     (loop for item in (sheet-get-conect-to-me target)
           while (not rep) do
           (if (equal item source) (setf rep t)
               (setf rep (recursive-connection? item source))))
     rep))


(defmethod sheet-get-conect-to-me ((self t)) nil)

(defmethod sheet-get-conect-to-me ((self OMBoxcall))
   "Get all boxes connected to one or more outputs of 'self'."
   (append (get-conect-to-me self)
           (let* ((sheet (reference (om-view-container (car (frames self))))))
             (loop for ev in (loop for tr in (voices sheet) append (objs tr)) 
                   when (is-connected? self ev)
                   collect ev))
           ))

(defmethod sheet-get-conect-to-me ((self track-ev))
   "Get all boxes connected to one or more outputs of 'self'."
   (let* ((sheet (or (mycontainer self) (setf (mycontainer self) (reference (sheet-container (car (frames self)))))))
          (patch (mus-patch sheet)))
     (append 
     (when patch
       (loop for box in (get-elements patch)
             when (is-connected? self box)
             collect box))
     (loop for ev in (loop for tr in (inside sheet) append (objs tr)) 
           when (is-connected? self ev)
           collect ev)))
     )

(defmethod is-connected? ((self track-ev) (source OMBox))
   "T if one input of 'self' is connected to one output of 'source'."
   (let ((list (inputs source)) rep)
     (loop while list do
           (let ((connec (connected? (pop list))))
             (when (and connec (equal (first connec) self))
               (setf rep t)
               (setf list nil))))
     rep))

(defmethod is-connected? ((self t) (source track-ev))
   "T if one input of 'self' is connected to one output of 'source'."
   (let ((list (inputs source)) rep)
     (loop while list do
           (let ((connec (connected? (pop list))))
             (when (and connec (equal (first connec) self))
               (setf rep t)
               (setf list nil))))
     rep))

(defmethod connect-ctrl ((self track-ev) input  numout)
  (setf (connected? input) (list self numout nil 0)))

(defmethod new-connection ((self sheet-objectframe) index)
  (let ((theconnection (make-instance (class-of-connection self) :index index :thebox self)))
    (setf (points theconnection)
          (get-connection-lines self index))
    theconnection))

(defmethod remove-connection ((self sheet-objectframe) index)
  (flet ((match (x) (= index (index x))))
    (let ((count (position-if #'match (connections self))))
      (when count
        (let ((rectangle (get-rectangle-space (nth count (connections self))))) 
          (setf (connections self) (remove-if #'match (connections self)))
          (om-invalidate-corners (sheet-container self) 
                              (om-make-point (- (first rectangle) 4) (- (third rectangle) 4))  
                              (om-make-point (+ 4 (second rectangle)) (+ 4 (fourth rectangle))) t))))))

(defmethod unconnected ((self t) (source t))
   "T if  inputs of 'self' are not connected."
   (let ((list (inputs source)))
     (loop for input in list do
           (let ((connec (connected? input)))
             (when (and connec (equal (first connec) self))
               (setf (connected? input) nil))))))


(defmethod numouts ((self track-ev)) (length (outs self)))



(defmethod get-connect-pos-source ((self sheet-objectframe))
  (om-add-points (om-view-position self) (om-view-position (track-container self))))

(defmethod get-connection-lines ((self sheet-objectframe) i)
  ; c'est la boite du in
  (let* ((container (sheet-container self))
         (ctrl (nth i (inputframes self)))
         (connection (connected? (object ctrl)))
         (boxsource (first connection))
         possource sizesource
         (x-self (x self))
         (y-self (+ (y self) (y (om-view-container self))))
         (in-xs (x ctrl))
         x1 y1 xi yi)
     (if (car (frames boxsource))
       (progn
         (setf possource (get-connect-pos-source (car (frames boxsource))))
         (setf sizesource (om-view-size (car (frames boxsource))))
         (setq x1 (round (+ (om-point-h possource)  
                            (- (* (+ (second connection) 1) (/ (om-point-h sizesource) (+ (numouts boxsource) 1))) 2))))
         (setq y1 (- (+ (om-point-v possource) (h (car (frames boxsource)))) 2))
         (setq xi (+ x-self in-xs 4))
         (setq yi  y-self)
         ;(normalize-points container 
         (list (om-make-point x1 y1)
               (om-make-point xi yi))
         ;)
         )
       nil)
     ))

(defmethod redraw-connections ((self sheet-objectframe))
  (when (connections self)
       (let ((eraserect (list 10000 0 10000 0)))
         (mapc #'(lambda (conection)
                           (let ((initrect (get-rectangle-space conection)) finalrect)
                             (setf eraserect (list (min (first eraserect) (first initrect))
                                                                (max (second eraserect) (second initrect))
                                                                (min (third eraserect) (third initrect))
                                                                (max (fourth eraserect) (fourth initrect))))
                             (change-position conection)
                             (setf finalrect (get-rectangle-space conection))
                             (setf eraserect (list (min (first eraserect) (first finalrect))
                                                                (max (second eraserect) (second finalrect))
                                      (min (third eraserect) (third finalrect))
                                                                (max (fourth eraserect) (fourth finalrect)))))) (connections self))
         (om-invalidate-corners (sheet-container self) 
                                                    (om-make-point (- (first eraserect) 4) (- (third eraserect) 4))
                                                    (om-make-point (+ 4 (second eraserect)) (+ 4 (fourth eraserect))) t)
         )))

;(defmethod connect-box ((self outfleche) (ctrl input-funboxframe))
;  (let* ((boxframe (om-view-container self))
;         (boxcall (object boxframe))
;         (boxtarget (om-view-container ctrl)))
;    (if (not (recursive-connection boxtarget boxframe))
;      (progn
;        (when (connected? (object ctrl))
;          (remove-connection boxtarget (position ctrl (inputframes boxtarget) :test 'equal))) 
;        (connect-ctrl boxcall (object ctrl) (index self))
;        (push (new-connection boxtarget (position ctrl (inputframes boxtarget) :test 'equal))
;              (connections boxtarget))
;        (redraw-connections boxtarget))
;      (om-beep-msg "Impossible to connect, this would create a cycle."))))


(defmethod delete-connections ((sheet sheet) (self track-ev))
  (let* ((boxes (get-elements (mus-patch sheet)))
         (track-evs (remove nil (remove self 
                                        (flat (loop for tr in (inside sheet) collect 
                                                    (loop for obj in (objs tr) collect obj)))))))
         (when boxes
      (mapc #'(lambda (source)
                (when (is-connected? self source)
                  (unconnected self source)
                  )) 
            boxes))
    (when track-evs
      (mapc #'(lambda (source)
                (when (is-connected? self source)
                  (unconnected self source)
                  ))
            track-evs))
    t))



(defmethod om-draw-contents  ((self sheetpanel))
  (call-next-method)
  (draw-sheet-connections self))

(defmethod draw-sheet-connections ((self sheetpanel))
  (when (in-patch-mode? self)
    (loop for tr in (trackpanels self) do
          (loop for tr-ev in (track-subviews tr) do
               ;(redraw-connections tr-ev)
                (box-draw-connections tr-ev t)
               ))
    ))

(defmethod box-draw-connections ((self sheet-objectframe) val)
  ;(om-with-focused-view (sheet-container self) 
    (mapc #'(lambda (conection)
              ;(om-draw-line (om-point-h (car (points conection))) (om-point-v (car (points conection))) 
              ;              (om-point-h (cadr (points conection))) (om-point-v (cadr (points conection))))
              (draw-connection conection val)
              ) (connections self))
    ;)
  )


(defmethod update-boxes-connections ((self sheetpanel) boxes)
  (mapc #'(lambda (oneobject)
            (loop for tr in (trackpanels self) do 
                  (loop for trev in (track-subviews tr) do
                        (when (is-connected? (object oneobject) (reference trev))
                          (redraw-connections trev))
                        ))
            ) boxes))

(defmethod make-move-after ((self sheetpanel) dragged)
  (update-boxes-connections self dragged)
  (call-next-method))
   


(defmethod update-graphic-connections ((self sheet-objectframe) boxes)
  ;(print boxes)
   (let ((i 0) rep exist?)
     (mapc #'(lambda (input)     
               (if (connected? (object input))
                 (if (and (setf exist? (member (first (connected? (object input))) boxes :test 'equal))
                          (>= (- (numouts (car exist?)) 1) (second (connected? (object input))))) 
                   (let ((newcon (new-connection self i)))
                     (when (nth 2 (connected? (object input)))
                       (setf (points newcon) (nth 2 (connected? (object input)))))
                     (when (nth 3 (connected? (object input)))
                       (setf (ccolor newcon) (nth 3 (connected? (object input)))))
                     (push newcon rep))
                   (setf (connected? (object input)) nil)))
               (incf i)) (inputframes self))
;     (inspect rep)
     (setf (connections self) rep)))


(defmethod connection-container ((self sheet-objectframe)) (sheet-container self))

(defmethod click-in-connection ((self sheetpanel) where)
   "Called by 'view-click-event-handler' this method verify if you click on a connection. If this is the case
this method set the select flag of the connection to T and return a list with the selected connections."
   (or (call-next-method)
       (let ((controls (sheet-get-allobjs self))
             rep)
         (loop for box in  controls 
               while (not rep) do
               (let* ((connection (connections box)))
                 (loop for oneconnection in connection 
                       while (not rep) do
                       (let* ((where-click (point-in-connection oneconnection self where)))
                         (cond
                          ((numberp where-click)
                           (draw-connection oneconnection nil)
                           (unless (selected? oneconnection)
                             (unless (om-shift-key-p)
                               (mapc #'(lambda (control) 
                                         (deactivate-connect control)) 
                                     (remove oneconnection (get-connections self) :test 'equal)))
                             (setf (selected? oneconnection) t))
                           (cond 
                            ((om-shift-key-p)
                             (if (member (nth where-click (points oneconnection)) (point-sel oneconnection))
                               (setf (point-sel oneconnection) 
                                     (remove (nth where-click (points oneconnection))
                                             (point-sel oneconnection)))
                               (progn
                                 (push (nth where-click (points oneconnection)) (point-sel oneconnection))
                                 (scroll-points oneconnection))))
                            (t (unless (member (nth where-click (points oneconnection)) (point-sel oneconnection))
                                 (setf (point-sel oneconnection)  (list (nth where-click (points oneconnection)))))
                               (scroll-points oneconnection)))
                           (draw-connection oneconnection t)
                           (setf rep t))
                          (where-click
                           (select-connection oneconnection)
                           (unless (om-shift-key-p)
                             (mapc #'(lambda (control) 
                                       (deactivate-connect control)) 
                                   (remove oneconnection (get-connections self) :test 'equal)))
                           (setf rep t))
                          (t nil)))))) rep)))


(defmethod get-connections ((self sheetpanel))
  (append (call-next-method)
          (let* (rep)
            (mapc #'(lambda (box)
                      (setf rep (list+ rep (connections box)))) (sheet-get-allobjs self))
            rep)))




;;; EVAL

(defmethod omNG-box-value ((self track-ev) &optional (numout 0))
  (let ((args (eval-box-inputs self)))
    (when (car args) 
      (setf (obj self) (car args))
      (setf (end-t self) (+ (start-t self) (get-obj-dur (obj self)))))
    (clone (obj self))))

(defmethod eval-box-inputs ((self track-ev))
    (loop for input in (inputs self)
                        collect (omNG-box-value input)))

(defmethod get-actives-track-ev ((self sheetpanel))
  (let* (rep)
    (mapc #'(lambda (icon)
              (if (selected icon) 
                (push icon rep))) (sheet-get-allobjs self))
    (reverse rep)))

(defmethod eval-box ((self sheet-objectframe)) 
   (format *om-stream* "OM->~S~%" (omng-box-value (reference self))))