(in-package :om)


;===================
;==== INIT ====
;===================

(defvar *audio-player* nil)

(defvar *audio-vol* 100)
(defvar *audio-pan* 64)


(defun audio-open ()
 (when (om-start-audio)
  (setq *audio-player* (om-open-audio-player))
  (add-assoc-player *general-player* 'audioengine)))

(defun audio-close ()
 (when *audio-player*
  (om-close-audio-player *audio-player*)
  (remove-assoc-player *general-player* 'audioengine)
  (setq *audio-player* nil)
   ))
  
(om-add-init-func 'audio-open)  
(om-add-exit-cleanup-func 'audio-close t)


;===================
;==== AUDIO PLAY ====
;===================


(defmethod Preparetoplay ((player t) (s sound) at &key approx port interval voice)
  (when (om-sound-file-name s)
      (if *audio-player*
          (om-add-sound-to-player *audio-player* s at (first interval) (second interval) (tracknum s) (float (/ (vol s) 100)) (- 1.0 (float (/ (+ (pan s) 100) 200))))
        (progn
          (call-next-method)
          (om-stop-sound s)
          (om-prepare-sound s (first interval) (second interval))))))
  

;;;===============
;;; ca c'est pour quand ya pas de player
;;;===============

;; start end en ms
(defmethod DoPlay ((s sound) start end)
   (call-next-method)
   ;;;(play-from-to s (/ start 1000.0) (/ end 1000.0))
   (om-play-sound s start end)
   )

(defmethod DoStop ((s sound))
   (om-stop-sound s))

(defmethod DoPause ((s sound))
  (om-pause-sound s))

(defmethod DoContinue ((s sound))
   (om-continue-sound s))



;;;===============
;;; quand ya un player
;;;===============

(defmethod Play-player ((self (eql 'audioengine)))
   (when *audio-player* 
     (om-start-player *audio-player*)))

(defmethod Continue-Player ((self (eql 'audioengine)))
   (when *audio-player* 
     (om-continue-player *audio-player*)))

(defmethod Pause-Player ((self (eql 'audioengine)))
   (when *audio-player* 
     (om-pause-player *audio-player*)))

(defmethod Stop-Player ((self (eql 'audioengine)) &optional view)
   (declare (ignore view))
   (when *audio-player* 
     (om-stop-player *audio-player*)))

(defmethod Reset-Player ((self (eql 'audioengine)) &optional view)
   (declare (ignore view))
   (when *audio-player* 
     (om-reset-player *audio-player*)))
















