;=============================================================================
;		FM-1.ORC
; FREQUENCY MODULATION (FROM ACCCI, 20_10_1.ORC) / MONO
; AMPLITUDE AND INDEX ENVELOPES WITH OSCILI
;=============================================================================

; Synthesis: FM with dynamic spectral evolution
;            Bell settings
; Source:    Chowning (1973)
; Coded:     jpg 8/92, modified ms 9/02

; NB: the apparently arbitrary amplitude range (0-1000, rather than 0-1)
;         avoids Lisp printing small values with exponential notation
;-----------------------------------------------------------------------------

;	p1	= instrument number
;	p2	= action time [sec]
;	p3	= duration [sec]
;	p4	= maximum amplitude [linear, 0.0 -> 1000.0]
;	p5	= fundamental frequency [Hz]
;	p6	= N1
;	p7	= N2
;	p8	= maximum index
;	p9	= minimum index
;	p10	= amplitude envelope [GEN number]
;	p11	= index envelope [GEN number]

;-----------------------------------------------------------------------------
; COMPULSORY GEN FUNCTIONS
;	f1	carrier audio wave (sine tone)
;	f2	modulating audio wave (sine tone)
;_____________________________________________________________________________

; GEN functions **********************************************************
; carrier
f1  0  4097  10  1

; modulating
f2  0  4097  10  1

; envelopes
f51 0 513 5 1 513 .0001
f52 0 513 5 1 513 .001


; score ******************************************************************

;       idur iamp  if0 in1 in2 imax imin iaenv ienv
i1   0   15   250  55	5	7	10	  0	   51   52
e
