;=============================================================================
;		FOF-1.ORC
; FORMANTIC WAVEFORM (FROM ACCCI, 45_01_2.ORC) / MONO
; AMPLITUDE ENVELOPE WITH OSCILI
;=============================================================================

; Timbre:    Granular synthesis with fof module, voice-like tones
; Synthesis: FOF (Forme d'Onde Formatique)
;            OSCILI envelopes
; Coded:     jpg 8/92, modified ms 9/02

; NB1: this implementation works better with audio fundamental frequencies
; NB2: the apparently arbitrary amplitude range (0-1000, rather than 0-1)
;         avoids Lisp printing small values with exponential notation
;-----------------------------------------------------------------------------

;	p1	= instrument number
;	p2	= action time [sec]
;	p3	= duration [sec]
;	p4	= maximum amplitude [linear, 0.0 -> 1000.0]
;	p5	= fundamental frequency [Hz]
;	p6	= formant frequency [Hz]
;	p7	= bandwidth [Hz]
;	p8	= amplitude envelope [GEN number]

;-----------------------------------------------------------------------------
; COMPULSORY GEN FUNCTIONS
;	f1	large sine tone
;	f19	sigmoid rise/decay shape
;_____________________________________________________________________________

; large sine tone
f1  0 65536  10  1
; sigmoid rise/decay
f19 0  8192  19 .5 .5 270 .5

; amplitude envelope
f31 0 513 7 0.0  20 1  90 1  402 0.0  1 0.0

; score ******************************************************************

; default vowel "a" from the old Chant program in Fortran
; ---> NO VIBRATO, NO RULES WHATSOEVER...!@!

;  iatk idur   iamp	if0	ifreq	ibw		iaenv
i1  0    10    278	100	609.0	77.6	31
i1  0     8    137	 .	1000.0	88.4	.
i1  0     6     70	 .	2450.0	122.9	.
i1  0     4     78	 .	2700.0	127.8	.
i1  0     2     18	 .	3240.0	137.7	.

s1

i1  0     2    278	100	609.0	77.6	31
i1  0     4    137	 .	1000.0	88.4	.
i1  0     6     70	 .	2450.0	122.9	.
i1  0     8     78	 .	2700.0	127.8	.
i1  0    10     18	 .	3240.0	137.7	.


e

