;=============================================================================
;			PLUCK-1.ORC
; PLUCKED STRING USING THE KARPLUS-STRONG MODEL
;    (FROM ACCCI, 15_01_3.ORC) / MONO
; AMPLITUDE ENVELOPE WITH LINSEG, CONTROL OF NOISE SOURCE FROM THE SCORE
;=============================================================================

; Timbre:       Plucked string
; Synthesis:    Karplus-Strong algorithm
;               PLUCK
;               LINSEG envelope,
;               Varying parameter ranfun: 10 different sources of random
;                  numbers, two different buffer sizes
; Coded:     	jpg 8/93, modified ms 9/02

; NB: the apparently arbitrary amplitude range (0-1000, rather than 0-1)
;         avoids Lisp printing small values with exponential notation
;-----------------------------------------------------------------------------

;	p1	= instrument number
;	p2	= action time [sec]
;	p3	= duration [sec]
;	p4	= maximum amplitude [linear, 0.0 -> 1000.0]
;	p5	= frequency [Hz]
;	p6	= buffer size [power of 2]
;	p7	= function number of the random source [GEN number]
;	p8	= percentage of the total duration used for the last decay [0-1]

;-----------------------------------------------------------------------------
; COMPULSORY GEN FUNCTIONS

; The file "pluck-a.aiff" contains random noise with center frequency 'fqr'
; changing each second...


; !! BEWARE THAT THE DIRECTORY WHERE THIS FILE IS LOCATED IS KNOWN BY CSOUND !

; f71-80: 10 sources of random noise with center frequency changing every sec.

;_____________________________________________________________________________


; GEN functions **********************************************************

; "pluck-a.aiff contains random noise with center frequency 'fqr'
;    changing each second...
; NB: ignore csound's warning concerning the table's length

;       size GEN  inputfile             start
f71  0  1024  1   "pluck-a.aif"    .2    0  0         ; fqr = 10000
f72  0  1024  1   "pluck-a.aif"   1.2    0  0         ; fqr =  5000
f73  0  1024  1   "pluck-a.aif"   2.2    0  0         ; fqr =  2500
f74  0  1024  1   "pluck-a.aif"   3.2    0  0         ; fqr =  2000
f75  0  1024  1   "pluck-a.aif"   4.2    0  0         ; fqr =  1000
f76  0  1024  1   "pluck-a.aif"   5.2    0  0         ; fqr =   500
f77  0  1024  1   "pluck-a.aif"   6.2    0  0         ; fqr =   250
f78  0  1024  1   "pluck-a.aif"   7.2    0  0         ; fqr =   125
f79  0  1024  1   "pluck-a.aif"   8.2    0  0         ; fqr =    50
f80  0  1024  1   "pluck-a.aif"   9.2    0  0         ; fqr =    25


; score ******************************************************************

;            iamp    ifq   ibuf  iranfun idec
i1   0   1    250    220   128   0   0.2       ; pluck-made random numbers
i1   2   2     .      .     .    .    .

s

; section 2

;            iamp    ifq   ibuf  iranfun idec
i1   1   1    250    220   128   71  0.2    ; random numbers from audio file
i1   3   .   .       .     .     72   .
i1   5   .   .       .     .     73   .
i1   7   .   .       .     .     74   .
i1   9   .   .       .     .     75   .
i1  11   .   .       .     .     76   .
i1  13   .   .       .     .     77   .
i1  15   .   .       .     .     78   .
i1  17   .   .       .     .     79   .
i1  19   .   .       .     .     80   .

s

; section 3: changed ibuf to 1024

;            iamp    ifq   ibuf  iranfun
i1   1   1    250    220   1024  71  0.2
i1   3   .   .       .     .     72   .
i1   5   .   .       .     .     73   .
i1   7   .   .       .     .     74   .
i1   9   .   .       .     .     75   .
i1  11   .   .       .     .     76   .
i1  13   .   .       .     .     77   .
i1  15   .   .       .     .     78   .
i1  17   .   .       .     .     79   .
i1  19   .   .       .     .     80   .

e
