;;=============================================================================
;				WSHP-1.ORC
; 		WAVESHAPING (FROM ACCCI, 40_02_1.ORC) / MONO
; 		AMPLITUDE ENVELOPE WITH LINEN
;=============================================================================

; Timbre:    Clarinet-like
; Synthesis: Waveshaping
;            Basic instrument with duration dependent envelope
; Source:    Risset(1969)
;            #150, Serial Excerpt with Clarinet-like Sounds by Nonlinearity
; Coded:     jpg 8/92, modified ms 9/02

; NB: the apparently arbitrary amplitude range (0-1000, rather than 0-1)
;         avoids Lisp printing small values with exponential notation
;-----------------------------------------------------------------------------

;	p1	= instrument number
;	p2	= action time [sec]
;	p3	= duration [sec]
;	p4	= maximum amplitude [linear, 0.0 -> 1000.0]
;	p5	= frequency [Hz]

;-----------------------------------------------------------------------------
; COMPULSORY GEN FUNCTIONS
;	f1	sine tone
;	f31	transfer function for the waveshaper
;_____________________________________________________________________________

; GEN functions **********************************************************
f1   0 4097 10 1                           ; sinus

; transfer function waveshaper
f31  0  4097  7 -1 1600 -.5 897 .5 1600 1


; score ******************************************************************

;           idur   iamp   ipch
i1  0.000   0.750   250   165.6
i1  0.750   0.250  .      197
i1  1.000   1.000  .      262.8
i1  2.000   0.200  .      295
i1  2.200   0.200  .      331
i1  2.400   0.200  .      350.8
i1  2.600   0.200  .      525.6
i1  2.800   0.200  .      662.2
i1  3.000   0.250  .      701.6
i1  3.250   0.250  .      525.6
i1  3.500   0.250  .      350.8
i1  3.750   0.250  .      262.8
i1  4.000   1.000  .      165.6
i1  5.000   0.125  .      197
i1  5.125   0.125  .      262.8
i1  5.250   0.125  .      295
i1  5.375   0.125  .      331
i1  5.500   0.125  .      350.8
i1  5.625   0.125  .      525.6
i1  5.750   0.125  .      662.2
i1  5.875   0.125  .      701.6

e
