(in-package :om)


 

; FILLS THE SLOTS OF A LISP-WRITTEN CLASS READING A CSOUND INSTRUMENT

(defun get-orc-source (name)
  (let((result nil))
    (if name 
        (if (string-equal (pathname-type name) "orc")
            (with-open-file (file name)
              (loop while (not (stream-eofp file)) do
                    (let* ((rep (look-for-line-head file "instr"))
                           (j (car rep)))
                      (when (integerp j) (setf result (parse-csound-source file)))))
              )
          (om-beep-msg "Sorry only .ORC files can be parsed."))
      (om-beep-msg "ORC file not found..."))
   result))

(defun get-orc-globals (name)
  (let ((globals ()))
    (if name
        (with-open-file (file name)
          (setf globals (second (look-for-line-head file "instr")) ))
      (om-beep-msg "ORC file not found..."))
  (nreverse globals)))

(defun get-orc-macros (name)
  (let ((macs ()))
    (if name 
        (with-open-file (file name)
          (setf macs (search-macro-lines file "#define")) )
      (om-beep-msg "ORC file not found..."))
  (nreverse macs)))

(defun search-macro-lines (file name)
   (let ((rep nil) 
         (size (length name)))
     (loop while (not (stream-eofp file)) do
           (let* ((newl (delete-spaces (read-line file))))
             (when (and (>= (length newl) size) (search name newl :start2 0 :end2 (length name)))
               ; debut de macro
               (print newl)
               (let ((onemac "")
                     (cpt 0) (pos 7))
                 (loop while (and (< cpt 2) (not (stream-eofp file))) do
                       (setf pos (search "#" newl :start2 (+ pos 1)))
                       (if pos (setf cpt (+ cpt 1))
                           (setf onemac (string+ onemac (format nil "~D~%" newl))
                                 newl (delete-spaces (read-line file))
                                 pos 0)))
                 (setf onemac (string+ onemac (subseq newl 0 (+ pos 1))))
                 (push onemac rep)))))
     rep))

(defun parse-csound-source (file)
   (let ((oldpos (file-position file))
         (numins 0) end?)
     (loop while (and  (not end?) (not (stream-eofp file))) do
           (let ((tokem-rep (get-rep-char file 'valid "")))
             (cond
              ((integerp tokem-rep)
               (setf numins (max numins tokem-rep)))
              ((stringp tokem-rep)
               (print (fill-linescode file oldpos))
               (setf end? t)))))))

(defun parse-csound-source (file)
  (let ((oldpos (file-position file)))
    (fill-linescode file oldpos)))
 

;add by carlos
(defun get-orc-channels (name)
  (let ((channel ()))
    (if name
        (with-open-file (file name)
          (setf channel (third (look-for-line-head file "instr")) ))
      (om-beep-msg "ORC file not found..."))
  channel))



