(in-package :om)


;;;=======================================
;;; Un widget pour choisir une tonalite
;;;=======================================

(omg-defclass tonalite-dialog-item (om-view)
  ((nthton :accessor nthton :initarg :nthton :initform 7)
   (mode :accessor mode :initarg :mode :initform 0)))

(omg-defclass scoretonaliteview (om-view)
  ((ref-item :accessor ref-item :initarg :ref-item :initform nil)))

(defmethod make-tonalite-dialog-item (&optional ton-obj (pos (om-make-point 0 0)))
  (unless ton-obj (setf ton-obj (make-instance 'tonalite)))
  (let* ((view (om-make-view 'tonalite-dialog-item 
                             :position pos
                             :size (om-make-point 180 84)
                             :bg-color *om-white-color*
                             :mode (if (equal *majeur* (mode ton-obj)) 0 1)
                             :nthton (or (find-tonalite-num ton-obj) 7)
                             ))
         (score (om-make-view 'scoretonaliteview :position (om-make-point 5 5) :size (om-make-point 80 50)
                              :font (om-make-font *micron-font* 20)
                              :ref-item view
                              :bg-color *om-white-color*
                              ))
         (button-down (om-make-dialog-item 'om-button (om-make-point 95 5)
                                       (om-make-point 30 24) "<"
                                       ;;;:bg-color *om-white-color*
                                       :di-action (om-dialog-item-act item
                                                                      (unless (>= (nthton view) (- (length *ton-list*) 1)) 
                                                                        (setf (nthton view) (+ (nthton view) 1))
                                                                        (om-invalidate-view view)))
                                       ))
         (button-up (om-make-dialog-item 'om-button (om-make-point 134 5)
                                       (om-make-point 30 24) ">"
                                       ;;;:bg-color *om-white-color*
                                       :di-action (om-dialog-item-act item
                                                                      (unless (<= (nthton view) 0) 
                                                                        (setf (nthton view) (- (nthton view) 1))
                                                                        (om-invalidate-view view)))
                                         ))
         (modelist (om-make-dialog-item 'om-pop-up-dialog-item (om-make-point 90 52)
                                       (om-make-point 88 20) ""
                                       :range '("majeur" "mineur")
                                       :value (if (= 0 (mode view)) "majeur" "mineur")
                                       :di-action (om-dialog-item-act item
                                                                     (setf (mode view) (om-get-selected-item-index item))
                                                                     (om-invalidate-view view))
                                       )))

     (om-add-subviews view score button-down button-up modelist)
     
     view))
    

(defmethod om-draw-contents ((self scoretonaliteview))
  (let* ((wid (w self))
         (armure (get-armure (nthton (ref-item self))))
         (sym (car armure))
         (listpos (second armure)))
    (om-with-focused-view self 
      (om-with-font (om-get-font self)
                    (om-draw-line 0 12 wid 12)  
                    (om-draw-line 0 18 wid 18)  
                    (om-draw-line 0 24 wid 24)  
                    (om-draw-line 0 30 wid 30)  
                    (om-draw-line 0 36 wid 36)
                    (om-with-font (om-make-font *signs-font* 20)
                                  (om-draw-char 10 30 (key-g)))
                    (loop for a in listpos 
                          for i = 0 then (+ i 1) do
                          (om-draw-char (+ 30 (* i 5)) (- 36 (* 3 a)) sym)
                          )
                    (om-draw-view-outline self)
                    ))))

(defmethod om-draw-contents ((self tonalite-dialog-item))
  (let* ((ton (nth (mode self) (nth (nthton self) *ton-list*)))
         (str (string+ (string (first ton)) " " (cond 
                                                 ((equal (second ton) 'bemol) "bemol")
                                                 ((equal (second ton) 'diese) "diese")
                                                 (t "")))))
    (om-with-focused-view self
    (om-with-font (om-make-font "Arial" 14 :style '(:bold))
                  (om-draw-string 5 72 str))
)))


;;; tonalite dialog a partir d'une tonalite
;;; renvoie une liste formatee de valeurs
(defmethod ask-tonalite-dialog (ton-obj)
  (let* ((win (om-make-window 'om-window :size (om-make-point 190 150) :position :centered :resizable nil :maximize nil :close nil
                              :window-title "Tonalite"))
         (text (om-make-dialog-item 'om-static-text (om-make-point 5 5) (om-make-point 80 24) "ToNaLiTe"))
         (di (make-tonalite-dialog-item ton-obj (om-make-point 5 30)))
         (canc (om-make-dialog-item 'om-button (om-make-point 20 120) (om-make-point 60 22) "cancel"
                                    :di-action (om-dialog-item-act item
                                                (om-return-from-modal-dialog win nil))))
        (ok (om-make-dialog-item 'om-button (om-make-point 90 120) (om-make-point 60 22) "ok"
                                   :di-action 
                                   (om-dialog-item-act item
                                     (om-return-from-modal-dialog win (list (nth (mode di) (nth (nthton di) *ton-list*)) (mode di)))))))
    (om-add-subviews win canc ok text di)
    (om-modal-dialog win)))



;;;==============================
;;; set la tonalite d'un objet
;;;==============================

;;; tonalite dialog a partir d'une tonalite
;;; renvoie une instance de tonalite
(defun choose-new-tonalite (&optional tonalite)
    (let ((tonalite-values (ask-tonalite-dialog tonalite))
         note alt tonton)
      (when (consp tonalite-values)
        (setf note (car (car tonalite-values)))
        (setf alt (second (car tonalite-values)))
        (make-instance 'tonalite 
                     :tonnote note
                     :tonalt (convertnilalt alt)
                     :mode (convertnummode (second tonalite-values))))
      ))



(defmethod set-obj-tonalite ((self t)) nil)

(defmethod set-obj-tonalite ((self tonal-object))
  (let ((tonalite-values (ask-tonalite-dialog (tonalite self)))
         note alt tonton)
    (when (consp tonalite-values)
      (setf note (car (car tonalite-values)))
      (setf alt (second (car tonalite-values)))
      (setf tonton (make-instance (get-tonalite-class self) 
                     :tonnote note
                     :tonalt (convertnilalt alt)
                     :mode (convertnummode (second tonalite-values))))
    (set-tonalite self tonton)
)))


(defmethod score-set-tonalite ((self scorepanel))
  (let ((selection (selection? self)))
    (if selection
      (unless (equal 'grap-note (grap-class-from-type  (obj-mode self)))
        (let* ((tonalite (choose-new-tonalite (tonalite (car selection))))
               note alt mode)
          (when tonalite
            (setf note (tonnote tonalite))
            (setf alt (tonalt tonalite))
            (setf mod (mode tonalite))
            (loop for item in (selection? self) do
                  (set-tonalite item (make-instance (get-tonalite-class item) 
                                       :tonnote note
                                       :tonalt alt
                                       :mode mod))))))
      (progn
        (set-obj-tonalite (object (editor self)))
        (set-editor-tonality (panel self)))
      )
    (update-panel self)))


(defmethod score-remove-tonalite ((self scorepanel))
  (let ((selection (selection? self)))
    (if selection
      (loop for item in (selection? self) do
            (set-tonalite item nil))
      (set-tonalite (object (editor self)) nil))
    (update-panel self)))


(defmethod om-get-menu-context ((object grap-container))
  (let ((rep (list (om-new-leafmenu "Tonalite"
                           #'(lambda () 
                               (set-obj-tonalite (reference object)))))))
  (when (tonalite (reference object))
    (setf rep (append rep (list (om-new-leafmenu "Suppr. Tonalite"
                           #'(lambda () 
                               (set-tonalite (reference object) nil)))))))
    rep))




;;;===============================================
;;; SET TONALITE D'UNE NOTE = MODIF ENHARMONIE


(defmethod om-get-menu-context ((object grap-note))
  (let* ((alt (find-alt-list (midic (reference object))))
        (item1 (first alt)) (item2 (second alt)) (item3 (third alt))
        (menu1 (om-new-leafmenu (string+ (string (car item1)) (case (second item1) (-2 "bb") (-1 "b") (0 ".") (1 "#") (2 "##") (t "")))
                                #'(lambda () 
                                    (set-note-tonalite (reference object) (car item1) (second item1)))
                                ))
        (menu2 (om-new-leafmenu (string+ (string (car item2)) (case (second item2) (-2 "bb") (-1 "b") (0 ".") (1 "#") (2 "##") (t "")))
                           #'(lambda () 
                               (set-note-tonalite (reference object) (car item2) (second item2)))
                           ))
        (menu3 (when (car item3) (om-new-leafmenu (string+ (string (car item3)) (case (second item3) (-2 "bb") (-1 "b") (0 ".") (1 "#") (2 "##") (t "")))
                                                  #'(lambda () 
                                                      (set-note-tonalite (reference object) (car item3) (second item3)))
                                                  )))
        (menureset (om-new-leafmenu (string+ "reset")
                                #'(lambda () 
                                    (set-tonalite (reference object) nil))
                                )))
    (remove nil (list menu1 menu2 menu3 menureset))))


(defmethod set-obj-tonalite ((self note))
  (om-beep))

(defmethod set-note-tonalite ((self note) note alt)
  (let* ((tonnote note)
         (tonalt (case alt (-2 (list 'bemol 'bemol)) (-1 'bemol) (0 'becarre) (1 'diese) (2 (list 'diese 'diese))))
         (tonalite (make-instance (get-tonalite-class self) :tonnote tonnote :tonalt tonalt)))
    ;(set-tonalite self (arrange-note-tonalite-alteration tonalite (get-tonalite self)))
    (set-tonalite self tonalite)
    )
)




