(in-package :om)



;============ARPERGES


;ordre de degrees I V IV VI II VII III


;asc   priorites au hazar pas plus de deux repetitions

;desc  pareil

;brise c'est pas une mode c'est une option 1/2


;========


;les notes etrangeres apparaissent au moins une fois
;====

;broderie = monte un demi tone et descendre ou descendre un demi tone et monte  

;il faut remplir plus ou moins l'ambitus



(defun mk-arp-tree (sign times numsymboles symb/arp)
  (list (list sign (loop for i from 1 to times append
                         (list (list (round numsymboles times)  (make-list symb/arp :initial-element 1)))))))

(defvar *priolist* '(1 5 4 6 2 7 3))

(defun new-note (degrees) (nth-random degrees))
  
(defun mk-notes-by-mode (degrees n)
  (let* ((sdegree (loop for item in *priolist* when (member item degrees) collect item))
        (sdegree (loop for item in sdegree
                       for i = (+ 3 (length sdegree)) then (- i 1) append
                       (repeat-n item i)))
        (rep (if (member 1 degrees) (list 1))))
    (loop while (< (length rep) n) do
          (let ((newnote (new-note sdegree)))
            (unless (equal (car rep) newnote)
              (push newnote rep))))
    (reverse rep)))

(defun true-octave (note lastnote dir fun)
  (loop while (not (funcall fun note lastnote)) do
        (setf note (+ note (* dir 1200))))
  note)
  

(defun realize-notes (dnotes ambitus mode brise? tonality)
  (let* ((start (if (equal mode "up") (car ambitus) (second ambitus)))
         (pitch-class (mod (round (approx-m start 2) 100) 12))
         (midimindo (- start (* 100 pitch-class)))
         (lastnote midimindo)
         rep)
    (loop for note in dnotes
          for k = 0 then (+ k 1)
          for pair? = t then (not pair?) do
          (let* ((rnote (+ midimindo   (* (get-pitch note tonality) 100))))
            (setf rnote (true-octave rnote lastnote (if (equal mode "up") 1 -1) (if (equal mode "up") '>= '<=)))
            (when (and brise? pair? (not (zerop k)))
             (if (equal mode "up") (setf rnote (- rnote 1200)) (setf rnote (+ rnote 1200))))
            (push rnote rep)
            (setf lastnote rnote)))
    (reverse rep)))


(defun string-until-PLUS (string)
  (let ((index (search "+" string)))
    (if index 
      (list (subseq string 0 index) (subseq string index) 1)
      (progn
        (setf index (search "-" string))
        (if index 
          (list (subseq string 0 index) (subseq string index) -1)
          (list string nil 0))))))


(defun degree2num (degree)
  (let* ((pair (string-until-PLUS (string degree)))
        (d (first pair))
        (oct (second pair))
        (dir (* (third pair) (length oct))))
  (cond
   ((equal d "B") (list -1 nil))
   ((equal d "I") (list 1 dir)) ((equal d "II") (list 2 dir)) 
   ((equal d "III") (list 3 dir)) ((equal d "IV") (list 4 dir))
   ((equal d "V") (list 5 dir)) ((equal d "VI") (list 6 dir)) 
   ((equal d "VII") (list 7 dir)))))



(defun mk-arpegio-from-pattern (chord tonality figure times pattern ambitus)
  (let* ((degree-list (loop for item in pattern collect (degree2num item)))
         (min (car ambitus))
         (pitch-class (mod (round (approx-m min 2) 100) 12))
         (midimindo (- min (* 100 pitch-class)))
         len  arp-list degrees foregn tree rep)
    (loop for item in degree-list do
          (cond
           ((equal (car item) -1) 
            (when (car rep)
              (push (- (car rep) 100) rep)
              (push (+ (car rep) 100) rep)))
           (t
            (let* ((rnote (get-pitch (car item) tonality))
                   (delta (second item)))
              (push (+ midimindo  (* rnote 100) (* delta 1200)) rep)
              ))))
    (setf rep (reverse rep))
    (setf len (length rep))
    (setf tree
          (list (list (list (* times len) figure)
                (loop for i from 1 to times append
                      (list (list len  (make-list len :initial-element 1)))))))
    (make-instance 'voice
      :tree tree
      :chords (flat (repeat-n rep times)))))


;(mk-arpegio-from-pattern nil "DO" 8 2 '(I III V b I- VI+) '(6000 7200))

;mode = asc desc brise exp graph
(defmethod mk-arpegio ((self chord) tonality figure sign times mode brise? group-arpgortemps? ambitus)
  (cond
   ((listp mode) (mk-arpegio-from-pattern self tonality figure times mode ambitus))
   (t
    (let* ((symb/puls (/ figure (second sign )))
           (numsymboles (* (car sign) symb/puls))
           (symb/arp (floor numsymboles times))
           (notes (Lmidic self))
           arp-list degrees foregn tree)
      (setf tree (mk-arp-tree sign times numsymboles symb/arp))
      (loop for item in notes do 
            (let ((degree (get-degree (mod (round (approx-m item 2) 100) 12) tonality)))
              (if degree 
                (push degree degrees)
                (push (mod (round (approx-m item 2) 100) 12) foregn))))
      (setf degrees (remove-duplicates degrees))
      (setf foregn (remove-duplicates foregn))
      (setf arp-list (loop for i from 1 to times collect
                           (let ((dnotes (mk-notes-by-mode degrees symb/arp)))
                            
                             (realize-notes dnotes ambitus mode brise? tonality))))
      ;(print arp-list)
      (setf arp-list (flat arp-list))
      (make-instance 'voice
        :tree tree
          :chords arp-list)))))






;;; JB 
(defmethod get-tonality-str ((self tonalite))
  (let ((str "") (note (tonnote self)))
    (setf str (if (equal majeur (mode self))
                (cond 
                 ((equal 'do note) "DO")
                 ((equal 're note) "RE")
                 ((equal 'mi note) "MI")
                 ((equal 'fa note) "FA")
                 ((equal 'sol note) "SOL")
                 ((equal 'la note) "LA")
                 ((equal 'si note) "SI"))
                (cond 
                 ((equal 'do note) "do")
                 ((equal 're note) "re")
                 ((equal 'mi note) "mi")
                 ((equal 'fa note) "fa")
                 ((equal 'sol note) "sol")
                 ((equal 'la note) "la")
                 ((equal 'si note) "si"))))
    (setf str (string+ str (cond ((equal 'bemol (tonalt self)) "b")
                                 ((equal 'diese (tonalt self)) "#")
                                 (t ""))))
    str))

